!     SUBROUTINE DROT(N,DX,INCX,DY,INCY,C,S)
      subroutine ddrot(n,dxh,dxl,incx,dyh,dyl,incy,ch,cl,sh,sl)
      implicit none
*     .. Scalar Arguments ..
#ifdef FPCOUNTER
#include "fpcounter.h"
#endif
!     DOUBLE PRECISION C,S
      double precision ch, cl
      double precision sh, sl
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
!     DOUBLE PRECISION DX(*),DY(*)
      double precision dxh(*), dxl(*)
      double precision dyh(*), dyl(*)
*     ..
*
*  Purpose
*  =======
*
*     applies a plane rotation.
*     jack dongarra, linpack, 3/11/78.
*     modified 12/3/93, array(1) declarations changed to array(*)
*
*
!     double double modefication 3/2011
!
*     .. Local Scalars ..
!     DOUBLE PRECISION DTEMP
      double precision dtemph, dtempl
      double precision ddah, ddal
      double precision ddmh, ddml
      INTEGER I,IX,IY
      integer iix,iiy
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
#ifdef FPCOUNTER
#include "finit.h"
      SUBNAME = "ddrot"
#endif
*     ..
!     IF (N.LE.0) RETURN
      if (n.le.0) goto 9999
      IF (INCX.EQ.1 .AND. INCY.EQ.1) GO TO 20
*
*       code for unequal increments or equal increments not equal
*         to 1
*
      IX = 1
      IY = 1
      IF (INCX.LT.0) IX = (-N+1)*INCX + 1
      IF (INCY.LT.0) IY = (-N+1)*INCY + 1
      iix = ix
      iiy = iy
!$omp parallel
!$omp do
!$omp+ private(I,ix,iy)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddmh, ddml)
!$omp+ private(ddah, ddal)
!$omp+ private(dtemph, dtempl)
      DO 10 I = 1,N
          ix = iix + (i - 1)*incx
          iy = iiy + (i - 1)*incy
!         DTEMP = C*DX(IX) + S*DY(IY)
!<<<      dda = s * dy(iy)
          ddah = sh * dyh(iy)
          t_u1 = 134217729.0 * sh
          t_p1 = t_u1
     +             - (t_u1 - sh)
          t_p2 = sh - t_p1
          t_u1 = 134217729.0 * dyh(iy)
          t_r1 = t_u1
     +             - (t_u1 - dyh(iy))
          t_r2 = dyh(iy) - t_r1
          ddal = ((t_p1*t_r1
     +            - ddah)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddal = ddal
     +          + (sh*dyl(iy)
     +          + sl*dyh(iy))
          t_s1 = ddah + ddal
          ddal = ddal - (t_s1 - ddah)
          ddah = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      dda = s * dy(iy)
!<<<      ddm = c * dx(ix)
          ddmh = ch * dxh(ix)
          t_u1 = 134217729.0 * ch
          t_p1 = t_u1
     +             - (t_u1 - ch)
          t_p2 = ch - t_p1
          t_u1 = 134217729.0 * dxh(ix)
          t_r1 = t_u1
     +             - (t_u1 - dxh(ix))
          t_r2 = dxh(ix) - t_r1
          ddml = ((t_p1*t_r1
     +            - ddmh)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddml = ddml
     +          + (ch*dxl(ix)
     +          + cl*dxh(ix))
          t_s1 = ddmh + ddml
          ddml = ddml - (t_s1 - ddmh)
          ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      ddm = c * dx(ix)
!<<<      dtemp = ddm + dda
          t_p1 = ddmh + ddah
          t_p2 = t_p1 - ddmh
          dtemph = t_p1
          dtempl = (ddmh - (t_p1 - t_p2))
     +          + (ddah - t_p2)
          dtempl = dtempl + ddml + ddal
          t_s1 = dtemph + dtempl
          dtempl = dtempl - (t_s1 - dtemph)
          dtemph = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>      dtemp = ddm + dda
!         DY(IY) = C*DY(IY) - S*DX(IX)
!<<<      dda = s * dx(ix)
          ddah = sh * dxh(ix)
          t_u1 = 134217729.0 * sh
          t_p1 = t_u1
     +             - (t_u1 - sh)
          t_p2 = sh - t_p1
          t_u1 = 134217729.0 * dxh(ix)
          t_r1 = t_u1
     +             - (t_u1 - dxh(ix))
          t_r2 = dxh(ix) - t_r1
          ddal = ((t_p1*t_r1
     +            - ddah)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddal = ddal
     +          + (sh*dxl(ix)
     +          + sl*dxh(ix))
          t_s1 = ddah + ddal
          ddal = ddal - (t_s1 - ddah)
          ddah = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      dda = s * dx(ix)
!<<<      ddm = c * dy(iy)
          ddmh = ch * dyh(iy)
          t_u1 = 134217729.0 * ch
          t_p1 = t_u1
     +             - (t_u1 - ch)
          t_p2 = ch - t_p1
          t_u1 = 134217729.0 * dyh(iy)
          t_r1 = t_u1
     +             - (t_u1 - dyh(iy))
          t_r2 = dyh(iy) - t_r1
          ddml = ((t_p1*t_r1
     +            - ddmh)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddml = ddml
     +          + (ch*dyl(iy)
     +          + cl*dyh(iy))
          t_s1 = ddmh + ddml
          ddml = ddml - (t_s1 - ddmh)
          ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      ddm = c * dy(iy)
!<<<      dy(iy) = ddm - dda
          t_p1 = ddmh - ddah
          t_p2 = t_p1 - ddmh
          dyh(iy) = t_p1
          dyl(iy) = (ddmh - (t_p1 - t_p2))
     +             - (ddah + t_p2)
          dyl(iy) = dyl(iy) + ddml - ddal
          t_s1 = dyh(iy) + dyl(iy)
          dyl(iy) = dyl(iy) - (t_s1 - dyh(iy))
          dyh(iy) = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>      dy(iy) = ddm - dda
!         DX(IX) = DTEMP
          dxh(ix) = dtemph
          dxl(ix) = dtempl
!!        IX = IX + INCX
!!        IY = IY + INCY
   10 CONTINUE
!$omp end do
!$omp end parallel
      goto 9999
!     RETURN
*
*       code for both increments equal to 1
*
   20 continue
!$omp parallel
!$omp do
!$omp+ private(I)
!     tmp vars -> private
!$omp+ private(t_ch, t_cl)
!$omp+ private(t_p1, t_p2)
!$omp+ private(t_q1, t_q2)
!$omp+ private(t_r1, t_r2)
!$omp+ private(t_s1, t_s2)
!$omp+ private(t_t1, t_t2)
!$omp+ private(t_u1, t_u2)
!$omp+ private(t_x1, t_x2)
!$omp+ private(t_y1, t_y2)
!$omp+ private(t_z1, t_z2)
!$omp+ private(t_x, t_ax)
!$omp+ private(t_t1h, t_t1l)
!$omp+ private(t_t2h, t_t2l)
!$omp+ private(ddah, ddal)
!$omp+ private(ddmh, ddml)
!$omp+ private(dtemph, dtempl)
!  20 DO 30 I = 1,N
      DO 30 I = 1,N
!         DTEMP = C*DX(I) + S*DY(I)
!<<<      dda = s * dy(i)
          ddah = sh * dyh(i)
          t_u1 = 134217729.0 * sh
          t_p1 = t_u1
     +             - (t_u1 - sh)
          t_p2 = sh - t_p1
          t_u1 = 134217729.0 * dyh(i)
          t_r1 = t_u1
     +             - (t_u1 - dyh(i))
          t_r2 = dyh(i) - t_r1
          ddal = ((t_p1*t_r1
     +            - ddah)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddal = ddal
     +          + (sh*dyl(i)
     +          + sl*dyh(i))
          t_s1 = ddah + ddal
          ddal = ddal - (t_s1 - ddah)
          ddah = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      dda = s * dy(i)
!<<<      ddm = c * dx(i)
          ddmh = ch * dxh(i)
          t_u1 = 134217729.0 * ch
          t_p1 = t_u1
     +             - (t_u1 - ch)
          t_p2 = ch - t_p1
          t_u1 = 134217729.0 * dxh(i)
          t_r1 = t_u1
     +             - (t_u1 - dxh(i))
          t_r2 = dxh(i) - t_r1
          ddml = ((t_p1*t_r1
     +            - ddmh)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddml = ddml
     +          + (ch*dxl(i)
     +          + cl*dxh(i))
          t_s1 = ddmh + ddml
          ddml = ddml - (t_s1 - ddmh)
          ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      ddm = c * dx(i)
!<<<      dtemp = ddm + dda
          t_p1 = ddmh + ddah
          t_p2 = t_p1 - ddmh
          dtemph = t_p1
          dtempl = (ddmh - (t_p1 - t_p2))
     +          + (ddah - t_p2)
          dtempl = dtempl + ddml + ddal
          t_s1 = dtemph + dtempl
          dtempl = dtempl - (t_s1 - dtemph)
          dtemph = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>      dtemp = ddm + dda
!         DY(I) = C*DY(I) - S*DX(I)
!<<<      dda = s * dx(i)
          ddah = sh * dxh(i)
          t_u1 = 134217729.0 * sh
          t_p1 = t_u1
     +             - (t_u1 - sh)
          t_p2 = sh - t_p1
          t_u1 = 134217729.0 * dxh(i)
          t_r1 = t_u1
     +             - (t_u1 - dxh(i))
          t_r2 = dxh(i) - t_r1
          ddal = ((t_p1*t_r1
     +            - ddah)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddal = ddal
     +          + (sh*dxl(i)
     +          + sl*dxh(i))
          t_s1 = ddah + ddal
          ddal = ddal - (t_s1 - ddah)
          ddah = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      dda = s * dx(i)
!<<<      ddm = c * dy(i)
          ddmh = ch * dyh(i)
          t_u1 = 134217729.0 * ch
          t_p1 = t_u1
     +             - (t_u1 - ch)
          t_p2 = ch - t_p1
          t_u1 = 134217729.0 * dyh(i)
          t_r1 = t_u1
     +             - (t_u1 - dyh(i))
          t_r2 = dyh(i) - t_r1
          ddml = ((t_p1*t_r1
     +            - ddmh)
     +            + t_p1 * t_r2
     +            + t_p2 * t_r1)
     +            + t_p2 * t_r2
          ddml = ddml
     +          + (ch*dyl(i)
     +          + cl*dyh(i))
          t_s1 = ddmh + ddml
          ddml = ddml - (t_s1 - ddmh)
          ddmh = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>      ddm = c * dy(i)
!<<<      dy(i) = ddm - dda
          t_p1 = ddmh - ddah
          t_p2 = t_p1 - ddmh
          dyh(i) = t_p1
          dyl(i) = (ddmh - (t_p1 - t_p2))
     +             - (ddah + t_p2)
          dyl(i) = dyl(i) + ddml - ddal
          t_s1 = dyh(i) + dyl(i)
          dyl(i) = dyl(i) - (t_s1 - dyh(i))
          dyh(i) = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>      dy(i) = ddm - dda
!         DX(I) = DTEMP
          dxh(i) = dtemph
          dxl(i) = dtempl
   30 CONTINUE
!$omp end do
!$omp end parallel
 9999 continue
#ifdef FPCOUNTER
      WRITE(6,1000) "MODULE    = ddrot"
#include "fout2.h"
#include "fformat.h"
#endif
      RETURN
      END
