!      subroutine eigen_hrd_2update(
!     &             ar, ai, nm,
!     &             ur_x, ui_x,
!     &             ur_y, ui_y,
!     &             vr_x, vi_x,
!     &             vr_y, vi_y,
!     &             nv, m, n,
!     &             ar_,ai_,n_,nm_
      subroutine ddeigen_hrd_2update(
     &             arh, arl, aih, ail, nm,
     &             ur_xh, ur_xl, ui_xh, ui_xl,
     &             ur_yh, ur_yl, ui_yh, ui_yl,
     &             vr_xh, vr_xl, vi_xh, vi_xl,
     &             vr_yh, vr_yl, vi_yh, vi_yl,
     &             nv, m, n,
     &             ar_h,ar_l,ai_h,ai_l,n_,nm_
#ifdef MEMORY1
     &      ,nxx_ur_x,nxx_ui_x,nxx_ur_y,nxx_ui_y
     &      ,nxx_vr_x,nxx_vi_x,nxx_vr_y,nxx_vi_y
#endif
     &           )

!======================================================================!
!$    use omp_lib
      implicit none
!----
!      real(8), intent(inout) :: ar (nm,*),  ai (nm,*)
!      real(8), intent(in)    :: ur_x(nv,*), ui_x(nv,*)
!      real(8), intent(in)    :: ur_y(nv,*), vi_y(nv,*)
!      real(8), intent(in)    :: vr_x(nv,*), vi_x(nv,*)
!      real(8), intent(in)    :: vr_y(nv,*), ui_y(nv,*)
      real(8), intent(inout) :: arh (nm,*), arl (nm,*),
     &                          aih (nm,*), ail (nm,*)
      real(8), intent(in)    :: ur_xh(nv,*), ui_xh(nv,*)
      real(8), intent(in)    :: ur_yh(nv,*), vi_yh(nv,*)
      real(8), intent(in)    :: vr_xh(nv,*), vi_xh(nv,*)
      real(8), intent(in)    :: vr_yh(nv,*), ui_yh(nv,*)
      real(8), intent(in)    :: ur_xl(nv,*), ui_xl(nv,*)
      real(8), intent(in)    :: ur_yl(nv,*), vi_yl(nv,*)
      real(8), intent(in)    :: vr_xl(nv,*), vi_xl(nv,*)
      real(8), intent(in)    :: vr_yl(nv,*), ui_yl(nv,*)
      integer, intent(in)    :: nm, nv, m, n
      real(8) :: ar_h, ar_l, ai_h, ai_l
      integer :: n_, nm_
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_vr_y
      integer,intent(in) :: nxx_vi_y
#endif
!----
      if ( n <= 0 ) return
!----
!      call eigen_hrd_2update_body(
!     &       ar(1,1), ai(1,1),
!     &       nm,
!     &       ur_x(1,1), ui_x(1,1), ur_y(1,1), ui_y(1,1),
!     &       vr_x(1,1), vi_x(1,1), vr_y(1,1), vi_y(1,1),
!     &       nv, m, n
      call ddeigen_hrd_2update_body(
     &       arh(1,1), arl(1,1), aih(1,1), ail(1,1),
     &       nm,
     &       ur_xh(1,1), ur_xl(1,1), ui_xh(1,1), ui_xl(1,1),
     &       ur_yh(1,1), ur_yl(1,1), ui_yh(1,1), ui_yl(1,1),
     &       vr_xh(1,1), vr_xl(1,1), vi_xh(1,1), vi_xl(1,1),
     &       vr_yh(1,1), vr_yl(1,1), vi_yh(1,1), vi_yl(1,1),
     &       nv, m, n
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1), xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1), xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1), xx_vi_x(0,1,1)
     &      ,xx_vr_y(0,1,1), xx_vi_y(0,1,1)
#endif
     &     )
!----
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1,i2
      xx_ur_x = nxx_ur_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_2update:ur_x")
      end function

      function xx_ui_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1,i2
      xx_ui_x = nxx_ui_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_2update:ui_x")
      end function

      function xx_vr_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1,i2
      xx_vr_x = nxx_vr_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_2update:vr_x")
      end function

      function xx_vi_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1,i2
      xx_vi_x = nxx_vi_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_2update:vi_x")
      end function

      function xx_ur_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1,i2
      xx_ur_y = nxx_ur_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_2update:ur_y")
      end function

      function xx_ui_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1,i2
      xx_ui_y = nxx_ui_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_2update:ui_y")
      end function

      function xx_vr_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_y
      integer :: i0,i1,i2
      xx_vr_y = nxx_vr_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vr_y,kxx_vr_y,"ddeigen_hrd_2update:vr_y")
      end function

      function xx_vi_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_y
      integer :: i0,i1,i2
      xx_vi_y = nxx_vi_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vi_y,kxx_vi_y,"ddeigen_hrd_2update:vi_y")
      end function
#endif
      end subroutine
!======================================================================!
!      subroutine eigen_hrd_2update_body(
!     &             ar_alias_0, ai_alias_0,
!     &             nma,
!     &             ur, ui, uyr, uyi, vr, vi, vyr, vyi, nmv,
!     &             m_size, i_base
      subroutine ddeigen_hrd_2update_body(
     &             ar_alias_0h, ar_alias_0l, ai_alias_0h, ai_alias_0l,
     &             nma,
     &             urh, url, uih, uil, uyrh, uyrl, uyih, uyil,
     &             vrh, vrl, vih, vil, vyrh, vyrl, vyih, vyil, nmv,
     &             m_size, i_base
#ifdef MEMORY1
! ur_x > ur, ui_x > ui, ur_y > uyr, ui_y > uyi
! vr_x > vr, vi_x > vi, vr_y > vyr, vi_y > vyi
     &      ,nxx_ur , nxx_ui
     &      ,nxx_uyr, nxx_uyi
     &      ,nxx_vr , nxx_vi
     &      ,nxx_vyr, nxx_vyi
#endif
     &           )
!----
!      use communication_h, only : get_loop_start
!     &               , get_loop_end
!     &               , translate_l2g
      use ddcommunication_h, only : get_loop_start
     &                            , get_loop_end
     &                            , translate_l2g
!----
!$    use omp_lib
      implicit none
!----
!      real(8), intent(inout) :: ar_alias_0(nma,*), ai_alias_0(nma,*)
!      real(8), intent(in)    :: ur (nmv,*), ui (nmv,*)
!      real(8), intent(in)    :: uyr(nmv,*), uyi(nmv,*)
!      real(8), intent(in)    :: vr (nmv,*), vi (nmv,*)
!      real(8), intent(in)    :: vyr(nmv,*), vyi(nmv,*)
      real(8), intent(inout) :: ar_alias_0h(nma,*), ai_alias_0h(nma,*)
      real(8), intent(inout) :: ar_alias_0l(nma,*), ai_alias_0l(nma,*)
      real(8), intent(in)    :: urh (nmv,*), uih (nmv,*)
      real(8), intent(in)    :: url (nmv,*), uil (nmv,*)
      real(8), intent(in)    :: uyrh(nmv,*), uyih(nmv,*)
      real(8), intent(in)    :: uyrl(nmv,*), uyil(nmv,*)
      real(8), intent(in)    :: vrh (nmv,*), vih (nmv,*)
      real(8), intent(in)    :: vrl (nmv,*), vil (nmv,*)
      real(8), intent(in)    :: vyrh(nmv,*), vyih(nmv,*)
      real(8), intent(in)    :: vyrl(nmv,*), vyil(nmv,*)
      integer, intent(in)    :: nma, nmv, m_size, i_base
!----
      integer :: j, k0, n

      integer, parameter :: nvec = 2128
      integer, parameter :: blas_chunk = 24
      integer, parameter :: blas_nvect = 1024

      include 'trd.h'

      integer :: i_1,i_2,i_3,i_4
      integer :: j_1,j_2,j_3,j_4
      integer :: ii_1,ii_2,ii_3,ii_4
      integer :: jjj_1,jjj_2,jjj_3,jjj_4
      integer :: ii_step
!----
      integer :: local_rank, local_size
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur
      integer,intent(in) :: nxx_ui
      integer,intent(in) :: nxx_uyr
      integer,intent(in) :: nxx_uyi
      integer,intent(in) :: nxx_vr
      integer,intent(in) :: nxx_vi
      integer,intent(in) :: nxx_vyr
      integer,intent(in) :: nxx_vyi
#endif
#ifdef MEMORY1
      integer :: nxx
#endif
!----
      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()
!----
      n = get_loop_end  (i_base, size_of_row,my_row)
      k0 = translate_l2g(n, size_of_row,my_row)

      jjj_2 = 1 ! get_loop_start(1,      size_of_col, my_col)
      jjj_3 = get_loop_end  (k0, size_of_col,my_col)
      ii_step = 0
      do jjj_1 = jjj_2, jjj_3, blas_nvect
         jjj_4 = min(jjj_1+blas_nvect-1, jjj_3)
         k0   = translate_l2g(jjj_1, size_of_col, my_col)
         ii_2 = get_loop_start(k0,     size_of_row, my_row)
         ii_2 = max(jjj_2,ii_2)
         ii_3 = n

         do i_1=ii_2,ii_3,blas_chunk
            i_4=min(ii_3-i_1+1,blas_chunk)
            i_3 = i_1+i_4-1
            j   = translate_l2g(i_3, size_of_row, my_row)
            j_4 = get_loop_end(j, size_of_col, my_col)
            j_4 = min(j_4,jjj_4)-jjj_1+1

            ii_step = ii_step+1
            if(mod(ii_step-1,local_size)==local_rank)then

#ifdef MEMORY1
c      nxx = xx_ur (3000,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_vyr(3010,i_1   + nmv*m_size - 1,1)
      nxx = xx_ur (3000,jjj_1 + j_4+nmv*(m_size - 1) - 1,1)
      nxx = xx_vyr(3010,i_1   + i_4+nmv*(m_size - 1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    -1.0d+00, ur (jjj_1,1), nmv,
!     &                    vyr(i_1,1), nmv,
!     &                    1.0d+00, ar_alias_0(jjj_1, i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     -1.0d+00, 0.0d+00, 
     &                     urh (jjj_1,1), url (jjj_1,1), nmv,
     &                     vyrh(i_1,1),   vyrl(i_1,1),   nmv,
     &                      1.0d+00, 0.0d+00,
     &                     ar_alias_0h(jjj_1, i_1),
     &                     ar_alias_0l(jjj_1, i_1), nma)
#ifdef MEMORY1
c      nxx = xx_ui (3020,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_vyi(3030,i_1   + nmv*m_size - 1,1)
      nxx = xx_ui (3020,jjj_1 + j_4+ nmv*(m_size - 1)- 1,1)
      nxx = xx_vyi(3030,i_1   + i_4+ nmv*(m_size - 1)- 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    -1.0d+00, ui (jjj_1,1), nmv,
!     &                    vyi(i_1,1), nmv,
!     &                    1.0d+00, ar_alias_0(jjj_1, i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     -1.0d+00, 0.0d+00,
     &                     uih (jjj_1,1), uil (jjj_1,1), nmv,
     &                     vyih(i_1,1),   vyil(i_1,1),   nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ar_alias_0h(jjj_1, i_1),
     &                     ar_alias_0l(jjj_1, i_1), nma)
#ifdef MEMORY1
c      nxx = xx_vr (3040,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_uyr(3050,i_1   + nmv*m_size - 1,1)
      nxx = xx_vr (3040,jjj_1 + j_4+nmv*(m_size-1) - 1,1)
      nxx = xx_uyr(3050,i_1   + i_4+nmv*(m_size-1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    -1.0d+00, vr (jjj_1,1), nmv,
!     &                    uyr(i_1,1), nmv,
!     &                    1.0d+00, ar_alias_0(jjj_1,i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     -1.0d+00, 0.0d+00, 
     &                     vrh (jjj_1,1), vrl (jjj_1,1), nmv,
     &                     uyrh(i_1,1),   uyrl(i_1,1),   nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ar_alias_0h(jjj_1,i_1),
     &                     ar_alias_0l(jjj_1,i_1), nma)
#ifdef MEMORY1
c      nxx = xx_vi (3060,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_uyi(3070,i_1   + nmv*m_size - 1,1)
      nxx = xx_vi (3060,jjj_1 + j_4+nmv*(m_size-1) - 1,1)
      nxx = xx_uyi(3070,i_1   + i_4+nmv*(m_size-1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    -1.0d+00, vi (jjj_1,1), nmv,
!     &                    uyi(i_1,1), nmv,
!     &                    1.0d+00, ar_alias_0(jjj_1,i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     -1.0d+00, 0.0d+00,
     &                     vih (jjj_1,1), vil (jjj_1,1), nmv,
     &                     uyih(i_1,1),   uyil(i_1,1),   nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ar_alias_0h(jjj_1,i_1),
     &                     ar_alias_0l(jjj_1,i_1), nma)

            end if

            ii_step = ii_step+1
            if(mod(ii_step-1,local_size)==local_rank)then

#ifdef MEMORY1
c      nxx = xx_ui (3080,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_vyr(3090,i_1   + nmv*m_size - 1,1)
      nxx = xx_ui (3080,jjj_1 + j_4+nmv*(m_size-1) - 1,1)
      nxx = xx_vyr(3090,i_1   + i_4+nmv*(m_size-1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    -1.0d+00, ui (jjj_1,1), nmv,
!     &                    vyr(i_1,1), nmv,
!     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     -1.0d+00, 0.0d+00,
     &                     uih (jjj_1,1), uil (jjj_1,1), nmv,
     &                     vyrh(i_1,1),   vyrl(i_1,1),   nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ai_alias_0h(jjj_1,i_1),
     &                     ai_alias_0l(jjj_1,i_1), nma)
#ifdef MEMORY1
c      nxx = xx_ur (3100,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_vyi(3110,i_1   + nmv*m_size - 1,1)
      nxx = xx_ur (3100,jjj_1 + j_4+nmv*(m_size-1) - 1,1)
      nxx = xx_vyi(3110,i_1   + i_4+nmv*(m_size-1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    1.0d+00, ur (jjj_1,1), nmv,
!     &                    vyi(i_1,1), nmv,
!     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     1.0d+00, 0.0d+00,
     &                     urh (jjj_1,1), url (jjj_1,1), nmv,
     &                     vyih(i_1,1),   vyil(i_1,1),   nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ai_alias_0h(jjj_1,i_1),
     &                     ai_alias_0l(jjj_1,i_1), nma)
#ifdef MEMORY1
c      nxx = xx_vi (3120,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_uyr(3130,i_1   + nmv*m_size - 1,1)
      nxx = xx_vi (3120,jjj_1 + j_4+nmv*(m_size-1) - 1,1)
      nxx = xx_uyr(3130,i_1   + i_4+nmv*(m_size-1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    -1.0d+00, vi (jjj_1,1), nmv,
!     &                    uyr(i_1,1), nmv,
!     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     -1.0d+00, 0.0d+00,
     &                     vih (jjj_1,1), vil (jjj_1,1), nmv,
     &                     uyrh(i_1,1),   uyrl(i_1,1), nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ai_alias_0h(jjj_1,i_1),
     &                     ai_alias_0l(jjj_1,i_1), nma)
#ifdef MEMORY1
c      nxx = xx_vr (3140,jjj_1 + nmv*m_size - 1,1)
c      nxx = xx_uyi(3150,i_1   + nmv*m_size - 1,1)
      nxx = xx_vr (3140,jjj_1 + j_4+nmv*(m_size-1) - 1,1)
      nxx = xx_uyi(3150,i_1   + i_4+nmv*(m_size-1) - 1,1)
#endif
!               call dgemm('n','t',
!     &                    j_4, i_4, m_size,
!     &                    1.0d+00, vr (jjj_1,1), nmv,
!     &                    uyi(i_1,1), nmv,
!     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call ddgemm('n','t',
     &                     j_4, i_4, m_size,
     &                     1.0d+00, 0.0d+00,
     &                     vrh (jjj_1,1), vrl (jjj_1,1), nmv,
     &                     uyih(i_1,1),   uyil(i_1,1),   nmv,
     &                     1.0d+00, 0.0d+00,
     &                     ai_alias_0h(jjj_1,i_1),
     &                     ai_alias_0l(jjj_1,i_1), nma)

            end if

         end do

      end do
!----
      return
#ifdef MEMORY1
      contains

      function xx_ur(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur
      integer :: i0,i1,i2
      xx_ur = nxx_ur + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_ur,kxx_ur,"ddeigen_hrd_2update_body:ur")
      end function

      function xx_ui(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui
      integer :: i0,i1,i2
      xx_ui = nxx_ui + i1 - 1 + (i2 - 1)*nmv 
      call accessor(i0,xx_ui,kxx_ui,"ddeigen_hrd_2update_body:ui")
      end function

      function xx_uyr(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_uyr
      integer :: i0,i1,i2
      xx_uyr = nxx_uyr + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_uyr,kxx_uyr,"ddeigen_hrd_2update_body:uyr")
      end function

      function xx_uyi(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_uyi
      integer :: i0,i1,i2
      xx_uyi = nxx_uyi + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_uyi,kxx_uyi,"ddeigen_hrd_2update_body:uyi")
      end function

      function xx_vr(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr
      integer :: i0,i1,i2
      xx_vr = nxx_vr + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_vr,kxx_vr,"ddeigen_hrd_2update_body:vr")
      end function

      function xx_vi(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi
      integer :: i0,i1,i2
      xx_vi = nxx_vi + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_vi,kxx_vi,"ddeigen_hrd_2update_body:vi")
      end function

      function xx_vyr(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vyr
      integer :: i0,i1,i2
      xx_vyr = nxx_vyr + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_vyr,kxx_vyr,"ddeigen_hrd_2update_body:vyr")
      end function

      function xx_vyi(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vyi
      integer :: i0,i1,i2
      xx_vyi = nxx_vyi + i1 - 1 + (i2 - 1)*nmv
      call accessor(i0,xx_vyi,kxx_vyi,"ddeigen_hrd_2update_body:vyi")
      end function
#endif
      end subroutine
!======================================================================!
