!       subroutine eigen_hrd_u(
!     &              ar,ai,
!     &              ur_x,ui_x,
!     &              ur_y,ui_y,
!     &              u_t,v_t,
!     &              x_root,y_root,x_pos,
!     &              n,nm,nv
       subroutine ddeigen_hrd_u(
     &              arh,arl,aih,ail,
     &              ur_xh,ur_xl,ui_xh,ui_xl,
     &              ur_yh,ur_yl,ui_yh,ui_yl,
     &              u_th,u_tl,v_th,v_tl,
     &              x_root,y_root,x_pos,
     &              n,nm,nv
#ifdef MEMORY1
! wr > ar, wi > ai
     &            ,nxx_ar,nxx_ai
     &            ,nxx_ur_x,nxx_ui_x
     &            ,nxx_ur_y,nxx_ui_y
     &            ,nxx_u_t,nxx_v_t
#endif
     &            )
!
!      use communication_h, only : send_dbl
!     &               , recv_dbl
!     &               , reduce_dbl
!     &               , bcast_dbl
!     &               , datacast_dbl
      use ddcommunication_h, only : ddsend_dbl
     &                            , ddrecv_dbl
     &                            , ddreduce_dbl
     &                            , ddbcast_dbl
     &                            , dddatacast_dbl
!
      implicit none

      integer, intent(in)    :: nm, nv, n
!      real(8), intent(in)    :: ar(1:nm)
!      real(8), intent(in)    :: ai(1:nm)
!      real(8), intent(inout) :: ur_x(1:nv), ur_y(1:nv)
!      real(8), intent(inout) :: ui_x(1:nv), ui_y(1:nv)
!      real(8), intent(inout) :: u_t(1:nv+4), v_t(1:nv+4)
      real(8), intent(in)    :: arh(1:nm), arl(1:nm)
      real(8), intent(in)    :: aih(1:nm), ail(1:nm)
      real(8), intent(inout) :: ur_xh(1:nv), ur_yh(1:nv)
      real(8), intent(inout) :: ur_xl(1:nv), ur_yl(1:nv)
      real(8), intent(inout) :: ui_xh(1:nv), ui_yh(1:nv)
      real(8), intent(inout) :: ui_xl(1:nv), ui_yl(1:nv)
      real(8), intent(inout) :: u_th(1:nv+4), v_th(1:nv+4)
      real(8), intent(inout) :: u_tl(1:nv+4), v_tl(1:nv+4)

      integer ::  j_1, j_2, j_3
      integer ::  x_root, x_pos
      integer ::  y_root

!...  real(8) ::  scale, theta
!      real(8) ::  scale(1), theta(1)
!      real(8) ::  alpha, beta, gamma(2), kappa(2)
!      real(8) ::  wk1(3), wk2(3)
      double precision scaleh(1), scalel(1)
      double precision thetah(1), thetal(1)
      double precision alphah, alphal
      double precision betah, betal
      double precision gammah(2), gammal(2)
      double precision kappah(2), kappal(2)
      double precision wk1h(3), wk1l(3)
      double precision wk2h(3), wk2l(3)
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision t_oneh, t_onel
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      include 'trd.h'
#ifdef MEMORY1
      integer,intent(in) :: nxx_ar
      integer,intent(in) :: nxx_ai
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_u_t
      integer,intent(in) :: nxx_v_t
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

      t_oneh = 1.0d+0
      t_onel = 0.0d+0

      j_2 = 1
      j_3 = n
!
! u=...
!
!     print*,"eigen_hrd_u start"
      if(y_root==my_row)then
!         scale(1) = 0.0d+00
         scaleh(1) = 0.0d+0
         scalel(1) = 0.0d+0
#ifdef MEMORY1
      nxx = xx_ar(5000,j_3)
      nxx = xx_ai(5010,j_3)
#endif
         do j_1=j_2,j_3
!            scale(1) = scale(1)+abs(ar(j_1))+abs(ai(j_1))
!<<<        tmp1 = abs(ar(j_1))
            if (arh(j_1) .lt. 0.0d+0) then
              tmp1h = -arh(j_1)
              tmp1l = -arl(j_1)
            elseif (
     +        (arh(j_1) .eq. 0.0d+0).and.
     +        (arl(j_1) .lt. 0.0d+0)) then
              tmp1h = arh(j_1)
              tmp1l = -arl(j_1)
            else
              tmp1h = arh(j_1)
              tmp1l = arl(j_1)
            endif
!>>>        tmp1 = abs(ar(j_1))
!<<<        scale(1) = scale(1) + tmp1
            t_p1 = scaleh(1) + tmp1h
            t_p2 = t_p1 - scaleh(1)
            t_q1 = t_p1
            t_q2 = (scaleh(1) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + scalel(1) + tmp1l
            scaleh(1) = t_q1 + t_q2
            scalel(1) = t_q2 - (scaleh(1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        scale(1) = scale(1) + tmp1
!<<<        tmp1 = abs(ai(j_1))
            if (aih(j_1) .lt. 0.0d+0) then
              tmp1h = -aih(j_1)
              tmp1l = -ail(j_1)
            elseif (
     +        (aih(j_1) .eq. 0.0d+0).and.
     +        (ail(j_1) .lt. 0.0d+0)) then
              tmp1h = aih(j_1)
              tmp1l = -ail(j_1)
            else
              tmp1h = aih(j_1)
              tmp1l = ail(j_1)
            endif
!>>>        tmp1 = abs(ai(j_1))
!<<<        scale(1) = scale(1) + tmp1
            t_p1 = scaleh(1) + tmp1h
            t_p2 = t_p1 - scaleh(1)
            t_q1 = t_p1
            t_q2 = (scaleh(1) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + scalel(1) + tmp1l
            scaleh(1) = t_q1 + t_q2
            scalel(1) = t_q2 - (scaleh(1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        scale(1) = scale(1) + tmp1
         enddo! j_1
!         call reduce_dbl(scale, theta, 1, mpi_comm_col)
         call ddreduce_dbl(scaleh, scalel, thetah, thetal, 1, 
     &                     mpi_comm_col)
!         if(scale(1)/=0.0d+00)then
         if(
!             (scale(1) .ne. 0.0)
     +       ((scaleh(1) .ne. 0.0d+0) .or.
     +        (scalel(1) .ne. 0.0d+0))
     &   )then
!            alpha    = 0.0d+00
!            gamma(1) = 0.0d+00
!            gamma(2) = 0.0d+00
            alphah = 0.0d+0
            alphal = 0.0d+0
            gammah(1) = 0.0d+0
            gammal(1) = 0.0d+0
            gammah(2) = 0.0d+0
            gammal(2) = 0.0d+0
#ifdef MEMORY1
      nxx = xx_ar (5020,j_3)
      nxx = xx_ai (5030,j_3)
      nxx = xx_u_t(5040,j_3)
      nxx = xx_v_t(5050,j_3)
#endif
            do j_1=j_2,j_3
!               u_t(j_1) = ar(j_1)/scale(1)
!               v_t(j_1) = ai(j_1)/scale(1)
!               alpha     = alpha+u_t(j_1)**2+v_t(j_1)**2
!<<<           u_t(j_1) = ar(j_1) / scale(1)
               t_q1 = arh(j_1) / scaleh(1)
               u_th(j_1) = scaleh(1) * t_q1
               t_u1 = 134217729.0 * scaleh(1)
               t_p1 = t_u1
     +                  - (t_u1 - scaleh(1))
               t_p2 = scaleh(1) - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               u_tl(j_1) = ((t_p1*t_r1
     +                - u_th(j_1))
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               u_tl(j_1) = u_tl(j_1) + (scalel(1)*t_q1)
               t_s1 = u_th(j_1) + u_tl(j_1)
               u_tl(j_1) = u_tl(j_1) - (t_s1 - u_th(j_1))
               u_th(j_1) = t_s1
               t_s1 = arh(j_1) - u_th(j_1)
               t_r1 = t_s1 - arh(j_1)
               t_s2 = (arh(j_1) 
     +                  - (t_s1 - t_r1))
     +                  - (u_th(j_1) + t_r1)
               t_s2 = t_s2 - u_tl(j_1)
               t_s2 = t_s2 + arl(j_1)
               t_q2 = (t_s1 + t_s2)
     +                  / scaleh(1)
               u_th(j_1) = t_q1 + t_q2
               u_tl(j_1) = t_q2
     +               - (u_th(j_1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           u_t(j_1) = ar(j_1) / scale(1)
!<<<           v_t(j_1) = ai(j_1) / scale(1)
               t_q1 = aih(j_1) / scaleh(1)
               v_th(j_1) = scaleh(1) * t_q1
               t_u1 = 134217729.0 * scaleh(1)
               t_p1 = t_u1
     +                  - (t_u1 - scaleh(1))
               t_p2 = scaleh(1) - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               v_tl(j_1) = ((t_p1*t_r1
     +                - v_th(j_1))
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               v_tl(j_1) = v_tl(j_1) + (scalel(1)*t_q1)
               t_s1 = v_th(j_1) + v_tl(j_1)
               v_tl(j_1) = v_tl(j_1) - (t_s1 - v_th(j_1))
               v_th(j_1) = t_s1
               t_s1 = aih(j_1) - v_th(j_1)
               t_r1 = t_s1 - aih(j_1)
               t_s2 = (aih(j_1) 
     +                  - (t_s1 - t_r1))
     +                  - (v_th(j_1) + t_r1)
               t_s2 = t_s2 - v_tl(j_1)
               t_s2 = t_s2 + ail(j_1)
               t_q2 = (t_s1 + t_s2)
     +                  / scaleh(1)
               v_th(j_1) = t_q1 + t_q2
               v_tl(j_1) = t_q2
     +               - (v_th(j_1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           v_t(j_1) = ai(j_1) / scale(1)
!<<<           tmp1 = u_t(j_1) * u_t(j_1)
               tmp1h = u_th(j_1) * u_th(j_1)
               t_u1 = 134217729.0 * u_th(j_1)
               t_p1 = t_u1
     +                  - (t_u1 - u_th(j_1))
               t_p2 = u_th(j_1) - t_p1
               t_u1 = 134217729.0 * u_th(j_1)
               t_r1 = t_u1
     +                  - (t_u1 - u_th(j_1))
               t_r2 = u_th(j_1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (u_th(j_1)*u_tl(j_1)
     +               + u_tl(j_1)*u_th(j_1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = u_t(j_1) * u_t(j_1)
!<<<           alpha = alpha + tmp1
               t_p1 = alphah + tmp1h
               t_p2 = t_p1 - alphah
               t_q1 = t_p1
               t_q2 = (alphah - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + alphal + tmp1l
               alphah = t_q1 + t_q2
               alphal = t_q2 - (alphah - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           alpha = alpha + tmp1
!<<<           tmp1 = v_t(j_1) * v_t(j_1)
               tmp1h = v_th(j_1) * v_th(j_1)
               t_u1 = 134217729.0 * v_th(j_1)
               t_p1 = t_u1
     +                  - (t_u1 - v_th(j_1))
               t_p2 = v_th(j_1) - t_p1
               t_u1 = 134217729.0 * v_th(j_1)
               t_r1 = t_u1
     +                  - (t_u1 - v_th(j_1))
               t_r2 = v_th(j_1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (v_th(j_1)*v_tl(j_1)
     +               + v_tl(j_1)*v_th(j_1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = v_t(j_1) * v_t(j_1)
!<<<           alpha = alpha + tmp1
               t_p1 = alphah + tmp1h
               t_p2 = t_p1 - alphah
               t_q1 = t_p1
               t_q2 = (alphah - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + alphal + tmp1l
               alphah = t_q1 + t_q2
               alphal = t_q2 - (alphah - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           alpha = alpha + tmp1
            enddo! j_1
            if(x_root==my_col)then
#ifdef MEMORY1
      nxx = xx_u_t (5060,x_pos)
      nxx = xx_v_t (5070,x_pos)
#endif
!               gamma(1) = u_t(x_pos)
!               gamma(2) = v_t(x_pos)
               gammah(1) = u_th(x_pos)
               gammal(1) = u_tl(x_pos)
               gammah(2) = v_th(x_pos)
               gammal(2) = v_tl(x_pos)
            endif
!            wk1(1) = gamma(1)
!            wk1(2) = gamma(2)
!            wk1(3) = alpha
            wk1h(1) = gammah(1)
            wk1l(1) = gammal(1)
            wk1h(2) = gammah(2)
            wk1l(2) = gammal(2)
            wk1h(3) = alphah
            wk1l(3) = alphal
!            call reduce_dbl(wk1, wk2, 3, mpi_comm_col)
            call ddreduce_dbl(wk1h, wk1l, wk2h, wk2l, 3, mpi_comm_col)
!            gamma(1) = wk1(1)
!            gamma(2) = wk1(2)
!            alpha    = wk1(3)
            gammah(1) = wk1h(1)
            gammal(1) = wk1l(1)
            gammah(2) = wk1h(2)
            gammal(2) = wk1l(2)
            alphah = wk1h(3)
            alphal = wk1l(3)
         endif
#ifdef MEMORY1
      nxx = xx_u_t (5080,x_pos+3)
      nxx = xx_v_t (5090,x_pos+3)
#endif

!         u_t(x_pos+1) = scale(1)
!         u_t(x_pos+2) = alpha
!         u_t(x_pos+3) = gamma(1)
!         v_t(x_pos+3) = gamma(2)
         u_th(x_pos+1) = scaleh(1)
         u_tl(x_pos+1) = scalel(1)
         u_th(x_pos+2) = alphah
         u_tl(x_pos+2) = alphal
         u_th(x_pos+3) = gammah(1)
         u_tl(x_pos+3) = gammal(1)
         v_th(x_pos+3) = gammah(2)
         v_tl(x_pos+3) = gammal(2)
      endif
!
      if ( nprocs >= es_cluster**2 .and.
     &       size_of_col > 1 .and. es_icnod > 1 ) then
!         call recv_dbl(u_t(1), 0, es_icnod-1, es_ccomm_world)
         call ddrecv_dbl(u_th(1), u_tl(1), 0,
     &                   es_icnod-1, es_ccomm_world)
      endif
#ifdef MEMORY1
      nxx = xx_u_t(5100,x_pos+3)
      nxx = xx_v_t(5110,x_pos+3)
#endif
!      call bcast_dbl(u_t(1), x_pos+3, y_root, mpi_comm_row)
!      call bcast_dbl(v_t(1), x_pos+3, y_root, mpi_comm_row)
      call ddbcast_dbl(u_th(1), u_tl(1), x_pos+3, y_root, mpi_comm_row)
      call ddbcast_dbl(v_th(1), v_tl(1), x_pos+3, y_root, mpi_comm_row)
      if ( nprocs >= es_cluster**2 .and.
     &       size_of_col > 1 .and. es_icnod < es_ncnod ) then
!         call send_dbl(u_t(1), 0, es_icnod+1, es_ccomm_world)
         call ddsend_dbl(u_th(1), u_tl(1), 0,
     &                   es_icnod+1, es_ccomm_world)
      endif
!
#ifdef MEMORY1
      nxx = xx_u_t(5120,x_pos+1)
#endif

!      scale(1)=u_t(x_pos+1)
      scaleh(1) = u_th(x_pos+1)
      scalel(1) = u_tl(x_pos+1)
!      if(scale(1)/=0.0d+00)then
      if(
!          (scale(1) .ne. 0.0)
     +    ((scaleh(1) .ne. 0.0d+0) .or.
     +     (scalel(1) .ne. 0.0d+0))
     &)then
!         alpha = u_t(x_pos+2)
         alphah = u_th(x_pos+2)
         alphal = u_tl(x_pos+2)
#ifdef MEMORY1
      nxx = xx_u_t(5130,x_pos+3)
      nxx = xx_v_t(5140,x_pos+3)
#endif
!         gamma(1) = u_t(x_pos+3)
!         gamma(2) = v_t(x_pos+3)
         gammah(1) = u_th(x_pos+3)
         gammal(1) = u_tl(x_pos+3)
         gammah(2) = v_th(x_pos+3)
         gammal(2) = v_tl(x_pos+3)
!         theta(1) = sqrt(alpha)
!<<<     theta(1) = sqrt(alpha)
         if (alphah.eq.0.0D+0.and.alphal.eq.0.0D+0) then
           thetah(1) = 0.0d+0
           thetal(1) = 0.0d+0
         endif
         if (alphah.lt.0.0d+0.or.
     +      (alphah.eq.0.0d+0.and.alphal.lt.0.0d+0)) then
           write(6,'(a)')
     +        'SQRT CALLED WITH NEGATIVE ARGUMENT'
           thetah(1) = 0.0d+0
           thetal(1) = 0.0d+0
           return
         endif
         t_x = 1.0D+0/sqrt(alphah)
         t_ax = alphah * t_x
!            call dd_mul(t_y1,t_y2,t_x,
!                        0.0,0.5,0.0)
             t_y1 = t_x * 0.5d+0
             t_u1 = 134217729.0 * t_x
             t_p1 = t_u1
     +                - (t_u1 - t_x)
             t_p2 = t_x - t_p1
             t_u1 = 134217729.0 * 0.5d+0
             t_r1 = t_u1
     +                - (t_u1 - 0.5d+0)
             t_r2 = 0.5d+0 - t_r1
             t_y2 = ((t_p1*t_r1
     +                - t_y1)
     +                + t_p1*t_r2
     +                + t_p2 * t_r1)
     +                + t_p2 * t_r2
             t_s1 = t_y1 + t_y2
             t_y2 = t_y2
     +                - (t_s1 - t_y1)
             t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!            call dd_mul(t_z1,t_z2,t_ax,
!                        0.0,t_ax,0.0)
             t_z1 = t_ax * t_ax
             t_u1 = 134217729.0 * t_ax
             t_p1 = t_u1
     +                - (t_u1 - t_ax)
             t_p2 = t_ax - t_p1
             t_u1 = 134217729.0 * t_ax
             t_r1 = t_u1
     +                - (t_u1 - t_ax)
             t_r2 = t_ax - t_r1
             t_z2 = ((t_p1 * t_r1
     +                - t_z1)
     +                + t_p1 * t_r2
     +                + t_p2 * t_r1)
     +                + t_p2*t_r2
             t_s1 = t_z1 + t_z2
             t_z2 = t_z2
     +                - (t_s1 - t_z1)
             t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!            call dd_sub(t_t2h,t_t2l,
!                           alphah,alphal,t_z1,t_z2)
             t_p1 = alphah - t_z1
             t_p2 = t_p1 - alphah
             t_t2l = (alphah
     +                -(t_p1 - t_p2))
     +                -(t_z1 + t_p2)
             t_t2h = t_p1
             t_t2l = t_t2l
     +                + alphal - t_z2
             t_s1 = t_t2h + t_t2l
             t_t2l = t_t2l
     +                - (t_s1 - t_t2h)
             t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!            call dd_mul(t_t1h,t_t1l,
!                        t_t2h,t_t2l,
!                        t_y1,t_y2)
             t_t1h = t_t2h * t_y1
             t_u1 = 134217729.0 * t_t2h
             t_p1 = t_u1
     +                - (t_u1 - t_t2h)
             t_p2 = t_t2h - t_p1
             t_u1 = 134217729.0 * t_y1
             t_r1 = t_u1
     +                - (t_u1 - t_y1)
             t_r2 = t_y1 - t_r1
             t_t1l = ((t_p1*t_r1
     +                - t_t1h)
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
             t_t1l = t_t1l
     +                + (t_t2h * t_y2
     +                +  t_t2l * t_y1)
             t_s1 = t_t1h + t_t1l
             t_t1l = t_t1l - (t_s1
     +                 - t_t1h)
             t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!            call dd_selfadd(t_t1h,t_t1l,
!                        t_ax,0.0)
             t_p1 = t_t1h + t_ax
             t_p2 = t_p1 - t_t1h
             t_q2 = (t_t1h
     +                - (t_p1 - t_p2))
     +                + (t_ax - t_p2)
             t_q1 = t_p1
             t_q2 = t_q2 + t_t1l
             t_t1h = t_q1 + t_q2
             t_t1l = t_q2
     +                 - (t_t1h - t_q1)
             thetah(1) = t_t1h
             thetal(1) = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     theta(1) = sqrt(alpha)
!         kappa(1) = sqrt(u_t(x_pos+3)**2+v_t(x_pos+3)**2)
!<<<     tmp1 = u_t(x_pos+3) * u_t(x_pos+3)
         tmp1h = u_th(x_pos+3) * u_th(x_pos+3)
         t_u1 = 134217729.0 * u_th(x_pos+3)
         t_p1 = t_u1
     +            - (t_u1 - u_th(x_pos+3))
         t_p2 = u_th(x_pos+3) - t_p1
         t_u1 = 134217729.0 * u_th(x_pos+3)
         t_r1 = t_u1
     +            - (t_u1 - u_th(x_pos+3))
         t_r2 = u_th(x_pos+3) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (u_th(x_pos+3)*u_tl(x_pos+3)
     +         + u_tl(x_pos+3)*u_th(x_pos+3))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = u_t(x_pos+3) * u_t(x_pos+3)
!<<<     tmp2 = v_t(x_pos+3) * v_t(x_pos+3)
         tmp2h = v_th(x_pos+3) * v_th(x_pos+3)
         t_u1 = 134217729.0 * v_th(x_pos+3)
         t_p1 = t_u1
     +            - (t_u1 - v_th(x_pos+3))
         t_p2 = v_th(x_pos+3) - t_p1
         t_u1 = 134217729.0 * v_th(x_pos+3)
         t_r1 = t_u1
     +            - (t_u1 - v_th(x_pos+3))
         t_r2 = v_th(x_pos+3) - t_r1
         tmp2l = ((t_p1*t_r1
     +           - tmp2h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp2l = tmp2l
     +         + (v_th(x_pos+3)*v_tl(x_pos+3)
     +         + v_tl(x_pos+3)*v_th(x_pos+3))
         t_s1 = tmp2h + tmp2l
         tmp2l = tmp2l - (t_s1 - tmp2h)
         tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp2 = v_t(x_pos+3) * v_t(x_pos+3)
!<<<     tmp1 = tmp1 + tmp2
         t_p1 = tmp1h + tmp2h
         t_p2 = t_p1 - tmp1h
         t_q1 = t_p1
         t_q2 = (tmp1h - (t_p1 - t_p2))
     +            + (tmp2h - t_p2)
         t_q2 = t_q2 + tmp1l + tmp2l
         tmp1h = t_q1 + t_q2
         tmp1l = t_q2 - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     tmp1 = tmp1 + tmp2
!<<<     kappa(1) = sqrt(tmp1)
         if (tmp1h.eq.0.0D+0.and.tmp1l.eq.0.0D+0) then
           kappah(1) = 0.0d+0
           kappal(1) = 0.0d+0
         endif
         if (tmp1h.lt.0.0d+0.or.
     +      (tmp1h.eq.0.0d+0.and.tmp1l.lt.0.0d+0)) then
           write(6,'(a)')
     +        'SQRT CALLED WITH NEGATIVE ARGUMENT'
           kappah(1) = 0.0d+0
           kappal(1) = 0.0d+0
           return
         endif
         t_x = 1.0D+0/sqrt(tmp1h)
         t_ax = tmp1h * t_x
!            call dd_mul(t_y1,t_y2,t_x,
!                        0.0,0.5,0.0)
             t_y1 = t_x * 0.5d+0
             t_u1 = 134217729.0 * t_x
             t_p1 = t_u1
     +                - (t_u1 - t_x)
             t_p2 = t_x - t_p1
             t_u1 = 134217729.0 * 0.5d+0
             t_r1 = t_u1
     +                - (t_u1 - 0.5d+0)
             t_r2 = 0.5d+0 - t_r1
             t_y2 = ((t_p1*t_r1
     +                - t_y1)
     +                + t_p1*t_r2
     +                + t_p2 * t_r1)
     +                + t_p2 * t_r2
             t_s1 = t_y1 + t_y2
             t_y2 = t_y2
     +                - (t_s1 - t_y1)
             t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!            call dd_mul(t_z1,t_z2,t_ax,
!                        0.0,t_ax,0.0)
             t_z1 = t_ax * t_ax
             t_u1 = 134217729.0 * t_ax
             t_p1 = t_u1
     +                - (t_u1 - t_ax)
             t_p2 = t_ax - t_p1
             t_u1 = 134217729.0 * t_ax
             t_r1 = t_u1
     +                - (t_u1 - t_ax)
             t_r2 = t_ax - t_r1
             t_z2 = ((t_p1 * t_r1
     +                - t_z1)
     +                + t_p1 * t_r2
     +                + t_p2 * t_r1)
     +                + t_p2*t_r2
             t_s1 = t_z1 + t_z2
             t_z2 = t_z2
     +                - (t_s1 - t_z1)
             t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!            call dd_sub(t_t2h,t_t2l,
!                           tmp1h,tmp1l,t_z1,t_z2)
             t_p1 = tmp1h - t_z1
             t_p2 = t_p1 - tmp1h
             t_t2l = (tmp1h
     +                -(t_p1 - t_p2))
     +                -(t_z1 + t_p2)
             t_t2h = t_p1
             t_t2l = t_t2l
     +                + tmp1l - t_z2
             t_s1 = t_t2h + t_t2l
             t_t2l = t_t2l
     +                - (t_s1 - t_t2h)
             t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!            call dd_mul(t_t1h,t_t1l,
!                        t_t2h,t_t2l,
!                        t_y1,t_y2)
             t_t1h = t_t2h * t_y1
             t_u1 = 134217729.0 * t_t2h
             t_p1 = t_u1
     +                - (t_u1 - t_t2h)
             t_p2 = t_t2h - t_p1
             t_u1 = 134217729.0 * t_y1
             t_r1 = t_u1
     +                - (t_u1 - t_y1)
             t_r2 = t_y1 - t_r1
             t_t1l = ((t_p1*t_r1
     +                - t_t1h)
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
             t_t1l = t_t1l
     +                + (t_t2h * t_y2
     +                +  t_t2l * t_y1)
             t_s1 = t_t1h + t_t1l
             t_t1l = t_t1l - (t_s1
     +                 - t_t1h)
             t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!            call dd_selfadd(t_t1h,t_t1l,
!                        t_ax,0.0)
             t_p1 = t_t1h + t_ax
             t_p2 = t_p1 - t_t1h
             t_q2 = (t_t1h
     +                - (t_p1 - t_p2))
     +                + (t_ax - t_p2)
             t_q1 = t_p1
             t_q2 = t_q2 + t_t1l
             t_t1h = t_q1 + t_q2
             t_t1l = t_q2
     +                 - (t_t1h - t_q1)
             kappah(1) = t_t1h
             kappal(1) = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     kappa(1) = sqrt(tmp1)
!         ur_x(j_2:j_3) = u_t(j_2:j_3)
!         ui_x(j_2:j_3) = v_t(j_2:j_3)
         ur_xh(j_2:j_3) = u_th(j_2:j_3)
         ur_xl(j_2:j_3) = u_tl(j_2:j_3)
         ui_xh(j_2:j_3) = v_th(j_2:j_3)
         ui_xl(j_2:j_3) = v_tl(j_2:j_3)
         if(x_root==my_col)then
#ifdef MEMORY1
      nxx = xx_ur_x(5150,j_3)
      nxx = xx_ui_x(5160,j_3)
      nxx = xx_u_t (5170,j_3)
      nxx = xx_v_t (5180,j_3)
#endif
!            if(kappa(1)/=0.0d+00)then
            if(
!                (kappa(1) .ne. 0.0)
     +          ((kappah(1) .ne. 0.0d+0) .or.
     +           (kappal(1) .ne. 0.0d+0))
     &      )then
!               kappa(2) = 1.0d+00+theta(1)/kappa(1)
!<<<           tmp1 = theta(1) / kappa(1)
               t_q1 = thetah(1) / kappah(1)
               tmp1h = kappah(1) * t_q1
               t_u1 = 134217729.0 * kappah(1)
               t_p1 = t_u1
     +                  - (t_u1 - kappah(1))
               t_p2 = kappah(1) - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               tmp1l = ((t_p1*t_r1
     +                - tmp1h)
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               tmp1l = tmp1l + (kappal(1)*t_q1)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
               t_s1 = thetah(1) - tmp1h
               t_r1 = t_s1 - thetah(1)
               t_s2 = (thetah(1) 
     +                  - (t_s1 - t_r1))
     +                  - (tmp1h + t_r1)
               t_s2 = t_s2 - tmp1l
               t_s2 = t_s2 + thetal(1)
               t_q2 = (t_s1 + t_s2)
     +                  / kappah(1)
               tmp1h = t_q1 + t_q2
               tmp1l = t_q2
     +               - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tmp1 = theta(1) / kappa(1)
!<<<           kappa(2) = t_one + tmp1
               t_p1 = t_oneh + tmp1h
               t_p2 = t_p1 - t_oneh
               kappah(2) = t_p1
               kappal(2) = (t_oneh - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
               kappal(2) = kappal(2) + t_onel + tmp1l
               t_s1 = kappah(2) + kappal(2)
               kappal(2) = kappal(2) - (t_s1 - kappah(2))
               kappah(2) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>           kappa(2) = t_one + tmp1
            else
!               kappa(2) = 1.0d+00
               kappah(2) = 1.0d+0
               kappal(2) = 0.0d+0
            endif
!            ur_x(x_pos) = kappa(2)*ur_x(x_pos)
!            ui_x(x_pos) = kappa(2)*ui_x(x_pos)
!<<<        ur_x(x_pos) = kappa(2) * ur_x(x_pos)
            t_ch = kappah(2) * ur_xh(x_pos)
            t_u1 = 134217729.0 * kappah(2)
            t_p1 = t_u1
     +               - (t_u1 - kappah(2))
            t_p2 = kappah(2) - t_p1
            t_u1 = 134217729.0 * ur_xh(x_pos)
            t_r1 = t_u1
     +               - (t_u1 - ur_xh(x_pos))
            t_r2 = ur_xh(x_pos) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (kappah(2)*ur_xl(x_pos)
     +               +  kappal(2)*ur_xh(x_pos))
            t_s1 = t_ch + t_cl
            ur_xl(x_pos) = t_cl - (t_s1 - t_ch)
            ur_xh(x_pos) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ur_x(x_pos) = kappa(2) * ur_x(x_pos)
!<<<        ui_x(x_pos) = kappa(2) * ui_x(x_pos)
            t_ch = kappah(2) * ui_xh(x_pos)
            t_u1 = 134217729.0 * kappah(2)
            t_p1 = t_u1
     +               - (t_u1 - kappah(2))
            t_p2 = kappah(2) - t_p1
            t_u1 = 134217729.0 * ui_xh(x_pos)
            t_r1 = t_u1
     +               - (t_u1 - ui_xh(x_pos))
            t_r2 = ui_xh(x_pos) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (kappah(2)*ui_xl(x_pos)
     +               +  kappal(2)*ui_xh(x_pos))
            t_s1 = t_ch + t_cl
            ui_xl(x_pos) = t_cl - (t_s1 - t_ch)
            ui_xh(x_pos) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        ui_x(x_pos) = kappa(2) * ui_x(x_pos)
         endif
#ifdef MEMORY1
      nxx = xx_ur_y(5190,x_pos)
      nxx = xx_ur_x(5200,x_pos)
      nxx = xx_u_t (5210,x_pos)
      nxx = xx_v_t (5220,x_pos)
      nxx = xx_ui_y(5230,x_pos)
      nxx = xx_ui_x(5240,x_pos)
#endif
!         call datacast_dbl(ur_y,ur_x, u_t,v_t, x_pos)
!         call datacast_dbl(ui_y,ui_x, u_t,v_t, x_pos)
         call dddatacast_dbl(ur_yh,ur_yl,ur_xh,ur_xl,
     &                       u_th,u_tl,v_th,v_tl,x_pos)
         call dddatacast_dbl(ui_yh,ui_yl,ui_xh,ui_xl,
     &                       u_th,u_tl,v_th,v_tl,x_pos)
!         beta = alpha+kappa(1)*theta(1)
!<<<     tmp1 = kappa(1) * theta(1)
         tmp1h = kappah(1) * thetah(1)
         t_u1 = 134217729.0 * kappah(1)
         t_p1 = t_u1
     +            - (t_u1 - kappah(1))
         t_p2 = kappah(1) - t_p1
         t_u1 = 134217729.0 * thetah(1)
         t_r1 = t_u1
     +            - (t_u1 - thetah(1))
         t_r2 = thetah(1) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (kappah(1)*thetal(1)
     +         + kappal(1)*thetah(1))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = kappa(1) * theta(1)
!<<<     beta = alpha + tmp1
         t_p1 = alphah + tmp1h
         t_p2 = t_p1 - alphah
         betah = t_p1
         betal = (alphah - (t_p1 - t_p2))
     +         + (tmp1h - t_p2)
         betal = betal + alphal + tmp1l
         t_s1 = betah + betal
         betal = betal - (t_s1 - betah)
         betah = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>     beta = alpha + tmp1
         if(x_root==my_col)then
!            u_t(x_pos  ) = ur_x(x_pos  )
!            v_t(x_pos  ) = ui_x(x_pos  )
            u_th(x_pos) = ur_xh(x_pos)
            u_tl(x_pos) = ur_xl(x_pos)
            v_th(x_pos) = ui_xh(x_pos)
            v_tl(x_pos) = ui_xl(x_pos)
         endif
#ifdef MEMORY1
      nxx = xx_v_t(5250,x_pos+4)
      nxx = xx_u_t(5260,x_pos+4)
#endif
!         v_t(x_pos+1) = gamma(1)
!         v_t(x_pos+2) = gamma(2)
!         v_t(x_pos+3) = kappa(1)
!         v_t(x_pos+4) = kappa(2)
!         u_t(x_pos+1) = scale(1)
!         u_t(x_pos+2) = alpha
!         u_t(x_pos+3) = theta(1)
!         u_t(x_pos+4) = beta
         v_th(x_pos+1) = gammah(1)
         v_tl(x_pos+1) = gammal(1)
         v_th(x_pos+2) = gammah(2)
         v_tl(x_pos+2) = gammal(2)
         v_th(x_pos+3) = kappah(1)
         v_tl(x_pos+3) = kappal(1)
         v_th(x_pos+4) = kappah(2)
         v_tl(x_pos+4) = kappal(2)
         u_th(x_pos+1) = scaleh(1)
         u_tl(x_pos+1) = scalel(1)
         u_th(x_pos+2) = alphah
         u_tl(x_pos+2) = alphal
         u_th(x_pos+3) = thetah(1)
         u_tl(x_pos+3) = thetal(1)
         u_th(x_pos+4) = betah
         u_tl(x_pos+4) = betal
      endif
!     print*,"eigen_hrd_u passed"

      return
#ifdef MEMORY1
      contains

      function xx_ar(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ar
      integer :: i0,i1
      xx_ar = nxx_ar + i1 - 1
      call accessor(i0,xx_ar,kxx_ar,"ddeigen_hrd_u:ar")
      end function

      function xx_ai(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ai
      integer :: i0,i1
      xx_ai = nxx_ai + i1 - 1
      call accessor(i0,xx_ai,kxx_ai,"ddeigen_hrd_u:ai")
      end function

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_u:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_u:ui_x")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_u:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_u:ui_y")
      end function

      function xx_u_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_u_t
      integer :: i0,i1
      xx_u_t = nxx_u_t + i1 - 1
      call accessor(i0,xx_u_t,kxx_u_t,"ddeigen_hrd_u:u_t")
      end function

      function xx_v_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_v_t
      integer :: i0,i1
      xx_v_t = nxx_v_t + i1 - 1
      call accessor(i0,xx_v_t,kxx_v_t,"ddeigen_hrd_u:v_t")
      end function
#endif
      end subroutine
