!      subroutine eigen_hrd_v(
!     &             ur_x,ui_x, vr_x,vi_x, vr_y,vi_y,
!     &             u_t,v_t,
!     &             beta, n,x_pos,nv
      subroutine ddeigen_hrd_v(
     &             ur_xh,ur_xl,ui_xh,ui_xl,
     &             vr_xh,vr_xl,vi_xh,vi_xl,
     &             vr_yh,vr_yl,vi_yh,vi_yl,
     &             u_th,u_tl,v_th,v_tl,
     &             betah, betal, n, x_pos, nv
#ifdef MEMORY1
! ur_t > u_t, vr_t > v_t
     &             ,nxx_ur_x,nxx_ui_x
     &             ,nxx_vr_x,nxx_vi_x
     &             ,nxx_vr_y,nxx_vi_y
     &             ,nxx_u_t,nxx_v_t
#endif
     &           )
!----
!      use communication_h, only : reduce_dbl
!     &               , datacast_dbl
      use ddcommunication_h, only : ddreduce_dbl
     &                            , dddatacast_dbl
!----
      implicit none

      integer, intent(in)    :: n, nv
      real(8), intent(in)    :: ur_xh(1:nv), ur_xl(1:nv)
      real(8), intent(inout) :: vr_xh(1:nv), vr_yh(1:nv)
      real(8), intent(inout) :: vr_xl(1:nv), vr_yl(1:nv)
      real(8), intent(in)    :: ui_xh(1:nv), ui_xl(1:nv)
      real(8), intent(inout) :: vi_xh(1:nv), vi_yh(1:nv)
      real(8), intent(inout) :: vi_xl(1:nv), vi_yl(1:nv)
!---  real(8), intent(inout) :: u_t(1:nv),  v_t(1:nv)
      real(8), intent(inout) :: u_th(1:*),  v_th(1:*)
      real(8), intent(inout) :: u_tl(1:*),  v_tl(1:*)

!---- real(8) ::  alpha, beta, gamma, theta
!      real(8) ::  alpha(1), gamma(1), theta(1)
!      real(8) ::  beta
      double precision alphah(1), alphal(1)
      double precision gammah(1), gammal(1)
      double precision thetah(1), thetal(1)
      double precision betah, betal
      integer ::  j_1, j_2, j_3, x_pos

!      real(8) ::  vr_x0, vi_x0
!      real(8) ::  ur_x0, ui_x0
      double precision vr_x0h, vr_x0l
      double precision vi_x0h, vi_x0l
      double precision ur_x0h, ur_x0l
      double precision ui_x0h, ui_x0l

      include 'trd.h'
#ifdef MEMORY1
! ur_t > u_t, vr_t > v_t
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_vr_y
      integer,intent(in) :: nxx_vi_y
      integer,intent(in) :: nxx_u_t
      integer,intent(in) :: nxx_v_t
#endif
#ifdef MEMORY1
      integer :: nxx
#endif
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

!----
      j_2 = 1
      j_3 = n
!----
! v':= v-((u,v)/2|u|^2)u
!----
!      alpha(1) = 0.0d+00
!      gamma(1) = 0.0d+00
      alphah(1) = 0.0d+0
      alphal(1) = 0.0d+0
      gammah(1) = 0.0d+0
      gammal(1) = 0.0d+0
#ifdef MEMORY1
      nxx = xx_vr_x(6000,j_3)
      nxx = xx_vi_x(6010,j_3)
#endif
      do j_1=j_2,j_3
!         gamma(1) = gamma(1)+abs(vr_x(j_1))
!     &                      +abs(vi_x(j_1))
!<<<     tmp1 = abs(vr_x(j_1))
         if (vr_xh(j_1) .lt. 0.0d+0) then
           tmp1h = -vr_xh(j_1)
           tmp1l = -vr_xl(j_1)
         elseif (
     +     (vr_xh(j_1) .eq. 0.0d+0).and.
     +     (vr_xl(j_1) .lt. 0.0d+0)) then
           tmp1h = vr_xh(j_1)
           tmp1l = -vr_xl(j_1)
         else
           tmp1h = vr_xh(j_1)
           tmp1l = vr_xl(j_1)
         endif
!>>>     tmp1 = abs(vr_x(j_1))
!<<<     gamma(1) = gamma(1) + tmp1
         t_p1 = gammah(1) + tmp1h
         t_p2 = t_p1 - gammah(1)
         t_q1 = t_p1
         t_q2 = (gammah(1) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + gammal(1) + tmp1l
         gammah(1) = t_q1 + t_q2
         gammal(1) = t_q2 - (gammah(1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     gamma(1) = gamma(1) + tmp1
!<<<     tmp1 = abs(vi_x(j_1))
         if (vi_xh(j_1) .lt. 0.0d+0) then
           tmp1h = -vi_xh(j_1)
           tmp1l = -vi_xl(j_1)
         elseif (
     +     (vi_xh(j_1) .eq. 0.0d+0).and.
     +     (vi_xl(j_1) .lt. 0.0d+0)) then
           tmp1h = vi_xh(j_1)
           tmp1l = -vi_xl(j_1)
         else
           tmp1h = vi_xh(j_1)
           tmp1l = vi_xl(j_1)
         endif
!>>>     tmp1 = abs(vi_x(j_1))
!<<<     gamma(1) = gamma(1) + tmp1
         t_p1 = gammah(1) + tmp1h
         t_p2 = t_p1 - gammah(1)
         t_q1 = t_p1
         t_q2 = (gammah(1) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + gammal(1) + tmp1l
         gammah(1) = t_q1 + t_q2
         gammal(1) = t_q2 - (gammah(1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     gamma(1) = gamma(1) + tmp1
      enddo! j_1
!      call reduce_dbl(gamma, theta, 1, mpi_comm_col)
      call ddreduce_dbl(gammah, gammal, thetah, thetal, 1, mpi_comm_col)
!      if(gamma(1)/=0.0d+00)then
      if(
!          (gamma(1) .ne. 0.0)
     +    ((gammah(1) .ne. 0.0d+0) .or.
     +     (gammal(1) .ne. 0.0d+0))
     &)then
#ifdef MEMORY1
      nxx = xx_vr_x(6020,j_3)
      nxx = xx_vi_x(6030,j_3)
      nxx = xx_ur_x(6040,j_3)
      nxx = xx_ui_x(6050,j_3)
#endif
         do j_1=j_2,j_3
!            vr_x0 = vr_x(j_1)
!            vi_x0 = vi_x(j_1)
!            vr_x0 = vr_x0/(gamma(1)*beta)
!            vi_x0 = vi_x0/(gamma(1)*beta)
!            ur_x0 = ur_x(j_1)
!            ui_x0 = ui_x(j_1)
            vr_x0h = vr_xh(j_1)
            vr_x0l = vr_xl(j_1)
            vi_x0h = vi_xh(j_1)
            vi_x0l = vi_xl(j_1)
!<<<        tmp1 = gamma(1) * beta
            tmp1h = gammah(1) * betah
            t_u1 = 134217729.0 * gammah(1)
            t_p1 = t_u1
     +               - (t_u1 - gammah(1))
            t_p2 = gammah(1) - t_p1
            t_u1 = 134217729.0 * betah
            t_r1 = t_u1
     +               - (t_u1 - betah)
            t_r2 = betah - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (gammah(1)*betal
     +            + gammal(1)*betah)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = gamma(1) * beta
!<<<        vr_x0 = vr_x0 / tmp1
            t_q1 = vr_x0h / tmp1h
            t_ch = tmp1h * t_q1
            t_u1 = 134217729.0 * tmp1h
            t_p1 = t_u1
     +               - (t_u1 - tmp1h)
            t_p2 = tmp1h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +               + t_p1*t_r2
     +               + t_p2*t_r1)
     +               + t_p2*t_r2
            t_cl = t_cl
     +               + (tmp1l * t_q1)
            t_s1 = t_ch + t_cl
            t_cl = t_cl
     +               - (t_s1 - t_ch)
            t_ch = t_s1
            t_s1 = vr_x0h - t_ch
            t_r1 = t_s1 - vr_x0h
            t_s2 = (vr_x0h
     +               - (t_s1 - t_r1))
     +               - (t_ch + t_r1)
            t_s2 = t_s2 - t_cl
            t_s2 = t_s2 + vr_x0l
            t_q2 = (t_s1 + t_s2)
     +               / tmp1h
            vr_x0h = t_q1 + t_q2
            vr_x0l = t_q2
     +            - (vr_x0h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        vr_x0 = vr_x0 / tmp1
!<<<        tmp1 = gamma(1) * beta
            tmp1h = gammah(1) * betah
            t_u1 = 134217729.0 * gammah(1)
            t_p1 = t_u1
     +               - (t_u1 - gammah(1))
            t_p2 = gammah(1) - t_p1
            t_u1 = 134217729.0 * betah
            t_r1 = t_u1
     +               - (t_u1 - betah)
            t_r2 = betah - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (gammah(1)*betal
     +            + gammal(1)*betah)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = gamma(1) * beta
!<<<        vi_x0 = vi_x0 / tmp1
            t_q1 = vi_x0h / tmp1h
            t_ch = tmp1h * t_q1
            t_u1 = 134217729.0 * tmp1h
            t_p1 = t_u1
     +               - (t_u1 - tmp1h)
            t_p2 = tmp1h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +               + t_p1*t_r2
     +               + t_p2*t_r1)
     +               + t_p2*t_r2
            t_cl = t_cl
     +               + (tmp1l * t_q1)
            t_s1 = t_ch + t_cl
            t_cl = t_cl
     +               - (t_s1 - t_ch)
            t_ch = t_s1
            t_s1 = vi_x0h - t_ch
            t_r1 = t_s1 - vi_x0h
            t_s2 = (vi_x0h
     +               - (t_s1 - t_r1))
     +               - (t_ch + t_r1)
            t_s2 = t_s2 - t_cl
            t_s2 = t_s2 + vi_x0l
            t_q2 = (t_s1 + t_s2)
     +               / tmp1h
            vi_x0h = t_q1 + t_q2
            vi_x0l = t_q2
     +            - (vi_x0h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        vi_x0 = vi_x0 / tmp1
            ur_x0h = ur_xh(j_1)
            ur_x0l = ur_xl(j_1)
            ui_x0h = ui_xh(j_1)
            ui_x0l = ui_xl(j_1)
!            alpha(1)     = alpha(1)+vr_x0*ur_x0
!     &                             +vi_x0*ui_x0
!<<<        tmp1 = vr_x0 * ur_x0
            tmp1h = vr_x0h * ur_x0h
            t_u1 = 134217729.0 * vr_x0h
            t_p1 = t_u1
     +               - (t_u1 - vr_x0h)
            t_p2 = vr_x0h - t_p1
            t_u1 = 134217729.0 * ur_x0h
            t_r1 = t_u1
     +               - (t_u1 - ur_x0h)
            t_r2 = ur_x0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (vr_x0h*ur_x0l
     +            + vr_x0l*ur_x0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = vr_x0 * ur_x0
!<<<        alpha(1) = alpha(1) + tmp1
            t_p1 = alphah(1) + tmp1h
            t_p2 = t_p1 - alphah(1)
            t_q1 = t_p1
            t_q2 = (alphah(1) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + alphal(1) + tmp1l
            alphah(1) = t_q1 + t_q2
            alphal(1) = t_q2 - (alphah(1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        alpha(1) = alpha(1) + tmp1
!<<<        tmp1 = vi_x0 * ui_x0
            tmp1h = vi_x0h * ui_x0h
            t_u1 = 134217729.0 * vi_x0h
            t_p1 = t_u1
     +               - (t_u1 - vi_x0h)
            t_p2 = vi_x0h - t_p1
            t_u1 = 134217729.0 * ui_x0h
            t_r1 = t_u1
     +               - (t_u1 - ui_x0h)
            t_r2 = ui_x0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (vi_x0h*ui_x0l
     +            + vi_x0l*ui_x0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = vi_x0 * ui_x0
!<<<        alpha(1) = alpha(1) + tmp1
            t_p1 = alphah(1) + tmp1h
            t_p2 = t_p1 - alphah(1)
            t_q1 = t_p1
            t_q2 = (alphah(1) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + alphal(1) + tmp1l
            alphah(1) = t_q1 + t_q2
            alphal(1) = t_q2 - (alphah(1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        alpha(1) = alpha(1) + tmp1
!            vr_x(j_1) = vr_x0
!            vi_x(j_1) = vi_x0
            vr_xh(j_1) = vr_x0h
            vr_xl(j_1) = vr_x0l
            vi_xh(j_1) = vi_x0h
            vi_xl(j_1) = vi_x0l
         enddo! j_1
!         alpha(1) = alpha(1)*gamma(1)
!<<<     alpha(1) = alpha(1) * gamma(1)
         t_ch = alphah(1) * gammah(1)
         t_u1 = 134217729.0 * alphah(1)
         t_p1 = t_u1
     +            - (t_u1 - alphah(1))
         t_p2 = alphah(1) - t_p1
         t_u1 = 134217729.0 * gammah(1)
         t_r1 = t_u1
     +            - (t_u1 - gammah(1))
         t_r2 = gammah(1) - t_r1
         t_cl = ((t_p1*t_r1
     +            - t_ch)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         t_cl = t_cl
     +            + (alphah(1)*gammal(1)
     +            +  alphal(1)*gammah(1))
         t_s1 = t_ch + t_cl
         alphal(1) = t_cl - (t_s1 - t_ch)
         alphah(1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>     alpha(1) = alpha(1) * gamma(1)
      endif
!      call reduce_dbl(alpha, theta, 1, mpi_comm_col)
      call ddreduce_dbl(alphah, alphal, thetah, thetal, 1, mpi_comm_col)
!      alpha(1) = alpha(1)/(beta+beta)
!<<<  tmp1 = beta + beta
      t_p1 = betah + betah
      t_p2 = t_p1 - betah
      tmp1h = t_p1
      tmp1l = (betah - (t_p1 - t_p2))
     +      + (betah - t_p2)
      tmp1l = tmp1l + betal + betal
      t_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (t_s1 - tmp1h)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>  tmp1 = beta + beta
!<<<  alpha(1) = alpha(1) / tmp1
      t_q1 = alphah(1) / tmp1h
      t_ch = tmp1h * t_q1
      t_u1 = 134217729.0 * tmp1h
      t_p1 = t_u1
     +         - (t_u1 - tmp1h)
      t_p2 = tmp1h - t_p1
      t_u1 = 134217729.0 * t_q1
      t_r1 = t_u1
     +         - (t_u1 - t_q1)
      t_r2 = t_q1 - t_r1
      t_cl = ((t_p1*t_r1
     +         - t_ch)
     +         + t_p1*t_r2
     +         + t_p2*t_r1)
     +         + t_p2*t_r2
      t_cl = t_cl
     +         + (tmp1l * t_q1)
      t_s1 = t_ch + t_cl
      t_cl = t_cl
     +         - (t_s1 - t_ch)
      t_ch = t_s1
      t_s1 = alphah(1) - t_ch
      t_r1 = t_s1 - alphah(1)
      t_s2 = (alphah(1)
     +         - (t_s1 - t_r1))
     +         - (t_ch + t_r1)
      t_s2 = t_s2 - t_cl
      t_s2 = t_s2 + alphal(1)
      t_q2 = (t_s1 + t_s2)
     +         / tmp1h
      alphah(1) = t_q1 + t_q2
      alphal(1) = t_q2
     +      - (alphah(1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  alpha(1) = alpha(1) / tmp1
#ifdef MEMORY1
      nxx = xx_vr_x(6060,j_3)
      nxx = xx_ur_x(6070,j_3)
      nxx = xx_vi_x(6080,j_3)
      nxx = xx_ui_x(6090,j_3)
#endif
      do j_1=j_2,j_3
!         vr_x0 = vr_x(j_1)
!         ur_x0 = ur_x(j_1)
!         vi_x0 = vi_x(j_1)
!         ui_x0 = ui_x(j_1)
      vr_x0h = vr_xh(j_1)
      vr_x0l = vr_xl(j_1)
      ur_x0h = ur_xh(j_1)
      ur_x0l = ur_xl(j_1)
      vi_x0h = vi_xh(j_1)
      vi_x0l = vi_xl(j_1)
      ui_x0h = ui_xh(j_1)
      ui_x0l = ui_xl(j_1)
!         vr_x0 = gamma(1)*vr_x0-alpha(1)*ur_x0
!         vi_x0 = gamma(1)*vi_x0-alpha(1)*ui_x0
!<<<  tmp1 = gamma(1) * vr_x0
      tmp1h = gammah(1) * vr_x0h
      t_u1 = 134217729.0 * gammah(1)
      t_p1 = t_u1
     +         - (t_u1 - gammah(1))
      t_p2 = gammah(1) - t_p1
      t_u1 = 134217729.0 * vr_x0h
      t_r1 = t_u1
     +         - (t_u1 - vr_x0h)
      t_r2 = vr_x0h - t_r1
      tmp1l = ((t_p1*t_r1
     +        - tmp1h)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      tmp1l = tmp1l
     +      + (gammah(1)*vr_x0l
     +      + gammal(1)*vr_x0h)
      t_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (t_s1 - tmp1h)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp1 = gamma(1) * vr_x0
!<<<  tmp2 = alpha(1) * ur_x0
      tmp2h = alphah(1) * ur_x0h
      t_u1 = 134217729.0 * alphah(1)
      t_p1 = t_u1
     +         - (t_u1 - alphah(1))
      t_p2 = alphah(1) - t_p1
      t_u1 = 134217729.0 * ur_x0h
      t_r1 = t_u1
     +         - (t_u1 - ur_x0h)
      t_r2 = ur_x0h - t_r1
      tmp2l = ((t_p1*t_r1
     +        - tmp2h)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      tmp2l = tmp2l
     +      + (alphah(1)*ur_x0l
     +      + alphal(1)*ur_x0h)
      t_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (t_s1 - tmp2h)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = alpha(1) * ur_x0
!<<<  vr_x0 = tmp1 - tmp2
      t_p1 = tmp1h - tmp2h
      t_p2 = t_p1 - tmp1h
      vr_x0h = t_p1
      vr_x0l = (tmp1h - (t_p1 - t_p2))
     +         - (tmp2h + t_p2)
      vr_x0l = vr_x0l + tmp1l - tmp2l
      t_s1 = vr_x0h + vr_x0l
      vr_x0l = vr_x0l - (t_s1 - vr_x0h)
      vr_x0h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>  vr_x0 = tmp1 - tmp2
!<<<  tmp1 = gamma(1) * vi_x0
      tmp1h = gammah(1) * vi_x0h
      t_u1 = 134217729.0 * gammah(1)
      t_p1 = t_u1
     +         - (t_u1 - gammah(1))
      t_p2 = gammah(1) - t_p1
      t_u1 = 134217729.0 * vi_x0h
      t_r1 = t_u1
     +         - (t_u1 - vi_x0h)
      t_r2 = vi_x0h - t_r1
      tmp1l = ((t_p1*t_r1
     +        - tmp1h)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      tmp1l = tmp1l
     +      + (gammah(1)*vi_x0l
     +      + gammal(1)*vi_x0h)
      t_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (t_s1 - tmp1h)
      tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp1 = gamma(1) * vi_x0
!<<<  tmp2 = alpha(1) * ui_x0
      tmp2h = alphah(1) * ui_x0h
      t_u1 = 134217729.0 * alphah(1)
      t_p1 = t_u1
     +         - (t_u1 - alphah(1))
      t_p2 = alphah(1) - t_p1
      t_u1 = 134217729.0 * ui_x0h
      t_r1 = t_u1
     +         - (t_u1 - ui_x0h)
      t_r2 = ui_x0h - t_r1
      tmp2l = ((t_p1*t_r1
     +        - tmp2h)
     +        + t_p1 * t_r2
     +        + t_p2 * t_r1)
     +        + t_p2 * t_r2
      tmp2l = tmp2l
     +      + (alphah(1)*ui_x0l
     +      + alphal(1)*ui_x0h)
      t_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (t_s1 - tmp2h)
      tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = alpha(1) * ui_x0
!<<<  vi_x0 = tmp1 - tmp2
      t_p1 = tmp1h - tmp2h
      t_p2 = t_p1 - tmp1h
      vi_x0h = t_p1
      vi_x0l = (tmp1h - (t_p1 - t_p2))
     +         - (tmp2h + t_p2)
      vi_x0l = vi_x0l + tmp1l - tmp2l
      t_s1 = vi_x0h + vi_x0l
      vi_x0l = vi_x0l - (t_s1 - vi_x0h)
      vi_x0h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>  vi_x0 = tmp1 - tmp2
!         vr_x(j_1) = vr_x0
!         vi_x(j_1) = vi_x0
      vr_xh(j_1) = vr_x0h
      vr_xl(j_1) = vr_x0l
      vi_xh(j_1) = vi_x0h
      vi_xl(j_1) = vi_x0l
      enddo! j_1
#ifdef MEMORY1
      nxx = xx_vr_y(6100,x_pos)
      nxx = xx_vr_x(6110,x_pos)
      nxx = xx_u_t (6120,x_pos)
      nxx = xx_v_t (6130,x_pos)
      nxx = xx_vi_y(6140,x_pos)
      nxx = xx_vi_x(6150,x_pos)
#endif
!      call datacast_dbl(vr_y(1), vr_x(1), u_t(1), v_t(1), x_pos)
!      call datacast_dbl(vi_y(1), vi_x(1), u_t(1), v_t(1), x_pos)
      call dddatacast_dbl(vr_yh(1), vr_yl(1), vr_xh(1), vr_xl(1),
     &                    u_th(1), u_tl(1), v_th(1), v_tl(1), x_pos)
      call dddatacast_dbl(vi_yh(1), vi_yl(1), vi_xh(1), vi_xl(1),
     &                    u_th(1), u_tl(1), v_th(1), v_tl(1), x_pos)

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_v:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_v:ui_x")
      end function

      function xx_vr_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1
      xx_vr_x = nxx_vr_x + i1 - 1
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_v:vr_x")
      end function

      function xx_vi_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1
      xx_vi_x = nxx_vi_x + i1 - 1
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_v:vi_x")
      end function

      function xx_vr_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_y
      integer :: i0,i1
      xx_vr_y = nxx_vr_y + i1 - 1
      call accessor(i0,xx_vr_y,kxx_vr_y,"ddeigen_hrd_v:vr_y")
      end function

      function xx_vi_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_y
      integer :: i0,i1
      xx_vi_y = nxx_vi_y + i1 - 1
      call accessor(i0,xx_vi_y,kxx_vi_y,"ddeigen_hrd_v:vi_y")
      end function

      function xx_u_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_u_t
      integer :: i0,i1
      xx_u_t = nxx_u_t + i1 - 1
      call accessor(i0,xx_u_t,kxx_u_t,"ddeigen_hrd_v:u_t")
      end function

      function xx_v_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_v_t
      integer :: i0,i1
      xx_v_t = nxx_v_t + i1 - 1
      call accessor(i0,xx_v_t,kxx_v_t,"ddeigen_hrd_v:v_t")
      end function
#endif
      end subroutine

