!      use communication_h, only : eigen_init
!     &                , eigen_free
!     &                , cyc1d_cyc2d
!     &                , cyc2d_cyc1d
      use ddcommunication_h, only : eigen_init
     &                            , eigen_free
     &                            , ddcyc1d_cyc2d
     &                            , ddcyc2d_cyc1d

      implicit double precision (a-h,o-z)

!      real(8), allocatable :: a(:,:),ai(:,:)
!      real(8), allocatable :: as(:,:),asi(:,:)
!      real(8), pointer :: b(:),bi(:),c(:),ci(:),w(:)
      real(8), allocatable :: ah(:,:),aih(:,:)
      real(8), allocatable :: al(:,:),ail(:,:)
      real(8), allocatable :: ash(:,:),asih(:,:)
      real(8), allocatable :: asl(:,:),asil(:,:)
      real(8), pointer :: bh(:),bih(:),ch(:),cih(:),wh(:)
      real(8), pointer :: bl(:),bil(:),cl(:),cil(:),wl(:)
      logical :: iexist
      !!!!!!
      !real(16) :: q
      !!!!!!
!
      include 'mpif.h'
      include 'trd.h'
!
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_world,i$inod,ierr)
      call mpi_comm_size(mpi_comm_world,i$nnod,ierr)
*
      n=100
C*DebugWrite02-start*****************************************
c ....行列サイズをファイルから読み込み
      inquire(file='matsize.txt',exist=iexist)
      if(iexist) then
         open(999,file='matsize.txt',err=20)
         read(999,*,err=20) matsize
         n = matsize
 20      continue
         close(999)
      endif
!      if(myrank==1)then
         write(*,*) 'matrix size = ',n
!      endif
C*DebugWrite02-end*******************************************
      m=32
      nm=(n/2)*2+1
!      allocate( a(n,n), ai(n,n) )
!      allocate( as(n,n), asi(n,n) )
!      allocate(
!     &         b((nm)*((n-1)/i$nnod+1+nm+1)),
!     &         bi((nm)*((n-1)/i$nnod+1+nm+1)),
!     &         c((nm)*((n-1)/i$nnod+1+nm+1)),
!     &         ci((nm)*((n-1)/i$nnod+1+nm+1)),
!     &         w(nm),
!     &         stat=istat )
      allocate( ah(n,n), aih(n,n), al(n,n), ail(n,n) )
      allocate( ash(n,n), asih(n,n), asl(n,n), asil(n,n) )
      allocate(
     &         bh((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bih((nm)*((n-1)/i$nnod+1+nm+1)),
     &         ch((nm)*((n-1)/i$nnod+1+nm+1)),
     &         cih((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bl((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bil((nm)*((n-1)/i$nnod+1+nm+1)),
     &         cl((nm)*((n-1)/i$nnod+1+nm+1)),
     &         cil((nm)*((n-1)/i$nnod+1+nm+1)),
     &         wh(nm), wl(nm),
     &         stat=istat )
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         stop
      endif
*
!      call matrix_set(n,a,ai)
      call ddmatrix_set(n,ah,al,aih,ail)
!      as = a
!      asi = ai
      ash = ah
      asl = al
      asih = aih
      asil = ail
!      call matrix_adjust_h(a,n,b,nm)
!      call matrix_adjust_hi(ai,n,bi,nm)
!      call eigen_h(n,b,bi,w,nm,m,0)
      call ddmatrix_adjust_h(ah,al,n,bh,bl,nm)
      call ddmatrix_adjust_hi(aih,ail,n,bih,bil,nm)
      call ddeigen_h(n,bh,bl,bih,bil,wh,wl,nm,m,0)
      !!!!!!
      !if (i$inod == 0) then
      !  open(80, file='w.dd.dat')
      !  do i=1,n
      !    q = qext(wh(i)) + qext(wl(i))
      !    write(80,'(e56.48e4)') q
      !  enddo
      !  close(80)
      !  open(80, file='xr.dd.dat')
      !  open(81, file='xi.dd.dat')
      !  do j=1,n
      !    do i=1,n
      !      q = qext(bh(i+(j-1)*nm)) + qext(bl(i+(j-1)*nm))
      !      write(80,'(e56.48e4)') q
      !      q = qext(bih(i+(j-1)*nm)) + qext(bil(i+(j-1)*nm))
      !      write(81,'(e56.48e4)') q
      !    enddo
      !  enddo
      !  close(80)
      !  close(81)
      !endif
      !!!!!!
*
      !call matrix_set(n,a,ai)
!      a = as
!      ai = asi
      ah = ash
      al = asl
      aih = asih
      ail = asil
!      call matrix_adjust_h(a,n,c,nm)
!      call matrix_adjust_hi(ai,n,ci,nm)
!      call ev_test2(c,ci,w,b,bi,n,nm)
      call ddmatrix_adjust_h(ah,al,n,ch,cl,nm)
      call ddmatrix_adjust_hi(aih,ail,n,cih,cil,nm)
      call ddev_test2(ch,cl,cih,cil,wh,wl,bh,bl,bih,bil,n,nm)
*
!      deallocate(a,ai,b,bi,c,ci,w)
      deallocate(ah,aih,bh,bih,ch,cih,wh)
      deallocate(al,ail,bl,bil,cl,cil,wl)

      call MPI_Finalize(ierr)
      end
