#include "Bdef.h"

#if (INTFACE == C_CALL)
void Cmakempiinfo(char *scope, int ConTxt, int rsrc, int csrc, int *dest ,MPI_Comm *comm,int *tag)
#else
F_VOID_FUNC makempiinfo_(F_CHAR scope,int *ConTxt, int *rsrc, int *csrc, int *dest, MPI_Comm *comm,int *tag)
#endif
/*
 *  -- V1.1 BLACS routine --
 *  University of Tennessee, May 1, 1996
 *  Written by Clint Whaley.
 *
 *  Purpose
 *  =======
 *  Broadcast/receive for general double precision arrays.
 *
 *  Arguments
 *  =========
 *
 *  SCOPE   (input) Ptr to char
 *          Limit the scope of the operation.
 *          = 'R' :   Operation is performed by a process row.
 *          = 'C' :   Operation is performed by a process column.
 *          = 'A' :   Operation is performed by all processes in grid.
 *
 *  ConTxt  (input) Ptr to int
 *          Index into MyConTxts00 (my contexts array).
 *
 *  RSRC    (input) Ptr to int
 *          The process row of the source of the matrix.
 *
 *  CSRC    (input) Ptr to int
 *          The process column of the source of the matrix.
 *
 *  DEST    (output) Ptr to int
 *          The PE number
 *
 *  COMM    (output) Ptr to int
 *          Communicator
 *
 * ------------------------------------------------------------------------
 */
{
   char tscope;
   BLACSCONTEXT *ctxt;

   int dest_,tag_;
   MPI_Comm comm_;

   MGetConTxt(Mpval(ConTxt), ctxt);
   tscope = F2C_CharTrans(scope);
   tscope = Mlowcase(tscope);
   if(tscope =='b'){
     ctxt->scp = &ctxt->ascp;
     dest_ = Mvkpnum(ctxt, Mpval(rsrc), Mpval(csrc));
   }else if(tscope =='s'){
     ctxt->scp = &ctxt->ascp;
     dest_ = ctxt->scp->Iam;
   }else{
     ctxt->scp = &ctxt->pscp;
     dest_ = Mvkpnum(ctxt, Mpval(rsrc), Mpval(csrc));
   }
   comm_ = ctxt->scp->comm;
   tag_ = PT2PTID;

   *dest = dest_;
   *comm = comm_;
   *tag  = tag_;
}
