!      SUBROUTINE PDLAED2( ICTXT, K, N, N1, NB, D, DROW, DCOL, Q, LDQ,
!     $                   RHO, Z, W, DLAMDA, Q2, LDQ2, QBUF, CTOT, PSM,
!     $                   NPCOL, INDX, INDXC, INDXP, INDCOL, COLTYP, NN,
!     $                   NN1, NN2, IB1, IB2 )
      SUBROUTINE PDDLAED2( ICTXT, K, N, N1, NB, Dh,Dl, DROW, DCOL, 
     $                    Qh,Ql, LDQ,RHOh, RHOl, Zh, Zl, Wh, Wl, 
     $                    DLAMDAh, DLAMDAl, Q2h, Q2l,LDQ2,QBUFh,QBUFl, 
     $                    CTOT, PSM, NPCOL, INDX, INDXC, INDXP,
     $                    INDCOL, COLTYP, NN, NN1, NN2, IB1, IB2 )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            DCOL, DROW, IB1, IB2, ICTXT, K, LDQ, LDQ2, N,
     $                   N1, NB, NN, NN1, NN2, NPCOL
!      DOUBLE PRECISION   RHO
      double precision RHOh, RHOl
*     ..
*     .. Array Arguments ..
      INTEGER            COLTYP( * ), CTOT( 0: NPCOL-1, 4 ),
     $                   INDCOL( N ), INDX( * ), INDXC( * ), INDXP( * ),
     $                   PSM( 0: NPCOL-1, 4 )
!      DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ),
!     $                   Q2( LDQ2, * ), QBUF( * ), W( * ), Z( * )
      double precision Dh(*), Dl(*)
      double precision DLAMDAh(*), DLAMDAl(*)
      double precision Qh(LDQ,*), Ql(LDQ,*)
      double precision Q2h(LDQ2,*), Q2l(LDQ2,*)
      double precision QBUFh(*), QBUFl(*)
      double precision Wh(*), Wl(*)
      double precision Zh(*), Zl(*)
!... MPI ...
#ifdef COMM_MPI
      include 'mpif.h'
      integer ireq(2),ierr
      integer DEST,TAG,COMM
      integer myrank
      integer status(MPI_STATUS_SIZE)
      double precision QBUFF(2*N), SBUFF(2*N)
#endif
!.............
*     ..
*
*  Purpose
*  =======
*
*  PDLAED2 sorts the two sets of eigenvalues together into a single
*  sorted set.  Then it tries to deflate the size of the problem.
*  There are two ways in which deflation can occur:  when two or more
*  eigenvalues are close together or if there is a tiny entry in the
*  Z vector.  For each such occurrence the order of the related secular
*  equation problem is reduced by one.
*
*  Arguments
*  =========
*
*  ICTXT  (global input) INTEGER
*         The BLACS context handle, indicating the global context of
*         the operation on the matrix. The context itself is global.
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  N1     (input) INTEGER
*         The location of the last eigenvalue in the leading sub-matrix.
*         min(1,N) < N1 < N.
*
*  NB      (global input) INTEGER
*          The blocking factor used to distribute the columns of the
*          matrix. NB >= 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  DROW   (global input) INTEGER
*          The process row over which the first row of the matrix D is
*          distributed. 0 <= DROW < NPROW.
*
*  DCOL   (global input) INTEGER
*          The process column over which the first column of the
*          matrix D is distributed. 0 <= DCOL < NPCOL.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,NQ).
*
*  RHO    (global input/output) DOUBLE PRECISION
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         PDLAED3.
*
*  Z      (global input) DOUBLE PRECISION array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  DLAMDA (global output) DOUBLE PRECISION array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (global output) DOUBLE PRECISION array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Q2     (output) DOUBLE PRECISION array, dimension (LDQ2, NQ)
*         A copy of the first K eigenvectors which will be used by
*
*  LDQ2    (input) INTEGER
*         The leading dimension of the array Q2.
*
*  QBUF   (workspace) DOUBLE PRECISION array, dimension 3*N
*
*  CTOT   (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  PSM    (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  NPCOL   (global input) INTEGER
*          The total number of columns over which the distributed
*           submatrix is distributed.
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDXC  (output) INTEGER array, dimension (N)
*         The permutation used to arrange the columns of the deflated
*         Q matrix into three groups:  the first group contains non-zero
*         elements only at and above N1, the second contains
*         non-zero elements only below N1, and the third is dense.
*
*  INDXP  (workspace) INTEGER array, dimension (N)
*         The permutation used to place deflated values of D at the end
*         of the array.  INDXP(1:K) points to the nondeflated D-values
*         and INDXP(K+1:N) points to the deflated eigenvalues.
*
*  INDCOL (workspace) INTEGER array, dimension (N)
*
*  COLTYP (workspace/output) INTEGER array, dimension (N)
*         During execution, a label which will indicate which of the
*         following types a column in the Q2 matrix is:
*         1 : non-zero in the upper half only;
*         2 : dense;
*         3 : non-zero in the lower half only;
*         4 : deflated.
*
*  NN     (global output) INTEGER, the order of matrix U, (PDLAED1).
*  NN1    (global output) INTEGER, the order of matrix Q1, (PDLAED1).
*  NN2    (global output) INTEGER, the order of matrix Q2, (PDLAED1).
*  IB1    (global output) INTEGER, pointeur on Q1, (PDLAED1).
*  IB2    (global output) INTEGER, pointeur on Q2, (PDLAED1).
*
*  =====================================================================
*
*     .. Parameters ..
!      DOUBLE PRECISION   MONE, ZERO, ONE, TWO, EIGHT
      double precision MONEh, MONEl
      double precision ZEROh, ZEROl
      double precision ONEh, ONEl
      double precision TWOh, TWOl
      double precision EIGHTh, EIGHTl
!      PARAMETER          ( MONE = -1.0D0, ZERO = 0.0D0, ONE = 1.0D0,
!     $                   TWO = 2.0D0, EIGHT = 8.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COL, CT, I, IAM, IE1, IE2, IMAX, INFO, J, JJQ2,
     $                   JJS, JMAX, JS, K2, MYCOL, MYROW, N1P1, N2, NJ,
     $                   NJCOL, NJJ, NP, NPROCS, NPROW, PJ, PJCOL, PJJ
!      DOUBLE PRECISION   C, EPS, S, T, TAU, TOL
      double precision Ch, Cl
      double precision EPSh, EPSl
      double precision Sh, Sl
      double precision Th, Tl
      double precision TAUh, TAUl
      double precision TOLh, TOLl
#ifdef COMM_BLACS2
      double precision Q(2*N)
      double precision QBUF(6*N)
#endif
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX, INDXG2L, INDXL2G, NUMROC
!      DOUBLE PRECISION   DLAPY2, PDLAMCH
!      EXTERNAL           IDAMAX, INDXG2L, INDXL2G, NUMROC, PDLAMCH,
!     $                   DLAPY2
      EXTERNAL           IDAMAX, INDXG2L, INDXL2G, NUMROC
*     ..
*     .. External Subroutines ..
!      EXTERNAL           BLACS_GRIDINFO, BLACS_PINFO, DCOPY, DGERV2D,
!     $                   DGESD2D, DLAPST, DROT, DSCAL, INFOG1L
      EXTERNAL           BLACS_GRIDINFO, BLACS_PINFO, DDCOPY, DGERV2D,
     $                   DGESD2D, DDLAPST, DDROT, DDSCAL, INFOG1L,
     $                   PDDLAMCH, DDLAPY2
!... MPI ...
#ifdef COMM_MPI
      EXTERNAL           MakeMpiInfo
#endif
!.............
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, MOD, SQRT
*     ..
*     .. External Functions ..
*     ..
*     .. Local Arrays ..
      INTEGER            PTT( 4 )
*     ..
*     .. Executable Statements ..
*
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision tmp3h, tmp3l
      double precision tmp4h, tmp4l
      double precision tmp5h, tmp5l
      double precision tmp6h, tmp6l
!     tmp vars
      double precision T_ch, T_cl
      double precision T_p1, T_p2
      double precision T_q1, T_q2
      double precision T_r1, T_r2
      double precision T_s1, T_s2
      double precision T_t1, T_t2
      double precision T_u1, T_u2
      double precision T_x1, T_x2
      double precision T_y1, T_y2
      double precision T_z1, T_z2
      double precision T_x, T_ax
      double precision T_t1h, T_t1l
      double precision T_t2h, T_t2l
!... MPI ...
#ifdef COMM_MPI
      Call mpi_comm_rank(MPI_COMM_WORLD,myrank,ierr)
#endif
!...........

      MONEh = -1.0d0
      MONEl = 0.0d+0
      ZEROh = 0.0d+0
      ZEROl = 0.0d+0
      ONEh = 1.0d+0
      ONEl = 0.0d+0
      TWOh = 2.0d0
      TWOl = 0.0d+0
      EIGHTh = 8.0d0
      EIGHTl = 0.0d+0

*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      CALL BLACS_PINFO( IAM, NPROCS )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      NP = NUMROC( N, NB, MYROW, DROW, NPROW )
*
      N2 = N - N1
      N1P1 = N1 + 1
*
      IF(
!         RHO.LT.ZERO 
!       (RHO .lt. ZERO)
     + ((RHOh .lt. ZEROh) .or.
     +  ((RHOh .eq. ZEROh) .and.
     +   (RHOl .lt. ZEROl)))
     $   ) THEN
!         CALL DSCAL( N2, MONE, Z( N1P1 ), 1 )
         CALL DDSCAL( N2, MONEh, MONEl, Zh( N1P1 ), Zl( N1P1 ), 1 )
      END IF
*
*     Normalize z so that norm(z) = 1.  Since z is the concatenation of
*     two normalized vectors, norm2(z) = sqrt(2).
*
!      T = ONE / SQRT( TWO )
!<<<  tmp1 = sqrt(TWO)
      if (TWOh.eq.0.0D+0.and.TWOl.eq.0.0D+0) then
        tmp1h = 0.0d+0
        tmp1l = 0.0d+0
      endif
      if (TWOh.lt.0.0d+0.or.
     +   (TWOh.eq.0.0d+0.and.TWOl.lt.0.0d+0)) then
        write(6,'(a)')
     +     'SQRT CALLED WITH NEGATIVE ARGUMENT'
        tmp1h = 0.0d+0
        tmp1l = 0.0d+0
        return
      endif
      T_x = 1.0D+0/sqrt(TWOh)
      T_ax = TWOh * T_x
!         call dd_mul(T_y1,T_y2,T_x,
!                     0.0,0.5,0.0)
          T_y1 = T_x * 0.5d+0
          T_u1 = 134217729.0 * T_x
          T_p1 = T_u1
     +             - (T_u1 - T_x)
          T_p2 = T_x - T_p1
          T_u1 = 134217729.0 * 0.5d+0
          T_r1 = T_u1
     +             - (T_u1 - 0.5d+0)
          T_r2 = 0.5d+0 - T_r1
          T_y2 = ((T_p1*T_r1
     +             - T_y1)
     +             + T_p1*T_r2
     +             + T_p2 * T_r1)
     +             + T_p2 * T_r2
          T_s1 = T_y1 + T_y2
          T_y2 = T_y2
     +             - (T_s1 - T_y1)
          T_y1 = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_mul(T_z1,T_z2,T_ax,
!                     0.0,T_ax,0.0)
          T_z1 = T_ax * T_ax
          T_u1 = 134217729.0 * T_ax
          T_p1 = T_u1
     +             - (T_u1 - T_ax)
          T_p2 = T_ax - T_p1
          T_u1 = 134217729.0 * T_ax
          T_r1 = T_u1
     +             - (T_u1 - T_ax)
          T_r2 = T_ax - T_r1
          T_z2 = ((T_p1 * T_r1
     +             - T_z1)
     +             + T_p1 * T_r2
     +             + T_p2 * T_r1)
     +             + T_p2*T_r2
          T_s1 = T_z1 + T_z2
          T_z2 = T_z2
     +             - (T_s1 - T_z1)
          T_z1 = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_sub(T_t2h,T_t2l,
!                           TWOh,TWOl,T_z1,T_z2)
          T_p1 = TWOh - T_z1
          T_p2 = T_p1 - TWOh
          T_t2l = (TWOh
     +             -(T_p1 - T_p2))
     +             -(T_z1 + T_p2)
          T_t2h = T_p1
          T_t2l = T_t2l
     +             + TWOl - T_z2
          T_s1 = T_t2h + T_t2l
          T_t2l = T_t2l
     +             - (T_s1 - T_t2h)
          T_t2h = T_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!         call dd_mul(T_t1h,T_t1l,
!                     T_t2h,T_t2l,
!                     T_y1,T_y2)
          T_t1h = T_t2h * T_y1
          T_u1 = 134217729.0 * T_t2h
          T_p1 = T_u1
     +             - (T_u1 - T_t2h)
          T_p2 = T_t2h - T_p1
          T_u1 = 134217729.0 * T_y1
          T_r1 = T_u1
     +             - (T_u1 - T_y1)
          T_r2 = T_y1 - T_r1
          T_t1l = ((T_p1*T_r1
     +             - T_t1h)
     +             + T_p1*T_r2
     +             + T_p2*T_r1)
     +             + T_p2*T_r2
          T_t1l = T_t1l
     +             + (T_t2h * T_y2
     +             +  T_t2l * T_y1)
          T_s1 = T_t1h + T_t1l
          T_t1l = T_t1l - (T_s1
     +              - T_t1h)
          T_t1h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!         call dd_selfadd(T_t1h,T_t1l,
!                     T_ax,0.0)
          T_p1 = T_t1h + T_ax
          T_p2 = T_p1 - T_t1h
          T_q2 = (T_t1h
     +             - (T_p1 - T_p2))
     +             + (T_ax - T_p2)
          T_q1 = T_p1
          T_q2 = T_q2 + T_t1l
          T_t1h = T_q1 + T_q2
          T_t1l = T_q2
     +              - (T_t1h - T_q1)
          tmp1h = T_t1h
          tmp1l = T_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>  tmp1 = sqrt(TWO)
!<<<  T = ONE / tmp1
      T_q1 = ONEh / tmp1h
      Th = tmp1h * T_q1
      T_u1 = 134217729.0 * tmp1h
      T_p1 = T_u1
     +         - (T_u1 - tmp1h)
      T_p2 = tmp1h - T_p1
      T_u1 = 134217729.0 * T_q1
      T_r1 = T_u1
     +         - (T_u1 - T_q1)
      T_r2 = T_q1 - T_r1
      Tl = ((T_p1*T_r1
     +       - Th)
     +       + T_p1*T_r2
     +       + T_p2*T_r1)
     +       + T_p2*T_r2
      Tl = Tl + (tmp1l*T_q1)
      T_s1 = Th + Tl
      Tl = Tl - (T_s1 - Th)
      Th = T_s1
      T_s1 = ONEh - Th
      T_r1 = T_s1 - ONEh
      T_s2 = (ONEh 
     +         - (T_s1 - T_r1))
     +         - (Th + T_r1)
      T_s2 = T_s2 - Tl
      T_s2 = T_s2 + ONEl
      T_q2 = (T_s1 + T_s2)
     +         / tmp1h
      Th = T_q1 + T_q2
      Tl = T_q2
     +      - (Th - T_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  T = ONE / tmp1
!      CALL DSCAL( N, T, Z, 1 )
      CALL DDSCAL( N, Th, Tl, Zh,Zl, 1 )
*
*     RHO = ABS( norm(z)**2 * RHO )
*
!      RHO = ABS( TWO*RHO )
!<<<  tmp1 = TWO * RHO
      tmp1h = TWOh * RHOh
      T_u1 = 134217729.0 * TWOh
      T_p1 = T_u1
     +         - (T_u1 - TWOh)
      T_p2 = TWOh - T_p1
      T_u1 = 134217729.0 * RHOh
      T_r1 = T_u1
     +         - (T_u1 - RHOh)
      T_r2 = RHOh - T_r1
      tmp1l = ((T_p1*T_r1
     +        - tmp1h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp1l = tmp1l
     +      + (TWOh*RHOl
     +      + TWOl*RHOh)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp1 = TWO * RHO
!<<<  RHO = abs(tmp1)
      if (tmp1h .lt. 0.0d+0) then
        RHOh = -tmp1h
        RHOl = -tmp1l
      elseif (
     +  (tmp1h .eq. 0.0d+0).and.
     +  (tmp1l .lt. 0.0d+0)) then
        RHOh = tmp1h
        RHOl = -tmp1l
      else
        RHOh = tmp1h
        RHOl = tmp1l
      endif
!>>>  RHO = abs(tmp1)
*
*     Calculate the allowable deflation tolerance
*
      IMAX = IDAMAX( N, Zh, 1 )
      JMAX = IDAMAX( N, Dh, 1 )
!      EPS = PDLAMCH( ICTXT, 'Epsilon' )
       CALL PDDLAMCH( ICTXT, 'Epsilon', EPSh, EPSl )
!      TOL = EIGHT*EPS*MAX( ABS( D( JMAX ) ), ABS( Z( IMAX ) ) )
!<<<  tmp1 = abs(D(JMAX))
      if (Dh(JMAX) .lt. 0.0d+0) then
        tmp1h = -Dh(JMAX)
        tmp1l = -Dl(JMAX)
      elseif (
     +  (Dh(JMAX) .eq. 0.0d+0).and.
     +  (Dl(JMAX) .lt. 0.0d+0)) then
        tmp1h = Dh(JMAX)
        tmp1l = -Dl(JMAX)
      else
        tmp1h = Dh(JMAX)
        tmp1l = Dl(JMAX)
      endif
!>>>  tmp1 = abs(D(JMAX))
!<<<  tmp2 = abs(Z(IMAX))
      if (Zh(IMAX) .lt. 0.0d+0) then
        tmp2h = -Zh(IMAX)
        tmp2l = -Zl(IMAX)
      elseif (
     +  (Zh(IMAX) .eq. 0.0d+0).and.
     +  (Zl(IMAX) .lt. 0.0d+0)) then
        tmp2h = Zh(IMAX)
        tmp2l = -Zl(IMAX)
      else
        tmp2h = Zh(IMAX)
        tmp2l = Zl(IMAX)
      endif
!>>>  tmp2 = abs(Z(IMAX))
      IF(
!       (tmp1 .ge. tmp2)
     + ((tmp1h .gt. tmp2h) .or.
     +  ((tmp1h .eq. tmp2h) .and.
     +   (tmp1l .ge. tmp2l)))
     &   ) THEN
      tmp3h = tmp1h
      tmp3l = tmp1l
      ELSE IF(
!       (tmp2 .gt. tmp1)
     + ((tmp2h .gt. tmp1h) .or.
     +  ((tmp2h .eq. tmp1h) .and.
     +   (tmp2l .gt. tmp1l)))
     &   ) THEN
      tmp3h = tmp2h
      tmp3l = tmp2l
      END IF
!<<<  tmp4 = EPS * tmp3
      tmp4h = EPSh * tmp3h
      T_u1 = 134217729.0 * EPSh
      T_p1 = T_u1
     +         - (T_u1 - EPSh)
      T_p2 = EPSh - T_p1
      T_u1 = 134217729.0 * tmp3h
      T_r1 = T_u1
     +         - (T_u1 - tmp3h)
      T_r2 = tmp3h - T_r1
      tmp4l = ((T_p1*T_r1
     +        - tmp4h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp4l = tmp4l
     +      + (EPSh*tmp3l
     +      + EPSl*tmp3h)
      T_s1 = tmp4h + tmp4l
      tmp4l = tmp4l - (T_s1 - tmp4h)
      tmp4h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp4 = EPS * tmp3
!<<<  TOL = EIGHT * tmp4
      TOLh = EIGHTh * tmp4h
      T_u1 = 134217729.0 * EIGHTh
      T_p1 = T_u1
     +         - (T_u1 - EIGHTh)
      T_p2 = EIGHTh - T_p1
      T_u1 = 134217729.0 * tmp4h
      T_r1 = T_u1
     +         - (T_u1 - tmp4h)
      T_r2 = tmp4h - T_r1
      TOLl = ((T_p1*T_r1
     +        - TOLh)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      TOLl = TOLl
     +      + (EIGHTh*tmp4l
     +      + EIGHTl*tmp4h)
      T_s1 = TOLh + TOLl
      TOLl = TOLl - (T_s1 - TOLh)
      TOLh = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  TOL = EIGHT * tmp4

*
*     If the rank-1 modifier is small enough, no more needs to be done
*     except to reorganize Q so that its columns correspond with the
*     elements in D.
*
!<<<  tmp1 = abs(Z(IMAX))
      if (Zh(IMAX) .lt. 0.0d+0) then
        tmp1h = -Zh(IMAX)
        tmp1l = -Zl(IMAX)
      elseif (
     +  (Zh(IMAX) .eq. 0.0d+0).and.
     +  (Zl(IMAX) .lt. 0.0d+0)) then
        tmp1h = Zh(IMAX)
        tmp1l = -Zl(IMAX)
      else
        tmp1h = Zh(IMAX)
        tmp1l = Zl(IMAX)
      endif
!>>>  tmp1 = abs(Z(IMAX))
!<<<  tmp2 = RHO * tmp1
      tmp2h = RHOh * tmp1h
      T_u1 = 134217729.0 * RHOh
      T_p1 = T_u1
     +         - (T_u1 - RHOh)
      T_p2 = RHOh - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (RHOh*tmp1l
     +      + RHOl*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = RHO * tmp1
      IF(
!        RHO*ABS( Z( IMAX ) ).LE.TOL
!       (tmp2 .le. TOL)
     + ((tmp2h .lt. TOLh) .or.
     +  ((tmp2h .eq. TOLh) .and.
     +   (tmp2l .le. TOLl)))
     &   ) THEN
         K = 0
         GO TO 220
      END IF
*
*     If there are multiple eigenvalues then the problem deflates.  Here
*     the number of equal eigenvalues are found.  As each equal
*     eigenvalue is found, an elementary reflector is computed to rotate
*     the corresponding eigensubspace so that the corresponding
*     components of Z are zero in this new basis.
*
*
!      CALL DLAPST( 'I', N, D, INDX, INFO )
      CALL DDLAPST( 'I', N, Dh, Dl, INDX, INFO )
*
      DO 10 I = 1, N1
         COLTYP( I ) = 1
   10 CONTINUE
      DO 20 I = N1P1, N
         COLTYP( I ) = 3
   20 CONTINUE
      COL = DCOL
      DO 40 I = 1, N, NB
         DO 30 J = 0, NB - 1
            IF( I+J.LE.N )
     $         INDCOL( I+J ) = COL
   30    CONTINUE
         COL = MOD( COL+1, NPCOL )
   40 CONTINUE
*
      K = 0
      K2 = N + 1
      DO 50 J = 1, N
         NJ = INDX( J )
!<<<  tmp1 = abs(Z(NJ))
      if (Zh(NJ) .lt. 0.0d+0) then
        tmp1h = -Zh(NJ)
        tmp1l = -Zl(NJ)
      elseif (
     +  (Zh(NJ) .eq. 0.0d+0).and.
     +  (Zl(NJ) .lt. 0.0d+0)) then
        tmp1h = Zh(NJ)
        tmp1l = -Zl(NJ)
      else
        tmp1h = Zh(NJ)
        tmp1l = Zl(NJ)
      endif
!>>>  tmp1 = abs(Z(NJ))
!<<<  tmp2 = RHO * tmp1
      tmp2h = RHOh * tmp1h
      T_u1 = 134217729.0 * RHOh
      T_p1 = T_u1
     +         - (T_u1 - RHOh)
      T_p2 = RHOh - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (RHOh*tmp1l
     +      + RHOl*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = RHO * tmp1
         IF(
!            RHO*ABS( Z( NJ ) ).LE.TOL
!       (tmp2 .le. TOL)
     + ((tmp2h .lt. TOLh) .or.
     +  ((tmp2h .eq. TOLh) .and.
     +   (tmp2l .le. TOLl)))
     $    ) THEN
*
*           Deflate due to small z component.
*
            K2 = K2 - 1
            COLTYP( NJ ) = 4
            INDXP( K2 ) = NJ
            IF( J.EQ.N )
     $         GO TO 80
         ELSE
            PJ = NJ
            GO TO 60
         END IF
   50 CONTINUE
   60 CONTINUE
      J = J + 1
      NJ = INDX( J )
      IF( J.GT.N )
     $   GO TO 80
!<<<  tmp1 = abs(Z(NJ))
      if (Zh(NJ) .lt. 0.0d+0) then
        tmp1h = -Zh(NJ)
        tmp1l = -Zl(NJ)
      elseif (
     +  (Zh(NJ) .eq. 0.0d+0).and.
     +  (Zl(NJ) .lt. 0.0d+0)) then
        tmp1h = Zh(NJ)
        tmp1l = -Zl(NJ)
      else
        tmp1h = Zh(NJ)
        tmp1l = Zl(NJ)
      endif
!>>>  tmp1 = abs(Z(NJ))
!<<<  tmp2 = RHO * tmp1
      tmp2h = RHOh * tmp1h
      T_u1 = 134217729.0 * RHOh
      T_p1 = T_u1
     +         - (T_u1 - RHOh)
      T_p2 = RHOh - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (RHOh*tmp1l
     +      + RHOl*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = RHO * tmp1
      IF(
!         RHO*ABS( Z( NJ ) ).LE.TOL
!       (tmp2 .le. TOL)
     + ((tmp2h .lt. TOLh) .or.
     +  ((tmp2h .eq. TOLh) .and.
     +   (tmp2l .le. TOLl)))
     $    ) THEN
*
*        Deflate due to small z component.
*
         K2 = K2 - 1
         COLTYP( NJ ) = 4
         INDXP( K2 ) = NJ
      ELSE
*
*        Check if eigenvalues are close enough to allow deflation.
*
!         S = Z( PJ )
      Sh = Zh(PJ)
      Sl = Zl(PJ)
!         C = Z( NJ )
      Ch = Zh(NJ)
      Cl = Zl(NJ)
*
*        Find sqrt(a**2+b**2) without overflow or
*        destructive underflow.
*
!         TAU = DLAPY2( C, S )
          CALL DDLAPY2( Ch, Cl, Sh, Sl, TAUh, TAUl )
!         T = D( NJ ) - D( PJ )
!<<<  T = D(NJ) - D(PJ)
      T_p1 = Dh(NJ) - Dh(PJ)
      T_p2 = T_p1 - Dh(NJ)
      Th = T_p1
      Tl = (Dh(NJ) - (T_p1 - T_p2))
     +         - (Dh(PJ) + T_p2)
      Tl = Tl + Dl(NJ) - Dl(PJ)
      T_s1 = Th + Tl
      Tl = Tl - (T_s1 - Th)
      Th = T_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>  T = D(NJ) - D(PJ)
!         C = C / TAU
!<<<  C = C / TAU
      T_q1 = Ch / TAUh
      T_ch = TAUh * T_q1
      T_u1 = 134217729.0 * TAUh
      T_p1 = T_u1
     +         - (T_u1 - TAUh)
      T_p2 = TAUh - T_p1
      T_u1 = 134217729.0 * T_q1
      T_r1 = T_u1
     +         - (T_u1 - T_q1)
      T_r2 = T_q1 - T_r1
      T_cl = ((T_p1*T_r1
     +         - T_ch)
     +         + T_p1*T_r2
     +         + T_p2*T_r1)
     +         + T_p2*T_r2
      T_cl = T_cl
     +         + (TAUl * T_q1)
      T_s1 = T_ch + T_cl
      T_cl = T_cl
     +         - (T_s1 - T_ch)
      T_ch = T_s1
      T_s1 = Ch - T_ch
      T_r1 = T_s1 - Ch
      T_s2 = (Ch
     +         - (T_s1 - T_r1))
     +         - (T_ch + T_r1)
      T_s2 = T_s2 - T_cl
      T_s2 = T_s2 + Cl
      T_q2 = (T_s1 + T_s2)
     +         / TAUh
      Ch = T_q1 + T_q2
      Cl = T_q2
     +      - (Ch - T_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  C = C / TAU
!         S = -S / TAU
!<<<  tmp1 = S / TAU
      T_q1 = Sh / TAUh
      tmp1h = TAUh * T_q1
      T_u1 = 134217729.0 * TAUh
      T_p1 = T_u1
     +         - (T_u1 - TAUh)
      T_p2 = TAUh - T_p1
      T_u1 = 134217729.0 * T_q1
      T_r1 = T_u1
     +         - (T_u1 - T_q1)
      T_r2 = T_q1 - T_r1
      tmp1l = ((T_p1*T_r1
     +       - tmp1h)
     +       + T_p1*T_r2
     +       + T_p2*T_r1)
     +       + T_p2*T_r2
      tmp1l = tmp1l + (TAUl*T_q1)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
      T_s1 = Sh - tmp1h
      T_r1 = T_s1 - Sh
      T_s2 = (Sh 
     +         - (T_s1 - T_r1))
     +         - (tmp1h + T_r1)
      T_s2 = T_s2 - tmp1l
      T_s2 = T_s2 + Sl
      T_q2 = (T_s1 + T_s2)
     +         / TAUh
      tmp1h = T_q1 + T_q2
      tmp1l = T_q2
     +      - (tmp1h - T_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>  tmp1 = S / TAU
!<<<  S = -tmp1
      Sh = -tmp1h
      Sl = -tmp1l
!>>>  S = -tmp1
!<<<  tmp1 = T * C
      tmp1h = Th * Ch
      T_u1 = 134217729.0 * Th
      T_p1 = T_u1
     +         - (T_u1 - Th)
      T_p2 = Th - T_p1
      T_u1 = 134217729.0 * Ch
      T_r1 = T_u1
     +         - (T_u1 - Ch)
      T_r2 = Ch - T_r1
      tmp1l = ((T_p1*T_r1
     +        - tmp1h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp1l = tmp1l
     +      + (Th*Cl
     +      + Tl*Ch)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp1 = T * C
!<<<  tmp2 = tmp1 * S
      tmp2h = tmp1h * Sh
      T_u1 = 134217729.0 * tmp1h
      T_p1 = T_u1
     +         - (T_u1 - tmp1h)
      T_p2 = tmp1h - T_p1
      T_u1 = 134217729.0 * Sh
      T_r1 = T_u1
     +         - (T_u1 - Sh)
      T_r2 = Sh - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (tmp1h*Sl
     +      + tmp1l*Sh)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = tmp1 * S
!<<<  tmp3 = abs(tmp2)
      if (tmp2h .lt. 0.0d+0) then
        tmp3h = -tmp2h
        tmp3l = -tmp2l
      elseif (
     +  (tmp2h .eq. 0.0d+0).and.
     +  (tmp2l .lt. 0.0d+0)) then
        tmp3h = tmp2h
        tmp3l = -tmp2l
      else
        tmp3h = tmp2h
        tmp3l = tmp2l
      endif
!>>>  tmp3 = abs(tmp2)
         IF( 
!            ABS( T*C*S ).LE.TOL
!       (tmp3 .le. TOL)
     + ((tmp3h .lt. TOLh) .or.
     +  ((tmp3h .eq. TOLh) .and.
     +   (tmp3l .le. TOLl)))
     $      ) THEN
*
*           Deflation is possible.
*
!            Z( NJ ) = TAU
!            Z( PJ ) = ZERO
      Zh(NJ) = TAUh
      Zl(NJ) = TAUl
      Zh(PJ) = ZEROh
      Zl(PJ) = ZEROl
            IF( COLTYP( NJ ).NE.COLTYP( PJ ) )
     $         COLTYP( NJ ) = 2
            COLTYP( PJ ) = 4
            CALL INFOG1L( NJ, NB, NPCOL, MYCOL, DCOL, NJJ, NJCOL )
            CALL INFOG1L( PJ, NB, NPCOL, MYCOL, DCOL, PJJ, PJCOL )
            IF( INDCOL( PJ ).EQ.INDCOL( NJ ) .AND. MYCOL.EQ.NJCOL ) THEN
!               CALL DROT( NP, Q( 1, PJJ ), 1, Q( 1, NJJ ), 1, C, S )
               CALL DDROT( NP, Qh( 1, PJJ ), Ql( 1, PJJ ), 1, 
     &                     Qh( 1, NJJ ), Ql( 1, NJJ ), 1, Ch, Cl, 
     &                     Sh, Sl )
            ELSE IF( MYCOL.EQ.PJCOL ) THEN
!               CALL DGESD2D( ICTXT, NP, 1, Q( 1, PJJ ), NP, MYROW,
!     $                       NJCOL )
!               CALL DGERV2D( ICTXT, NP, 1, QBUF, NP, MYROW, NJCOL )
#ifdef COMM_MPI
               CALL MakeMpiInfo('A',ICTXT,MYROW,NJCOL,DEST,COMM,TAG)
               CALL MPI_Isend_dd(Qh(1,PJJ),Ql(1,PJJ),SBUFF,NP,
     $              MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
               CALL MPI_Wait_dd(SBUFF,ireq,status,ierr)

               CALL MakeMpiInfo('A',ICTXT,MYROW,NJCOL,DEST,COMM,TAG)
               QBUFF(1:NP)      = QBUFh(1:NP)
               QBUFF(1+NP:2*NP) = QBUFl(1:NP)
               CALL MPI_Irecv_dd(QBUFF,NP,
     $              MPI_DOUBLE_PRECISION,DEST,TAG,COMM,ireq,ierr)
               CALL MPI_WaitIrecv_dd(QBUFh,QBUFl,QBUFF,NP,
     $              ireq,status,ierr)
#elif defined COMM_BLACS2
               DO l = 1,NP
                  Q(l)    = Qh(l,PJJ)
                  Q(l+NP) = Ql(l,PJJ)
               END DO
               CALL DGESD2D( ICTXT, NP*2, 1, Q,    NP*2, MYROW, NJCOL )
               CALL DGERV2D( ICTXT, NP*2, 1, QBUF, NP*2, MYROW, NJCOL )
               DO l = 1,NP
                  QBUFh(l) = QBUF(l)
                  QBUFl(l) = QBUF(l+NP)
               END DO
#else
               CALL DGESD2D( ICTXT, NP, 1, Qh( 1, PJJ ), NP, MYROW,
     $                       NJCOL )
               CALL DGESD2D( ICTXT, NP, 1, Ql( 1, PJJ ), NP, MYROW,
     $                       NJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFh, NP, MYROW, NJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFl, NP, MYROW, NJCOL )
#endif
!.............
!               CALL DROT( NP, Q( 1, PJJ ), 1, QBUF, 1, C, S )
               CALL DDROT( NP, Qh( 1, PJJ ), Ql( 1, PJJ ), 1, QBUFh, 
     &                     QBUFl, 1, Ch, Cl, Sh, Sl )
            ELSE IF( MYCOL.EQ.NJCOL ) THEN
!               CALL DGESD2D( ICTXT, NP, 1, Q( 1, NJJ ), NP, MYROW,
!     $                       PJCOL )
!               CALL DGERV2D( ICTXT, NP, 1, QBUF, NP, MYROW, PJCOL )
!... MPI ...
#ifdef MPICOMM
               CALL MakeMpiInfo('A',ICTXT,MYROW,PJCOL,DEST,COMM,TAG)
               CALL MPI_Isend_dd(Qh(1,NJJ),Ql(1,NJJ),SBUFF,NP,
     $              MPI_DOUBLE_PRECISION,DEST,1,COMM,ireq,ierr)
               CALL MPI_Wait_dd(SBUFF,ireq,status,ierr)

               CALL MakeMpiInfo('A',ICTXT,MYROW,PJCOL,DEST,COMM,TAG)
               QBUFF(1:NP)      = QBUFh(1:NP)
               QBUFF(1+NP:2*NP) = QBUFl(1:NP)
               CALL MPI_Irecv_dd(QBUFF,NP,
     $              MPI_DOUBLE_PRECISION,DEST,TAG,COMM,ireq,ierr)
               CALL MPI_WaitIrecv_dd(QBUFh,QBUFl,QBUFF,NP,
     $              ireq,status,ierr)
#elif defined COMM_BLACS2
               DO l = 1,NP
                  Q(l)    = Qh(l,NJJ)
                  Q(l+NP) = Ql(l,NJJ)
               END DO
               CALL DGESD2D( ICTXT, NP*2, 1, Q,    NP*2, MYROW, PJCOL )
               CALL DGERV2D( ICTXT, NP*2, 1, QBUF, NP*2, MYROW, PJCOL )
               DO l = 1,NP
                  QBUFh(l) = QBUF(l)
                  QBUFl(l) = QBUF(l+NP)
               END DO
#else
               CALL DGESD2D( ICTXT, NP, 1, Qh( 1, NJJ ), NP, MYROW,
     $                       PJCOL )
               CALL DGESD2D( ICTXT, NP, 1, Ql( 1, NJJ ), NP, MYROW,
     $                       PJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFh, NP, MYROW, PJCOL )
               CALL DGERV2D( ICTXT, NP, 1, QBUFl, NP, MYROW, PJCOL )
#endif
!...........
!               CALL DROT( NP, QBUF, 1, Q( 1, NJJ ), 1, C, S )
               CALL DDROT( NP, QBUFh, QBUFl, 1, Qh( 1, NJJ ), 
     &                     Ql( 1, NJJ ), 1, Ch, Cl, Sh, Sl )
            END IF
!            T = D( PJ )*C**2 + D( NJ )*S**2
!<<<  tmp1 = C * C
      tmp1h = Ch * Ch
      T_u1 = 134217729.0 * Ch
      T_p1 = T_u1
     +         - (T_u1 - Ch)
      T_p2 = Ch - T_p1
      T_u1 = 134217729.0 * Ch
      T_r1 = T_u1
     +         - (T_u1 - Ch)
      T_r2 = Ch - T_r1
      tmp1l = ((T_p1*T_r1
     +        - tmp1h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp1l = tmp1l
     +      + (Ch*Cl
     +      + Cl*Ch)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp1 = C * C
!<<<  tmp2 = D(PJ) * tmp1
      tmp2h = Dh(PJ) * tmp1h
      T_u1 = 134217729.0 * Dh(PJ)
      T_p1 = T_u1
     +         - (T_u1 - Dh(PJ))
      T_p2 = Dh(PJ) - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (Dh(PJ)*tmp1l
     +      + Dl(PJ)*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = D(PJ) * tmp1
!<<<  tmp3 = S * S
      tmp3h = Sh * Sh
      T_u1 = 134217729.0 * Sh
      T_p1 = T_u1
     +         - (T_u1 - Sh)
      T_p2 = Sh - T_p1
      T_u1 = 134217729.0 * Sh
      T_r1 = T_u1
     +         - (T_u1 - Sh)
      T_r2 = Sh - T_r1
      tmp3l = ((T_p1*T_r1
     +        - tmp3h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp3l = tmp3l
     +      + (Sh*Sl
     +      + Sl*Sh)
      T_s1 = tmp3h + tmp3l
      tmp3l = tmp3l - (T_s1 - tmp3h)
      tmp3h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp3 = S * S
!<<<  tmp4 = D(NJ) * tmp3
      tmp4h = Dh(NJ) * tmp3h
      T_u1 = 134217729.0 * Dh(NJ)
      T_p1 = T_u1
     +         - (T_u1 - Dh(NJ))
      T_p2 = Dh(NJ) - T_p1
      T_u1 = 134217729.0 * tmp3h
      T_r1 = T_u1
     +         - (T_u1 - tmp3h)
      T_r2 = tmp3h - T_r1
      tmp4l = ((T_p1*T_r1
     +        - tmp4h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp4l = tmp4l
     +      + (Dh(NJ)*tmp3l
     +      + Dl(NJ)*tmp3h)
      T_s1 = tmp4h + tmp4l
      tmp4l = tmp4l - (T_s1 - tmp4h)
      tmp4h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp4 = D(NJ) * tmp3
!<<<  T = tmp2 + tmp4
      T_p1 = tmp2h + tmp4h
      T_p2 = T_p1 - tmp2h
      Th = T_p1
      Tl = (tmp2h - (T_p1 - T_p2))
     +      + (tmp4h - T_p2)
      Tl = Tl + tmp2l + tmp4l
      T_s1 = Th + Tl
      Tl = Tl - (T_s1 - Th)
      Th = T_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>  T = tmp2 + tmp4
!            D( NJ ) = D( PJ )*S**2 + D( NJ )*C**2
!            D( PJ ) = T
!<<<  tmp1 = S * S
      tmp1h = Sh * Sh
      T_u1 = 134217729.0 * Sh
      T_p1 = T_u1
     +         - (T_u1 - Sh)
      T_p2 = Sh - T_p1
      T_u1 = 134217729.0 * Sh
      T_r1 = T_u1
     +         - (T_u1 - Sh)
      T_r2 = Sh - T_r1
      tmp1l = ((T_p1*T_r1
     +        - tmp1h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp1l = tmp1l
     +      + (Sh*Sl
     +      + Sl*Sh)
      T_s1 = tmp1h + tmp1l
      tmp1l = tmp1l - (T_s1 - tmp1h)
      tmp1h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp1 = S * S
!<<<  tmp2 = D(PJ) * tmp1
      tmp2h = Dh(PJ) * tmp1h
      T_u1 = 134217729.0 * Dh(PJ)
      T_p1 = T_u1
     +         - (T_u1 - Dh(PJ))
      T_p2 = Dh(PJ) - T_p1
      T_u1 = 134217729.0 * tmp1h
      T_r1 = T_u1
     +         - (T_u1 - tmp1h)
      T_r2 = tmp1h - T_r1
      tmp2l = ((T_p1*T_r1
     +        - tmp2h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp2l = tmp2l
     +      + (Dh(PJ)*tmp1l
     +      + Dl(PJ)*tmp1h)
      T_s1 = tmp2h + tmp2l
      tmp2l = tmp2l - (T_s1 - tmp2h)
      tmp2h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp2 = D(PJ) * tmp1
!<<<  tmp3 = C * C
      tmp3h = Ch * Ch
      T_u1 = 134217729.0 * Ch
      T_p1 = T_u1
     +         - (T_u1 - Ch)
      T_p2 = Ch - T_p1
      T_u1 = 134217729.0 * Ch
      T_r1 = T_u1
     +         - (T_u1 - Ch)
      T_r2 = Ch - T_r1
      tmp3l = ((T_p1*T_r1
     +        - tmp3h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp3l = tmp3l
     +      + (Ch*Cl
     +      + Cl*Ch)
      T_s1 = tmp3h + tmp3l
      tmp3l = tmp3l - (T_s1 - tmp3h)
      tmp3h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp3 = C * C
!<<<  tmp4 = D(NJ) * tmp3
      tmp4h = Dh(NJ) * tmp3h
      T_u1 = 134217729.0 * Dh(NJ)
      T_p1 = T_u1
     +         - (T_u1 - Dh(NJ))
      T_p2 = Dh(NJ) - T_p1
      T_u1 = 134217729.0 * tmp3h
      T_r1 = T_u1
     +         - (T_u1 - tmp3h)
      T_r2 = tmp3h - T_r1
      tmp4l = ((T_p1*T_r1
     +        - tmp4h)
     +        + T_p1 * T_r2
     +        + T_p2 * T_r1)
     +        + T_p2 * T_r2
      tmp4l = tmp4l
     +      + (Dh(NJ)*tmp3l
     +      + Dl(NJ)*tmp3h)
      T_s1 = tmp4h + tmp4l
      tmp4l = tmp4l - (T_s1 - tmp4h)
      tmp4h = T_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>  tmp4 = D(NJ) * tmp3
!<<<  D(NJ) = tmp2 + tmp4
      T_p1 = tmp2h + tmp4h
      T_p2 = T_p1 - tmp2h
      Dh(NJ) = T_p1
      Dl(NJ) = (tmp2h - (T_p1 - T_p2))
     +      + (tmp4h - T_p2)
      Dl(NJ) = Dl(NJ) + tmp2l + tmp4l
      T_s1 = Dh(NJ) + Dl(NJ)
      Dl(NJ) = Dl(NJ) - (T_s1 - Dh(NJ))
      Dh(NJ) = T_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>  D(NJ) = tmp2 + tmp4
      Dh(PJ) = Th
      Dl(PJ) = Tl
            K2 = K2 - 1
            I = 1
   70       CONTINUE
            IF( K2+I.LE.N ) THEN
               IF(
!                 D( PJ ).LT.D( INDXP( K2+I ) ) 
!       (D(PJ) .lt. D(INDXP(K2+I)))
     + ((Dh(PJ) .lt. Dh(INDXP(K2+I))) .or.
     +  ((Dh(PJ) .eq. Dh(INDXP(K2+I))) .and.
     +   (Dl(PJ) .lt. Dl(INDXP(K2+I)))))
     &            ) THEN
                  INDXP( K2+I-1 ) = INDXP( K2+I )
                  INDXP( K2+I ) = PJ
                  I = I + 1
                  GO TO 70
               ELSE
                  INDXP( K2+I-1 ) = PJ
               END IF
            ELSE
               INDXP( K2+I-1 ) = PJ
            END IF
            PJ = NJ
         ELSE
            K = K + 1
!            DLAMDA( K ) = D( PJ )
!            W( K ) = Z( PJ )
      DLAMDAh(K) = Dh(PJ)
      DLAMDAl(K) = Dl(PJ)
      Wh(K) = Zh(PJ)
      Wl(K) = Zl(PJ)
            INDXP( K ) = PJ
            PJ = NJ
         END IF
      END IF
      GO TO 60
   80 CONTINUE
*
*     Record the last eigenvalue.
*
      K = K + 1
!      DLAMDA( K ) = D( PJ )
!      W( K ) = Z( PJ )
      DLAMDAh(K) = Dh(PJ)
      DLAMDAl(K) = Dl(PJ)
      Wh(K) = Zh(PJ)
      Wl(K) = Zl(PJ)
      INDXP( K ) = PJ
*
*     Count up the total number of the various types of columns, then
*     form a permutation which positions the four column types into
*     four uniform groups (although one or more of these groups may be
*     empty).
*
      DO 100 J = 1, 4
         DO 90 I = 0, NPCOL - 1
            CTOT( I, J ) = 0
   90    CONTINUE
         PTT( J ) = 0
  100 CONTINUE
      DO 110 J = 1, N
         CT = COLTYP( J )
         COL = INDCOL( J )
         CTOT( COL, CT ) = CTOT( COL, CT ) + 1
  110 CONTINUE
*
*     PSM(*) = Position in SubMatrix (of types 1 through 4)
*
      DO 120 COL = 0, NPCOL - 1
         PSM( COL, 1 ) = 1
         PSM( COL, 2 ) = 1 + CTOT( COL, 1 )
         PSM( COL, 3 ) = PSM( COL, 2 ) + CTOT( COL, 2 )
         PSM( COL, 4 ) = PSM( COL, 3 ) + CTOT( COL, 3 )
  120 CONTINUE
      PTT( 1 ) = 1
      DO 140 I = 2, 4
         CT = 0
         DO 130 J = 0, NPCOL - 1
            CT = CT + CTOT( J, I-1 )
  130    CONTINUE
         PTT( I ) = PTT( I-1 ) + CT
  140 CONTINUE
*
*     Fill out the INDXC array so that the permutation which it induces
*     will place all type-1 columns first, all type-2 columns next,
*     then all type-3's, and finally all type-4's.
*
      DO 150 J = 1, N
         JS = INDXP( J )
         COL = INDCOL( JS )
         CT = COLTYP( JS )
         I = INDXL2G( PSM( COL, CT ), NB, COL, DCOL, NPCOL )
         INDX( J ) = I
         INDXC( PTT( CT ) ) = I
         PSM( COL, CT ) = PSM( COL, CT ) + 1
         PTT( CT ) = PTT( CT ) + 1
  150 CONTINUE
*
*
      DO 160 J = 1, N
         JS = INDXP( J )
         JJS = INDXG2L( JS, NB, J, J, NPCOL )
         COL = INDCOL( JS )
         IF( COL.EQ.MYCOL ) THEN
            I = INDX( J )
            JJQ2 = INDXG2L( I, NB, J, J, NPCOL )
!            CALL DCOPY( NP, Q( 1, JJS ), 1, Q2( 1, JJQ2 ), 1 )
            CALL DDCOPY( NP, Qh( 1, JJS ), Ql( 1, JJS ), 1, 
     &                   Q2h( 1, JJQ2 ), Q2l( 1, JJQ2 ), 1 )
         END IF
  160 CONTINUE
*
*
*     The deflated eigenvalues and their corresponding vectors go back
*     into the last N - K slots of D and Q respectively.
*
!      CALL DCOPY( N, D, 1, Z, 1 )
      CALL DDCOPY( N, Dh, Dl, 1, Zh, Zl, 1 )
      DO 170 J = K + 1, N
         JS = INDXP( J )
         I = INDX( J )
!         D( I ) = Z( JS )
      Dh(I) = Zh(JS)
      Dl(I) = Zl(JS)
  170 CONTINUE
*
      PTT( 1 ) = 1
      DO 190 I = 2, 4
         CT = 0
         DO 180 J = 0, NPCOL - 1
            CT = CT + CTOT( J, I-1 )
  180    CONTINUE
         PTT( I ) = PTT( I-1 ) + CT
  190 CONTINUE
*
*
      IB1 = INDXC( 1 )
      IE1 = IB1
      IB2 = INDXC( PTT( 2 ) )
      IE2 = IB2
      DO 200 I = 2, PTT( 3 ) - 1
         IB1 = MIN( IB1, INDXC( I ) )
         IE1 = MAX( IE1, INDXC( I ) )
  200 CONTINUE
      DO 210 I = PTT( 2 ), PTT( 4 ) - 1
         IB2 = MIN( IB2, INDXC( I ) )
         IE2 = MAX( IE2, INDXC( I ) )
  210 CONTINUE
      NN1 = IE1 - IB1 + 1
      NN2 = IE2 - IB2 + 1
      NN = MAX( IE1, IE2 ) - MIN( IB1, IB2 ) + 1
  220 CONTINUE
      RETURN
*
*     End of PDDLAED2
*
      END
