#ifdef MEMORY1
      module xx_hrd_info
      implicit none
      integer,private :: myrank
      integer,parameter :: nmax = 6
      integer,private,parameter :: IMAX = 2147483647
      integer,private :: ns(1:nmax) =  IMAX
      integer,private :: ne(1:nmax) = -IMAX
      integer,private :: ns0(1:nmax) =  IMAX
      integer,private :: ne0(1:nmax) = -IMAX

      integer,parameter :: kxx_uv_x = 1
      integer,parameter :: kxx_uv_y = 2
      integer,parameter :: kxx_w    = 3
      integer,parameter :: kxx_u_t  = 4
      integer,parameter :: kxx_v_t  = 5
      integer,parameter :: kxx_d_t  = 6

      integer,parameter :: kxx_ur_x = 1
      integer,parameter :: kxx_ui_x = 1
      integer,parameter :: kxx_vr_x = 1
      integer,parameter :: kxx_vi_x = 1
      integer,parameter :: kxx_ur_y = 2
      integer,parameter :: kxx_ui_y = 2
      integer,parameter :: kxx_vr_y = 2
      integer,parameter :: kxx_vi_y = 2
      integer,parameter :: kxx_wr   = 3
      integer,parameter :: kxx_wi   = 3
      integer,parameter :: kxx_ur_t = 4
      integer,parameter :: kxx_ui_t = 4
      integer,parameter :: kxx_vr_t = 5
      integer,parameter :: kxx_vi_t = 5

      integer,parameter :: kxx_ar   = 3
      integer,parameter :: kxx_ai   = 3

      integer,parameter :: kxx_ur_t2= 1
      integer,parameter :: kxx_ui_t2= 1

      integer,parameter :: kxx_ur   = 1
      integer,parameter :: kxx_ui   = 1
      integer,parameter :: kxx_uyr  = 2
      integer,parameter :: kxx_uyi  = 2
      integer,parameter :: kxx_vr   = 1
      integer,parameter :: kxx_vi   = 1
      integer,parameter :: kxx_vyr  = 2
      integer,parameter :: kxx_vyi  = 2

      contains

      subroutine setter(ns1,ne1)
      implicit none
      include 'mpif.h'
      integer,intent(in) :: ns1(1:nmax)
      integer,intent(in) :: ne1(1:nmax)
      integer :: ierr
      ns0 = ns1
      ne0 = ne1
      call mpi_comm_rank(mpi_comm_world, myrank, ierr)
      myrank = myrank+1
      end subroutine

      subroutine accessor(i0,n,kxx,c1)
      implicit none
      integer,intent(in) :: i0
      integer,intent(in) :: n
      integer,intent(in) :: kxx
      character(*),intent(in) :: c1
      character(2) :: cc1,cc2,cc3
      integer :: ncc3
      if ( (kxx < 1) .or. (nmax < kxx) ) then
        print *,"kxx error",kxx
        return
      end if
      ns(kxx) = min(ns(kxx),n)
      ne(kxx) = max(ne(kxx),n)
      cc3 = "ok"
      ncc3 = 0
      if (n <= ne0(kxx)) then
        cc2 = "<="
      else
        cc2 = "> "
        cc3 = "ng"
        ncc3 = 1
      end if
      if (ncc3 == 1) then
        print *,myrank,kxx,":",n,cc2,ne0(kxx)," at ",i0,c1
      end if
      end subroutine

      function eigen_get_memsize_hrd()
      implicit none
      integer :: i
      integer :: eigen_get_memsize_hrd
      eigen_get_memsize_hrd = ne(1)
      do i=1,nmax
        print *,myrank,i,":",ne(i)," in [",ns0(i),ne0(i),"]"
        eigen_get_memsize_hrd = max(eigen_get_memsize_hrd,ne(i))
      end do
      end function

      end module
#endif

#ifdef ARRAY_2D
      subroutine eigen_hrd(
     &             n,ar2d,ai2d,lda,
     &             d_out,e_out,e2_out,
     &             tau,ldtau, m
     &           )
#else
      subroutine eigen_hrd(
     &             n,ar,ai,lda,
     &             d_out,e_out,e2_out,
     &             tau,ldtau, m,zr,zi
     &           )
#endif
!----
      use communication_h, only : eigen_init
     &               , eigen_free
     &               , cyc1d_cyc2d
     &               , cyc2d_cyc1d
!----
      implicit none
!----
      include 'mpif.h'
!----
      integer  ::  n, lda, ldtau, m
#ifdef ARRAY_2D
      real(8) ::   ar2d(*),ai2d(*)
#else
      real(8)  ::  ar(*),ai(*)
      real(8)  ::  zr(*),zi(*)
#endif
      real(8)  ::  d_out(*),e_out(*),e2_out(*)
      real(8)  ::  tau(*)
!----
      include 'trd.h'
!----
      integer  ::  ierr
      integer  ::  n_, nm_

      real(8), pointer :: ar_(:), ai_(:)

      real(8)  :: d0, d1, d2, d3, d4

      integer  :: ldz, nz
!----
      call eigen_init(2)
!----
      d0=mpi_wtime()
      ldz = (n-1)/size_of_col+1
      nz = (n-1)/size_of_row+1
      d1=mpi_wtime()
#ifdef ARRAY_2D
!     none
#else
      call cyc1d_cyc2d(n,ar,lda,zr,ldz, size_of_col, size_of_row, ierr)
      call cyc1d_cyc2d(n,ai,lda,zi,ldz, size_of_col, size_of_row, ierr)
#endif
      d2=mpi_wtime()
!----
      n_ = 0; nm_ = 1

      allocate(ar_(1),ai_(1))
#ifdef ARRAY_2D
      call eigen_hrd_main1(
     &       n,ar2d(1),ai2d(1),lda,
     &       d_out(1),e_out(1),e2_out(1),tau(1),ldtau,m,
     &       ar_(1),ai_(1),n_,nm_
     &     )
#else
      call eigen_hrd_main1(
     &       n,zr(1),zi(1),ldz,
     &       d_out(1),e_out(1),e2_out(1),tau(1),ldtau,m,
     &       ar_(1),ai_(1),n_,nm_
     &     )
#endif
      deallocate(ar_,ai_)

      d3=mpi_wtime()
#ifdef ARRAY_2D
!     none
#else
      call cyc2d_cyc1d(n,ar,lda,zr,ldz, size_of_col, size_of_row, ierr)
      call cyc2d_cyc1d(n,ai,lda,zi,ldz, size_of_col, size_of_row, ierr)
#endif
      d4=mpi_wtime()
#ifdef DETAIL
      if(myrank==1) then
         print*,"  communication time in 'eigen_hrd'"
         print*,"   cyc1d_cyc2d :: ",d2-d1,"(sec)"
         print*,"   cyc2d_cyc1d :: ",d4-d3,"(sec)"
      endif
    d4=mpi_wtime()
#endif
!----
      call eigen_free(1)
!----
#ifdef TIMER
      if(myrank==1)then
         print*,"Exectime of 'eigen_hrd' routine =",d4-d0,"(sec)"
!----&            4*dble(n)**3*4/3/(s1-s0)*1d-6,"MFLOPS"
      endif
#endif

      return
      end subroutine
!----
      subroutine eigen_hrd_main1(
     &             n,ar,ai,lda,d_out,e_out,e2_out,tau,ldtau,m,
     &             ar_,ai_,n_,nm_
     &           )
!----
#ifdef MEMORY1
      use xx_hrd_info
#endif
      implicit none
!----
      integer  ::  n,  lda, nv, ldtau, m
      real(8)  ::  ar(lda,*),ai(lda,*)
      real(8)  ::  d_out(n),e_out(n),e2_out(n)
      real(8)  ::  tau(ldtau,2)
      integer  ::  n_, nm_
      real(8)  ::  ar_(*), ai_(*)
!----
      include 'trd.h'
!----
      real(8), pointer ::  uv_x(:), uv_y(:)
      real(8), pointer ::  w(:)
      real(8), pointer ::  u_t(:), v_t(:)
      real(8), pointer ::  d_t(:)

      integer :: i,j,k
#ifdef MEMORY1
      integer :: nxx_uv_x
      integer :: nxx_uv_y
      integer :: nxx_w
      integer :: nxx_u_t
      integer :: nxx_v_t
      integer :: nxx_d_t
      integer :: nxx_all
#endif
#ifdef MEMORY1
       integer ns1(1:nmax),ne1(1:nmax)
#endif
!----
      nv=lda
!----
      allocate(
     &         uv_x(4*nv*m),
     &         uv_y(4*nv*m),
     &         w(2*nv*m),
     &         u_t(1+8*2*max(nv+4,m*4)),
     &         v_t(1+8*2*max(nv+4,m*4)),
     &         d_t(nv)
     &        )
#ifdef MEMORY1
      nxx_uv_x = 1
      nxx_uv_y = nxx_uv_x + 4*nv*m
      nxx_w    = nxx_uv_y + 4*nv*m
      nxx_u_t  = nxx_w    + 2*nv*m
      nxx_v_t  = nxx_u_t  + 1+8*2*max(nv+4,m*4)
      nxx_d_t  = nxx_v_t  + 1+8*2*max(nv+4,m*4)
      nxx_all  = nxx_d_t  + nv

      ns1(1) = nxx_uv_x
      ns1(2) = nxx_uv_y
      ns1(3) = nxx_w
      ns1(4) = nxx_u_t
      ns1(5) = nxx_v_t
      ns1(6) = nxx_d_t

      ne1(1) = nxx_uv_y - 1
      ne1(2) = nxx_w    - 1
      ne1(3) = nxx_u_t  - 1
      ne1(4) = nxx_v_t  - 1
      ne1(5) = nxx_d_t  - 1
      ne1(6) = nxx_all  - 1

      call setter(ns1,ne1)
#endif
!----
      j = 0
!----
      call eigen_hrd_main2(
     &       n,ar,ai,lda,d_out,e_out,e2_out,
     &       tau,ldtau,nv,m,
     &       uv_x(1+0*nv*m), uv_x(1+1*nv*m),
     &       uv_x(1+2*nv*m), uv_x(1+3*nv*m),
     &       uv_y(1+0*nv*m), uv_y(1+1*nv*m),
     &       uv_y(1+2*nv*m), uv_y(1+3*nv*m),
     &       w(1), w(1+nv*m),
     &       u_t(1), u_t(1+8*max(nv+4,m*4)),
     &       v_t(1), v_t(1+8*max(nv+4,m*4)),
     &       d_t(1),
     &       ar_,ai_,n_,nm_
#ifdef MEMORY1
     &      ,xx_uv_x(0,1+0*nv*m), xx_uv_x(0,1+1*nv*m)
     &      ,xx_uv_x(0,1+2*nv*m), xx_uv_x(0,1+3*nv*m)
     &      ,xx_uv_y(0,1+0*nv*m), xx_uv_y(0,1+1*nv*m)
     &      ,xx_uv_y(0,1+2*nv*m), xx_uv_y(0,1+3*nv*m)
     &      ,xx_w(0,1), xx_w(0,1+nv*m)
     &      ,xx_u_t(0,1), xx_u_t(0,1+8*max(nv+4,m*4))
     &      ,xx_v_t(0,1), xx_v_t(0,1+8*max(nv+4,m*4))
     &      ,xx_d_t(0,1)
#endif
     &     )
!----
      deallocate(uv_x, uv_y, w, u_t, v_t, d_t )
#ifdef MEMORY1
      print *," eigen_get_memsize_hrd = ",eigen_get_memsize_hrd()
#endif

      return
#ifdef MEMORY1
      contains

      function xx_uv_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_uv_x
      integer :: i0,i1
      xx_uv_x = nxx_uv_x + i1 - 1
      call accessor(i0,xx_uv_x,kxx_uv_x,"eigen_hrd_main1:uv_x")
      end function

      function xx_uv_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_uv_y
      integer :: i0,i1
      xx_uv_y = nxx_uv_y + i1 - 1
      call accessor(i0,xx_uv_y,kxx_uv_y,"eigen_hrd_main1:uv_y")
      end function

      function xx_w(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_w
      integer :: i0,i1
      xx_w = nxx_w + i1 - 1
      call accessor(i0,xx_w,kxx_w,"eigen_hrd_main1:w")
      end function

      function xx_u_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_u_t
      integer :: i0,i1
      xx_u_t = nxx_u_t + i1 - 1
      call accessor(i0,xx_u_t,kxx_u_t,"eigen_hrd_main1:u_t")
      end function

      function xx_v_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_v_t
      integer :: i0,i1
      xx_v_t = nxx_v_t + i1 - 1
      call accessor(i0,xx_v_t,kxx_v_t,"eigen_hrd_main1:v_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"eigen_hrd_main1:d_t")
      end function
#endif
      end subroutine
!----
      subroutine eigen_hrd_main2(
     &             n,ar,ai,lda,d_out,e_out,e2_out,
     &             tau,ldtau,nv,m,
     &             ur_x, ui_x, vr_x, vi_x,
     &             ur_y, ui_y, vr_y, vi_y,
     &             wr, wi,
     &             ur_t, ui_t,
     &             vr_t, vi_t,
     &             d_t,
     &             ar_,ai_,n_,nm_
#ifdef MEMORY1
     &            ,nxx_ur_x, nxx_ui_x, nxx_vr_x, nxx_vi_x
     &            ,nxx_ur_y, nxx_ui_y, nxx_vr_y, nxx_vi_y
     &            ,nxx_wr  , nxx_wi
     &            ,nxx_ur_t, nxx_ui_t
     &            ,nxx_vr_t, nxx_vi_t
     &            ,nxx_d_t
#endif
     &           )
!----
      use communication_h, only : reduce_dbl
     &               , bcast_dbl
     &               , get_loop_start
     &               , get_loop_end
     &               , get_owner_node
     &               , translate_l2g
     &               , translate_g2l
!----
      implicit integer         (i-n)
      implicit real(8)(a-h,o-z)
!----
      integer  ::  i,j,l,n,lda,ldtau,nv
      real(8)  ::  ar(lda,n),ai(lda,n)
      real(8)  ::  d_out(n),e_out(n),e2_out(n)
      real(8)  ::  tau(ldtau,2)
      real(8)  ::  g,h,scale
      real(8)  ::  sr,si,tr,ti
!----
      integer  ::  m_orig
      integer  ::  m,mm,m0
      integer  ::  i_block,i_base
!----
      integer  ::  y_root, y_pos
      integer  ::  x_root, x_pos
!----
      real(8)  ::  ur_x(nv,m),ui_x(nv,m)
      real(8)  ::  ur_y(nv,m),ui_y(nv,m)
      real(8)  ::  vr_x(nv,m),vi_x(nv,m)
      real(8)  ::  vr_y(nv,m),vi_y(nv,m)
      real(8)  ::  wr(nv,m),wi(nv,m)
      real(8)  ::  ur_t(1:8*max(nv+4,4*m))
      real(8)  ::  ui_t(1:8*max(nv+4,4*m))
      real(8)  ::  vr_t(1:8*max(nv+4,4*m))
      real(8)  ::  vi_t(1:8*max(nv+4,4*m))
      real(8)  ::  d_t(nv)
!----
      integer  ::  n_, nm_
      real(8)  ::  ar_(nm_,n_), ai_(nm_,n_)

      integer  :: local_rank, local_size
!----
      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
      real(8)  :: dd(10),d1,d2
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_vr_y
      integer,intent(in) :: nxx_vi_y
      integer,intent(in) :: nxx_wr
      integer,intent(in) :: nxx_wi
      integer,intent(in) :: nxx_ur_t
      integer,intent(in) :: nxx_ui_t
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
#endif
!----
      dd=0d0
!----
!$omp parallel private(local_rank,local_size)
#ifdef DETAIL
!$omp master
      if ( myrank == 1 ) then
         local_rank = 0
         local_size = 1
!$       local_rank = omp_get_thread_num()
!$       local_size = omp_get_num_threads()
!$       if ( local_rank == 0 ) then
            print*,"num.of.process=",nprocs,
     &             "(",size_of_col,size_of_row,")"
!$          print*,"num.of.threads=",local_size
!$       endif
      endif
!$omp end master
#endif
      call eigen_hrd_Au(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
     &       ur_t,ui_t, vr_t,vi_t, d_t,
     &       -1, x_pos,y_pos, nv,k_1-k_2,
     &       ar_,ai_,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_ur_t(0,1)  ,xx_ui_t(0,1)
     &      ,xx_vr_t(0,1)  ,xx_vi_t(0,1)
     &      ,xx_d_t (0,1)
#endif
     &     )
      call eigen_hrd_2update(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,
     &       vr_x,vi_x,vr_y,vi_y,
     &       nv,m0,-1,
     &       ar_,ai_,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_vr_y(0,1,1),xx_vi_y(0,1,1)
#endif
     &     )
!$omp end parallel

!----
      d_out(1:n)  = 0.0d0
      e_out(1:n)  = 0.0d0
      e2_out(1:n) = 0.0d0
      tau(1:n,1) = 1.0d0
      tau(1:n,2) = 0.0d0
!----
      if(diag_0>0)then
         i_2=diag_0
         i_3=((n)+size_of_row-my_row)/size_of_row
         i_4=size_of_col/n_common
         if(i_2<=n_)then
            do i_1=i_2,min(i_3,n_),i_4
               j=(i_1-1)*size_of_row+my_row
               j_1=(j-1)/size_of_col+1
               d_out(j)     = ar_(j_1,i_1)
               ai_(j_1,i_1) = 0.0d0
            enddo! i_1
            i_2=((n_-i_2)/i_4+1)*i_4+i_2
         endif
*poption indep(a,d_out)
         do i_1=i_2,i_3,i_4
            j=(i_1-1)*size_of_row+my_row
            j_1=(j-1)/size_of_col+1
            d_out(j)     = ar(j_1,i_1)
            ai(j_1,i_1)  = 0.0d0
         enddo! i_1
      endif
!----
      i_2=1
      i_3=((n)+size_of_row-my_row)/size_of_row
      do i_1=i_2,min(n_,i_3)
         j=(i_1-1)*size_of_row+my_row
         j_2=((j+1)+size_of_col-1-my_col)/size_of_col+1
         j_3=((n)+size_of_col-my_col)/size_of_col
         do j_1=j_2,nm_
            ar_(j_1,i_1) = 0.0d+00
            ai_(j_1,i_1) = 0.0d+00
         enddo! j_1
      enddo! i_1
      do i_1=max(i_2,n_+1),i_3
         j=(i_1-1)*size_of_row+my_row
         j_2=((j+1)+size_of_col-1-my_col)/size_of_col+1
         j_3=((n)+size_of_col-my_col)/size_of_col
         do j_1=j_2,lda
            ar(j_1,i_1)  = 0.0d+00
            ai(j_1,i_1)  = 0.0d+00
         enddo! j_1
      enddo! i_1
!----
      m_orig = m
      if ( m > n ) then
         m = n
      endif
      mm = (n-1)/m+1

      do  i_block = mm,max(1,3*(2-m)),-1

         i_base = (i_block-1)*m
         m0 = min(m,n-i_base)

         i = i_base + m0
         l = i_base + m0 - 1

         i_2=((i_base+1)+size_of_row-1-my_row)/size_of_row+1
         i_3=((i_base+m0)+size_of_row-my_row)/size_of_row
         j_2=1
         j_3=((i_base+m0)+size_of_col-my_col)/size_of_col

#ifdef MEMORY1
!     nxx = xx_wr(2000,        j_3
!    &         ,(min(n_,i_3)-1)*size_of_row+my_row-i_base)
!     nxx = xx_wi(2010,        j_3
!    &         ,(min(n_,i_3)-1)*size_of_row+my_row-i_base)
      nxx = xx_wr(2020,        j_3
     &         ,    (   i_3 -1)*size_of_row+my_row-i_base)
      nxx = xx_wi(2030,        j_3
     &         ,    (   i_3 -1)*size_of_row+my_row-i_base)
#endif
         do i_1=i_2,min(n_,i_3)
            j=(i_1-1)*size_of_row+my_row
            do j_1=j_2,min(nm_,j_3)
               wr(j_1,j-i_base) = ar_(j_1,i_1)
               wi(j_1,j-i_base) = ai_(j_1,i_1)
            enddo
            do j_1=min(nm_,j_3)+1,j_3
               wr(j_1,j-i_base) = 0.0d0+00
               wi(j_1,j-i_base) = 0.0d0+00
            enddo
         enddo
         do i_1=max(i_2,n_+1),i_3
            j=(i_1-1)*size_of_row+my_row
            do j_1=j_2,j_3
               wr(j_1,j-i_base) = ar(j_1,i_1)
               wi(j_1,j-i_base) = ai(j_1,i_1)
            enddo
         enddo
         if(diag_0>0)then
            i_2=diag_0
            i_3=((i_base+m0-1)+size_of_row-my_row)/size_of_row
            i_4=size_of_col/n_common
            if(i_2<=n_)then
#ifdef MEMORY1
      nxx = xx_d_t(2040,int((min(i_3,n_)-i_2)/i_4)*i_4+i_2)
#endif
               if(size_of_row==size_of_col)then
*poption indep(a,d_out)
                  do i_1=i_2,min(i_3,n_),i_4
                     d_t(i_1)     = ar_(i_1,i_1)
                     ar_(i_1,i_1) = 0.0d+00
                     ai_(i_1,i_1) = 0.0d+00
                  enddo! i_1
               else
*poption indep(a,d_out)
                  do i_1=i_2,min(i_3,n_),i_4
                     j=(i_1-1)*size_of_row+my_row
                     j_1 = (j-1)/size_of_col +1
                     d_t(i_1)     = ar_(j_1,i_1)
                     ar_(j_1,i_1) = 0.0d+00
                     ai_(j_1,i_1) = 0.0d+00
                  enddo! i_1
               endif
               i_2=((n_-i_2)/i_4+1)*i_4+i_2
            endif
#ifdef MEMORY1
      nxx = xx_d_t(2050,int((    i_3    -i_2)/i_4)*i_4+i_2)
#endif
            if(size_of_row==size_of_col)then
*poption indep(a,d_out)
               do i_1=i_2,i_3,i_4
                  d_t(i_1)    = ar(i_1,i_1)
                  ar(i_1,i_1) = 0.0d+00
                  ai(i_1,i_1) = 0.0d+00
               enddo! i_1
            else
*poption indep(a,d_out)
               do i_1=i_2,i_3,i_4
                  j=(i_1-1)*size_of_row+my_row
                  j_1 = (j-1)/size_of_col +1
                  d_t(i_1)    = ar(j_1,i_1)
                  ar(j_1,i_1) = 0.0d+00
                  ai(j_1,i_1) = 0.0d+00
               enddo! i_1
            endif
         endif

         k_2=m0
         k_3=max(1,3*(2-i_block))

         i=i_base+k_2
         l=i-1
         y_pos =   (i-1)/size_of_row +1
         x_pos =   (l-1)/size_of_col +1
         j_2=max(1,x_pos-m0)
         j_3=max(1,y_pos-m0)
#ifdef MEMORY1
      if(j_2<=x_pos)then
        nxx = xx_ur_x(2060,x_pos,k_2)
        nxx = xx_ui_x(2070,x_pos,k_2)
        nxx = xx_vr_x(2080,x_pos,k_2)
        nxx = xx_vi_x(2090,x_pos,k_2)
      end if
      if(j_3<=y_pos)then
        nxx = xx_ur_y(2100,y_pos,k_2)
        nxx = xx_ui_y(2110,y_pos,k_2)
        nxx = xx_vr_y(2120,y_pos,k_2)
        nxx = xx_vi_y(2130,y_pos,k_2)
      end if
#endif
         do  k_1 = k_3,k_2,1
            if(j_2<=x_pos)then
               ur_x(j_2:x_pos,k_1)=0.0d+00
               ui_x(j_2:x_pos,k_1)=0.0d+00
               vr_x(j_2:x_pos,k_1)=0.0d+00
               vi_x(j_2:x_pos,k_1)=0.0d+00
            endif
            if(j_3<=y_pos)then
               ur_y(j_3:y_pos,k_1)=0.0d+00
               ui_y(j_3:y_pos,k_1)=0.0d+00
               vr_y(j_3:y_pos,k_1)=0.0d+00
               vi_y(j_3:y_pos,k_1)=0.0d+00
            endif
         enddo! k_1

         do  k_1 = k_2,k_3,-1

            i = i_base+k_1
            l = i-1

            i_2 = get_loop_start(1, size_of_row,my_row)
            i_3 = get_loop_end  (l, size_of_row,my_row)
            j_2 = get_loop_start(1, size_of_col,my_col)
            j_3 = get_loop_end  (l, size_of_col,my_col)
!----
            y_root = get_owner_node (i, size_of_row,my_row)
            y_pos  = translate_g2l(i, size_of_row,my_row)

            x_root = get_owner_node (l, size_of_col,my_col)
            x_pos  = translate_g2l(l, size_of_col,my_col)

            d1=mpi_wtime()
            call eigen_hrd_u(
     &             wr(1,k_1),wi(1,k_1),
     &             ur_x(1,k_1),ui_x(1,k_1),
     &             ur_y(1,k_1),ui_y(1,k_1),
     &             ur_t(1),vr_t(1),
     &             x_root,y_root,x_pos, j_3,lda,nv
#ifdef MEMORY1
     &            ,xx_wr  (0,1,k_1),xx_wi  (0,1,k_1)
     &            ,xx_ur_x(0,1,k_1),xx_ui_x(0,1,k_1)
     &            ,xx_ur_y(0,1,k_1),xx_ui_y(0,1,k_1)
     &            ,xx_ur_t(0,1)    ,xx_vr_t(0,1)
#endif
     &           )

            scale = ur_t(x_pos+1)
#ifdef MEMORY1
      if ( scale == 0.0d+00 ) then
        nxx = xx_ur_x(2140,x_pos,k_1)
        nxx = xx_ui_x(2150,x_pos,k_1)
        nxx = xx_vr_x(2160,x_pos,k_1)
        nxx = xx_vi_x(2170,x_pos,k_1)
        nxx = xx_ur_y(2180,y_pos,k_1)
        nxx = xx_ui_y(2190,y_pos,k_1)
        nxx = xx_vr_y(2200,y_pos,k_1)
        nxx = xx_vi_y(2210,y_pos,k_1)
      end if
#endif
            if ( scale == 0.0d+00 ) then
               do j=1,x_pos
                  ur_x(j,k_1)=0.0d+00
                  ui_x(j,k_1)=0.0d+00
                  vr_x(j,k_1)=0.0d+00
                  vi_x(j,k_1)=0.0d+00
               enddo
               do j=1,y_pos
                  ur_y(j,k_1)=0.0d+00
                  ui_y(j,k_1)=0.0d+00
                  vr_y(j,k_1)=0.0d+00
                  vi_y(j,k_1)=0.0d+00
               enddo
               goto 1000
            endif
            d2=mpi_wtime()
            dd(1)=dd(1)+(d2-d1)

            if ( vr_t(x_pos+3) == 0.0d+00 ) then
#ifdef MEMORY1
      nxx = xx_wr(2220,x_pos,k_1)
      nxx = xx_ur_t(2230,x_pos+3)
#endif
               tau(l,1) = -tau(i,1)
               tau(l,2) = -tau(i,2)
               wr(x_pos,k_1) = ur_t(x_pos+3)
            else
#ifdef MEMORY1
      nxx = xx_vr_t(2240,x_pos+3)
#endif
               sr       =  vr_t(x_pos+1)
               si       =  vr_t(x_pos+2)
               tr       =  si*tau(i,2) - sr*tau(i,1)
               ti       = -sr*tau(i,2) - si*tau(i,1)
               tau(l,1) =  tr / vr_t(x_pos+3)
               tau(l,2) =  ti / vr_t(x_pos+3)
            endif

            beta  = ur_t(x_pos+4)
            if ( x_root == my_col .and. y_root == my_row ) then
#ifdef MEMORY1
      nxx = xx_ur_t(2250,x_pos+3)
      nxx = xx_vr_t(2260,x_pos)
      nxx = xx_wr(2270,x_pos,k_1)
      nxx = xx_wi(2280,x_pos,k_1)
#endif
               e_out(i)      = scale*ur_t(x_pos+3)
               e2_out(i)     = scale*scale*ur_t(x_pos+2)
               wr(x_pos,k_1) = scale*ur_t(x_pos)
               wi(x_pos,k_1) = scale*vr_t(x_pos)
            endif
            i_1 = get_owner_node(i, size_of_col,my_col)
            if ( i_1 == my_col .and. y_root == my_row ) then
               j_1 = translate_g2l(i, size_of_col,my_col)
#ifdef MEMORY1
      nxx = xx_ur_t(2290,x_pos+4)
      nxx = xx_wi(2300,j_1,k_1)
#endif
               wi(j_1,k_1) = scale*sqrt(ur_t(x_pos+4))
            endif
!----
!---- v = au
!----
            d1=mpi_wtime() 
!$omp parallel
            call eigen_hrd_Au(
     &             ar(1,1),ai(1,1),lda,
     &             ur_x(1,k_1),ui_x(1,k_1),
     &             ur_y(1,k_1),ui_y(1,k_1),
     &             vr_x(1,k_1),vi_x(1,k_1),
     &             ur_t(1),ui_t(1), vr_t(1),vi_t(1),
     &             d_t(1),
     &             i_3, x_pos,y_pos, nv,k_1-k_2,
     &             ar_(1,1),ai_(1,1),n_,nm_
#ifdef MEMORY1
     &            ,xx_ur_x(0,1,k_1),xx_ui_x(0,1,k_1)
     &            ,xx_ur_y(0,1,k_1),xx_ui_y(0,1,k_1)
     &            ,xx_vr_x(0,1,k_1),xx_vi_x(0,1,k_1)
     &            ,xx_ur_t(0,1)    ,xx_ui_t(0,1)
     &            ,xx_vr_t(0,1)    ,xx_vi_t(0,1)
     &            ,xx_d_t (0,1)
#endif
     &           )
!$omp end parallel

            d2=mpi_wtime() 
            dd(2)=dd(2)+d2-d1
!----
!---- v = (a+uv+vu)u = au+(vu)u+(uu)v
!----
            d1=mpi_wtime() 
            if(k_2>k_1)then
#ifdef MEMORY1
      nxx = xx_ur_x(2310,x_pos,k_1)
      nxx = xx_ui_x(2320,x_pos,k_1)
      nxx = xx_ur_x(2330,x_pos,k_2)
      nxx = xx_ui_x(2340,x_pos,k_2)
      nxx = xx_vr_x(2350,x_pos,k_2)
      nxx = xx_vi_x(2360,x_pos,k_2)
      nxx = xx_ur_t(2370,4*(k_2-l_1)+4)
#endif
*soption unroll(2)
               do l_1=k_2,k_1+1,-1
                  j=k_2-l_1
                  sr = 0.0d+00
                  si = 0.0d+00
                  tr = 0.0d+00
                  ti = 0.0d+00
*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do  j_1 = 1, x_pos
                     wr_x0 = ur_x(j_1,k_1)
                     wi_x0 = ui_x(j_1,k_1)
                     ur_x0 = ur_x(j_1,l_1)
                     ui_x0 = ui_x(j_1,l_1)
                     vr_x0 = vr_x(j_1,l_1)
                     vi_x0 = vi_x(j_1,l_1)

                     sr = sr
     &                      + vr_x0*wr_x0
                     sr = sr
     &                      + vi_x0*wi_x0
                     si = si
     &                      + vi_x0*wr_x0
                     si = si
     &                      - vr_x0*wi_x0
                     tr = tr
     &                      + ur_x0*wr_x0
                     tr = tr
     &                      + ui_x0*wi_x0
                     ti = ti
     &                      + ui_x0*wr_x0
                     ti = ti
     &                      - ur_x0*wi_x0
                  enddo! k
                  ur_t(4*j+1) = sr
                  ur_t(4*j+2) = si
                  ur_t(4*j+3) = tr
                  ur_t(4*j+4) = ti
               enddo! j0
               j=(k_2-k_1)*4
#ifdef MEMORY1
      nxx = xx_ur_t(2380,j)
      nxx = xx_vr_t(2390,j)
#endif
               call reduce_dbl(ur_t(1), vr_t(1), j, mpi_comm_col)
#ifdef MEMORY1
      nxx = xx_ur_t(2400,4*(k_2-(k_1+1))+4)
      nxx = xx_ur_x(2410,x_pos,k_2)
      nxx = xx_ui_x(2420,x_pos,k_2)
      nxx = xx_vr_x(2430,x_pos,k_2)
      nxx = xx_vi_x(2440,x_pos,k_2)
      nxx = xx_vr_x(2450,x_pos,k_1)
      nxx = xx_vi_x(2460,x_pos,k_1)
#endif
*soption unroll(2)
               do l_1=k_2,k_1+1,-1
                  j=k_2-l_1
                  sr = ur_t(4*j+1)
                  si = ur_t(4*j+2)
                  tr = ur_t(4*j+3)
                  ti = ur_t(4*j+4)
*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do  j_1 = 1, x_pos
                     wr_x0 = 0
                     wi_x0 = 0
                     ur_x0 = ur_x(j_1,l_1)
                     ui_x0 = ui_x(j_1,l_1)
                     vr_x0 = vr_x(j_1,l_1)
                     vi_x0 = vi_x(j_1,l_1)
                     wr_x0 = wr_x0
     &                            - tr*vr_x0
                     wi_x0 = wi_x0
     &                            + ti*vr_x0
                     wr_x0 = wr_x0
     &                            - sr*ur_x0
                     wi_x0 = wi_x0
     &                            + si*ur_x0
                     wr_x0 = wr_x0
     &                            - ti*vi_x0
                     wi_x0 = wi_x0
     &                            - tr*vi_x0
                     wr_x0 = wr_x0
     &                            - si*ui_x0
                     wi_x0 = wi_x0
     &                            - sr*ui_x0

                     vr_x(j_1,k_1) = wr_x0+vr_x(j_1,k_1)
                     vi_x(j_1,k_1) = wi_x0+vi_x(j_1,k_1)
                  enddo! k
               enddo! j0
            endif
            d2=mpi_wtime()
            dd(5)=dd(5)+d2-d1

            d1=mpi_wtime()
            call  eigen_hrd_v(
     &              ur_x(1,k_1),ui_x(1,k_1),
     &              vr_x(1,k_1),vi_x(1,k_1),
     &              vr_y(1,k_1),vi_y(1,k_1),
     &              ur_t(1),vr_t(1),
     &              beta, j_3,x_pos,nv
#ifdef MEMORY1
     &             ,xx_ur_x(0,1,k_1),xx_ui_x(0,1,k_1)
     &             ,xx_vr_x(0,1,k_1),xx_vi_x(0,1,k_1)
     &             ,xx_vr_y(0,1,k_1),xx_vi_y(0,1,k_1)
     &             ,xx_ur_t(0,1)    ,xx_vr_t(0,1)
#endif
     &            )
            d2=mpi_wtime()
            dd(4)=dd(4)+d2-d1

            d1=mpi_wtime()
            if(k_1>1)then

               i_2 = get_loop_start(i_base+1,     size_of_row,my_row)
               i_3 = get_loop_end  (i_base+k_1-1, size_of_row,my_row)
#ifdef MEMORY1
      nxx = xx_ur_y(2470,i_3,k_1)
      nxx = xx_vr_y(2480,i_3,k_1)
      nxx = xx_ui_y(2490,i_3,k_1)
      nxx = xx_vi_y(2500,i_3,k_1)
      nxx = xx_ur_x(2510,j_3,k_1)
      nxx = xx_ui_x(2520,j_3,k_1)
      nxx = xx_vr_x(2530,j_3,k_1)
      nxx = xx_vi_x(2540,j_3,k_1)
#endif

               do i_1=i_2,i_3

                  j   = translate_l2g(i_1, size_of_row,my_row)
                  l_1 = j-i_base

#ifdef MEMORY1
      nxx = xx_wr(2550,j_3,l_1)
      nxx = xx_wi(2560,j_3,l_1)
#endif
                  ur_y0=ur_y(i_1,k_1)
                  vr_y0=vr_y(i_1,k_1)
                  ui_y0=ui_y(i_1,k_1)
                  vi_y0=vi_y(i_1,k_1)

*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do j_1=j_2,j_3

                     wr_x0 = 0
                     wi_x0 = 0
                     ur_x0 = ur_x(j_1,k_1)
                     ui_x0 = ui_x(j_1,k_1)
                     vr_x0 = vr_x(j_1,k_1)
                     vi_x0 = vi_x(j_1,k_1)

                     wr_x0 = wr_x0
     &                            - vr_x0*ur_y0
                     wi_x0 = wi_x0
     &                            - vi_x0*ur_y0
                     wr_x0 = wr_x0
     &                            - ur_x0*vr_y0
                     wi_x0 = wi_x0
     &                            - ui_x0*vr_y0
                     wr_x0 = wr_x0
     &                            - vi_x0*ui_y0
                     wi_x0 = wi_x0
     &                            + vr_x0*ui_y0
                     wr_x0 = wr_x0
     &                            - ui_x0*vi_y0
                     wi_x0 = wi_x0
     &                            + ur_x0*vi_y0

                     wr(j_1,l_1) = wr_x0+wr(j_1,l_1)
                     wi(j_1,l_1) = wi_x0+wi(j_1,l_1)

                  enddo! j_1
               enddo! i_1
            endif
            d2=mpi_wtime()
            dd(6)=dd(6)+d2-d1

1000        continue
         enddo! k_1

         i_2 = get_loop_start(i_base+1,  size_of_row,my_row)
         i_3 = get_loop_end  (i_base+m0, size_of_row,my_row)
         do i_1=i_2,min(n_,i_3)
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_2 = 1
            j_3 = get_loop_end  (j, size_of_col,my_col)
#ifdef MEMORY1
      nxx = xx_wr(2570,j_3,j-i_base)
      nxx = xx_wi(2580,j_3,j-i_base)
#endif
            do j_1=j_2,j_3
               ar_(j_1,i_1) = wr(j_1,j-i_base)
               ai_(j_1,i_1) = wi(j_1,j-i_base)
            enddo! j_1
         enddo! i_1
         do i_1=max(i_2,n_+1),i_3
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_2 = 1
            j_3 = get_loop_end  (j, size_of_col,my_col)
#ifdef MEMORY1
      nxx = xx_wr(2590,j_3,j-i_base)
      nxx = xx_wi(2600,j_3,j-i_base)
#endif
            do j_1=j_2,j_3
               ar(j_1,i_1) = wr(j_1,j-i_base)
               ai(j_1,i_1) = wi(j_1,j-i_base)
            enddo! j_1
         enddo! i_1

         if ( diag_0 > 0 ) then
            i_2 = diag_0
            i_3 = get_loop_end  (i_base, size_of_row,my_row)
            i_4 = size_of_col/n_common
            if ( i_2 <= n_ ) then
#ifdef MEMORY1
      nxx = xx_d_t(2610,int((min(i_3,n_)-i_2)/i_4)*i_4+i_2)
#endif
               if ( size_of_row == size_of_col ) then
                  do i_1=i_2,min(i_3,n_),i_4
                     j_1 = i_1
                     ar_(j_1,i_1) = d_t(i_1)
                  enddo! i_1
               else
                  do i_1=i_2,min(i_3,n_),i_4
                     j   = (i_1-1)*size_of_row+my_row
                     j_1 = (j-1)/size_of_col +1
                     ar_(j_1,i_1) = d_t(i_1)
                  enddo! i_1
               endif
               i_2=((n_-i_2)/i_4+1)*i_4+i_2
            endif
#ifdef MEMORY1
      nxx = xx_d_t(2620,int((    i_3    -i_2)/i_4)*i_4+i_2)
#endif
            if ( size_of_row == size_of_col ) then
               do i_1=i_2,i_3,i_4
                  j_1 = i_1
                  ar(j_1,i_1)  = d_t(i_1)
               enddo! i_1
            else
               do i_1=i_2,i_3,i_4
                  j   = (i_1-1)*size_of_row+my_row
                  j_1 = (j-1)/size_of_col +1
                  ar(j_1,i_1)  = d_t(i_1)
               enddo! i_1
            endif
         endif

         if ( i_block > 1 ) then
            i_2 = 1
!----       i_3 = get_loop_end  (i_base, size_of_row,my_row)
            i_3 = i_base
            d1=mpi_wtime() 
!$omp parallel
            call eigen_hrd_2update(
     &             ar(1,1),ai(1,1),lda,
     &             ur_x(1,1),ui_x(1,1),
     &             ur_y(1,1),ui_y(1,1),
     &             vr_x(1,1),vi_x(1,1),
     &             vr_y(1,1),vi_y(1,1),   
     &             nv,m0,i_3,
     &             ar_(1,1),ai_(1,1),n_,nm_
#ifdef MEMORY1
     &            ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &            ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &            ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &            ,xx_vr_y(0,1,1),xx_vi_y(0,1,1)
#endif
     &           )
!$omp end parallel
            d2=mpi_wtime() 
            dd(3)=dd(3)+d2-d1

         endif

      enddo! i_block

      if ( n >= 2 ) then
         i = 2; l = i-1
         y_root = get_owner_node (i, size_of_row,my_row)
         x_root = get_owner_node (l, size_of_col,my_col)
         if ( y_root == my_row .and. x_root == my_col ) then
            i_1 = translate_g2l(i, size_of_row,my_row)
            j_1 = translate_g2l(l, size_of_col,my_col)
            if(i_1<=n_)then
               ur_t(1) = ar_(j_1,i_1)
               ur_t(2) = ai_(j_1,i_1)
            else
               ur_t(1) = ar(j_1,i_1)
               ur_t(2) = ai(j_1,i_1)
            endif
         endif
#ifdef MEMORY1
      nxx = xx_ur_t(2630,2)
#endif
         call bcast_dbl(ur_t(1), 2, x_root, mpi_comm_col)
         call bcast_dbl(ur_t(1), 2, y_root, mpi_comm_row)
         scale = abs(ur_t(1)) + abs(ur_t(2))

         if ( scale > 0.0d0 ) then
            sr = ur_t(1) / scale
            si = ur_t(2) / scale
            h = sr**2 + si**2
            g = sqrt(h)
            tau(l,1) =  (si * tau(i,2) - sr * tau(i,1)) / g
            tau(l,2) = -(sr * tau(i,2) + si * tau(i,1)) / g
            y_root = get_owner_node (i, size_of_row,my_row)
            x_root = get_owner_node (l, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(i, size_of_row,my_row)
               j_1 = translate_g2l(l, size_of_col,my_col)
               e_out(i)  = scale * g
               e2_out(i) = scale * scale * h
               if ( i_1 <= n_ ) then
                  ar_(j_1,i_1) = scale * 2 * sr
                  ai_(j_1,i_1) = scale * 2 * si
               else
                  ar(j_1,i_1)  = scale * 2 * sr
                  ai(j_1,i_1)  = scale * 2 * si
               endif
            endif
            y_root = get_owner_node (i, size_of_row,my_row)
            x_root = get_owner_node (i, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(i, size_of_row,my_row)
               j_1 = translate_g2l(i, size_of_col,my_col)
               if ( i_1 <= n_ ) then
                  ai_(j_1,i_1) = scale * sqrt(2*h)
               else
                  ai(j_1,i_1)  = scale * sqrt(2*h)
               endif
            endif
            y_root = get_owner_node (l, size_of_row,my_row)
            x_root = get_owner_node (l, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(l, size_of_row,my_row)
               j_1 = translate_g2l(l, size_of_col,my_col)
               if ( i_1 <= n_ ) then
                  ai_(j_1,i_1) = 0.0d0
               else
                  ai(j_1,i_1)  = 0.0d0
               endif
            endif
         endif
      endif

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = get_loop_end  (n, size_of_row,my_row)
         i_4 = size_of_col/n_common
         if ( i_2 <= n_ ) then
         do i_1=i_2,min(i_3,n_),i_4
            j   = (i_1-1)*size_of_row+my_row
            j_1 = (j-1)/size_of_col +1
            t1           = d_out(j)
            d_out(j)     = ar_(j_1,i_1)
            ar_(j_1,i_1) = t1
         enddo! i_1
         i_2=((n_-i_2)/i_4+1)*i_4+i_2
         endif
         do i_1=i_2,i_3,i_4
            j   = (i_1-1)*size_of_row+my_row
            j_1 = (j-1)/size_of_col +1
            t1           = d_out(j)
            d_out(j)     = ar(j_1,i_1)
            ar(j_1,i_1)  = t1
         enddo! i_1
      endif

#ifdef MEMORY1
      nxx = xx_ur_t(2640,n)
#endif
      call reduce_dbl(d_out(1), ur_t(1), n, mpi_comm_world)
      call reduce_dbl(e_out(1), ur_t(1), n, mpi_comm_world)
      call reduce_dbl(e2_out(1),ur_t(1), n, mpi_comm_world)

!$omp parallel
      call eigen_hrd_Au(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
     &       ur_t,ui_t, vr_t,vi_t, d_t,
     &       -2, x_pos,y_pos, nv,k_1-k_2,
     &       ar_,ai_,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_ur_t(0,1)  ,xx_ui_t(0,1)
     &      ,xx_vr_t(0,1)  ,xx_vi_t(0,1)
!-------
     &      ,xx_d_t (0,1)
!-------
#endif
     &     )
      call eigen_hrd_2update(
     &       ar,ai,lda,
     &       ur_x,ui_x,ur_y,ui_y,
     &       vr_x,vi_x,vr_y,vi_y,   
     &       nv,m0,-2,
     &       ar_,ai_,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_vr_y(0,1,1),xx_vi_y(0,1,1)
#endif
     &     )
!$omp end parallel

!----
#ifdef DETAIL
      if(myrank==1)then
         print*," "
         print*,"detail of exectime in 'eigen_hrd'"
         print*,"   calc (u,beta)    ",dd(1),"(sec)"
         print*,"   mat-vec (au)     ",dd(2),"(sec)"
         print*,"   2update (a-uv-vu)",dd(3),"(sec)"
!----    print*,"   mat-vec (au)     ",dd(2),(dble(n)**3*8d-9/3)/dd(2)
!----    print*,"   2update (a-uv-vu)",dd(3),(dble(n)**3*8d-9/3)/dd(3)
         print*,"   calc v           ",dd(4),"(sec)"
         print*,"   v=v-(uv+vu)u     ",dd(5),"(sec)"
         print*,"   uv post reduction",dd(6),"(sec)"
      endif
#endif
!----
      m = m_orig

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1,i2
      xx_ur_x = nxx_ur_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ur_x,kxx_ur_x,"eigen_hrd_main2:ur_x")
      end function

      function xx_ui_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1,i2
      xx_ui_x = nxx_ui_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ui_x,kxx_ui_x,"eigen_hrd_main2:ui_x")
      end function

      function xx_vr_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1,i2
      xx_vr_x = nxx_vr_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vr_x,kxx_vr_x,"eigen_hrd_main2:vr_x")
      end function

      function xx_vi_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1,i2
      xx_vi_x = nxx_vi_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vi_x,kxx_vi_x,"eigen_hrd_main2:vi_x")
      end function

      function xx_ur_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1,i2
      xx_ur_y = nxx_ur_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ur_y,kxx_ur_y,"eigen_hrd_main2:ur_y")
      end function

      function xx_ui_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1,i2
      xx_ui_y = nxx_ui_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ui_y,kxx_ui_y,"eigen_hrd_main2:ui_y")
      end function

      function xx_vr_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_y
      integer :: i0,i1,i2
      xx_vr_y = nxx_vr_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vr_y,kxx_vr_y,"eigen_hrd_main2:vr_y")
      end function

      function xx_vi_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_y
      integer :: i0,i1,i2
      xx_vi_y = nxx_vi_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vi_y,kxx_vi_y,"eigen_hrd_main2:vi_y")
      end function

      function xx_wr(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_wr
      integer :: i0,i1,i2
      xx_wr = nxx_wr + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_wr,kxx_wr,"eigen_hrd_main2:wr_x")
      end function

      function xx_wi(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_wi
      integer :: i0,i1,i2
      xx_wi = nxx_wi + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_wi,kxx_wi,"eigen_hrd_main2:wi_x")
      end function

      function xx_ur_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_t
      integer :: i0,i1
      xx_ur_t = nxx_ur_t + i1 - 1
      call accessor(i0,xx_ur_t,kxx_ur_t,"eigen_hrd_main2:ur_t")
      end function

      function xx_ui_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_t
      integer :: i0,i1
      xx_ui_t = nxx_ui_t + i1 - 1
      call accessor(i0,xx_ui_t,kxx_ui_t,"eigen_hrd_main2:ui_t")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"eigen_hrd_main2:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"eigen_hrd_main2:vi_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"eigen_hrd_main2:d_t")
      end function
#endif
      end
