      use communication_h, only : eigen_init
     &                , eigen_free
     &                , cyc1d_cyc2d
     &                , cyc2d_cyc1d

      implicit double precision (a-h,o-z)

      real(8), allocatable :: a(:,:),ai(:,:)
      real(8), allocatable :: as(:,:),asi(:,:)
      real(8), pointer :: b(:),bi(:),c(:),ci(:),w(:)
      logical :: iexist
!
      include 'mpif.h'
      include 'trd.h'
!
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_world,i$inod,ierr)
      call mpi_comm_size(mpi_comm_world,i$nnod,ierr)
*
      n=100
C*DebugWrite02-start*****************************************
c ....行列サイズをファイルから読み込み
      inquire(file='matsize.txt',exist=iexist)
      if(iexist) then
         open(999,file='matsize.txt',err=20)
         read(999,*,err=20) matsize
         n = matsize
 20      continue
         close(999)
      endif
      if(myrank==1)then
         write(*,*) 'matrix size = ',n
      endif
C*DebugWrite02-end*******************************************
      m=32
      nm=(n/2)*2+1
      allocate( a(n,n), ai(n,n) )
      allocate( as(n,n), asi(n,n) )
      allocate(
     &         b((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bi((nm)*((n-1)/i$nnod+1+nm+1)),
     &         c((nm)*((n-1)/i$nnod+1+nm+1)),
     &         ci((nm)*((n-1)/i$nnod+1+nm+1)),
     &         w(nm),
     &         stat=istat )
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         stop
      endif
*
      call matrix_set(n,a,ai)
      as = a
      asi = ai
      call matrix_adjust_h(a,n,b,nm)
      call matrix_adjust_hi(ai,n,bi,nm)
      call eigen_h(n,b,bi,w,nm,m,0)
      !!!!!!
      !if (i$inod == 0) then
      !  open(80,file='w_rand.dat')
      !  do i=1,n
      !    write(80,'(e56.48e4)') w(i)
      !  enddo
      !  close(80)
      !  open(80,file='z_rand.dat')
      !  open(81,file='zi_rand.dat')
      !  do j=1,n
      !    do i=1,n
      !      write(80,'(e56.48e4)') b(i+(j-1)*nm)
      !      write(81,'(e56.48e4)') bi(i+(j-1)*nm)
      !    enddo
      !  enddo
      !  close(80)
      !  close(81)
      !endif
      !!!!!!
*
      !call matrix_set(n,a,ai)
      a = as
      ai = asi
      call matrix_adjust_h(a,n,c,nm)
      call matrix_adjust_hi(ai,n,ci,nm)
      call ev_test2(c,ci,w,b,bi,n,nm)
*
      deallocate(a,ai,b,bi,c,ci,w)

      call MPI_Finalize(ierr)
      end
