C
C Subroutines for Basic operation of Matrix calculation
C                                   with Double-Double precision
C
C subroutine dd_add(ah,al,bh,bl,ch,cl)
C subroutine dd_sub(ah,al,bh,bl,ddmh,ddml)
C SUBROUTINE dd_multiple(ah,al,bh,bl,ddmh,ddml)
C subroutine dd_scal(ah,al,alphah,alphal)
C subroutine dd_reciprocal(ah,al)
C SUBROUTINE dd_divide(ah,al,bh,bl,ch,cl)
C subroutine dd_idot(n,DXH,DXL,DXIH,DXIL,DYH,DYL,
C    +                      DYIH,DYIL,DDH,DDL,DDIH,DDIL)
C SUBROUTINE dd_abs(ah,al,bh,bl)
C SUBROUTINE dd_sqrt(ah,al,bh,bl)

       SUBROUTINE dd_sqrt(ah,al,bh,bl)
       real(8) ::    ah    ,  al
       real(8) ::    bh    ,  bl

      INTRINSIC SQRT
      double precision SSQh, SSQl
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision tmp3h, tmp3l
      double precision tmp4h, tmp4l
      double precision T_ch, T_cl
      double precision T_p1, T_p2
      double precision T_q1, T_q2
      double precision T_r1, T_r2
      double precision T_s1, T_s2
      double precision T_t1, T_t2
      double precision T_u1, T_u2
      double precision T_x1, T_x2
      double precision T_y1, T_y2
      double precision T_z1, T_z2
      double precision T_x, T_ax
      double precision T_t1h, T_t1l
      double precision T_t2h, T_t2l

	SSQh=ah
	SSQl=al

!     tmp1 = sqrt(SSQ)
      if (SSQh.eq.0.0D+0.and.SSQl.eq.0.0D+0) then
        tmp1h = 0.0d+0
        tmp1l = 0.0d+0
      endif
      if (SSQh.lt.0.0d+0.or.
     +   (SSQh.eq.0.0d+0.and.SSQl.lt.0.0d+0)) then
        write(6,'(a)')
     +     'SQRT CALLED WITH NEGATIVE ARGUMENT'
        tmp1h = 0.0d+0
        tmp1l = 0.0d+0
        return
      endif
      T_x = 1.0D+0/sqrt(SSQh)
      T_ax = SSQh * T_x

!         call dd_mul(T_y1,T_y2,T_x,
!                     0.0,0.5,0.0)
          T_y1 = T_x * 0.5d+0
          T_u1 = 134217729.0 * T_x
          T_p1 = T_u1
     +             - (T_u1 - T_x)
          T_p2 = T_x - T_p1
          T_u1 = 134217729.0 * 0.5d+0
          T_r1 = T_u1
     +             - (T_u1 - 0.5d+0)
          T_r2 = 0.5d+0 - T_r1
          T_y2 = ((T_p1*T_r1
     +             - T_y1)
     +             + T_p1*T_r2
     +             + T_p2 * T_r1)
     +             + T_p2 * T_r2
          T_s1 = T_y1 + T_y2
          T_y2 = T_y2
     +             - (T_s1 - T_y1)
          T_y1 = T_s1

!         call dd_mul(T_z1,T_z2,T_ax,
!                     0.0,T_ax,0.0)

          T_z1 = T_ax * T_ax
          T_u1 = 134217729.0 * T_ax
          T_p1 = T_u1
     +             - (T_u1 - T_ax)
          T_p2 = T_ax - T_p1
          T_u1 = 134217729.0 * T_ax
          T_r1 = T_u1
     +             - (T_u1 - T_ax)
          T_r2 = T_ax - T_r1
          T_z2 = ((T_p1 * T_r1
     +             - T_z1)
     +             + T_p1 * T_r2
     +             + T_p2 * T_r1)
     +             + T_p2*T_r2
          T_s1 = T_z1 + T_z2
          T_z2 = T_z2
     +             - (T_s1 - T_z1)
          T_z1 = T_s1

!         call dd_sub(T_t2h,T_t2l,
!                           SSQh,SSQl,T_z1,T_z2)
          T_p1 = SSQh - T_z1
          T_p2 = T_p1 - SSQh
          T_t2l = (SSQh
     +             -(T_p1 - T_p2))
     +             -(T_z1 + T_p2)
          T_t2h = T_p1
          T_t2l = T_t2l
     +             + SSQl - T_z2
          T_s1 = T_t2h + T_t2l
          T_t2l = T_t2l
     +             - (T_s1 - T_t2h)
          T_t2h = T_s1
!         call dd_mul(T_t1h,T_t1l,
!                     T_t2h,T_t2l,
!                     T_y1,T_y2)
          T_t1h = T_t2h * T_y1
          T_u1 = 134217729.0 * T_t2h
          T_p1 = T_u1
     +             - (T_u1 - T_t2h)
          T_p2 = T_t2h - T_p1
          T_u1 = 134217729.0 * T_y1
          T_r1 = T_u1
     +             - (T_u1 - T_y1)
          T_r2 = T_y1 - T_r1
          T_t1l = ((T_p1*T_r1
     +             - T_t1h)
     +             + T_p1*T_r2
     +             + T_p2*T_r1)
     +             + T_p2*T_r2
          T_t1l = T_t1l
     +             + (T_t2h * T_y2
     +             +  T_t2l * T_y1)
          T_s1 = T_t1h + T_t1l
          T_t1l = T_t1l - (T_s1
     +              - T_t1h)
          T_t1h = T_s1

!         call dd_selfadd(T_t1h,T_t1l,
!                     T_ax,0.0)
          T_p1 = T_t1h + T_ax
          T_p2 = T_p1 - T_t1h
          T_q2 = (T_t1h
     +             - (T_p1 - T_p2))
     +             + (T_ax - T_p2)
          T_q1 = T_p1
          T_q2 = T_q2 + T_t1l
          T_t1h = T_q1 + T_q2
          T_t1l = T_q2
     +              - (T_t1h - T_q1)
          tmp1h = T_t1h
          tmp1l = T_t1l

	bh=tmp1h
	bl=tmp1l

       END SUBROUTINE

      SUBROUTINE dd_abs(ah,al,bh,bl)
      real(8) ::    ah    ,  al
      real(8) ::    bh    ,  bl

      if (ah .lt. 0.0d+00) then
           bh = -1.0 * ah
           bl = -1.0 * al
      else if ((ah .eq. 0.0d+0).and.(al .lt. 0.0d+0)) then
           bh =        ah
           bl = -1.0 * al
      else
           bh =        ah
           bl =        al
      endif

      END SUBROUTINE

       subroutine dd_idot(n,DXH,DXL,DXIH,DXIL,DYH,DYL,
     +                      DYIH,DYIL,DDH,DDL,DDIH,DDIL)
*     .. Scalar Arguments ..
      INTEGER INCX,INCY,N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION DXH(*),DXL(*),DYH(*),DYL(*),DDH,DDL
      DOUBLE PRECISION DXIH(*),DXIL(*),DYIH(*),DYIL(*),DDIH,DDIL
      double precision s1,s2,q1,q2,r1,r2,p1,p2,t1,t2,u1,u2
      INTEGER I,IX,IY,M,MP1

      DDH = 0.0d0
      DDL = 0.0d0
!     DTEMP = 0.0d0
      IF (N.LE.0) RETURN
*
*

      DO 10 IX = 1,N
          IY=IX
!         DTEMP = DTEMP + DX(IX)*DY(IY)
!         CALL dd_mul(t1,t2,DXH(IX),DXL(IX),DYH(IY),DYL(IY))
          t1 = DXH(IX) * DYH(IY)
          u1 = 134217729.0*DXH(IX)
          p1 = u1 - (u1-DXH(IX))
          p2 = DXH(IX) - p1
          u1 = 134217729.0*DYH(IY)
          r1 = u1 - (u1-DYH(IY))
          r2 = DYH(IY) - r1
          t2 = ((p1*r1-t1) + p1*r2 + p2*r1) + p2*r2
          t2 = t2 + (DXH(IX) * DYL(IY) + DXL(IX) * DYH(IY))
          s1 = t1 + t2
          t2 = t2 - (s1 - t1)
          t1 = s1

!         CALL dd_selfadd(DDH,DDL,t1,t2)
          p1 = DDH + t1
          p2 = p1 - DDH
          q2 = (DDH - (p1 - p2)) + (t1 - p2)
          q1 = p1
          q2 = q2 + DDL
          q2 = q2 + t2
          DDH = q1 + q2
          DDL = q2 - (DDH - q1)

!         DTEMP = DTEMP + DXI(IX)*DYI(IY)
          t1 = DXIH(IX) * DYIH(IY)
          u1 = 134217729.0*DXIH(IX)
          p1 = u1 - (u1-DXIH(IX))
          p2 = DXH(IX) - p1
          u1 = 134217729.0*DYIH(IY)
          r1 = u1 - (u1-DYIH(IY))
          r2 = DYIH(IY) - r1
          t2 = ((p1*r1-t1) + p1*r2 + p2*r1) + p2*r2
          t2 = t2 + (DXIH(IX) * DYIL(IY) + DXIL(IX) * DYIH(IY))
          s1 = t1 + t2
          t2 = t2 - (s1 - t1)
          t1 = s1

!         CALL dd_selfadd(DDH,DDL,t1,t2)
          p1 = DDH + t1
          p2 = p1 - DDH
          q2 = (DDH - (p1 - p2)) + (t1 - p2)
          q1 = p1
          q2 = q2 + DDL
          q2 = q2 + t2
          DDH = q1 + q2
          DDL = q2 - (DDH - q1)

!         DTEMP = DTEMP + DXI(IX)*DY(IY)
          t1 = DXIH(IX) * DYH(IY)
          u1 = 134217729.0*DXIH(IX)
          p1 = u1 - (u1-DXIH(IX))
          p2 = DXIH(IX) - p1
          u1 = 134217729.0*DYH(IY)
          r1 = u1 - (u1-DYH(IY))
          r2 = DYH(IY) - r1
          t2 = ((p1*r1-t1) + p1*r2 + p2*r1) + p2*r2
          t2 = t2 + (DXIH(IX) * DYL(IY) + DXIL(IX) * DYH(IY))
          s1 = t1 + t2
          t2 = t2 - (s1 - t1)
          t1 = s1

!         CALL dd_selfadd(DDIH,DDIL,t1,t2)
          p1 = DDIH + t1
          p2 = p1 - DDIH
          q2 = (DDIH - (p1 - p2)) + (t1 - p2)
          q1 = p1
          q2 = q2 + DDIL
          q2 = q2 + t2
          DDIH = q1 + q2
          DDIL = q2 - (DDIH - q1)

!         DTEMP = DTEMP + DX(IX)*DYI(IY)
          t1 = DXH(IX) * DYIH(IY)
          u1 = 134217729.0*DXH(IX)
          p1 = u1 - (u1-DXH(IX))
          p2 = DXH(IX) - p1
          u1 = 134217729.0*DYIH(IY)
          r1 = u1 - (u1-DYIH(IY))
          r2 = DYIH(IY) - r1
          t2 = ((p1*r1-t1) + p1*r2 + p2*r1) + p2*r2
          t2 = t2 + (DXH(IX) * DYIL(IY) + DXL(IX) * DYIH(IY))
          s1 = t1 + t2
          t2 = t2 - (s1 - t1)
          t1 = s1

!         CALL dd_selfadd(DDIH,DDIL,t1,t2)
          p1 = DDIH + t1
          p2 = p1 - DDIH
          q2 = (DDH - (p1 - p2)) + (t1 - p2)
          q1 = p1
          q2 = q2 + DDIL
          q2 = q2 + t2
          DDIH = q1 + q2
          DDIL = q2 - (DDIH - q1)

   10 CONTINUE
       end subroutine

       SUBROUTINE dd_divide(ah,al,bh,bl,ch,cl)

       real(8) ::    ah    ,  al
       real(8) ::    bh    ,  bl
       real(8) ::    ch    ,  cl
       double precision  tmp1h,tmp1l

         if (bh.eq.0.0d+0 .and. bl.eq.0.0d+0) then
           ch = 0.0d+0
           cl = 0.0d+0
         else
		tmp1h = bh
		tmp1l = bl
		call dd_reciprocal(tmp1h,tmp1l)
		call dd_multiple(ah,al,tmp1h,tmp1l,ch,cl)

         end if
       end subroutine

       subroutine dd_reciprocal(ah,al)
         real(8) ::     ah    ,  al
         real(8) ::    temph ,  templ
         real(8) :: t_q1,t_ch,t_u1,t_p1,t_p2,t_r1,t_r2,t_cl,t_s1,t_s2
         real(8) :: t_q2

		temph = 1.0

!         	temp = temp / a(i,i)
		t_q1 = temph / ah
		t_ch = ah * t_q1
		t_u1 = 134217729.0 * ah
		t_p1 = t_u1- (t_u1 - ah)                              
		t_p2 = ah - t_p1
		t_u1 = 134217729.0 * t_q1
		t_r1 = t_u1 - (t_u1 - t_q1)                             
		t_r2 = t_q1 - t_r1
		t_cl = ((t_p1*t_r1 - t_ch)
     +                 + t_p1*t_r2 + t_p2*t_r1)
     +                 + t_p2*t_r2
		t_cl = t_cl + (al * t_q1)                              
		t_s1 = t_ch + t_cl
		t_cl = t_cl - (t_s1 - t_ch)                            
		t_ch = t_s1
		t_s1 = temph - t_ch
		t_r1 = t_s1 - temph
		t_s2 = (temph- (t_s1 - t_r1))- (t_ch + t_r1)                              
		t_s2 = t_s2 - t_cl
		t_s2 = t_s2 + templ
		t_q2 = (t_s1 + t_s2)/ ah                               
		temph = t_q1 + t_q2
		templ = t_q2- (temph - t_q1)
         al = templ
         ah = temph

       end subroutine

       subroutine dd_scal(ah,al,alphah,alphal)
         real(8) ::     ah    ,  al
         real(8) ::    alphah ,  alphal
         real(8) ::t_ch,t_u1,t_p1,t_p2,t_r1,t_r2,t_cl,t_s1

!               a(i,j) = alpha * a(i,j)
		t_ch = alphah * ah
		t_u1 = 134217729.0 * alphah
		t_p1 = t_u1 - (t_u1 - alphah)                         
		t_p2 = alphah - t_p1
		t_u1 = 134217729.0 * ah
		t_r1 = t_u1 - (t_u1 - ah)                              
		t_r2 = ah - t_r1
		t_cl = ((t_p1 * t_r1 - t_ch)
     +                 + t_p1 * t_r2 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
		t_cl = t_cl + (alphah * al) + (alphal * ah)
		t_s1 = t_ch + t_cl
		al = t_cl - (t_s1 - t_ch)
		ah = t_s1

       end subroutine

       SUBROUTINE dd_multiple(ah,al,bh,bl,ddmh,ddml)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ddmh    ,  ddml
         real(8) :: t_u1,t_p1,t_p2,t_r1,t_r2,t_s1

		ddmh = bh * ah
		t_u1 = 134217729.0 * bh
		t_p1 = t_u1 - (t_u1 - bh)
		t_p2 = bh - t_p1
		t_u1 = 134217729.0 * ah
		t_r1 = t_u1- (t_u1 - ah)
		t_r2 = ah - t_r1
		ddml = ((t_p1*t_r1-ddmh)+ t_p1*t_r2+t_p2*t_r1) +t_p2*t_r2    
		ddml = ddml+ (bh*al+ bl*ah)
		t_s1 = ddmh + ddml
		ddml = ddml - (t_s1 - ddmh)
		ddmh = t_s1

       end subroutine

       subroutine dd_sub(ah,al,bh,bl,ddmh,ddml)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ddmh    ,  ddml
         real(8) t_p1,t_p2,t_s1

          T_p1 = ah - bh
          T_p2 = T_p1 - ah
          ddml = (ah-(T_p1 - T_p2))-(bh + T_p2)
          ddmh = T_p1
          ddml = ddml + al - bl
          T_s1 = ddmh + ddml
          ddml = ddml - (T_s1 - ddmh)
          ddmh = T_s1
       end subroutine

       subroutine dd_add(ah,al,bh,bl,ch,cl)
         real(8) ::    ah    ,  al
         real(8) ::    bh    ,  bl
         real(8) ::    ch    ,  cl
         real(8) x_p1,x_p2,x_s1

          x_p1 = ah + bh
          x_p2 = x_p1 - ah
          ch = x_p1
          cl = (ah - (x_p1 - x_p2)) + (bh - x_p2)
          cl = cl + al + bl
          x_s1 = ch + cl
          cl = cl - (x_s1 - ch)
          ch = x_s1

       end subroutine
