C
C     Sample program for calculating the eigenvalues 
C                         of the Hermeite mattix of order 5
C
      use ddcommunication_h, only : eigen_init
     &                            , eigen_free
     &                            , ddcyc1d_cyc2d
     &                            , ddcyc2d_cyc1d

      implicit double precision (a-h,o-z)

      real(8), allocatable :: ah(:,:),aih(:,:)
      real(8), allocatable :: al(:,:),ail(:,:)
      real(8), pointer :: bh(:),bih(:),wh(:)
      real(8), pointer :: bl(:),bil(:),wl(:)

      include 'mpif.h'
      include 'trd.h'

C     Initialize MPI
      call mpi_init(ierr)
      call mpi_comm_rank(mpi_comm_world,i$inod,ierr)
      call mpi_comm_size(mpi_comm_world,i$nnod,ierr)

C     Memoris of matrix
      n=5
      m=32
      nm=(n/2)*2+1
      allocate( ah(n,n), aih(n,n), al(n,n), ail(n,n) )
      allocate(
     &         bh((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bih((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bl((nm)*((n-1)/i$nnod+1+nm+1)),
     &         bil((nm)*((n-1)/i$nnod+1+nm+1)),
     &         wh(nm), wl(nm),
     &         stat=istat )
      if(istat.ne.0) then
         print*,"Memory exhausted"
         call flush(6)
         stop
      endif

C     Hermite matrix
      call ddmatrix_hermite(n,ah,al,aih,ail)

      call ddmatrix_adjust_h(ah,al,n,bh,bl,nm)
      call ddmatrix_adjust_hi(aih,ail,n,bih,bil,nm)

C     Calculating eigen values and vectors
      call ddeigen_h(n,bh,bl,bih,bil,wh,wl,nm,m,0)

      do i=1,n
         write(*,*) 
     &     'EigenValue=', wh(i) , wl(i)
      enddo

C     Free　
      deallocate(ah,aih,bh,bih,wh)
      deallocate(al,ail,bl,bil,wl)

C     Finalizing MPI
      call MPI_Finalize(ierr)
      end
