#ifdef MEMORY2
      module xx_hbk_info
      implicit none
      integer,private :: myrank
      integer,parameter :: nmax = 7
      integer,private,parameter :: IMAX = 2147483647
      integer,private :: ns(1:nmax) =  IMAX
      integer,private :: ne(1:nmax) = -IMAX
      integer,private :: ns0(1:nmax) = 0
      integer,private :: ne0(1:nmax) = 0
      integer,parameter ::  kxx_vr  = 1
      integer,parameter ::  kxx_vi  = 2
      integer,parameter ::  kxx_wr  = 3
      integer,parameter ::  kxx_wi  = 4
      integer,parameter ::  kxx_ssr = 5
      integer,parameter ::  kxx_ssi = 6
      integer,parameter ::  kxx_tt  = 7

      contains

      subroutine setter(ns1,ne1)
      implicit none
      include 'mpif.h'
      integer,intent(in) :: ns1(1:nmax)
      integer,intent(in) :: ne1(1:nmax)
      integer :: ierr
      ns0 = ns1
      ne0 = ne1
      call mpi_comm_rank(mpi_comm_world, myrank, ierr)
      myrank = myrank+1
      end subroutine

      subroutine accessor(i0,n,kxx,c1)
      implicit none
      integer,intent(in) :: i0
      integer,intent(in) :: n
      integer,intent(in) :: kxx
      character(*),intent(in) :: c1
      character(2) :: cc1,cc2,cc3
      integer :: ncc3
      if ( (kxx < 1) .or. (nmax < kxx) ) then
        print *,"kxx error",kxx
        return
      end if
      ns(kxx) = min(ns(kxx),n)
      ne(kxx) = max(ne(kxx),n)
      cc3 = "ok"
      ncc3 = 0
      if (n <= ne0(kxx)) then
        cc2 = "<="
      else
        cc2 = "> "
        cc3 = "ng"
        ncc3 = 1
      end if
      if (ncc3 == 1) then
        print *,myrank,kxx,":",n,cc2,ne0(kxx)," at ",i0,c1
      end if
      end subroutine

      function eigen_get_memsize_hbk()
      implicit none
      integer :: i
      integer :: eigen_get_memsize_hbk
      eigen_get_memsize_hbk = ne(1)
      do i=1,nmax
        print *,myrank,i,":",ne(i)," in [",ns0(i),ne0(i),"]"
        eigen_get_memsize_hbk = max(eigen_get_memsize_hbk,ne(i))
      end do
      end function

      end module
#endif
#ifdef ARRAY_2D
!      subroutine eigen_hbk(ar2d,ai2d,lda1,zr2d,zi2d,lda3
!     &                              , zr,zi,ldz, tau,ldtau, n
      subroutine ddeigen_hbk(ar2dh,ar2dl,ai2dh,ai2dl,lda1,
     &                       zr2dh,zr2dl,zi2dh,zi2dl,lda3,
     &                       zrh,zrl,zih,zil,ldz,
     &                       tauh,taul,ldtau,n
#else
!      subroutine eigen_hbk(ar,ai,lda, zr,zi,ldz, tau,ldtau, n
      subroutine ddeigen_hbk(arh,arl,aih,ail,lda,
     &                       zrh,zrl,zih,zil,ldz,
     &                       tauh,taul,ldtau,n
#endif

     &                    )

!      use communication_h , only : eigen_init
!     &                , eigen_free
!     &                , cyc1d_cyc2d
!     &                , cyc2d_cyc1d
      use ddcommunication_h , only : eigen_init
     &                             , eigen_free
     &                             , ddcyc1d_cyc2d
     &                             , ddcyc2d_cyc1d

#ifdef MEMORY2
      use xx_hbk_info
#endif
      implicit double precision(a-h,o-z),integer(i-n)

#ifdef ARRAY_2D
!      real(8) :: ar2d(*),ai2d(*)
!      real(8) :: zr2d(*),zi2d(*)
      real(8) :: ar2dh(*),ai2dh(*)
      real(8) :: zr2dh(*),zi2dh(*)
      real(8) :: ar2dl(*),ai2dl(*)
      real(8) :: zr2dl(*),zi2dl(*)
      integer :: lda1,lda2,lda3,lda4
      integer :: nnr,nnc
#else
!      real(8) :: ar(*), ai(*)
      real(8) :: arh(*), arl(*), aih(*), ail(*)
#endif
!      real(8) :: zr(*), zi(*)
!      real(8) :: tau(*)
      real(8) :: zrh(*), zrl(*), zih(*), zil(*)
      real(8) :: tauh(*), taul(*)

!      real(8) , allocatable :: wkr(:), wki(:)
!      real(8) , pointer :: vr(:),vi(:), wr(:),wi(:)
!      real(8) , pointer :: ssr(:),ssi(:)
!      real(8) , pointer :: tt(:)
      real(8) , allocatable :: wkrh(:), wkih(:)
      real(8) , allocatable :: wkrl(:), wkil(:)
      real(8) , pointer :: vrh(:),vih(:), wrh(:),wih(:)
      real(8) , pointer :: vrl(:),vil(:), wrl(:),wil(:)
      real(8) , pointer :: ssrh(:),ssih(:)
      real(8) , pointer :: ssrl(:),ssil(:)
      real(8) , pointer :: tth(:),ttl(:)

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
#ifdef MEMORY2
       integer :: nxx_vr
       integer :: nxx_vi
       integer :: nxx_wr
       integer :: nxx_wi
       integer :: nxx_ssr
       integer :: nxx_ssi
       integer :: nxx_tt
       integer :: nxx_all
#endif
#ifdef MEMORY2
       integer ns1(1:nmax),ne1(1:nmax)
#endif

      call eigen_init(2)
      m = 128; mm = m*(m-1)/2/1

      s0=mpi_wtime()
      lda2 = (n-1)/size_of_col+1
      na   = (n-1)/size_of_row+1
      lda2 = lda2+mod(lda2-1,2)
      na   = na  +mod(na  -1,2)
#ifdef ARRAY_2D
      lda4 = lda2
#endif
!      allocate( wkr(lda2*na) )
!      allocate( wki(lda2*na) )
      allocate( wkrh(lda2*na), wkrl(lda2*na) )
      allocate( wkih(lda2*na), wkil(lda2*na) )

#ifdef ARRAY_2D
!     wkr is not used. wkr dummy copy
!      call cyc1d_cyc2d(n,zr(1),ldz,wkr(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
      call ddcyc1d_cyc2d(n,zrh(1),zrl(1),ldz,wkrh(1),wkrl(1),lda2,
     &                   size_of_col,size_of_row,ierr)
#else
!      call cyc1d_cyc2d(n,zr(1),ldz,wkr(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
!      call cyc1d_cyc2d(n,zi(1),ldz,wki(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
!      call cyc1d_cyc2d(n,ar(1),lda,zr(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
!      call cyc1d_cyc2d(n,ai(1),lda,zi(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
      call ddcyc1d_cyc2d(n,zrh(1),zrl(1),ldz,wkrh(1),wkrl(1),lda2,
     &                   size_of_col,size_of_row,ierr)
      call ddcyc1d_cyc2d(n,zih(1),zil(1),ldz,wkih(1),wkil(1),lda2,
     &                   size_of_col,size_of_row,ierr)
      call ddcyc1d_cyc2d(n,arh(1),arl(1),lda,zrh(1),zrl(1),lda2,
     &                   size_of_col,size_of_row,ierr)
      call ddcyc1d_cyc2d(n,aih(1),ail(1),lda,zih(1),zil(1),lda2,
     &                   size_of_col,size_of_row,ierr)
#endif
#ifdef ARRAY_2D
      nnc = (n-1)/size_of_col+1
      nnr = (n-1)/size_of_row+1
!      call arraycopy (ar2d,lda1,ar2d,lda2,nnc,nnr)
!      call arraycopy (ai2d,lda1,ai2d,lda2,nnc,nnr)
!      call arraycopy (zr2d,lda3,zr2d,lda4,nnc,nnr)
      call ddarraycopy (ar2dh,ar2dl,lda1,ar2dh,ar2dl,lda2,nnc,nnr)
      call ddarraycopy (ai2dh,ai2dl,lda1,ai2dh,ai2dl,lda2,nnc,nnr)
      call ddarraycopy (zr2dh,zr2dl,lda3,zr2dh,zr2dl,lda4,nnc,nnr)
!     lda3 = lda2
#endif

      nm = lda2
      allocate(
!     &         vr(1:nm*m), vi(1:nm*m),
!     &         wr(1:nm*m), wi(1:nm*m),
!     &         ssr(1:max(na*m+mm,n)),
!     &         ssi(1:max(na*m+mm,n)),
!     &         tt(1:max(na*m+mm,n)),
     &         vrh(1:nm*m), vih(1:nm*m),
     &         vrl(1:nm*m), vil(1:nm*m),
     &         wrh(1:nm*m), wih(1:nm*m),
     &         wrl(1:nm*m), wil(1:nm*m),
     &         ssrh(1:max(na*m+mm,n)),
     &         ssrl(1:max(na*m+mm,n)),
     &         ssih(1:max(na*m+mm,n)),
     &         ssil(1:max(na*m+mm,n)),
     &         tth(1:max(na*m+mm,n)),
     &         ttl(1:max(na*m+mm,n)),
     &         stat=i_stat)
      if(i_stat/=0)then
         if(myrank==1)print*,"memory allocation error."
         call mpi_abort(mpi_comm_world,1,ierr)
      endif
#ifdef MEMORY2
       nxx_vr  = 1
       nxx_vi  = nxx_vr + nm*m
       nxx_wr  = nxx_vi + nm*m
       nxx_wi  = nxx_wr + nm*m
       nxx_ssr = nxx_wi + nm*m
       nxx_ssi = nxx_ssr + max(na*m+mm,n)
       nxx_tt  = nxx_ssi + max(na*m+mm,n)
       nxx_all = nxx_tt  + max(na*m+mm,n)

       ns1(1) = nxx_vr
       ns1(2) = nxx_vi
       ns1(3) = nxx_wr
       ns1(4) = nxx_wi
       ns1(5) = nxx_ssr
       ns1(6) = nxx_ssi
       ns1(7) = nxx_tt

       ne1(1) = nxx_vi  - 1
       ne1(2) = nxx_wr  - 1
       ne1(3) = nxx_wi  - 1
       ne1(4) = nxx_ssr - 1
       ne1(5) = nxx_ssi - 1
       ne1(6) = nxx_tt  - 1
       ne1(7) = nxx_all - 1

       call setter(ns1,ne1)
#endif
      call mpi_barrier(mpi_comm_world,ierr)
#ifdef ARRAY_2D
!      call eigen_hbk_main1( 
!     &       n, ar2d(1),ai2d(1), lda2,
!     &       zr2d(1),zi2d(1), lda2,
!     &       tau(1),ldtau, m, mm,
!     &       vr(1),vi(1), wr(1),wi(1), nm, ssr(1),ssi(1),tt(1)
      call ddeigen_hbk_main1( 
     &       n, ar2dh(1),ar2dl(1),ai2dh(1),ai2dl(1),lda2,
     &       zr2dh(1),zr2dl(1),zi2dh(1),zi2dl(1),lda2,
     &       tauh(1),taul(1),ldtau, m, mm,
     &       vrh(1),vrl(1),vih(1),vil(1),wrh(1),wrl(1),wih(1),wil(1),nm,
     &       ssrh(1),ssrl(1),ssih(1),ssil(1),tth(1),ttl(1),
#ifdef MEMORY2
     &      ,nxx_vr  ,nxx_vi  ,nxx_wr ,nxx_wi
     &      ,nxx_ssr ,nxx_ssi ,nxx_tt
#endif
     &     )
#else
!      call eigen_hbk_main1( 
!     &       n, zr(1),zi(1), lda2,
!     &       wkr(1),wki(1), lda2,
!     &       tau(1),ldtau, m, mm,
!     &       vr(1),vi(1), wr(1),wi(1), nm, ssr(1),ssi(1),tt(1)
      call ddeigen_hbk_main1( 
     &       n, zrh(1),zrl(1),zih(1),zil(1),lda2,
     &       wkrh(1),wkrl(1),wkih(1),wkil(1),lda2,
     &       tauh(1),taul(1),ldtau, m, mm,
     &       vrh(1),vrl(1),vih(1),vil(1),wrh(1),wrl(1),wih(1),wil(1),nm,
     &       ssrh(1),ssrl(1),ssih(1),ssil(1),tth(1),ttl(1)
#ifdef MEMORY2
     &      ,nxx_vr  ,nxx_vi  ,nxx_wr ,nxx_wi
     &      ,nxx_ssr ,nxx_ssi ,nxx_tt
#endif
     &     )
#endif
#ifdef MEMORY2
      iok = eigen_get_memsize_hbk()
      print *," eigen_get_memsize_hbk = ",iok
#endif
      call mpi_barrier(mpi_comm_world,ierr)

#ifdef ARRAY_2D
      lda1 = lda2
      lda3 = lda4
#else
!      call cyc2d_cyc1d(n,zr(1),ldz,wkr(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
!      call cyc2d_cyc1d(n,zi(1),ldz,wki(1),lda2,size_of_col,size_of_row,
!     &                 ierr)
      call ddcyc2d_cyc1d(n,zrh(1),zrl(1),ldz,wkrh(1),wkrl(1),lda2,
     &                   size_of_col,size_of_row,ierr)
      call ddcyc2d_cyc1d(n,zih(1),zil(1),ldz,wkih(1),wkil(1),lda2,
     &                   size_of_col,size_of_row,ierr)
#endif


!      deallocate( vr,vi )
!      deallocate( wr,wi )
!      deallocate( ssr,ssi )
!      deallocate( tt )
!      deallocate( wkr,wki )
      deallocate( vrh,vrl,vih,vil )
      deallocate( wrh,wrl,wih,wil )
      deallocate( ssrh,ssrl,ssih,ssil )
      deallocate( tth,ttl )
      deallocate( wkrh,wkrl,wkih,wkil )

      call eigen_free(3)

#ifdef TIMER
      s1=mpi_wtime()
      if(myrank==1)then
!          print*,"Exectime of 'eigen_hbk' routine =",s1-s0,"(sec)"
          print*,"Exectime of 'ddeigen_hbk' routine =",s1-s0,"(sec)"
!----     s1-s0,8e-9*dble(n)**3/(s1-s0),"GFLOPS"
      endif
#endif

      return

      end subroutine
!----
!       subroutine eigen_hbk_main1(n,ar,ai,nma,zr,zi,nmz,tau,nmtau,
!     &                          m,mm, vr,vi,wr,wi,nm,ssr,ssi,tt
       subroutine ddeigen_hbk_main1(
     &                          n,arh,arl,aih,ail,nma,
     &                          zrh,zrl,zih,zil,nmz,
     &                          tauh,taul,nmtau,
     &                          m,mm,vrh,vrl,vih,vil,
     &                          wrh,wrl,wih,wil,nm,
     &                          ssrh,ssrl,ssih,ssil,tth,ttl
#ifdef MEMORY2
     &                         ,nxx_vr,nxx_vi,nxx_wr,nxx_wi
     &                         ,nxx_ssr,nxx_ssi,nxx_tt
#endif
     &                          )
!----
!      use communication_h, only : get_loop_start
!     &               , get_loop_end
!     &               , get_owner_node
!     &               , translate_l2g
!     &               , translate_g2l
!     &               , bcast_dbl
!     &               , reduce_dbl
      use ddcommunication_h, only : get_loop_start
     &                            , get_loop_end
     &                            , get_owner_node
     &                            , translate_l2g
     &                            , translate_g2l
     &                            , ddbcast_dbl
     &                            , ddreduce_dbl
!----
       implicit double precision(a-h,o-z),integer(i-n)

!       real(8) :: ar(1:nma,*), ai(1:nma,*)
!       real(8) :: zr(1:nmz,*), zi(1:nmz,*)
!       real(8) :: tau(1:nmtau,2)
       real(8) :: arh(1:nma,*), aih(1:nma,*)
       real(8) :: arl(1:nma,*), ail(1:nma,*)
       real(8) :: zrh(1:nmz,*), zih(1:nmz,*)
       real(8) :: zrl(1:nmz,*), zil(1:nmz,*)
       real(8) :: tauh(1:nmtau,2), taul(1:nmtau,2)

!       real(8) :: vr(1:nm,*), vi(1:nm,*)
!       real(8) :: wr(1:nm,*), wi(1:nm,*)
       real(8) :: vrh(1:nm,*), vih(1:nm,*)
       real(8) :: vrl(1:nm,*), vil(1:nm,*)
       real(8) :: wrh(1:nm,*), wih(1:nm,*)
       real(8) :: wrl(1:nm,*), wil(1:nm,*)

!       real(8) :: ssr(*),ssi(*), tt(*)
       real(8) :: ssrh(*),ssrl(*),ssih(*),ssil(*),tth(*),ttl(*)

      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

       integer :: nodes(0:m-1)

       include 'mpif.h'
!$     include 'omp_lib.h'
       include 'trd.h'
#ifdef MEMORY2
       integer,intent(in) :: nxx_vr
       integer,intent(in) :: nxx_vi
       integer,intent(in) :: nxx_wr
       integer,intent(in) :: nxx_wi
       integer,intent(in) :: nxx_ssr
       integer,intent(in) :: nxx_ssi
       integer,intent(in) :: nxx_tt
#endif
!----
       call mpi_barrier(mpi_comm_world,ierr)
       d1=mpi_wtime()
       dcom=0.0d0+00
!----
       i_2 = get_loop_start(1, size_of_row,my_row)
       i_3 = get_loop_end  (n, size_of_row,my_row)
       j_2 = get_loop_start(1, size_of_col,my_col)
       j_3 = get_loop_end  (n, size_of_col,my_col)

       do i_1=i_2,i_3
          do j_1=j_2,j_3
             k = (j_1-1)*size_of_col+my_col
!             zi(j_1,i_1) =  zr(j_1,i_1) * tau(k,2)
!             zr(j_1,i_1) =  zr(j_1,i_1) * tau(k,1)
!<<<        zi(j_1,i_1) = zr(j_1,i_1) * tau(k,2)
            zih(j_1,i_1) = zrh(j_1,i_1) * tauh(k,2)
            t_u1 = 134217729.0 * zrh(j_1,i_1)
            t_p1 = t_u1
     +               - (t_u1 - zrh(j_1,i_1))
            t_p2 = zrh(j_1,i_1) - t_p1
            t_u1 = 134217729.0 * tauh(k,2)
            t_r1 = t_u1
     +               - (t_u1 - tauh(k,2))
            t_r2 = tauh(k,2) - t_r1
            zil(j_1,i_1) = ((t_p1*t_r1
     +              - zih(j_1,i_1))
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            zil(j_1,i_1) = zil(j_1,i_1)
     +            + (zrh(j_1,i_1)*taul(k,2)
     +            + zrl(j_1,i_1)*tauh(k,2))
            t_s1 = zih(j_1,i_1) + zil(j_1,i_1)
            zil(j_1,i_1) = zil(j_1,i_1) - (t_s1 - zih(j_1,i_1))
            zih(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        zi(j_1,i_1) = zr(j_1,i_1) * tau(k,2)
!<<<        zr(j_1,i_1) = zr(j_1,i_1) * tau(k,1)
            t_ch = zrh(j_1,i_1) * tauh(k,1)
            t_u1 = 134217729.0 * zrh(j_1,i_1)
            t_p1 = t_u1
     +               - (t_u1 - zrh(j_1,i_1))
            t_p2 = zrh(j_1,i_1) - t_p1
            t_u1 = 134217729.0 * tauh(k,1)
            t_r1 = t_u1
     +               - (t_u1 - tauh(k,1))
            t_r2 = tauh(k,1) - t_r1
            t_cl = ((t_p1*t_r1
     +               - t_ch)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            t_cl = t_cl
     +               + (zrh(j_1,i_1)*taul(k,1)
     +               +  zrl(j_1,i_1)*tauh(k,1))
            t_s1 = t_ch + t_cl
            zrl(j_1,i_1) = t_cl - (t_s1 - t_ch)
            zrh(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fselfmul.h"
#endif
!>>>        zr(j_1,i_1) = zr(j_1,i_1) * tau(k,1)
          end do! j_1
       end do! i_1

!       tau(1:n,1) = 0.0
      tauh(1:n,1) = 0.0d+0
      taul(1:n,1) = 0.0d+0
       do i_1=i_2,i_3
          k = (i_1-1)*size_of_row+my_row
          x_root = mod(k-1,size_of_col)+1
          if ( x_root == my_col ) then
             j_1  = (k-1)/size_of_col+1
!             tau(k,1) = ai(j_1,i_1)
            tauh(k,1) = aih(j_1,i_1)
            taul(k,1) = ail(j_1,i_1)
          end if
       end do! i_1
!       call reduce_dbl(tau(1,1), tau(1,2), n, mpi_comm_world)
       call ddreduce_dbl(tauh(1,1),taul(1,1),tauh(1,2),taul(1,2), n,
     &                   mpi_comm_world)

       i=1
1000   i=i+1; if ( i > n ) go to 9000

!       if ( tau(i,1) == 0.0d+00 ) go to 1000
       if (
!          (tau(i,1) .eq. 0.0)
     +    ((tauh(i,1) .eq. 0.0d+0) .and.
     +     (taul(i,1) .eq. 0.0d+0))
     & ) then
          go to 1000
       endif

!1100   if ( (i+1<=n) .and. (tau(i+1,1)/=0.0d+00) ) go to 1200
1100   if ( (i+1<=n) .and. (
!          (tau(i+1,1) .ne. 0.0)
     +    ((tauh(i+1,1) .ne. 0.0d+0) .or.
     +     (taul(i+1,1) .ne. 0.0d+0))
     & )) then
          go to 1200
       endif  

1111   continue

          j_2 = get_loop_start(1,   size_of_col,my_col)
          j_3 = get_loop_end  (i-1, size_of_col,my_col)
!----
          ds=mpi_wtime()
          nodes(0) = get_owner_node(i, size_of_row, my_row)
          if ( nodes(0) == my_row ) then
             i_1 = translate_g2l(i, size_of_row, my_row)
#ifdef MEMORY2
      nxx = xx_vr(1000,j_3,1)
      nxx = xx_vi(1010,j_3,1)
#endif
             do j_1=j_2,j_3
!                vr(j_1,1) = ar(j_1,i_1)
!                vi(j_1,1) = ai(j_1,i_1)
               vrh(j_1,1) = arh(j_1,i_1)
               vrl(j_1,1) = arl(j_1,i_1)
               vih(j_1,1) = aih(j_1,i_1)
               vil(j_1,1) = ail(j_1,i_1)
             end do! j_1
          end if
#ifdef MEMORY2
      nxx = xx_vr(1020,j_2 + j_3-j_2+1 - 1,1)
      nxx = xx_vi(1030,j_2 + j_3-j_2+1 - 1,1)
#endif
!          call bcast_dbl(vr(j_2,1), j_3-j_2+1, nodes(0), mpi_comm_row)
!          call bcast_dbl(vi(j_2,1), j_3-j_2+1, nodes(0), mpi_comm_row)
          call ddbcast_dbl(vrh(j_2,1), vrl(j_2,1), j_3-j_2+1, nodes(0),
     &                     mpi_comm_row)
          call ddbcast_dbl(vih(j_2,1), vil(j_2,1), j_3-j_2+1, nodes(0),
     &                     mpi_comm_row)
          de=mpi_wtime()
          dcom=dcom+(de-ds)
!----
          i_4=mod(i_3-i_2+1,8)+i_2
#ifdef MEMORY2
      nxx = xx_vr(1040,j_3,1)
      nxx = xx_vi(1050,j_3,1)
      nxx = xx_ssr(1060,i_4-1)
      nxx = xx_ssi(1070,i_4-1)
#endif
          do i_1=i_2,i_4-1 !                  0
!             sr0=0.0d+00
!             si0=0.0d+00
               sr0h = 0.0d+0
               sr0l = 0.0d+0
               si0h = 0.0d+0
               si0l = 0.0d+0
             do j_1=j_2,j_3
!                sr0=sr0+vr(j_1,1)*zr(j_1,i_1+0)
!     &                       +vi(j_1,1)*zi(j_1,i_1+0)
!                si0=si0+vr(j_1,1)*zi(j_1,i_1+0)
!     &                       -vi(j_1,1)*zr(j_1,i_1+0)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+0)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+0)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+0))
               t_r2 = zrh(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+0)
     +               + vrl(j_1,1)*zrh(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+0)
!<<<           sr0 = sr0 + tmp1
               t_p1 = sr0h + tmp1h
               t_p2 = t_p1 - sr0h
               t_q1 = t_p1
               t_q2 = (sr0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr0l + tmp1l
               sr0h = t_q1 + t_q2
               sr0l = t_q2 - (sr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr0 = sr0 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+0)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+0)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+0))
               t_r2 = zih(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+0)
     +               + vil(j_1,1)*zih(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+0)
!<<<           sr0 = sr0 + tmp1
               t_p1 = sr0h + tmp1h
               t_p2 = t_p1 - sr0h
               t_q1 = t_p1
               t_q2 = (sr0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr0l + tmp1l
               sr0h = t_q1 + t_q2
               sr0l = t_q2 - (sr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr0 = sr0 + tmp1
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+0)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+0)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+0))
               t_r2 = zih(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+0)
     +               + vrl(j_1,1)*zih(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+0)
!<<<           si0 = si0 + tmp1
               t_p1 = si0h + tmp1h
               t_p2 = t_p1 - si0h
               t_q1 = t_p1
               t_q2 = (si0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si0l + tmp1l
               si0h = t_q1 + t_q2
               si0l = t_q2 - (si0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si0 = si0 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+0)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+0)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+0))
               t_r2 = zrh(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+0)
     +               + vil(j_1,1)*zrh(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+0)
!<<<           si0 = si0 - tmp1
               t_p1 = si0h - tmp1h
               t_p2 = t_p1 - si0h
               t_ch = t_p1
               t_cl = (si0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si0l - tmp1l
               t_s1 = t_ch + t_cl
               si0l = t_cl - (t_s1 - t_ch)
               si0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si0 = si0 - tmp1
             end do! j_1
!             ssr(i_1+0)=sr0
!             ssi(i_1+0)=si0
            ssrh(i_1+0) = sr0h
            ssrl(i_1+0) = sr0l
            ssih(i_1+0) = si0h
            ssil(i_1+0) = si0l
          end do! i_1
#ifdef MEMORY2
      nxx = xx_vr(1080,j_3,1)
      nxx = xx_vi(1090,j_3,1)
      nxx = xx_ssr(1100,i_4 +int((i_3-i_4)/8)*8 +7)
      nxx = xx_ssi(1110,i_4 +int((i_3-i_4)/8)*8 +7)
#endif
          do i_1=i_4,i_3,8 !             7
!             sr0=0.0d+00
!             si0=0.0d+00
!             sr1=0.0d+00
!             si1=0.0d+00
!             sr2=0.0d+00
!             si2=0.0d+00
!             sr3=0.0d+00
!             si3=0.0d+00
!             sr4=0.0d+00
!             si4=0.0d+00
!             sr5=0.0d+00
!             si5=0.0d+00
!             sr6=0.0d+00
!             si6=0.0d+00
!             sr7=0.0d+00
!             si7=0.0d+00
            sr0h = 0.0d+0
            sr0l = 0.0d+0
            si0h = 0.0d+0
            si0l = 0.0d+0
            sr1h = 0.0d+0
            sr1l = 0.0d+0
            si1h = 0.0d+0
            si1l = 0.0d+0
            sr2h = 0.0d+0
            sr2l = 0.0d+0
            si2h = 0.0d+0
            si2l = 0.0d+0
            sr3h = 0.0d+0
            sr3l = 0.0d+0
            si3h = 0.0d+0
            si3l = 0.0d+0
            sr4h = 0.0d+0
            sr4l = 0.0d+0
            si4h = 0.0d+0
            si4l = 0.0d+0
            sr5h = 0.0d+0
            sr5l = 0.0d+0
            si5h = 0.0d+0
            si5l = 0.0d+0
            sr6h = 0.0d+0
            sr6l = 0.0d+0
            si6h = 0.0d+0
            si6l = 0.0d+0
            sr7h = 0.0d+0
            sr7l = 0.0d+0
            si7h = 0.0d+0
            si7l = 0.0d+0
             do j_1=j_2,j_3
!                sr0=sr0+vr(j_1,1)*zr(j_1,i_1+0)
!     &                       +vi(j_1,1)*zi(j_1,i_1+0)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+0)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+0)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+0))
               t_r2 = zrh(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+0)
     +               + vrl(j_1,1)*zrh(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+0)
!<<<           sr0 = sr0 + tmp1
               t_p1 = sr0h + tmp1h
               t_p2 = t_p1 - sr0h
               t_q1 = t_p1
               t_q2 = (sr0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr0l + tmp1l
               sr0h = t_q1 + t_q2
               sr0l = t_q2 - (sr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr0 = sr0 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+0)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+0)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+0))
               t_r2 = zih(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+0)
     +               + vil(j_1,1)*zih(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+0)
!<<<           sr0 = sr0 + tmp1
               t_p1 = sr0h + tmp1h
               t_p2 = t_p1 - sr0h
               t_q1 = t_p1
               t_q2 = (sr0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr0l + tmp1l
               sr0h = t_q1 + t_q2
               sr0l = t_q2 - (sr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr0 = sr0 + tmp1
!                si0=si0+vr(j_1,1)*zi(j_1,i_1+0)
!     &                       -vi(j_1,1)*zr(j_1,i_1+0)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+0)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+0)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+0))
               t_r2 = zih(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+0)
     +               + vrl(j_1,1)*zih(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+0)
!<<<           si0 = si0 + tmp1
               t_p1 = si0h + tmp1h
               t_p2 = t_p1 - si0h
               t_q1 = t_p1
               t_q2 = (si0h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si0l + tmp1l
               si0h = t_q1 + t_q2
               si0l = t_q2 - (si0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si0 = si0 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+0)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+0)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+0)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+0))
               t_r2 = zrh(j_1,i_1+0) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+0)
     +               + vil(j_1,1)*zrh(j_1,i_1+0))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+0)
!<<<           si0 = si0 - tmp1
               t_p1 = si0h - tmp1h
               t_p2 = t_p1 - si0h
               t_ch = t_p1
               t_cl = (si0h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si0l - tmp1l
               t_s1 = t_ch + t_cl
               si0l = t_cl - (t_s1 - t_ch)
               si0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si0 = si0 - tmp1
!                sr1=sr1+vr(j_1,1)*zr(j_1,i_1+1)
!     &                       +vi(j_1,1)*zi(j_1,i_1+1)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+1)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+1)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+1))
               t_r2 = zrh(j_1,i_1+1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+1)
     +               + vrl(j_1,1)*zrh(j_1,i_1+1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+1)
!<<<           sr1 = sr1 + tmp1
               t_p1 = sr1h + tmp1h
               t_p2 = t_p1 - sr1h
               t_q1 = t_p1
               t_q2 = (sr1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr1l + tmp1l
               sr1h = t_q1 + t_q2
               sr1l = t_q2 - (sr1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr1 = sr1 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+1)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+1)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+1))
               t_r2 = zih(j_1,i_1+1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+1)
     +               + vil(j_1,1)*zih(j_1,i_1+1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+1)
!<<<           sr1 = sr1 + tmp1
               t_p1 = sr1h + tmp1h
               t_p2 = t_p1 - sr1h
               t_q1 = t_p1
               t_q2 = (sr1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr1l + tmp1l
               sr1h = t_q1 + t_q2
               sr1l = t_q2 - (sr1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr1 = sr1 + tmp1
!                si1=si1+vr(j_1,1)*zi(j_1,i_1+1)
!     &                       -vi(j_1,1)*zr(j_1,i_1+1)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+1)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+1)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+1))
               t_r2 = zih(j_1,i_1+1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+1)
     +               + vrl(j_1,1)*zih(j_1,i_1+1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+1)
!<<<           si1 = si1 + tmp1
               t_p1 = si1h + tmp1h
               t_p2 = t_p1 - si1h
               t_q1 = t_p1
               t_q2 = (si1h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si1l + tmp1l
               si1h = t_q1 + t_q2
               si1l = t_q2 - (si1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si1 = si1 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+1)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+1)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+1)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+1))
               t_r2 = zrh(j_1,i_1+1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+1)
     +               + vil(j_1,1)*zrh(j_1,i_1+1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+1)
!<<<           si1 = si1 - tmp1
               t_p1 = si1h - tmp1h
               t_p2 = t_p1 - si1h
               t_ch = t_p1
               t_cl = (si1h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si1l - tmp1l
               t_s1 = t_ch + t_cl
               si1l = t_cl - (t_s1 - t_ch)
               si1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si1 = si1 - tmp1
!                sr2=sr2+vr(j_1,1)*zr(j_1,i_1+2)
!     &                       +vi(j_1,1)*zi(j_1,i_1+2)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+2)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+2)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+2))
               t_r2 = zrh(j_1,i_1+2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+2)
     +               + vrl(j_1,1)*zrh(j_1,i_1+2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+2)
!<<<           sr2 = sr2 + tmp1
               t_p1 = sr2h + tmp1h
               t_p2 = t_p1 - sr2h
               t_q1 = t_p1
               t_q2 = (sr2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr2l + tmp1l
               sr2h = t_q1 + t_q2
               sr2l = t_q2 - (sr2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr2 = sr2 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+2)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+2)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+2))
               t_r2 = zih(j_1,i_1+2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+2)
     +               + vil(j_1,1)*zih(j_1,i_1+2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+2)
!<<<           sr2 = sr2 + tmp1
               t_p1 = sr2h + tmp1h
               t_p2 = t_p1 - sr2h
               t_q1 = t_p1
               t_q2 = (sr2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr2l + tmp1l
               sr2h = t_q1 + t_q2
               sr2l = t_q2 - (sr2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr2 = sr2 + tmp1
!                si2=si2+vr(j_1,1)*zi(j_1,i_1+2)
!     &                       -vi(j_1,1)*zr(j_1,i_1+2)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+2)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+2)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+2))
               t_r2 = zih(j_1,i_1+2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+2)
     +               + vrl(j_1,1)*zih(j_1,i_1+2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+2)
!<<<           si2 = si2 + tmp1
               t_p1 = si2h + tmp1h
               t_p2 = t_p1 - si2h
               t_q1 = t_p1
               t_q2 = (si2h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si2l + tmp1l
               si2h = t_q1 + t_q2
               si2l = t_q2 - (si2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si2 = si2 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+2)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+2)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+2)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+2))
               t_r2 = zrh(j_1,i_1+2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+2)
     +               + vil(j_1,1)*zrh(j_1,i_1+2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+2)
!<<<           si2 = si2 - tmp1
               t_p1 = si2h - tmp1h
               t_p2 = t_p1 - si2h
               t_ch = t_p1
               t_cl = (si2h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si2l - tmp1l
               t_s1 = t_ch + t_cl
               si2l = t_cl - (t_s1 - t_ch)
               si2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si2 = si2 - tmp1
!                sr3=sr3+vr(j_1,1)*zr(j_1,i_1+3)
!     &                       +vi(j_1,1)*zi(j_1,i_1+3)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+3)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+3)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+3)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+3))
               t_r2 = zrh(j_1,i_1+3) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+3)
     +               + vrl(j_1,1)*zrh(j_1,i_1+3))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+3)
!<<<           sr3 = sr3 + tmp1
               t_p1 = sr3h + tmp1h
               t_p2 = t_p1 - sr3h
               t_q1 = t_p1
               t_q2 = (sr3h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr3l + tmp1l
               sr3h = t_q1 + t_q2
               sr3l = t_q2 - (sr3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr3 = sr3 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+3)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+3)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+3)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+3))
               t_r2 = zih(j_1,i_1+3) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+3)
     +               + vil(j_1,1)*zih(j_1,i_1+3))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+3)
!<<<           sr3 = sr3 + tmp1
               t_p1 = sr3h + tmp1h
               t_p2 = t_p1 - sr3h
               t_q1 = t_p1
               t_q2 = (sr3h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr3l + tmp1l
               sr3h = t_q1 + t_q2
               sr3l = t_q2 - (sr3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr3 = sr3 + tmp1
!                si3=si3+vr(j_1,1)*zi(j_1,i_1+3)
!     &                       -vi(j_1,1)*zr(j_1,i_1+3)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+3)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+3)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+3)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+3))
               t_r2 = zih(j_1,i_1+3) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+3)
     +               + vrl(j_1,1)*zih(j_1,i_1+3))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+3)
!<<<           si3 = si3 + tmp1
               t_p1 = si3h + tmp1h
               t_p2 = t_p1 - si3h
               t_q1 = t_p1
               t_q2 = (si3h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si3l + tmp1l
               si3h = t_q1 + t_q2
               si3l = t_q2 - (si3h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si3 = si3 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+3)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+3)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+3)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+3))
               t_r2 = zrh(j_1,i_1+3) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+3)
     +               + vil(j_1,1)*zrh(j_1,i_1+3))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+3)
!<<<           si3 = si3 - tmp1
               t_p1 = si3h - tmp1h
               t_p2 = t_p1 - si3h
               t_ch = t_p1
               t_cl = (si3h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si3l - tmp1l
               t_s1 = t_ch + t_cl
               si3l = t_cl - (t_s1 - t_ch)
               si3h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si3 = si3 - tmp1
!                sr4=sr4+vr(j_1,1)*zr(j_1,i_1+4)
!     &                       +vi(j_1,1)*zi(j_1,i_1+4)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+4)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+4)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+4)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+4))
               t_r2 = zrh(j_1,i_1+4) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+4)
     +               + vrl(j_1,1)*zrh(j_1,i_1+4))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+4)
!<<<           sr4 = sr4 + tmp1
               t_p1 = sr4h + tmp1h
               t_p2 = t_p1 - sr4h
               t_q1 = t_p1
               t_q2 = (sr4h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr4l + tmp1l
               sr4h = t_q1 + t_q2
               sr4l = t_q2 - (sr4h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr4 = sr4 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+4)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+4)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+4)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+4))
               t_r2 = zih(j_1,i_1+4) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+4)
     +               + vil(j_1,1)*zih(j_1,i_1+4))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+4)
!<<<           sr4 = sr4 + tmp1
               t_p1 = sr4h + tmp1h
               t_p2 = t_p1 - sr4h
               t_q1 = t_p1
               t_q2 = (sr4h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr4l + tmp1l
               sr4h = t_q1 + t_q2
               sr4l = t_q2 - (sr4h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr4 = sr4 + tmp1
!                si4=si4+vr(j_1,1)*zi(j_1,i_1+4)
!     &                       -vi(j_1,1)*zr(j_1,i_1+4)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+4)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+4)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+4)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+4))
               t_r2 = zih(j_1,i_1+4) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+4)
     +               + vrl(j_1,1)*zih(j_1,i_1+4))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+4)
!<<<           si4 = si4 + tmp1
               t_p1 = si4h + tmp1h
               t_p2 = t_p1 - si4h
               t_q1 = t_p1
               t_q2 = (si4h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si4l + tmp1l
               si4h = t_q1 + t_q2
               si4l = t_q2 - (si4h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si4 = si4 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+4)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+4)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+4)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+4))
               t_r2 = zrh(j_1,i_1+4) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+4)
     +               + vil(j_1,1)*zrh(j_1,i_1+4))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+4)
!<<<           si4 = si4 - tmp1
               t_p1 = si4h - tmp1h
               t_p2 = t_p1 - si4h
               t_ch = t_p1
               t_cl = (si4h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si4l - tmp1l
               t_s1 = t_ch + t_cl
               si4l = t_cl - (t_s1 - t_ch)
               si4h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si4 = si4 - tmp1
!                sr5=sr5+vr(j_1,1)*zr(j_1,i_1+5)
!     &                       +vi(j_1,1)*zi(j_1,i_1+5)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+5)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+5)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+5)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+5))
               t_r2 = zrh(j_1,i_1+5) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+5)
     +               + vrl(j_1,1)*zrh(j_1,i_1+5))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+5)
!<<<           sr5 = sr5 + tmp1
               t_p1 = sr5h + tmp1h
               t_p2 = t_p1 - sr5h
               t_q1 = t_p1
               t_q2 = (sr5h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr5l + tmp1l
               sr5h = t_q1 + t_q2
               sr5l = t_q2 - (sr5h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr5 = sr5 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+5)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+5)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+5)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+5))
               t_r2 = zih(j_1,i_1+5) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+5)
     +               + vil(j_1,1)*zih(j_1,i_1+5))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+5)
!<<<           sr5 = sr5 + tmp1
               t_p1 = sr5h + tmp1h
               t_p2 = t_p1 - sr5h
               t_q1 = t_p1
               t_q2 = (sr5h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr5l + tmp1l
               sr5h = t_q1 + t_q2
               sr5l = t_q2 - (sr5h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr5 = sr5 + tmp1
!                si5=si5+vr(j_1,1)*zi(j_1,i_1+5)
!     &                       -vi(j_1,1)*zr(j_1,i_1+5)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+5)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+5)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+5)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+5))
               t_r2 = zih(j_1,i_1+5) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+5)
     +               + vrl(j_1,1)*zih(j_1,i_1+5))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+5)
!<<<           si5 = si5 + tmp1
               t_p1 = si5h + tmp1h
               t_p2 = t_p1 - si5h
               t_q1 = t_p1
               t_q2 = (si5h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si5l + tmp1l
               si5h = t_q1 + t_q2
               si5l = t_q2 - (si5h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si5 = si5 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+5)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+5)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+5)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+5))
               t_r2 = zrh(j_1,i_1+5) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+5)
     +               + vil(j_1,1)*zrh(j_1,i_1+5))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+5)
!<<<           si5 = si5 - tmp1
               t_p1 = si5h - tmp1h
               t_p2 = t_p1 - si5h
               t_ch = t_p1
               t_cl = (si5h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si5l - tmp1l
               t_s1 = t_ch + t_cl
               si5l = t_cl - (t_s1 - t_ch)
               si5h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si5 = si5 - tmp1
!                sr6=sr6+vr(j_1,1)*zr(j_1,i_1+6)
!     &                       +vi(j_1,1)*zi(j_1,i_1+6)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+6)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+6)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+6)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+6))
               t_r2 = zrh(j_1,i_1+6) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+6)
     +               + vrl(j_1,1)*zrh(j_1,i_1+6))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+6)
!<<<           sr6 = sr6 + tmp1
               t_p1 = sr6h + tmp1h
               t_p2 = t_p1 - sr6h
               t_q1 = t_p1
               t_q2 = (sr6h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr6l + tmp1l
               sr6h = t_q1 + t_q2
               sr6l = t_q2 - (sr6h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr6 = sr6 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+6)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+6)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+6)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+6))
               t_r2 = zih(j_1,i_1+6) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+6)
     +               + vil(j_1,1)*zih(j_1,i_1+6))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+6)
!<<<           sr6 = sr6 + tmp1
               t_p1 = sr6h + tmp1h
               t_p2 = t_p1 - sr6h
               t_q1 = t_p1
               t_q2 = (sr6h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr6l + tmp1l
               sr6h = t_q1 + t_q2
               sr6l = t_q2 - (sr6h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr6 = sr6 + tmp1
!                si6=si6+vr(j_1,1)*zi(j_1,i_1+6)
!     &                       -vi(j_1,1)*zr(j_1,i_1+6)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+6)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+6)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+6)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+6))
               t_r2 = zih(j_1,i_1+6) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+6)
     +               + vrl(j_1,1)*zih(j_1,i_1+6))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+6)
!<<<           si6 = si6 + tmp1
               t_p1 = si6h + tmp1h
               t_p2 = t_p1 - si6h
               t_q1 = t_p1
               t_q2 = (si6h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si6l + tmp1l
               si6h = t_q1 + t_q2
               si6l = t_q2 - (si6h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si6 = si6 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+6)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+6)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+6)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+6))
               t_r2 = zrh(j_1,i_1+6) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+6)
     +               + vil(j_1,1)*zrh(j_1,i_1+6))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+6)
!<<<           si6 = si6 - tmp1
               t_p1 = si6h - tmp1h
               t_p2 = t_p1 - si6h
               t_ch = t_p1
               t_cl = (si6h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si6l - tmp1l
               t_s1 = t_ch + t_cl
               si6l = t_cl - (t_s1 - t_ch)
               si6h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si6 = si6 - tmp1
!                sr7=sr7+vr(j_1,1)*zr(j_1,i_1+7)
!     &                       +vi(j_1,1)*zi(j_1,i_1+7)
!<<<           tmp1 = vr(j_1,1) * zr(j_1,i_1+7)
               tmp1h = vrh(j_1,1) * zrh(j_1,i_1+7)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+7)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+7))
               t_r2 = zrh(j_1,i_1+7) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zrl(j_1,i_1+7)
     +               + vrl(j_1,1)*zrh(j_1,i_1+7))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zr(j_1,i_1+7)
!<<<           sr7 = sr7 + tmp1
               t_p1 = sr7h + tmp1h
               t_p2 = t_p1 - sr7h
               t_q1 = t_p1
               t_q2 = (sr7h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr7l + tmp1l
               sr7h = t_q1 + t_q2
               sr7l = t_q2 - (sr7h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr7 = sr7 + tmp1
!<<<           tmp1 = vi(j_1,1) * zi(j_1,i_1+7)
               tmp1h = vih(j_1,1) * zih(j_1,i_1+7)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+7)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+7))
               t_r2 = zih(j_1,i_1+7) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zil(j_1,i_1+7)
     +               + vil(j_1,1)*zih(j_1,i_1+7))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zi(j_1,i_1+7)
!<<<           sr7 = sr7 + tmp1
               t_p1 = sr7h + tmp1h
               t_p2 = t_p1 - sr7h
               t_q1 = t_p1
               t_q2 = (sr7h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + sr7l + tmp1l
               sr7h = t_q1 + t_q2
               sr7l = t_q2 - (sr7h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           sr7 = sr7 + tmp1
!                si7=si7+vr(j_1,1)*zi(j_1,i_1+7)
!     &                       -vi(j_1,1)*zr(j_1,i_1+7)
!<<<           tmp1 = vr(j_1,1) * zi(j_1,i_1+7)
               tmp1h = vrh(j_1,1) * zih(j_1,i_1+7)
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_p2 = vrh(j_1,1) - t_p1
               t_u1 = 134217729.0 * zih(j_1,i_1+7)
               t_r1 = t_u1
     +                  - (t_u1 - zih(j_1,i_1+7))
               t_r2 = zih(j_1,i_1+7) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vrh(j_1,1)*zil(j_1,i_1+7)
     +               + vrl(j_1,1)*zih(j_1,i_1+7))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vr(j_1,1) * zi(j_1,i_1+7)
!<<<           si7 = si7 + tmp1
               t_p1 = si7h + tmp1h
               t_p2 = t_p1 - si7h
               t_q1 = t_p1
               t_q2 = (si7h - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + si7l + tmp1l
               si7h = t_q1 + t_q2
               si7l = t_q2 - (si7h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           si7 = si7 + tmp1
!<<<           tmp1 = vi(j_1,1) * zr(j_1,i_1+7)
               tmp1h = vih(j_1,1) * zrh(j_1,i_1+7)
               t_u1 = 134217729.0 * vih(j_1,1)
               t_p1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_p2 = vih(j_1,1) - t_p1
               t_u1 = 134217729.0 * zrh(j_1,i_1+7)
               t_r1 = t_u1
     +                  - (t_u1 - zrh(j_1,i_1+7))
               t_r2 = zrh(j_1,i_1+7) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (vih(j_1,1)*zrl(j_1,i_1+7)
     +               + vil(j_1,1)*zrh(j_1,i_1+7))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = vi(j_1,1) * zr(j_1,i_1+7)
!<<<           si7 = si7 - tmp1
               t_p1 = si7h - tmp1h
               t_p2 = t_p1 - si7h
               t_ch = t_p1
               t_cl = (si7h - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + si7l - tmp1l
               t_s1 = t_ch + t_cl
               si7l = t_cl - (t_s1 - t_ch)
               si7h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           si7 = si7 - tmp1
             end do! j_1
!             ssr(i_1+0)=sr0
!             ssi(i_1+0)=si0
!             ssr(i_1+1)=sr1
!             ssi(i_1+1)=si1
!             ssr(i_1+2)=sr2
!             ssi(i_1+2)=si2
!             ssr(i_1+3)=sr3
!             ssi(i_1+3)=si3
!             ssr(i_1+4)=sr4
!             ssi(i_1+4)=si4
!             ssr(i_1+5)=sr5
!             ssi(i_1+5)=si5
!             ssr(i_1+6)=sr6
!             ssi(i_1+6)=si6
!             ssr(i_1+7)=sr7
!             ssi(i_1+7)=si7
            ssrh(i_1+0) = sr0h
            ssrl(i_1+0) = sr0l
            ssih(i_1+0) = si0h
            ssil(i_1+0) = si0l
            ssrh(i_1+1) = sr1h
            ssrl(i_1+1) = sr1l
            ssih(i_1+1) = si1h
            ssil(i_1+1) = si1l
            ssrh(i_1+2) = sr2h
            ssrl(i_1+2) = sr2l
            ssih(i_1+2) = si2h
            ssil(i_1+2) = si2l
            ssrh(i_1+3) = sr3h
            ssrl(i_1+3) = sr3l
            ssih(i_1+3) = si3h
            ssil(i_1+3) = si3l
            ssrh(i_1+4) = sr4h
            ssrl(i_1+4) = sr4l
            ssih(i_1+4) = si4h
            ssil(i_1+4) = si4l
            ssrh(i_1+5) = sr5h
            ssrl(i_1+5) = sr5l
            ssih(i_1+5) = si5h
            ssil(i_1+5) = si5l
            ssrh(i_1+6) = sr6h
            ssrl(i_1+6) = sr6l
            ssih(i_1+6) = si6h
            ssil(i_1+6) = si6l
            ssrh(i_1+7) = sr7h
            ssrl(i_1+7) = sr7l
            ssih(i_1+7) = si7h
            ssil(i_1+7) = si7l
          end do! i_1

#ifdef MEMORY2
      nxx = xx_ssr(1120,i_2+i_3-i_2+1-1)
      nxx = xx_ssi(1130,i_2+i_3-i_2+1-1)
      nxx = xx_tt (1140,    i_3-i_2+1  )
#endif
          ds=mpi_wtime()
!          call reduce_dbl(ssr(i_2), tt, i_3-i_2+1, mpi_comm_col)
!          call reduce_dbl(ssi(i_2), tt, i_3-i_2+1, mpi_comm_col)
          call ddreduce_dbl(ssrh(i_2),ssrl(i_2),tth,ttl,i_3-i_2+1,
     &                      mpi_comm_col)
          call ddreduce_dbl(ssih(i_2),ssil(i_2),tth,ttl,i_3-i_2+1,
     &                      mpi_comm_col)
          de=mpi_wtime()
          dcom=dcom+(de-ds)

#ifdef MEMORY2
      nxx = xx_ssr(1150,i_3)
      nxx = xx_ssi(1160,i_3)
#endif
          do i_1=i_2,i_3
!             h0 = tau(i,1)
            h0h = tauh(i,1)
            h0l = taul(i,1)
!             if ( h0 /= 0.0d+00 ) then
             if (
!                (h0 .ne. 0.0)
     +          ((h0h .ne. 0.0d+0) .or.
     +           (h0l .ne. 0.0d+0))
     &       ) then
!                ssr(i_1) = (ssr(i_1)/h0)/h0
!                ssi(i_1) = (ssi(i_1)/h0)/h0
!<<<           tmp1 = ssr(i_1) / h0
               t_q1 = ssrh(i_1) / h0h
               tmp1h = h0h * t_q1
               t_u1 = 134217729.0 * h0h
               t_p1 = t_u1
     +                  - (t_u1 - h0h)
               t_p2 = h0h - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               tmp1l = ((t_p1*t_r1
     +                - tmp1h)
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               tmp1l = tmp1l + (h0l*t_q1)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
               t_s1 = ssrh(i_1) - tmp1h
               t_r1 = t_s1 - ssrh(i_1)
               t_s2 = (ssrh(i_1) 
     +                  - (t_s1 - t_r1))
     +                  - (tmp1h + t_r1)
               t_s2 = t_s2 - tmp1l
               t_s2 = t_s2 + ssrl(i_1)
               t_q2 = (t_s1 + t_s2)
     +                  / h0h
               tmp1h = t_q1 + t_q2
               tmp1l = t_q2
     +               - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tmp1 = ssr(i_1) / h0
!<<<           ssr(i_1) = tmp1 / h0
               t_q1 = tmp1h / h0h
               ssrh(i_1) = h0h * t_q1
               t_u1 = 134217729.0 * h0h
               t_p1 = t_u1
     +                  - (t_u1 - h0h)
               t_p2 = h0h - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               ssrl(i_1) = ((t_p1*t_r1
     +                - ssrh(i_1))
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               ssrl(i_1) = ssrl(i_1) + (h0l*t_q1)
               t_s1 = ssrh(i_1) + ssrl(i_1)
               ssrl(i_1) = ssrl(i_1) - (t_s1 - ssrh(i_1))
               ssrh(i_1) = t_s1
               t_s1 = tmp1h - ssrh(i_1)
               t_r1 = t_s1 - tmp1h
               t_s2 = (tmp1h 
     +                  - (t_s1 - t_r1))
     +                  - (ssrh(i_1) + t_r1)
               t_s2 = t_s2 - ssrl(i_1)
               t_s2 = t_s2 + tmp1l
               t_q2 = (t_s1 + t_s2)
     +                  / h0h
               ssrh(i_1) = t_q1 + t_q2
               ssrl(i_1) = t_q2
     +               - (ssrh(i_1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           ssr(i_1) = tmp1 / h0
!<<<           tmp1 = ssi(i_1) / h0
               t_q1 = ssih(i_1) / h0h
               tmp1h = h0h * t_q1
               t_u1 = 134217729.0 * h0h
               t_p1 = t_u1
     +                  - (t_u1 - h0h)
               t_p2 = h0h - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               tmp1l = ((t_p1*t_r1
     +                - tmp1h)
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               tmp1l = tmp1l + (h0l*t_q1)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
               t_s1 = ssih(i_1) - tmp1h
               t_r1 = t_s1 - ssih(i_1)
               t_s2 = (ssih(i_1) 
     +                  - (t_s1 - t_r1))
     +                  - (tmp1h + t_r1)
               t_s2 = t_s2 - tmp1l
               t_s2 = t_s2 + ssil(i_1)
               t_q2 = (t_s1 + t_s2)
     +                  / h0h
               tmp1h = t_q1 + t_q2
               tmp1l = t_q2
     +               - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tmp1 = ssi(i_1) / h0
!<<<           ssi(i_1) = tmp1 / h0
               t_q1 = tmp1h / h0h
               ssih(i_1) = h0h * t_q1
               t_u1 = 134217729.0 * h0h
               t_p1 = t_u1
     +                  - (t_u1 - h0h)
               t_p2 = h0h - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               ssil(i_1) = ((t_p1*t_r1
     +                - ssih(i_1))
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               ssil(i_1) = ssil(i_1) + (h0l*t_q1)
               t_s1 = ssih(i_1) + ssil(i_1)
               ssil(i_1) = ssil(i_1) - (t_s1 - ssih(i_1))
               ssih(i_1) = t_s1
               t_s1 = tmp1h - ssih(i_1)
               t_r1 = t_s1 - tmp1h
               t_s2 = (tmp1h 
     +                  - (t_s1 - t_r1))
     +                  - (ssih(i_1) + t_r1)
               t_s2 = t_s2 - ssil(i_1)
               t_s2 = t_s2 + tmp1l
               t_q2 = (t_s1 + t_s2)
     +                  / h0h
               ssih(i_1) = t_q1 + t_q2
               ssil(i_1) = t_q2
     +               - (ssih(i_1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           ssi(i_1) = tmp1 / h0
             else
!                ssr(i_1) = 0.0d+00
!                ssi(i_1) = 0.0d+00
               ssrh(i_1) = 0.0d+0
               ssrl(i_1) = 0.0d+0
               ssih(i_1) = 0.0d+0
               ssil(i_1) = 0.0d+0
             endif
          end do! i_1

#ifdef MEMORY2
      nxx = xx_ssr(1170,i_4-1+0)
      nxx = xx_ssi(1180,i_4-1+0)
#endif
          do i_1=i_2,i_4-1 !                  0
!             sr0=ssr(i_1+0)
!             si0=ssi(i_1+0)
            sr0h = ssrh(i_1+0)
            sr0l = ssrl(i_1+0)
            si0h = ssih(i_1+0)
            si0l = ssil(i_1+0)
             do j_1=j_2,j_3
!                zr(j_1,i_1+0)=zr(j_1,i_1+0)
!     &                                           -sr0*vr(j_1,1)
!     &                                           +si0*vi(j_1,1)
!<<<           tmp1 = sr0 * vr(j_1,1)
               tmp1h = sr0h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr0h
               t_p1 = t_u1
     +                  - (t_u1 - sr0h)
               t_p2 = sr0h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr0h*vrl(j_1,1)
     +               + sr0l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr0 * vr(j_1,1)
!<<<           zr(j_1,i_1+0) = zr(j_1,i_1+0) - tmp1
               t_p1 = zrh(j_1,i_1+0) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+0)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+0) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+0) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+0) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+0) = zr(j_1,i_1+0) - tmp1
!<<<           tmp1 = si0 * vi(j_1,1)
               tmp1h = si0h * vih(j_1,1)
               t_u1 = 134217729.0 * si0h
               t_p1 = t_u1
     +                  - (t_u1 - si0h)
               t_p2 = si0h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si0h*vil(j_1,1)
     +               + si0l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si0 * vi(j_1,1)
!<<<           zr(j_1,i_1+0) = zr(j_1,i_1+0) + tmp1
               t_p1 = zrh(j_1,i_1+0) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+0)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+0) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+0) + tmp1l
               zrh(j_1,i_1+0) = t_q1 + t_q2
               zrl(j_1,i_1+0) = t_q2 - (zrh(j_1,i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+0) = zr(j_1,i_1+0) + tmp1
!                zi(j_1,i_1+0)=zi(j_1,i_1+0)
!     &                                           -si0*vr(j_1,1)
!     &                                           -sr0*vi(j_1,1)
!<<<           tmp1 = si0 * vr(j_1,1)
               tmp1h = si0h * vrh(j_1,1)
               t_u1 = 134217729.0 * si0h
               t_p1 = t_u1
     +                  - (t_u1 - si0h)
               t_p2 = si0h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si0h*vrl(j_1,1)
     +               + si0l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si0 * vr(j_1,1)
!<<<           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
               t_p1 = zih(j_1,i_1+0) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+0)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+0) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+0) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+0) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
!<<<           tmp1 = sr0 * vi(j_1,1)
               tmp1h = sr0h * vih(j_1,1)
               t_u1 = 134217729.0 * sr0h
               t_p1 = t_u1
     +                  - (t_u1 - sr0h)
               t_p2 = sr0h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr0h*vil(j_1,1)
     +               + sr0l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr0 * vi(j_1,1)
!<<<           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
               t_p1 = zih(j_1,i_1+0) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+0)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+0) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+0) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+0) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
             end do! j_1
          end do! i_1
#ifdef MEMORY2
      nxx = xx_vr(1190,j_3,1)
      nxx = xx_vi(1200,j_3,1)
      nxx = xx_ssr(1210,i_4 +int((i_3-i_4)/8)*8 +7)
      nxx = xx_ssi(1220,i_4 +int((i_3-i_4)/8)*8 +7)
#endif
          do i_1=i_4,i_3,8 !             7
!             sr0=ssr(i_1+0)
!             si0=ssi(i_1+0)
!             sr1=ssr(i_1+1)
!             si1=ssi(i_1+1)
!             sr2=ssr(i_1+2)
!             si2=ssi(i_1+2)
!             sr3=ssr(i_1+3)
!             si3=ssi(i_1+3)
!             sr4=ssr(i_1+4)
!             si4=ssi(i_1+4)
!             sr5=ssr(i_1+5)
!             si5=ssi(i_1+5)
!             sr6=ssr(i_1+6)
!             si6=ssi(i_1+6)
!             sr7=ssr(i_1+7)
!             si7=ssi(i_1+7)
            sr0h = ssrh(i_1+0)
            sr0l = ssrl(i_1+0)
            si0h = ssih(i_1+0)
            si0l = ssil(i_1+0)
            sr1h = ssrh(i_1+1)
            sr1l = ssrl(i_1+1)
            si1h = ssih(i_1+1)
            si1l = ssil(i_1+1)
            sr2h = ssrh(i_1+2)
            sr2l = ssrl(i_1+2)
            si2h = ssih(i_1+2)
            si2l = ssil(i_1+2)
            sr3h = ssrh(i_1+3)
            sr3l = ssrl(i_1+3)
            si3h = ssih(i_1+3)
            si3l = ssil(i_1+3)
            sr4h = ssrh(i_1+4)
            sr4l = ssrl(i_1+4)
            si4h = ssih(i_1+4)
            si4l = ssil(i_1+4)
            sr5h = ssrh(i_1+5)
            sr5l = ssrl(i_1+5)
            si5h = ssih(i_1+5)
            si5l = ssil(i_1+5)
            sr6h = ssrh(i_1+6)
            sr6l = ssrl(i_1+6)
            si6h = ssih(i_1+6)
            si6l = ssil(i_1+6)
            sr7h = ssrh(i_1+7)
            sr7l = ssrl(i_1+7)
            si7h = ssih(i_1+7)
            si7l = ssil(i_1+7)
             do j_1=j_2,j_3
!                zr(j_1,i_1+0)=zr(j_1,i_1+0)
!     &                                           -sr0*vr(j_1,1)
!     &                                           +si0*vi(j_1,1)
!<<<           tmp1 = sr0 * vr(j_1,1)
               tmp1h = sr0h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr0h
               t_p1 = t_u1
     +                  - (t_u1 - sr0h)
               t_p2 = sr0h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr0h*vrl(j_1,1)
     +               + sr0l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr0 * vr(j_1,1)
!<<<           zr(j_1,i_1+0) = zr(j_1,i_1+0) - tmp1
               t_p1 = zrh(j_1,i_1+0) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+0)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+0) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+0) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+0) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+0) = zr(j_1,i_1+0) - tmp1
!<<<           tmp1 = si0 * vi(j_1,1)
               tmp1h = si0h * vih(j_1,1)
               t_u1 = 134217729.0 * si0h
               t_p1 = t_u1
     +                  - (t_u1 - si0h)
               t_p2 = si0h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si0h*vil(j_1,1)
     +               + si0l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si0 * vi(j_1,1)
!<<<           zr(j_1,i_1+0) = zr(j_1,i_1+0) + tmp1
               t_p1 = zrh(j_1,i_1+0) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+0)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+0) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+0) + tmp1l
               zrh(j_1,i_1+0) = t_q1 + t_q2
               zrl(j_1,i_1+0) = t_q2 - (zrh(j_1,i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+0) = zr(j_1,i_1+0) + tmp1
!                zi(j_1,i_1+0)=zi(j_1,i_1+0)
!     &                                           -si0*vr(j_1,1)
!     &                                           -sr0*vi(j_1,1)
!<<<           tmp1 = si0 * vr(j_1,1)
               tmp1h = si0h * vrh(j_1,1)
               t_u1 = 134217729.0 * si0h
               t_p1 = t_u1
     +                  - (t_u1 - si0h)
               t_p2 = si0h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si0h*vrl(j_1,1)
     +               + si0l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si0 * vr(j_1,1)
!<<<           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
               t_p1 = zih(j_1,i_1+0) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+0)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+0) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+0) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+0) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
!<<<           tmp1 = sr0 * vi(j_1,1)
               tmp1h = sr0h * vih(j_1,1)
               t_u1 = 134217729.0 * sr0h
               t_p1 = t_u1
     +                  - (t_u1 - sr0h)
               t_p2 = sr0h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr0h*vil(j_1,1)
     +               + sr0l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr0 * vi(j_1,1)
!<<<           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
               t_p1 = zih(j_1,i_1+0) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+0)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+0) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+0) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+0) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+0) = zi(j_1,i_1+0) - tmp1
!                zr(j_1,i_1+1)=zr(j_1,i_1+1)
!     &                                           -sr1*vr(j_1,1)
!     &                                           +si1*vi(j_1,1)
!<<<           tmp1 = sr1 * vr(j_1,1)
               tmp1h = sr1h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr1h
               t_p1 = t_u1
     +                  - (t_u1 - sr1h)
               t_p2 = sr1h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr1h*vrl(j_1,1)
     +               + sr1l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr1 * vr(j_1,1)
!<<<           zr(j_1,i_1+1) = zr(j_1,i_1+1) - tmp1
               t_p1 = zrh(j_1,i_1+1) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+1)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+1) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+1) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+1) = zr(j_1,i_1+1) - tmp1
!<<<           tmp1 = si1 * vi(j_1,1)
               tmp1h = si1h * vih(j_1,1)
               t_u1 = 134217729.0 * si1h
               t_p1 = t_u1
     +                  - (t_u1 - si1h)
               t_p2 = si1h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si1h*vil(j_1,1)
     +               + si1l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si1 * vi(j_1,1)
!<<<           zr(j_1,i_1+1) = zr(j_1,i_1+1) + tmp1
               t_p1 = zrh(j_1,i_1+1) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+1)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+1) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+1) + tmp1l
               zrh(j_1,i_1+1) = t_q1 + t_q2
               zrl(j_1,i_1+1) = t_q2 - (zrh(j_1,i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+1) = zr(j_1,i_1+1) + tmp1
!                zi(j_1,i_1+1)=zi(j_1,i_1+1)
!     &                                           -si1*vr(j_1,1)
!     &                                           -sr1*vi(j_1,1)
!<<<           tmp1 = si1 * vr(j_1,1)
               tmp1h = si1h * vrh(j_1,1)
               t_u1 = 134217729.0 * si1h
               t_p1 = t_u1
     +                  - (t_u1 - si1h)
               t_p2 = si1h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si1h*vrl(j_1,1)
     +               + si1l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si1 * vr(j_1,1)
!<<<           zi(j_1,i_1+1) = zi(j_1,i_1+1) - tmp1
               t_p1 = zih(j_1,i_1+1) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+1)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+1) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+1) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+1) = zi(j_1,i_1+1) - tmp1
!<<<           tmp1 = sr1 * vi(j_1,1)
               tmp1h = sr1h * vih(j_1,1)
               t_u1 = 134217729.0 * sr1h
               t_p1 = t_u1
     +                  - (t_u1 - sr1h)
               t_p2 = sr1h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr1h*vil(j_1,1)
     +               + sr1l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr1 * vi(j_1,1)
!<<<           zi(j_1,i_1+1) = zi(j_1,i_1+1) - tmp1
               t_p1 = zih(j_1,i_1+1) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+1)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+1) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+1) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+1) = zi(j_1,i_1+1) - tmp1
!                zr(j_1,i_1+2)=zr(j_1,i_1+2)
!     &                                           -sr2*vr(j_1,1)
!     &                                           +si2*vi(j_1,1)
!<<<           tmp1 = sr2 * vr(j_1,1)
               tmp1h = sr2h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr2h
               t_p1 = t_u1
     +                  - (t_u1 - sr2h)
               t_p2 = sr2h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr2h*vrl(j_1,1)
     +               + sr2l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr2 * vr(j_1,1)
!<<<           zr(j_1,i_1+2) = zr(j_1,i_1+2) - tmp1
               t_p1 = zrh(j_1,i_1+2) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+2)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+2) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+2) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+2) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+2) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+2) = zr(j_1,i_1+2) - tmp1
!<<<           tmp1 = si2 * vi(j_1,1)
               tmp1h = si2h * vih(j_1,1)
               t_u1 = 134217729.0 * si2h
               t_p1 = t_u1
     +                  - (t_u1 - si2h)
               t_p2 = si2h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si2h*vil(j_1,1)
     +               + si2l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si2 * vi(j_1,1)
!<<<           zr(j_1,i_1+2) = zr(j_1,i_1+2) + tmp1
               t_p1 = zrh(j_1,i_1+2) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+2)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+2) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+2) + tmp1l
               zrh(j_1,i_1+2) = t_q1 + t_q2
               zrl(j_1,i_1+2) = t_q2 - (zrh(j_1,i_1+2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+2) = zr(j_1,i_1+2) + tmp1
!                zi(j_1,i_1+2)=zi(j_1,i_1+2)
!     &                                           -si2*vr(j_1,1)
!     &                                           -sr2*vi(j_1,1)
!<<<           tmp1 = si2 * vr(j_1,1)
               tmp1h = si2h * vrh(j_1,1)
               t_u1 = 134217729.0 * si2h
               t_p1 = t_u1
     +                  - (t_u1 - si2h)
               t_p2 = si2h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si2h*vrl(j_1,1)
     +               + si2l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si2 * vr(j_1,1)
!<<<           zi(j_1,i_1+2) = zi(j_1,i_1+2) - tmp1
               t_p1 = zih(j_1,i_1+2) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+2)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+2) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+2) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+2) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+2) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+2) = zi(j_1,i_1+2) - tmp1
!<<<           tmp1 = sr2 * vi(j_1,1)
               tmp1h = sr2h * vih(j_1,1)
               t_u1 = 134217729.0 * sr2h
               t_p1 = t_u1
     +                  - (t_u1 - sr2h)
               t_p2 = sr2h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr2h*vil(j_1,1)
     +               + sr2l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr2 * vi(j_1,1)
!<<<           zi(j_1,i_1+2) = zi(j_1,i_1+2) - tmp1
               t_p1 = zih(j_1,i_1+2) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+2)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+2) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+2) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+2) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+2) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+2) = zi(j_1,i_1+2) - tmp1
!                zr(j_1,i_1+3)=zr(j_1,i_1+3)
!     &                                           -sr3*vr(j_1,1)
!     &                                           +si3*vi(j_1,1)
!<<<           tmp1 = sr3 * vr(j_1,1)
               tmp1h = sr3h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr3h
               t_p1 = t_u1
     +                  - (t_u1 - sr3h)
               t_p2 = sr3h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr3h*vrl(j_1,1)
     +               + sr3l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr3 * vr(j_1,1)
!<<<           zr(j_1,i_1+3) = zr(j_1,i_1+3) - tmp1
               t_p1 = zrh(j_1,i_1+3) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+3)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+3) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+3) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+3) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+3) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+3) = zr(j_1,i_1+3) - tmp1
!<<<           tmp1 = si3 * vi(j_1,1)
               tmp1h = si3h * vih(j_1,1)
               t_u1 = 134217729.0 * si3h
               t_p1 = t_u1
     +                  - (t_u1 - si3h)
               t_p2 = si3h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si3h*vil(j_1,1)
     +               + si3l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si3 * vi(j_1,1)
!<<<           zr(j_1,i_1+3) = zr(j_1,i_1+3) + tmp1
               t_p1 = zrh(j_1,i_1+3) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+3)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+3) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+3) + tmp1l
               zrh(j_1,i_1+3) = t_q1 + t_q2
               zrl(j_1,i_1+3) = t_q2 - (zrh(j_1,i_1+3) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+3) = zr(j_1,i_1+3) + tmp1
!                zi(j_1,i_1+3)=zi(j_1,i_1+3)
!     &                                           -si3*vr(j_1,1)
!     &                                           -sr3*vi(j_1,1)
!<<<           tmp1 = si3 * vr(j_1,1)
               tmp1h = si3h * vrh(j_1,1)
               t_u1 = 134217729.0 * si3h
               t_p1 = t_u1
     +                  - (t_u1 - si3h)
               t_p2 = si3h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si3h*vrl(j_1,1)
     +               + si3l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si3 * vr(j_1,1)
!<<<           zi(j_1,i_1+3) = zi(j_1,i_1+3) - tmp1
               t_p1 = zih(j_1,i_1+3) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+3)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+3) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+3) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+3) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+3) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+3) = zi(j_1,i_1+3) - tmp1
!<<<           tmp1 = sr3 * vi(j_1,1)
               tmp1h = sr3h * vih(j_1,1)
               t_u1 = 134217729.0 * sr3h
               t_p1 = t_u1
     +                  - (t_u1 - sr3h)
               t_p2 = sr3h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr3h*vil(j_1,1)
     +               + sr3l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr3 * vi(j_1,1)
!<<<           zi(j_1,i_1+3) = zi(j_1,i_1+3) - tmp1
               t_p1 = zih(j_1,i_1+3) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+3)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+3) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+3) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+3) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+3) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+3) = zi(j_1,i_1+3) - tmp1
!                zr(j_1,i_1+4)=zr(j_1,i_1+4)
!     &                                           -sr4*vr(j_1,1)
!     &                                           +si4*vi(j_1,1)
!<<<           tmp1 = sr4 * vr(j_1,1)
               tmp1h = sr4h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr4h
               t_p1 = t_u1
     +                  - (t_u1 - sr4h)
               t_p2 = sr4h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr4h*vrl(j_1,1)
     +               + sr4l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr4 * vr(j_1,1)
!<<<           zr(j_1,i_1+4) = zr(j_1,i_1+4) - tmp1
               t_p1 = zrh(j_1,i_1+4) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+4)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+4) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+4) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+4) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+4) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+4) = zr(j_1,i_1+4) - tmp1
!<<<           tmp1 = si4 * vi(j_1,1)
               tmp1h = si4h * vih(j_1,1)
               t_u1 = 134217729.0 * si4h
               t_p1 = t_u1
     +                  - (t_u1 - si4h)
               t_p2 = si4h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si4h*vil(j_1,1)
     +               + si4l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si4 * vi(j_1,1)
!<<<           zr(j_1,i_1+4) = zr(j_1,i_1+4) + tmp1
               t_p1 = zrh(j_1,i_1+4) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+4)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+4) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+4) + tmp1l
               zrh(j_1,i_1+4) = t_q1 + t_q2
               zrl(j_1,i_1+4) = t_q2 - (zrh(j_1,i_1+4) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+4) = zr(j_1,i_1+4) + tmp1
!                zi(j_1,i_1+4)=zi(j_1,i_1+4)
!     &                                           -si4*vr(j_1,1)
!     &                                           -sr4*vi(j_1,1)
!<<<           tmp1 = si4 * vr(j_1,1)
               tmp1h = si4h * vrh(j_1,1)
               t_u1 = 134217729.0 * si4h
               t_p1 = t_u1
     +                  - (t_u1 - si4h)
               t_p2 = si4h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si4h*vrl(j_1,1)
     +               + si4l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si4 * vr(j_1,1)
!<<<           zi(j_1,i_1+4) = zi(j_1,i_1+4) - tmp1
               t_p1 = zih(j_1,i_1+4) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+4)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+4) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+4) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+4) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+4) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+4) = zi(j_1,i_1+4) - tmp1
!<<<           tmp1 = sr4 * vi(j_1,1)
               tmp1h = sr4h * vih(j_1,1)
               t_u1 = 134217729.0 * sr4h
               t_p1 = t_u1
     +                  - (t_u1 - sr4h)
               t_p2 = sr4h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr4h*vil(j_1,1)
     +               + sr4l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr4 * vi(j_1,1)
!<<<           zi(j_1,i_1+4) = zi(j_1,i_1+4) - tmp1
               t_p1 = zih(j_1,i_1+4) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+4)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+4) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+4) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+4) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+4) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+4) = zi(j_1,i_1+4) - tmp1
!                zr(j_1,i_1+5)=zr(j_1,i_1+5)
!     &                                           -sr5*vr(j_1,1)
!     &                                           +si5*vi(j_1,1)
!<<<           tmp1 = sr5 * vr(j_1,1)
               tmp1h = sr5h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr5h
               t_p1 = t_u1
     +                  - (t_u1 - sr5h)
               t_p2 = sr5h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr5h*vrl(j_1,1)
     +               + sr5l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr5 * vr(j_1,1)
!<<<           zr(j_1,i_1+5) = zr(j_1,i_1+5) - tmp1
               t_p1 = zrh(j_1,i_1+5) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+5)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+5) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+5) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+5) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+5) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+5) = zr(j_1,i_1+5) - tmp1
!<<<           tmp1 = si5 * vi(j_1,1)
               tmp1h = si5h * vih(j_1,1)
               t_u1 = 134217729.0 * si5h
               t_p1 = t_u1
     +                  - (t_u1 - si5h)
               t_p2 = si5h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si5h*vil(j_1,1)
     +               + si5l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si5 * vi(j_1,1)
!<<<           zr(j_1,i_1+5) = zr(j_1,i_1+5) + tmp1
               t_p1 = zrh(j_1,i_1+5) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+5)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+5) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+5) + tmp1l
               zrh(j_1,i_1+5) = t_q1 + t_q2
               zrl(j_1,i_1+5) = t_q2 - (zrh(j_1,i_1+5) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+5) = zr(j_1,i_1+5) + tmp1
!                zi(j_1,i_1+5)=zi(j_1,i_1+5)
!     &                                           -si5*vr(j_1,1)
!     &                                           -sr5*vi(j_1,1)
!<<<           tmp1 = si5 * vr(j_1,1)
               tmp1h = si5h * vrh(j_1,1)
               t_u1 = 134217729.0 * si5h
               t_p1 = t_u1
     +                  - (t_u1 - si5h)
               t_p2 = si5h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si5h*vrl(j_1,1)
     +               + si5l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si5 * vr(j_1,1)
!<<<           zi(j_1,i_1+5) = zi(j_1,i_1+5) - tmp1
               t_p1 = zih(j_1,i_1+5) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+5)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+5) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+5) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+5) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+5) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+5) = zi(j_1,i_1+5) - tmp1
!<<<           tmp1 = sr5 * vi(j_1,1)
               tmp1h = sr5h * vih(j_1,1)
               t_u1 = 134217729.0 * sr5h
               t_p1 = t_u1
     +                  - (t_u1 - sr5h)
               t_p2 = sr5h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr5h*vil(j_1,1)
     +               + sr5l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr5 * vi(j_1,1)
!<<<           zi(j_1,i_1+5) = zi(j_1,i_1+5) - tmp1
               t_p1 = zih(j_1,i_1+5) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+5)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+5) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+5) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+5) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+5) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+5) = zi(j_1,i_1+5) - tmp1
!                zr(j_1,i_1+6)=zr(j_1,i_1+6)
!     &                                           -sr6*vr(j_1,1)
!     &                                           +si6*vi(j_1,1)
!<<<           tmp1 = sr6 * vr(j_1,1)
               tmp1h = sr6h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr6h
               t_p1 = t_u1
     +                  - (t_u1 - sr6h)
               t_p2 = sr6h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr6h*vrl(j_1,1)
     +               + sr6l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr6 * vr(j_1,1)
!<<<           zr(j_1,i_1+6) = zr(j_1,i_1+6) - tmp1
               t_p1 = zrh(j_1,i_1+6) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+6)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+6) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+6) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+6) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+6) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+6) = zr(j_1,i_1+6) - tmp1
!<<<           tmp1 = si6 * vi(j_1,1)
               tmp1h = si6h * vih(j_1,1)
               t_u1 = 134217729.0 * si6h
               t_p1 = t_u1
     +                  - (t_u1 - si6h)
               t_p2 = si6h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si6h*vil(j_1,1)
     +               + si6l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si6 * vi(j_1,1)
!<<<           zr(j_1,i_1+6) = zr(j_1,i_1+6) + tmp1
               t_p1 = zrh(j_1,i_1+6) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+6)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+6) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+6) + tmp1l
               zrh(j_1,i_1+6) = t_q1 + t_q2
               zrl(j_1,i_1+6) = t_q2 - (zrh(j_1,i_1+6) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+6) = zr(j_1,i_1+6) + tmp1
!                zi(j_1,i_1+6)=zi(j_1,i_1+6)
!     &                                           -si6*vr(j_1,1)
!     &                                           -sr6*vi(j_1,1)
!<<<           tmp1 = si6 * vr(j_1,1)
               tmp1h = si6h * vrh(j_1,1)
               t_u1 = 134217729.0 * si6h
               t_p1 = t_u1
     +                  - (t_u1 - si6h)
               t_p2 = si6h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si6h*vrl(j_1,1)
     +               + si6l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si6 * vr(j_1,1)
!<<<           zi(j_1,i_1+6) = zi(j_1,i_1+6) - tmp1
               t_p1 = zih(j_1,i_1+6) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+6)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+6) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+6) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+6) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+6) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+6) = zi(j_1,i_1+6) - tmp1
!<<<           tmp1 = sr6 * vi(j_1,1)
               tmp1h = sr6h * vih(j_1,1)
               t_u1 = 134217729.0 * sr6h
               t_p1 = t_u1
     +                  - (t_u1 - sr6h)
               t_p2 = sr6h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr6h*vil(j_1,1)
     +               + sr6l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr6 * vi(j_1,1)
!<<<           zi(j_1,i_1+6) = zi(j_1,i_1+6) - tmp1
               t_p1 = zih(j_1,i_1+6) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+6)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+6) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+6) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+6) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+6) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+6) = zi(j_1,i_1+6) - tmp1
!                zr(j_1,i_1+7)=zr(j_1,i_1+7)
!     &                                           -sr7*vr(j_1,1)
!     &                                           +si7*vi(j_1,1)
!<<<           tmp1 = sr7 * vr(j_1,1)
               tmp1h = sr7h * vrh(j_1,1)
               t_u1 = 134217729.0 * sr7h
               t_p1 = t_u1
     +                  - (t_u1 - sr7h)
               t_p2 = sr7h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr7h*vrl(j_1,1)
     +               + sr7l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr7 * vr(j_1,1)
!<<<           zr(j_1,i_1+7) = zr(j_1,i_1+7) - tmp1
               t_p1 = zrh(j_1,i_1+7) - tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+7)
               t_ch = t_p1
               t_cl = (zrh(j_1,i_1+7) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zrl(j_1,i_1+7) - tmp1l
               t_s1 = t_ch + t_cl
               zrl(j_1,i_1+7) = t_cl - (t_s1 - t_ch)
               zrh(j_1,i_1+7) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zr(j_1,i_1+7) = zr(j_1,i_1+7) - tmp1
!<<<           tmp1 = si7 * vi(j_1,1)
               tmp1h = si7h * vih(j_1,1)
               t_u1 = 134217729.0 * si7h
               t_p1 = t_u1
     +                  - (t_u1 - si7h)
               t_p2 = si7h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si7h*vil(j_1,1)
     +               + si7l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si7 * vi(j_1,1)
!<<<           zr(j_1,i_1+7) = zr(j_1,i_1+7) + tmp1
               t_p1 = zrh(j_1,i_1+7) + tmp1h
               t_p2 = t_p1 - zrh(j_1,i_1+7)
               t_q1 = t_p1
               t_q2 = (zrh(j_1,i_1+7) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + zrl(j_1,i_1+7) + tmp1l
               zrh(j_1,i_1+7) = t_q1 + t_q2
               zrl(j_1,i_1+7) = t_q2 - (zrh(j_1,i_1+7) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           zr(j_1,i_1+7) = zr(j_1,i_1+7) + tmp1
!                zi(j_1,i_1+7)=zi(j_1,i_1+7)
!     &                                           -si7*vr(j_1,1)
!     &                                           -sr7*vi(j_1,1)
!<<<           tmp1 = si7 * vr(j_1,1)
               tmp1h = si7h * vrh(j_1,1)
               t_u1 = 134217729.0 * si7h
               t_p1 = t_u1
     +                  - (t_u1 - si7h)
               t_p2 = si7h - t_p1
               t_u1 = 134217729.0 * vrh(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vrh(j_1,1))
               t_r2 = vrh(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (si7h*vrl(j_1,1)
     +               + si7l*vrh(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si7 * vr(j_1,1)
!<<<           zi(j_1,i_1+7) = zi(j_1,i_1+7) - tmp1
               t_p1 = zih(j_1,i_1+7) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+7)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+7) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+7) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+7) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+7) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+7) = zi(j_1,i_1+7) - tmp1
!<<<           tmp1 = sr7 * vi(j_1,1)
               tmp1h = sr7h * vih(j_1,1)
               t_u1 = 134217729.0 * sr7h
               t_p1 = t_u1
     +                  - (t_u1 - sr7h)
               t_p2 = sr7h - t_p1
               t_u1 = 134217729.0 * vih(j_1,1)
               t_r1 = t_u1
     +                  - (t_u1 - vih(j_1,1))
               t_r2 = vih(j_1,1) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sr7h*vil(j_1,1)
     +               + sr7l*vih(j_1,1))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr7 * vi(j_1,1)
!<<<           zi(j_1,i_1+7) = zi(j_1,i_1+7) - tmp1
               t_p1 = zih(j_1,i_1+7) - tmp1h
               t_p2 = t_p1 - zih(j_1,i_1+7)
               t_ch = t_p1
               t_cl = (zih(j_1,i_1+7) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + zil(j_1,i_1+7) - tmp1l
               t_s1 = t_ch + t_cl
               zil(j_1,i_1+7) = t_cl - (t_s1 - t_ch)
               zih(j_1,i_1+7) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           zi(j_1,i_1+7) = zi(j_1,i_1+7) - tmp1
             end do! j_1
          end do! i_1
          i=i+0; goto 1000

1200      continue

            i_ng=0
            do i_1=2,m-1
!               if ( (i+i_1<=n) .and. (tau(i+i_1,1)/=0.0) ) then
               if ( (i+i_1<=n) .and. (
!                   (tau(i+i_1,1) .ne. 0.0)
     +             ((tauh(i+i_1,1) .ne. 0.0d+0) .or.
     +              (taul(i+i_1,1) .ne. 0.0d+0))
     &         ) ) then
                  continue
               else
                  i_ng=i_ng+1
                  exit
               endif
            enddo
            if (i_ng/=0) goto 1111

          ds=mpi_wtime()
          do j=0,m-1
             nodes(j) = get_owner_node(i+j, size_of_row, my_row)
             if ( nodes(j) == my_row ) then
                i_1 = translate_g2l(i+j, size_of_row, my_row)
                j_2 = get_loop_start(1,  size_of_col,my_col)
                j_3 = get_loop_end  (i+m-2,size_of_col,my_col)
#ifdef MEMORY2
      nxx = xx_vr(1230,j_3,j+1)
      nxx = xx_vi(1240,j_3,j+1)
#endif
                do j_1=j_2,j_3
!                   vr(j_1,j+1)=ar(j_1,i_1)
!                   vi(j_1,j+1)=ai(j_1,i_1)
                     vrh(j_1,j+1) = arh(j_1,i_1)
                     vrl(j_1,j+1) = arl(j_1,i_1)
                     vih(j_1,j+1) = aih(j_1,i_1)
                     vil(j_1,j+1) = ail(j_1,i_1)
                end do! k
                j_2 = get_loop_start(i+j,size_of_col,my_col)
                j_3 = get_loop_end  (i+m-2,size_of_col,my_col)
!cdir novector
                do j_1=j_2,j_3
!                   vr(j_1,j+1)=0.0d+00
!                   vi(j_1,j+1)=0.0d+00
                     vrh(j_1,j+1) = 0.0d+0
                     vrl(j_1,j+1) = 0.0d+0
                     vih(j_1,j+1) = 0.0d+0
                     vil(j_1,j+1) = 0.0d+0
                end do
             end if
          end do
          j_2 = get_loop_start(1,     size_of_col,my_col)
          j_3 = get_loop_end  (i+m-2, size_of_col,my_col)
#ifdef MEMORY2
      nxx = xx_vr(1250,j_3-j_2+1,m)
      nxx = xx_vi(1260,j_3-j_2+1,m)
#endif
          do j=0,m-1
!             call bcast_dbl(vr(1,j+1), j_3-j_2+1,
!     &                      nodes(j), mpi_comm_row)
!             call bcast_dbl(vi(1,j+1), j_3-j_2+1,
!     &                      nodes(j), mpi_comm_row)
             call ddbcast_dbl(vrh(1,j+1),vrl(1,j+1), j_3-j_2+1,
     &                      nodes(j), mpi_comm_row)
             call ddbcast_dbl(vih(1,j+1),vil(1,j+1),j_3-j_2+1,
     &                      nodes(j), mpi_comm_row)
          enddo
          de=mpi_wtime()
          dcom=dcom+(de-ds)

!          call eigen_hbk_main2(
!     &           i_3, zr, zi, nmz,
!     &           tau, nmtau, m, mm,
!     &           vr,vi, wr,wi, nm, i, ssr,ssi,tt, dcom
          call ddeigen_hbk_main2(
     &           i_3, zrh, zrl, zih, zil, nmz,
     &           tauh, taul, nmtau, m, mm,
     &           vrh, vrl, vih, vil, wrh, wrl, wih, wil, nm, i,
     &           ssrh, ssrl, ssih, ssil, tth, ttl, dcom
#ifdef MEMORY2
     &          ,xx_vr (0,1,1),xx_vi (0,1,1)
     &          ,xx_wr (0,1,1),xx_wi (0,1,1)
     &          ,xx_ssr(0,1)  ,xx_ssi(0,1)
     &          ,xx_tt (0,1)
#endif
     &         )

          i=i+m-1; goto 1000

       continue

9000   continue

       call mpi_barrier(mpi_comm_world,ierr)
#ifdef DETAIL
       d2=mpi_wtime()
       if (myrank==1) then
          print*," "
!          print*,"detail of exectime in eigen_hbk "
!          print*,"   time of eigen_hbk_main1=",(d2-d1),"(sec)"
!          print*,"   communication in eigen_hbk_main1=",dcom,"(sec)"
          print*,"detail of exectime in ddeigen_hbk "
          print*,"   time of ddeigen_hbk_main1=",(d2-d1),"(sec)"
          print*,"   communication in ddeigen_hbk_main1=",dcom,"(sec)"
!----     print*,"   ",(8d0*n*n*n)/(d2-d1)*1d-9,"gflops"
       end if
#endif

       return
#ifdef MEMORY2
       contains

       function xx_vr(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_vr
       integer :: i0,i1,i2
       xx_vr = nxx_vr + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_vr,kxx_vr,"ddeigen_hbk_main1:xx_vr")
       end function

       function xx_vi(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_vi
       integer :: i0,i1,i2
       xx_vi = nxx_vi + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_vi,kxx_vi,"ddeigen_hbk_main1:xx_vi")
       end function

       function xx_wr(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_wr
       integer :: i0,i1,i2
       xx_wr = nxx_wr + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_wr,kxx_wr,"ddeigen_hbk_main1:xx_wr")
       end function

       function xx_wi(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_wi
       integer :: i0,i1,i2
       xx_wi = nxx_wi + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_wi,kxx_wi,"ddeigen_hbk_main1:xx_wi")
       end function

       function xx_ssr(i0,i1)
       use xx_hbk_info
       integer :: xx_ssr
       integer :: i0,i1
       xx_ssr = nxx_ssr + i1 - 1
       call accessor(i0,xx_ssr,kxx_ssr,"ddeigen_hbk_main1:xx_ssr")
       end function

       function xx_ssi(i0,i1)
       use xx_hbk_info
       integer :: xx_ssi
       integer :: i0,i1
       xx_ssi = nxx_ssi + i1 - 1
       call accessor(i0,xx_ssi,kxx_ssi,"ddeigen_hbk_main1:xx_ssi")
       end function

       function xx_tt(i0,i1)
       use xx_hbk_info
       integer :: xx_tt
       integer :: i0,i1
       xx_tt = nxx_tt + i1 - 1
       call accessor(i0,xx_tt,kxx_tt,"ddeigen_hbk_main1:xx_tt")
       end function
#endif
       end subroutine ! eigen_hbk_main1

!       subroutine eigen_hbk_main2(n, zr, zi, nmz,
!     &            tau, nmtau, m, mm,
!     &            vr,vi, wr,wi, nm, i, ssr,ssi, tt, dcom
       subroutine ddeigen_hbk_main2(n, zrh, zrl, zih, zil, nmz,
     &            tauh, taul, nmtau, m, mm,
     &            vrh, vrl, vih, vil, wrh, wrl, wih, wil, nm, i,
     &            ssrh, ssrl, ssih, ssil, tth, ttl, dcom
#ifdef MEMORY2
     &                         ,nxx_vr,nxx_vi,nxx_wr,nxx_wi
     &                         ,nxx_ssr,nxx_ssi,nxx_tt
#endif
     &            )

!----
!      use communication_h, only : get_loop_start
!     &               , get_loop_end
!     &               , reduce_dbl
      use ddcommunication_h, only : get_loop_start
     &                            , get_loop_end
     &                            , ddreduce_dbl
!----
       implicit double precision(a-h,o-z),integer(i-n)

       integer :: n, nmz, nm, i
!       real(8) :: zr(nmz,*),zi(nmz,*),tau(nmtau,2)
!       real(8) :: vr(nm,*),vi(nm,*),wr(nm,*),wi(nm,*)
!       real(8) :: ssr(*),ssi(*), tt(*), dcom, ds, de
       real(8) :: zrh(nmz,*),zih(nmz,*),tauh(nmtau,2)
       real(8) :: zrl(nmz,*),zil(nmz,*),taul(nmtau,2)
       real(8) :: vrh(nm,*),vih(nm,*),wrh(nm,*),wih(nm,*)
       real(8) :: vrl(nm,*),vil(nm,*),wrl(nm,*),wil(nm,*)
       real(8) :: ssrh(*),ssih(*), tth(*), dcom, ds, de
       real(8) :: ssrl(*),ssil(*), ttl(*)

      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

       include 'mpif.h'
!$     include 'omp_lib.h'
       include 'trd.h'
#ifdef MEMORY2
      integer,intent(in) :: nxx_vr
      integer,intent(in) :: nxx_vi
      integer,intent(in) :: nxx_wr
      integer,intent(in) :: nxx_wi
      integer,intent(in) :: nxx_ssr
      integer,intent(in) :: nxx_ssi
      integer,intent(in) :: nxx_tt
#endif

          i_2=1
          i_3=n
          j_2 = get_loop_start(1,    size_of_col,my_col)
          j_3 = get_loop_end  (i+m-2,size_of_col,my_col)

#ifdef MEMORY2
      nxx = xx_ssr(1270,m*(m-1)/2)
      nxx = xx_ssi(1280,m*(m-1)/2)
#endif
          do iss=1,m*(m-1)/2
!             ssr(iss)=0.0d0
!             ssi(iss)=0.0d0
            ssrh(iss) = 0.0d+0
            ssrl(iss) = 0.0d+0
            ssih(iss) = 0.0d+0
            ssil(iss) = 0.0d+0
          enddo
#ifdef MEMORY2
      nxx = xx_vr(1290,min(j_3,(j_2+int((j_3-j_2)/128)*128)+128-1),m)
      nxx = xx_vi(1300,min(j_3,(j_2+int((j_3-j_2)/128)*128)+128-1),m)
      nxx = xx_ssr(1310,m*(m-1)/2)
      nxx = xx_ssi(1320,m*(m-1)/2)
#endif
          do j_10=j_2,j_3,128; j_4=j_10; j_5=min(j_3,j_10+128-1)
          iss=m*(m-1)/2
          do l_1=m,2,-1
          do k_1=l_1-1,1,-1
!             sr0=ssr(iss)
!             si0=ssi(iss)
            sr0h = ssrh(iss)
            sr0l = ssrl(iss)
            si0h = ssih(iss)
            si0l = ssil(iss)
             do j_1=j_4,j_5
!             vr1=vr(j_1,l_1)
!             vi1=vi(j_1,l_1)
!             vr0=vr(j_1,k_1)
!             vi0=vi(j_1,k_1)
            vr1h = vrh(j_1,l_1)
            vr1l = vrl(j_1,l_1)
            vi1h = vih(j_1,l_1)
            vi1l = vil(j_1,l_1)
            vr0h = vrh(j_1,k_1)
            vr0l = vrl(j_1,k_1)
            vi0h = vih(j_1,k_1)
            vi0l = vil(j_1,k_1)
!             sr0=sr0+vr1*vr0+vi1*vi0
!<<<        tmp1 = vr1 * vr0
            tmp1h = vr1h * vr0h
            t_u1 = 134217729.0 * vr1h
            t_p1 = t_u1
     +               - (t_u1 - vr1h)
            t_p2 = vr1h - t_p1
            t_u1 = 134217729.0 * vr0h
            t_r1 = t_u1
     +               - (t_u1 - vr0h)
            t_r2 = vr0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (vr1h*vr0l
     +            + vr1l*vr0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = vr1 * vr0
!<<<        sr0 = sr0 + tmp1
            t_p1 = sr0h + tmp1h
            t_p2 = t_p1 - sr0h
            t_q1 = t_p1
            t_q2 = (sr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + sr0l + tmp1l
            sr0h = t_q1 + t_q2
            sr0l = t_q2 - (sr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        sr0 = sr0 + tmp1
!<<<        tmp1 = vi1 * vi0
            tmp1h = vi1h * vi0h
            t_u1 = 134217729.0 * vi1h
            t_p1 = t_u1
     +               - (t_u1 - vi1h)
            t_p2 = vi1h - t_p1
            t_u1 = 134217729.0 * vi0h
            t_r1 = t_u1
     +               - (t_u1 - vi0h)
            t_r2 = vi0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (vi1h*vi0l
     +            + vi1l*vi0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = vi1 * vi0
!<<<        sr0 = sr0 + tmp1
            t_p1 = sr0h + tmp1h
            t_p2 = t_p1 - sr0h
            t_q1 = t_p1
            t_q2 = (sr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + sr0l + tmp1l
            sr0h = t_q1 + t_q2
            sr0l = t_q2 - (sr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        sr0 = sr0 + tmp1
!             si0=si0-vi1*vr0+vr1*vi0
!<<<        tmp1 = vi1 * vr0
            tmp1h = vi1h * vr0h
            t_u1 = 134217729.0 * vi1h
            t_p1 = t_u1
     +               - (t_u1 - vi1h)
            t_p2 = vi1h - t_p1
            t_u1 = 134217729.0 * vr0h
            t_r1 = t_u1
     +               - (t_u1 - vr0h)
            t_r2 = vr0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (vi1h*vr0l
     +            + vi1l*vr0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = vi1 * vr0
!<<<        si0 = si0 - tmp1
            t_p1 = si0h - tmp1h
            t_p2 = t_p1 - si0h
            t_ch = t_p1
            t_cl = (si0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + si0l - tmp1l
            t_s1 = t_ch + t_cl
            si0l = t_cl - (t_s1 - t_ch)
            si0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        si0 = si0 - tmp1
!<<<        tmp1 = vr1 * vi0
            tmp1h = vr1h * vi0h
            t_u1 = 134217729.0 * vr1h
            t_p1 = t_u1
     +               - (t_u1 - vr1h)
            t_p2 = vr1h - t_p1
            t_u1 = 134217729.0 * vi0h
            t_r1 = t_u1
     +               - (t_u1 - vi0h)
            t_r2 = vi0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (vr1h*vi0l
     +            + vr1l*vi0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = vr1 * vi0
!<<<        si0 = si0 + tmp1
            t_p1 = si0h + tmp1h
            t_p2 = t_p1 - si0h
            t_q1 = t_p1
            t_q2 = (si0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + si0l + tmp1l
            si0h = t_q1 + t_q2
            si0l = t_q2 - (si0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        si0 = si0 + tmp1
             enddo
!             ssr(iss)=sr0
!             ssi(iss)=si0
            ssrh(iss) = sr0h
            ssrl(iss) = sr0l
            ssih(iss) = si0h
            ssil(iss) = si0l
             iss=iss-1
          enddo
          enddo
          enddo

          i_5 = i_3 - i_2 + 1
          j_5 = j_3 - j_2 + 1
          if ( j_5 > 0 .and. i_5 > 0 ) then
#ifdef MEMORY2
c      nxx = xx_vr (1330,j_2  + nm*m - 1,1)
      nxx = xx_vr (1330,j_2  + j_5+ nm*(m-1) - 1,1)
      nxx = xx_ssr(1340,1+mm + m *i_5 -1)
#endif
!                 call dgemm('t','n',
!     &               m, i_5, j_5,
!     &               1.0d+00, vr(j_2    ,1       ), nm,
!     &                        zr(j_2    ,i_2     ), nmz,
!     &               0.0d+00, ssr(1     +mm     ), m)
                 call ddgemm('t','n',
     &               m, i_5, j_5,
     &               1.0d+00, 0.0d+00,
     &               vrh(j_2    ,1       ), vrl(j_2    ,1       ), nm,
     &               zrh(j_2    ,i_2     ), zrl(j_2    ,i_2     ), nmz,
     &               0.0d+00, 0.0d+00,
     &               ssrh(1     +mm     ), ssrl(1     +mm     ), m)
#ifdef MEMORY2
c      nxx = xx_vi (1350,j_2  + nm*m - 1,1)
      nxx = xx_vi (1350,j_2  + j_5+ nm*(m-1) - 1,1)
      nxx = xx_ssi(1360,1+mm + m *i_5 -1)
#endif
!                 call dgemm('t','n',
!     &               m, i_5, j_5,
!     &               1.0d+00, vi(j_2    ,1       ), nm,
!     &                        zi(j_2    ,i_2     ), nmz,
!     &               1.0d+00, ssr(1     +mm     ), m)
                 call ddgemm('t','n',
     &               m, i_5, j_5,
     &               1.0d+00, 0.0d+00,
     &               vih(j_2    ,1       ), vil(j_2    ,1       ), nm,
     &               zih(j_2    ,i_2     ), zil(j_2    ,i_2     ), nmz,
     &               1.0d+00, 0.0d+00,
     &               ssrh(1     +mm     ), ssrl(1     +mm     ), m)

!                 call dgemm('t','n',
!     &               m, i_5, j_5,
!     &              -1.0d+00, vi(j_2    ,1       ), nm,
!     &                        zr(j_2    ,i_2     ), nmz,
!     &               0.0d+00, ssi(1     +mm     ), m)
                 call ddgemm('t','n',
     &               m, i_5, j_5,
     &              -1.0d+00, 0.0d+00,
     &               vih(j_2    ,1       ), vil(j_2    ,1       ), nm,
     &               zrh(j_2    ,i_2     ), zrl(j_2    ,i_2     ), nmz,
     &               0.0d+00, 0.0d+00,
     &               ssih(1     +mm     ), ssil(1     +mm     ), m)
!                 call dgemm('t','n',
!     &               m, i_5, j_5,
!     &               1.0d+00, vr(j_2    ,1       ), nm,
!     &                        zi(j_2    ,i_2     ), nmz,
!     &               1.0d+00, ssi(1     +mm     ), m)
                 call ddgemm('t','n',
     &               m, i_5, j_5,
     &               1.0d+00, 0.0d+00,
     &               vrh(j_2    ,1       ), vrl(j_2    ,1       ), nm,
     &               zih(j_2    ,i_2     ), zil(j_2    ,i_2     ), nmz,
     &               1.0d+00, 0.0d+00,
     &               ssih(1     +mm     ), ssil(1     +mm     ), m)
          endif
!----
#ifdef MEMORY2
      nxx = xx_ssr(1370,(i_3-i_2+1)*m+mm)
      nxx = xx_ssi(1380,(i_3-i_2+1)*m+mm)
      nxx = xx_tt (1390,(i_3-i_2+1)*m+mm)
#endif
          ds=mpi_wtime()
!          call reduce_dbl(ssr, tt, (i_3-i_2+1)*m+mm, mpi_comm_col)
!          call reduce_dbl(ssi, tt, (i_3-i_2+1)*m+mm, mpi_comm_col)
          call ddreduce_dbl(ssrh, ssrl, tth, ttl,
     &                      (i_3-i_2+1)*m+mm, mpi_comm_col)
          call ddreduce_dbl(ssih, ssil, tth, ttl,
     &                      (i_3-i_2+1)*m+mm, mpi_comm_col)
          de=mpi_wtime()
          dcom=dcom+(de-ds)
!----
#ifdef MEMORY2
      nxx = xx_ssr(1400,m*(m-1)/2)
      nxx = xx_ssi(1410,m*(m-1)/2)
      nxx = xx_ssr(1420,(i_3-i_2)*m+m+mm)
      nxx = xx_ssi(1430,(i_3-i_2)*m+m+mm)
#endif
             iss=m*(m-1)/2
          do k_1=m,1,-1
!             h0=tau(i+k_1-1,1)
            h0h = tauh(i+k_1-1,1)
            h0l = taul(i+k_1-1,1)
          do i_1=k_1-1,1,-1
!             ssr(iss)=(ssr(iss)/h0)/h0
!             ssi(iss)=(ssi(iss)/h0)/h0
!<<<        tmp1 = ssr(iss) / h0
            t_q1 = ssrh(iss) / h0h
            tmp1h = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            tmp1l = ((t_p1*t_r1
     +             - tmp1h)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            tmp1l = tmp1l + (h0l*t_q1)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
            t_s1 = ssrh(iss) - tmp1h
            t_r1 = t_s1 - ssrh(iss)
            t_s2 = (ssrh(iss) 
     +               - (t_s1 - t_r1))
     +               - (tmp1h + t_r1)
            t_s2 = t_s2 - tmp1l
            t_s2 = t_s2 + ssrl(iss)
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            tmp1h = t_q1 + t_q2
            tmp1l = t_q2
     +            - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tmp1 = ssr(iss) / h0
!<<<        ssr(iss) = tmp1 / h0
            t_q1 = tmp1h / h0h
            ssrh(iss) = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            ssrl(iss) = ((t_p1*t_r1
     +             - ssrh(iss))
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            ssrl(iss) = ssrl(iss) + (h0l*t_q1)
            t_s1 = ssrh(iss) + ssrl(iss)
            ssrl(iss) = ssrl(iss) - (t_s1 - ssrh(iss))
            ssrh(iss) = t_s1
            t_s1 = tmp1h - ssrh(iss)
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h 
     +               - (t_s1 - t_r1))
     +               - (ssrh(iss) + t_r1)
            t_s2 = t_s2 - ssrl(iss)
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            ssrh(iss) = t_q1 + t_q2
            ssrl(iss) = t_q2
     +            - (ssrh(iss) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        ssr(iss) = tmp1 / h0
!<<<        tmp1 = ssi(iss) / h0
            t_q1 = ssih(iss) / h0h
            tmp1h = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            tmp1l = ((t_p1*t_r1
     +             - tmp1h)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            tmp1l = tmp1l + (h0l*t_q1)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
            t_s1 = ssih(iss) - tmp1h
            t_r1 = t_s1 - ssih(iss)
            t_s2 = (ssih(iss) 
     +               - (t_s1 - t_r1))
     +               - (tmp1h + t_r1)
            t_s2 = t_s2 - tmp1l
            t_s2 = t_s2 + ssil(iss)
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            tmp1h = t_q1 + t_q2
            tmp1l = t_q2
     +            - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tmp1 = ssi(iss) / h0
!<<<        ssi(iss) = tmp1 / h0
            t_q1 = tmp1h / h0h
            ssih(iss) = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            ssil(iss) = ((t_p1*t_r1
     +             - ssih(iss))
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            ssil(iss) = ssil(iss) + (h0l*t_q1)
            t_s1 = ssih(iss) + ssil(iss)
            ssil(iss) = ssil(iss) - (t_s1 - ssih(iss))
            ssih(iss) = t_s1
            t_s1 = tmp1h - ssih(iss)
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h 
     +               - (t_s1 - t_r1))
     +               - (ssih(iss) + t_r1)
            t_s2 = t_s2 - ssil(iss)
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            ssih(iss) = t_q1 + t_q2
            ssil(iss) = t_q2
     +            - (ssih(iss) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        ssi(iss) = tmp1 / h0
             iss=iss-1
          enddo
          do i_1=i_2,i_3
!             ssr((i_1-i_2)*m+k_1+mm)=
!     $          (ssr((i_1-i_2)*m+k_1+mm)/h0)/h0
!             ssi((i_1-i_2)*m+k_1+mm)=
!     $          (ssi((i_1-i_2)*m+k_1+mm)/h0)/h0
!<<<        tmp1 = ssr((i_1-i_2)*m+k_1+mm) / h0
            t_q1 = ssrh((i_1-i_2)*m+k_1+mm) / h0h
            tmp1h = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            tmp1l = ((t_p1*t_r1
     +             - tmp1h)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            tmp1l = tmp1l + (h0l*t_q1)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
            t_s1 = ssrh((i_1-i_2)*m+k_1+mm) - tmp1h
            t_r1 = t_s1 - ssrh((i_1-i_2)*m+k_1+mm)
            t_s2 = (ssrh((i_1-i_2)*m+k_1+mm) 
     +               - (t_s1 - t_r1))
     +               - (tmp1h + t_r1)
            t_s2 = t_s2 - tmp1l
            t_s2 = t_s2 + ssrl((i_1-i_2)*m+k_1+mm)
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            tmp1h = t_q1 + t_q2
            tmp1l = t_q2
     +            - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tmp1 = ssr((i_1-i_2)*m+k_1+mm) / h0
!<<<        ssr((i_1-i_2)*m+k_1+mm) = tmp1 / h0
            t_q1 = tmp1h / h0h
            ssrh((i_1-i_2)*m+k_1+mm) = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            ssrl((i_1-i_2)*m+k_1+mm) = ((t_p1*t_r1
     +             - ssrh((i_1-i_2)*m+k_1+mm))
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            ssrl((i_1-i_2)*m+k_1+mm) = ssrl((i_1-i_2)*m+k_1+mm) 
     +                                 + (h0l*t_q1)
            t_s1 = ssrh((i_1-i_2)*m+k_1+mm) + ssrl((i_1-i_2)*m+k_1+mm)
            ssrl((i_1-i_2)*m+k_1+mm) = ssrl((i_1-i_2)*m+k_1+mm)
     +                               - (t_s1 - ssrh((i_1-i_2)*m+k_1+mm))
            ssrh((i_1-i_2)*m+k_1+mm) = t_s1
            t_s1 = tmp1h - ssrh((i_1-i_2)*m+k_1+mm)
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h 
     +               - (t_s1 - t_r1))
     +               - (ssrh((i_1-i_2)*m+k_1+mm) + t_r1)
            t_s2 = t_s2 - ssrl((i_1-i_2)*m+k_1+mm)
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            ssrh((i_1-i_2)*m+k_1+mm) = t_q1 + t_q2
            ssrl((i_1-i_2)*m+k_1+mm) = t_q2
     +            - (ssrh((i_1-i_2)*m+k_1+mm) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        ssr((i_1-i_2)*m+k_1+mm) = tmp1 / h0
!<<<        tmp1 = ssi((i_1-i_2)*m+k_1+mm) / h0
            t_q1 = ssih((i_1-i_2)*m+k_1+mm) / h0h
            tmp1h = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            tmp1l = ((t_p1*t_r1
     +             - tmp1h)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            tmp1l = tmp1l + (h0l*t_q1)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
            t_s1 = ssih((i_1-i_2)*m+k_1+mm) - tmp1h
            t_r1 = t_s1 - ssih((i_1-i_2)*m+k_1+mm)
            t_s2 = (ssih((i_1-i_2)*m+k_1+mm) 
     +               - (t_s1 - t_r1))
     +               - (tmp1h + t_r1)
            t_s2 = t_s2 - tmp1l
            t_s2 = t_s2 + ssil((i_1-i_2)*m+k_1+mm)
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            tmp1h = t_q1 + t_q2
            tmp1l = t_q2
     +            - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tmp1 = ssi((i_1-i_2)*m+k_1+mm) / h0
!<<<        ssi((i_1-i_2)*m+k_1+mm) = tmp1 / h0
            t_q1 = tmp1h / h0h
            ssih((i_1-i_2)*m+k_1+mm) = h0h * t_q1
            t_u1 = 134217729.0 * h0h
            t_p1 = t_u1
     +               - (t_u1 - h0h)
            t_p2 = h0h - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            ssil((i_1-i_2)*m+k_1+mm) = ((t_p1*t_r1
     +             - ssih((i_1-i_2)*m+k_1+mm))
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            ssil((i_1-i_2)*m+k_1+mm) = ssil((i_1-i_2)*m+k_1+mm)
     +                                 + (h0l*t_q1)
            t_s1 = ssih((i_1-i_2)*m+k_1+mm) + ssil((i_1-i_2)*m+k_1+mm)
            ssil((i_1-i_2)*m+k_1+mm) = ssil((i_1-i_2)*m+k_1+mm)
     +                               - (t_s1 - ssih((i_1-i_2)*m+k_1+mm))
            ssih((i_1-i_2)*m+k_1+mm) = t_s1
            t_s1 = tmp1h - ssih((i_1-i_2)*m+k_1+mm)
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h 
     +               - (t_s1 - t_r1))
     +               - (ssih((i_1-i_2)*m+k_1+mm) + t_r1)
            t_s2 = t_s2 - ssil((i_1-i_2)*m+k_1+mm)
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / h0h
            ssih((i_1-i_2)*m+k_1+mm) = t_q1 + t_q2
            ssil((i_1-i_2)*m+k_1+mm) = t_q2
     +            - (ssih((i_1-i_2)*m+k_1+mm) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        ssi((i_1-i_2)*m+k_1+mm) = tmp1 / h0
          end do! i_1
          end do! k_1
!----
#ifdef MEMORY2
      nxx = xx_wr(1440,min(j_3,(j_2+int((j_3-j_2)/128)*128)+128-1),m)
      nxx = xx_wi(1450,min(j_3,(j_2+int((j_3-j_2)/128)*128)+128-1),m)
      nxx = xx_ssr(1460,m*(m-1)/2)
      nxx = xx_ssi(1470,m*(m-1)/2)
#endif
          do j_10=j_2,j_3,128; j_4=j_10; j_5=min(j_3,j_10+128-1)
          do l_1=m,1,-1
             do j_1=j_4,j_5
!                wr(j_1,l_1)=vr(j_1,l_1)
!                wi(j_1,l_1)=vi(j_1,l_1)
               wrh(j_1,l_1) = vrh(j_1,l_1)
               wrl(j_1,l_1) = vrl(j_1,l_1)
               wih(j_1,l_1) = vih(j_1,l_1)
               wil(j_1,l_1) = vil(j_1,l_1)
             enddo
          enddo
             iss=m*(m-1)/2
          do l_1=m,2,-1
          do k_1=l_1-1,1,-1
             do j_1=j_4,j_5
!                wr(j_1,k_1)=wr(j_1,k_1)
!     &                     -wr(j_1,l_1)*ssr(iss)
!     &                     +wi(j_1,l_1)*ssi(iss)
!<<<           tmp1 = wr(j_1,l_1) * ssr(iss)
               tmp1h = wrh(j_1,l_1) * ssrh(iss)
               t_u1 = 134217729.0 * wrh(j_1,l_1)
               t_p1 = t_u1
     +                  - (t_u1 - wrh(j_1,l_1))
               t_p2 = wrh(j_1,l_1) - t_p1
               t_u1 = 134217729.0 * ssrh(iss)
               t_r1 = t_u1
     +                  - (t_u1 - ssrh(iss))
               t_r2 = ssrh(iss) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wrh(j_1,l_1)*ssrl(iss)
     +               + wrl(j_1,l_1)*ssrh(iss))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = wr(j_1,l_1) * ssr(iss)
!<<<           wr(j_1,k_1) = wr(j_1,k_1) - tmp1
               t_p1 = wrh(j_1,k_1) - tmp1h
               t_p2 = t_p1 - wrh(j_1,k_1)
               t_ch = t_p1
               t_cl = (wrh(j_1,k_1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + wrl(j_1,k_1) - tmp1l
               t_s1 = t_ch + t_cl
               wrl(j_1,k_1) = t_cl - (t_s1 - t_ch)
               wrh(j_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           wr(j_1,k_1) = wr(j_1,k_1) - tmp1
!<<<           tmp1 = wi(j_1,l_1) * ssi(iss)
               tmp1h = wih(j_1,l_1) * ssih(iss)
               t_u1 = 134217729.0 * wih(j_1,l_1)
               t_p1 = t_u1
     +                  - (t_u1 - wih(j_1,l_1))
               t_p2 = wih(j_1,l_1) - t_p1
               t_u1 = 134217729.0 * ssih(iss)
               t_r1 = t_u1
     +                  - (t_u1 - ssih(iss))
               t_r2 = ssih(iss) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wih(j_1,l_1)*ssil(iss)
     +               + wil(j_1,l_1)*ssih(iss))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = wi(j_1,l_1) * ssi(iss)
!<<<           wr(j_1,k_1) = wr(j_1,k_1) + tmp1
               t_p1 = wrh(j_1,k_1) + tmp1h
               t_p2 = t_p1 - wrh(j_1,k_1)
               t_q1 = t_p1
               t_q2 = (wrh(j_1,k_1) - (t_p1 - t_p2))
     +                  + (tmp1h - t_p2)
               t_q2 = t_q2 + wrl(j_1,k_1) + tmp1l
               wrh(j_1,k_1) = t_q1 + t_q2
               wrl(j_1,k_1) = t_q2 - (wrh(j_1,k_1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           wr(j_1,k_1) = wr(j_1,k_1) + tmp1
!                wi(j_1,k_1)=wi(j_1,k_1)
!     &                     -wi(j_1,l_1)*ssr(iss)
!     &                     -wr(j_1,l_1)*ssi(iss)
!<<<           tmp1 = wi(j_1,l_1) * ssr(iss)
               tmp1h = wih(j_1,l_1) * ssrh(iss)
               t_u1 = 134217729.0 * wih(j_1,l_1)
               t_p1 = t_u1
     +                  - (t_u1 - wih(j_1,l_1))
               t_p2 = wih(j_1,l_1) - t_p1
               t_u1 = 134217729.0 * ssrh(iss)
               t_r1 = t_u1
     +                  - (t_u1 - ssrh(iss))
               t_r2 = ssrh(iss) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wih(j_1,l_1)*ssrl(iss)
     +               + wil(j_1,l_1)*ssrh(iss))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = wi(j_1,l_1) * ssr(iss)
!<<<           wi(j_1,k_1) = wi(j_1,k_1) - tmp1
               t_p1 = wih(j_1,k_1) - tmp1h
               t_p2 = t_p1 - wih(j_1,k_1)
               t_ch = t_p1
               t_cl = (wih(j_1,k_1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + wil(j_1,k_1) - tmp1l
               t_s1 = t_ch + t_cl
               wil(j_1,k_1) = t_cl - (t_s1 - t_ch)
               wih(j_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           wi(j_1,k_1) = wi(j_1,k_1) - tmp1
!<<<           tmp1 = wr(j_1,l_1) * ssi(iss)
               tmp1h = wrh(j_1,l_1) * ssih(iss)
               t_u1 = 134217729.0 * wrh(j_1,l_1)
               t_p1 = t_u1
     +                  - (t_u1 - wrh(j_1,l_1))
               t_p2 = wrh(j_1,l_1) - t_p1
               t_u1 = 134217729.0 * ssih(iss)
               t_r1 = t_u1
     +                  - (t_u1 - ssih(iss))
               t_r2 = ssih(iss) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (wrh(j_1,l_1)*ssil(iss)
     +               + wrl(j_1,l_1)*ssih(iss))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = wr(j_1,l_1) * ssi(iss)
!<<<           wi(j_1,k_1) = wi(j_1,k_1) - tmp1
               t_p1 = wih(j_1,k_1) - tmp1h
               t_p2 = t_p1 - wih(j_1,k_1)
               t_ch = t_p1
               t_cl = (wih(j_1,k_1) - (t_p1 - t_p2))
     +                  - (tmp1h + t_p2)
               t_cl = t_cl + wil(j_1,k_1) - tmp1l
               t_s1 = t_ch + t_cl
               wil(j_1,k_1) = t_cl - (t_s1 - t_ch)
               wih(j_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>           wi(j_1,k_1) = wi(j_1,k_1) - tmp1
             enddo
             iss=iss-1
          enddo
          enddo
          enddo
!----
          i_5=i_3-i_2+1
          j_5=j_3-j_2+1
          if ( j_5 > 0 .and. i_5 > 0 ) then
#ifdef MEMORY2
      nxx = xx_wr (1480,j_2  + nm*m - 1,1)
      nxx = xx_ssr(1490,1+mm + m *i_5 - 1)
#endif
!             call dgemm('n','n',
!     &               j_5, i_5, m,
!     &              -1.0d+00, wr(j_2 ,1  ), nm,
!     &                        ssr(1   +mm), m,
!     &               1.0d+00, zr(j_2 ,i_2), nmz)
             call ddgemm('n','n',
     &               j_5, i_5, m,
     &              -1.0d+00, 0.0d+00, 
     &               wrh(j_2 ,1  ), wrl(j_2 ,1  ), nm,
     &               ssrh(1   +mm), ssrl(1   +mm), m,
     &               1.0d+00, 0.0d+00,
     &               zrh(j_2 ,i_2), zrl(j_2 ,i_2), nmz)
#ifdef MEMORY2
      nxx = xx_wi (1500,j_2  + nm*m - 1,1)
      nxx = xx_ssi(1510,1+mm + m *i_5 - 1)
#endif
!             call dgemm('n','n',
!     &               j_5, i_5, m,
!     &              +1.0d+00, wi(j_2 ,1  ), nm,
!     &                        ssi(1   +mm), m,
!     &               1.0d+00, zr(j_2 ,i_2), nmz)
             call ddgemm('n','n',
     &               j_5, i_5, m,
     &              +1.0d+00, 0.0d+00, 
     &               wih(j_2 ,1  ), wil(j_2 ,1  ), nm,
     &               ssih(1   +mm), ssil(1   +mm), m,
     &               1.0d+00, 0.0d+00,
     &               zrh(j_2 ,i_2), zrl(j_2 ,i_2), nmz)
!             call dgemm('n','n',
!     &               j_5, i_5, m,
!     &              -1.0d+00, wr(j_2 ,1  ), nm,
!     &                        ssi(1   +mm), m,
!     &               1.0d+00, zi(j_2 ,i_2), nmz)
             call ddgemm('n','n',
     &               j_5, i_5, m,
     &              -1.0d+00, 0.0d+00, 
     &               wrh(j_2 ,1  ), wrl(j_2 ,1  ), nm,
     &               ssih(1   +mm), ssil(1   +mm), m,
     &               1.0d+00, 0.0d+00, 
     &               zih(j_2 ,i_2), zil(j_2 ,i_2), nmz)
!             call dgemm('n','n',
!     &               j_5, i_5, m,
!     &              -1.0d+00, wi(j_2 ,1  ), nm,
!     &                        ssr(1   +mm), m,
!     &               1.0d+00, zi(j_2 ,i_2), nmz)
             call ddgemm('n','n',
     &               j_5, i_5, m,
     &              -1.0d+00, 0.0d+00,
     &               wih(j_2 ,1  ), wil(j_2 ,1  ), nm,
     &               ssrh(1   +mm), ssrl(1   +mm), m,
     &               1.0d+00, 0.0d+00,
     &               zih(j_2 ,i_2), zil(j_2 ,i_2), nmz)
          endif

       return

#ifdef MEMORY2
       contains

       function xx_vr(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_vr
       integer :: i0,i1,i2
       xx_vr = nxx_vr + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_vr,kxx_vr,"ddeigen_hbk_main2:xx_vr")
       end function

       function xx_vi(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_vi
       integer :: i0,i1,i2
       xx_vi = nxx_vi + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_vi,kxx_vi,"ddeigen_hbk_main2:xx_vi")
       end function

       function xx_wr(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_wr
       integer :: i0,i1,i2
       xx_wr = nxx_wr + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_wr,kxx_wr,"ddeigen_hbk_main2:xx_wr")
       end function

       function xx_wi(i0,i1,i2)
       use xx_hbk_info
       integer :: xx_wi
       integer :: i0,i1,i2
       xx_wi = nxx_wi + i1 - 1 + nm*(i2 - 1)
       call accessor(i0,xx_wi,kxx_wi,"ddeigen_hbk_main2:xx_wi")
       end function

       function xx_ssr(i0,i1)
       use xx_hbk_info
       integer :: xx_ssr
       integer :: i0,i1
       xx_ssr = nxx_ssr + i1 - 1
       call accessor(i0,xx_ssr,kxx_ssr,"ddeigen_hbk_main2:xx_ssr")
       end function

       function xx_ssi(i0,i1)
       use xx_hbk_info
       integer :: xx_ssi
       integer :: i0,i1
       xx_ssi = nxx_ssi + i1 - 1
       call accessor(i0,xx_ssi,kxx_ssi,"ddeigen_hbk_main2:xx_ssi")
       end function

       function xx_tt(i0,i1)
       use xx_hbk_info
       integer :: xx_tt
       integer :: i0,i1
       xx_tt = nxx_tt + i1 - 1
       call accessor(i0,xx_tt,kxx_tt,"ddeigen_hbk_main2:xx_tt")
       end function
#endif

       end subroutine ! ddeigen_hbk_main2
#ifdef ARRAY_2D
!       subroutine arraycopy(a,lda3,b,lda2,nnc,nnr)
       subroutine ddarraycopy(ah,al,lda3,bh,bl,lda2,nnc,nnr)
       integer,intent(in) :: lda3,lda2,nnr,nnc
       real(8),intent(inout) :: ah(lda3,nnr),bh(lda2,nnr)
       real(8),intent(inout) :: al(lda3,nnr),bl(lda2,nnr)
       integer :: ns1,ne1,nd1
       integer :: ns2,ne2,nd2
       real(8) :: wh(nnc,nnr),wl(nnc,nnr)
!       print *,"pass30",lda3,lda2,nnc,nnr,ns1,ne1,nd1,ns2,ne2,nd2
       do ii1=1,nnr
!         print *,ii1,a(nnc,ii1)
         do ii2=1,nnc
!           w(ii2,ii1) = a(ii2,ii1)
          wh(ii2,ii1) = ah(ii2,ii1)
          wl(ii2,ii1) = al(ii2,ii1)
         end do
       end do
!OCL noloopfusion
       do ii1=1,nnr
         do ii2=1,nnc
!           b(ii2,ii1) = w(ii2,ii1)
          bh(ii2,ii1) = wh(ii2,ii1)
          bl(ii2,ii1) = wl(ii2,ii1)
         end do
       end do
       end subroutine ! ddarraycopy
#endif
