#ifdef MEMORY1
      module xx_hrd_info
      implicit none
      integer,private :: myrank
      integer,parameter :: nmax = 6
      integer,private,parameter :: IMAX = 2147483647
      integer,private :: ns(1:nmax) =  IMAX
      integer,private :: ne(1:nmax) = -IMAX
      integer,private :: ns0(1:nmax) =  IMAX
      integer,private :: ne0(1:nmax) = -IMAX

      integer,parameter :: kxx_uv_x = 1
      integer,parameter :: kxx_uv_y = 2
      integer,parameter :: kxx_w    = 3
      integer,parameter :: kxx_u_t  = 4
      integer,parameter :: kxx_v_t  = 5
      integer,parameter :: kxx_d_t  = 6

      integer,parameter :: kxx_ur_x = 1
      integer,parameter :: kxx_ui_x = 1
      integer,parameter :: kxx_vr_x = 1
      integer,parameter :: kxx_vi_x = 1
      integer,parameter :: kxx_ur_y = 2
      integer,parameter :: kxx_ui_y = 2
      integer,parameter :: kxx_vr_y = 2
      integer,parameter :: kxx_vi_y = 2
      integer,parameter :: kxx_wr   = 3
      integer,parameter :: kxx_wi   = 3
      integer,parameter :: kxx_ur_t = 4
      integer,parameter :: kxx_ui_t = 4
      integer,parameter :: kxx_vr_t = 5
      integer,parameter :: kxx_vi_t = 5

      integer,parameter :: kxx_ar   = 3
      integer,parameter :: kxx_ai   = 3

      integer,parameter :: kxx_ur_t2= 1
      integer,parameter :: kxx_ui_t2= 1

      integer,parameter :: kxx_ur   = 1
      integer,parameter :: kxx_ui   = 1
      integer,parameter :: kxx_uyr  = 2
      integer,parameter :: kxx_uyi  = 2
      integer,parameter :: kxx_vr   = 1
      integer,parameter :: kxx_vi   = 1
      integer,parameter :: kxx_vyr  = 2
      integer,parameter :: kxx_vyi  = 2

      contains

      subroutine setter(ns1,ne1)
      implicit none
      include 'mpif.h'
      integer,intent(in) :: ns1(1:nmax)
      integer,intent(in) :: ne1(1:nmax)
      integer :: ierr
      ns0 = ns1
      ne0 = ne1
      call mpi_comm_rank(mpi_comm_world, myrank, ierr)
      myrank = myrank+1
      end subroutine

      subroutine accessor(i0,n,kxx,c1)
      implicit none
      integer,intent(in) :: i0
      integer,intent(in) :: n
      integer,intent(in) :: kxx
      character(*),intent(in) :: c1
      character(2) :: cc1,cc2,cc3
      integer :: ncc3
      if ( (kxx < 1) .or. (nmax < kxx) ) then
        print *,"kxx error",kxx
        return
      end if
      ns(kxx) = min(ns(kxx),n)
      ne(kxx) = max(ne(kxx),n)
      cc3 = "ok"
      ncc3 = 0
      if (n <= ne0(kxx)) then
        cc2 = "<="
      else
        cc2 = "> "
        cc3 = "ng"
        ncc3 = 1
      end if
      if (ncc3 == 1) then
        print *,myrank,kxx,":",n,cc2,ne0(kxx)," at ",i0,c1
      end if
      end subroutine

      function eigen_get_memsize_hrd()
      implicit none
      integer :: i
      integer :: eigen_get_memsize_hrd
      eigen_get_memsize_hrd = ne(1)
      do i=1,nmax
        print *,myrank,i,":",ne(i)," in [",ns0(i),ne0(i),"]"
        eigen_get_memsize_hrd = max(eigen_get_memsize_hrd,ne(i))
      end do
      end function

      end module
#endif

#ifdef ARRAY_2D
!      subroutine eigen_hrd(
!     &             n,ar2d,ai2d,lda,
!     &             d_out,e_out,e2_out,
!     &             tau,ldtau, m
!     &           )
      subroutine ddeigen_hrd(
     &             n,ar2dh,ar2dl,ai2dh,ai2dl,lda,
     &             d_outh,d_outl,e_outh,e_outl,e2_outh,e2_outl,
     &             tauh,taul,ldtau, m
     &           )
#else
!      subroutine eigen_hrd(
!     &             n,ar,ai,lda,
!     &             d_out,e_out,e2_out,
!     &             tau,ldtau, m,zr,zi
!     &           )
      subroutine ddeigen_hrd(
     &             n,arh,arl,aih,ail,lda,
     &             d_outh,d_outl,e_outh,e_outl,e2_outh,e2_outl,
     &             tauh,taul,ldtau,m,zrh,zrl,zih,zil
     &           )
#endif
!----
!      use communication_h, only : eigen_init
!     &               , eigen_free
!     &               , cyc1d_cyc2d
!     &               , cyc2d_cyc1d
      use ddcommunication_h, only : eigen_init
     &                            , eigen_free
     &                            , ddcyc1d_cyc2d
     &                            , ddcyc2d_cyc1d
!----
      implicit none
!----
      include 'mpif.h'
!----
      integer  ::  n, lda, ldtau, m
#ifdef ARRAY_2D
!      real(8) ::   ar2d(*),ai2d(*)
      real(8) ::   ar2dh(*),ai2dh(*)
      real(8) ::   ar2dl(*),ai2dl(*)
#else
!      real(8)  ::  ar(*),ai(*)
!      real(8)  ::  zr(*),zi(*)
      real(8)  ::  arh(*),aih(*)
      real(8)  ::  arl(*),ail(*)
      real(8)  ::  zrh(*),zih(*)
      real(8)  ::  zrl(*),zil(*)
#endif
!      real(8)  ::  d_out(*),e_out(*),e2_out(*)
!      real(8)  ::  tau(*)
      real(8)  ::  d_outh(*),d_outl(*)
      real(8)  ::  e_outh(*),e_outl(*),e2_outh(*),e2_outl(*)
      real(8)  ::  tauh(*),taul(*)
!----
      include 'trd.h'
!----
      integer  ::  ierr
      integer  ::  n_, nm_

!      real(8), pointer :: ar_(:), ai_(:)
      real(8), pointer :: ar_h(:), ar_l(:), ai_h(:), ai_l(:)

      real(8)  :: d0, d1, d2, d3, d4

      integer  :: ldz, nz
!----
      call eigen_init(2)
!----
      d0=mpi_wtime()
      ldz = (n-1)/size_of_col+1
      nz = (n-1)/size_of_row+1
      d1=mpi_wtime()
#ifdef ARRAY_2D
!     none
#else
!      call cyc1d_cyc2d(n,ar,lda,zr,ldz, size_of_col, size_of_row, ierr)
!      call cyc1d_cyc2d(n,ai,lda,zi,ldz, size_of_col, size_of_row, ierr)
      call ddcyc1d_cyc2d(n,arh,arl,lda,zrh,zrl,ldz,
     &                   size_of_col, size_of_row, ierr)
      call ddcyc1d_cyc2d(n,aih,ail,lda,zih,zil,ldz,
     &                   size_of_col, size_of_row, ierr)
#endif
      d2=mpi_wtime()
!----
      n_ = 0; nm_ = 1

!      allocate(ar_(1),ai_(1))
      allocate(ar_h(1),ar_l(1),ai_h(1),ai_l(1))
#ifdef ARRAY_2D
!      call eigen_hrd_main1(
!     &       n,ar2d(1),ai2d(1),lda,
!     &       d_out(1),e_out(1),e2_out(1),tau(1),ldtau,m,
!     &       ar_(1),ai_(1),n_,nm_
!     &     )
      call ddeigen_hrd_main1(
     &       n,ar2dh(1),ar2dl(1),ai2dh(1),ai2dl(1),lda,
     &       d_outh(1),d_outl(1),e_outh(1),e_outl(1),
     &       e2_outh(1),e2_outl(1),tauh(1),taul(1),ldtau,m,
     &       ar_h(1),ar_l(1),ai_h(1),ai_l(1),n_,nm_
     &     )
#else
!      call eigen_hrd_main1(
!     &       n,zr(1),zi(1),ldz,
!     &       d_out(1),e_out(1),e2_out(1),tau(1),ldtau,m,
!     &       ar_(1),ai_(1),n_,nm_
!     &     )
      call ddeigen_hrd_main1(
     &       n,zrh(1),zrl(1),zih(1),zil(1),ldz,
     &       d_outh(1),d_outl(1),e_outh(1),e_outl(1),
     &       e2_outh(1),e2_outl(1),tauh(1),taul(1),ldtau,m,
     &       ar_h(1),ar_l(1),ai_h(1),ai_l(1),n_,nm_
     &     )
#endif
!      deallocate(ar_,ai_)
      deallocate(ar_h,ar_l,ai_h,ai_l)

      d3=mpi_wtime()
#ifdef ARRAY_2D
!     none
#else
!      call cyc2d_cyc1d(n,ar,lda,zr,ldz, size_of_col, size_of_row, ierr)
!      call cyc2d_cyc1d(n,ai,lda,zi,ldz, size_of_col, size_of_row, ierr)
      call ddcyc2d_cyc1d(n,arh,arl,lda,zrh,zrl,ldz,
     &                   size_of_col, size_of_row, ierr)
      call ddcyc2d_cyc1d(n,aih,ail,lda,zih,zil,ldz,
     &                   size_of_col, size_of_row, ierr)
#endif
      d4=mpi_wtime()

#ifdef DETAIL
      if(myrank==1) then
         print*,"  communication time in 'eigen_hrd'"
         print*,"   cyc1d_cyc2d :: ",d2-d1,"(sec)"
         print*,"   cyc2d_cyc1d :: ",d4-d3,"(sec)"
      endif
    d4=mpi_wtime()
#endif
!----
      call eigen_free(1)
!----
#ifdef TIMER
      if(myrank==1)then
         print*,"Exectime of 'eigen_hrd' routine =",d4-d0,"(sec)"
!----&            4*dble(n)**3*4/3/(s1-s0)*1d-6,"MFLOPS"
      endif
#endif

      return
      end subroutine
!----
!      subroutine eigen_hrd_main1(
!     &             n,ar,ai,lda,d_out,e_out,e2_out,tau,ldtau,m,
!     &             ar_,ai_,n_,nm_
!     &           )
      subroutine ddeigen_hrd_main1(
     &             n,arh,arl,aih,ail,lda,
     &             d_outh,d_outl,e_outh,e_outl,e2_outh,e2_outl,
     &             tauh,taul,ldtau,m,
     &             ar_h,ar_l,ai_h,ai_l,n_,nm_
     &           )
!----
#ifdef MEMORY1
      use xx_hrd_info
#endif
      implicit none
!----
      integer  ::  n,  lda, nv, ldtau, m
!      real(8)  ::  ar(lda,*),ai(lda,*)
!      real(8)  ::  d_out(n),e_out(n),e2_out(n)
!      real(8)  ::  tau(ldtau,2)
      real(8)  ::  arh(lda,*),aih(lda,*)
      real(8)  ::  arl(lda,*),ail(lda,*)
      real(8)  ::  d_outh(n),e_outh(n),e2_outh(n)
      real(8)  ::  d_outl(n),e_outl(n),e2_outl(n)
      real(8)  ::  tauh(ldtau,2),taul(ldtau,2)
      integer  ::  n_, nm_
!      real(8)  ::  ar_(*), ai_(*)
      real(8)  ::  ar_h(*), ai_h(*)
      real(8)  ::  ar_l(*), ai_l(*)
!----
      include 'trd.h'
!----
!      real(8), pointer ::  uv_x(:), uv_y(:)
!      real(8), pointer ::  w(:)
!      real(8), pointer ::  u_t(:), v_t(:)
!      real(8), pointer ::  d_t(:)
      real(8), pointer ::  uv_xh(:), uv_yh(:)
      real(8), pointer ::  uv_xl(:), uv_yl(:)
      real(8), pointer ::  wh(:), wl(:)
      real(8), pointer ::  u_th(:), v_th(:)
      real(8), pointer ::  u_tl(:), v_tl(:)
      real(8), pointer ::  d_th(:), d_tl(:)

      integer :: i,j,k
#ifdef MEMORY1
      integer :: nxx_uv_x
      integer :: nxx_uv_y
      integer :: nxx_w
      integer :: nxx_u_t
      integer :: nxx_v_t
      integer :: nxx_d_t
      integer :: nxx_all
#endif
#ifdef MEMORY1
       integer ns1(1:nmax),ne1(1:nmax)
#endif
!----
      nv=lda
!----
      allocate(
!     &         uv_x(4*nv*m),
!     &         uv_y(4*nv*m),
!     &         w(2*nv*m),
!     &         u_t(1+8*2*max(nv+4,m*4)),
!     &         v_t(1+8*2*max(nv+4,m*4)),
!     &         d_t(nv)
     &         uv_xh(4*nv*m), uv_xl(4*nv*m),
     &         uv_yh(4*nv*m), uv_yl(4*nv*m),
     &         wh(2*nv*m), wl(2*nv*m),
     &         u_th(1+8*2*max(nv+4,m*4)), u_tl(1+8*2*max(nv+4,m*4)),
     &         v_th(1+8*2*max(nv+4,m*4)), v_tl(1+8*2*max(nv+4,m*4)),
     &         d_th(nv), d_tl(nv)
     &        )
#ifdef MEMORY1
      nxx_uv_x = 1
      nxx_uv_y = nxx_uv_x + 4*nv*m
      nxx_w    = nxx_uv_y + 4*nv*m
      nxx_u_t  = nxx_w    + 2*nv*m
      nxx_v_t  = nxx_u_t  + 1+8*2*max(nv+4,m*4)
      nxx_d_t  = nxx_v_t  + 1+8*2*max(nv+4,m*4)
      nxx_all  = nxx_d_t  + nv

      ns1(1) = nxx_uv_x
      ns1(2) = nxx_uv_y
      ns1(3) = nxx_w
      ns1(4) = nxx_u_t
      ns1(5) = nxx_v_t
      ns1(6) = nxx_d_t

      ne1(1) = nxx_uv_y - 1
      ne1(2) = nxx_w    - 1
      ne1(3) = nxx_u_t  - 1
      ne1(4) = nxx_v_t  - 1
      ne1(5) = nxx_d_t  - 1
      ne1(6) = nxx_all  - 1

      call setter(ns1,ne1)
#endif
!----
      j = 0
!----
!      call eigen_hrd_main2(
!     &       n,ar,ai,lda,d_out,e_out,e2_out,
!     &       tau,ldtau,nv,m,
!     &       uv_x(1+0*nv*m), uv_x(1+1*nv*m),
!     &       uv_x(1+2*nv*m), uv_x(1+3*nv*m),
!     &       uv_y(1+0*nv*m), uv_y(1+1*nv*m),
!     &       uv_y(1+2*nv*m), uv_y(1+3*nv*m),
!     &       w(1), w(1+nv*m),
!     &       u_t(1), u_t(1+8*max(nv+4,m*4)),
!     &       v_t(1), v_t(1+8*max(nv+4,m*4)),
!     &       d_t(1),
!     &       ar_,ai_,n_,nm_
      call ddeigen_hrd_main2(
     &       n,arh,arl,aih,ail,lda,
     &       d_outh,d_outl,e_outh,e_outl,e2_outh,e2_outl,
     &       tauh,taul,ldtau,nv,m,
     &       uv_xh(1+0*nv*m), uv_xl(1+0*nv*m),
     &       uv_xh(1+1*nv*m), uv_xl(1+1*nv*m),
     &       uv_xh(1+2*nv*m), uv_xl(1+2*nv*m),
     &       uv_xh(1+3*nv*m), uv_xl(1+3*nv*m),
     &       uv_yh(1+0*nv*m), uv_yl(1+0*nv*m),
     &       uv_yh(1+1*nv*m), uv_yl(1+1*nv*m),
     &       uv_yh(1+2*nv*m), uv_yl(1+2*nv*m),
     &       uv_yh(1+3*nv*m), uv_yl(1+3*nv*m),
     &       wh(1), wl(1), wh(1+nv*m), wl(1+nv*m),
     &       u_th(1), u_tl(1),
     &       u_th(1+8*max(nv+4,m*4)), u_tl(1+8*max(nv+4,m*4)),
     &       v_th(1), v_tl(1),
     &       v_th(1+8*max(nv+4,m*4)), v_tl(1+8*max(nv+4,m*4)),
     &       d_th(1), d_tl(1),
     &       ar_h,ar_l,ai_h,ai_l,n_,nm_
#ifdef MEMORY1
     &      ,xx_uv_x(0,1+0*nv*m), xx_uv_x(0,1+1*nv*m)
     &      ,xx_uv_x(0,1+2*nv*m), xx_uv_x(0,1+3*nv*m)
     &      ,xx_uv_y(0,1+0*nv*m), xx_uv_y(0,1+1*nv*m)
     &      ,xx_uv_y(0,1+2*nv*m), xx_uv_y(0,1+3*nv*m)
     &      ,xx_w(0,1), xx_w(0,1+nv*m)
     &      ,xx_u_t(0,1), xx_u_t(0,1+8*max(nv+4,m*4))
     &      ,xx_v_t(0,1), xx_v_t(0,1+8*max(nv+4,m*4))
     &      ,xx_d_t(0,1)
#endif
     &     )
!----
!      deallocate(uv_x, uv_y, w, u_t, v_t, d_t )
      deallocate(uv_xh, uv_xl, uv_yh, uv_yl, wh, wl,
     &           u_th, u_tl, v_th, v_tl, d_th, d_tl )
#ifdef MEMORY1
      print *," eigen_get_memsize_hrd = ",eigen_get_memsize_hrd()
#endif

      return
#ifdef MEMORY1
      contains

      function xx_uv_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_uv_x
      integer :: i0,i1
      xx_uv_x = nxx_uv_x + i1 - 1
      call accessor(i0,xx_uv_x,kxx_uv_x,"ddeigen_hrd_main1:uv_x")
      end function

      function xx_uv_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_uv_y
      integer :: i0,i1
      xx_uv_y = nxx_uv_y + i1 - 1
      call accessor(i0,xx_uv_y,kxx_uv_y,"ddeigen_hrd_main1:uv_y")
      end function

      function xx_w(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_w
      integer :: i0,i1
      xx_w = nxx_w + i1 - 1
      call accessor(i0,xx_w,kxx_w,"ddeigen_hrd_main1:w")
      end function

      function xx_u_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_u_t
      integer :: i0,i1
      xx_u_t = nxx_u_t + i1 - 1
      call accessor(i0,xx_u_t,kxx_u_t,"ddeigen_hrd_main1:u_t")
      end function

      function xx_v_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_v_t
      integer :: i0,i1
      xx_v_t = nxx_v_t + i1 - 1
      call accessor(i0,xx_v_t,kxx_v_t,"ddeigen_hrd_main1:v_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_main1:d_t")
      end function
#endif
      end subroutine
!----
!      subroutine eigen_hrd_main2(
!     &             n,ar,ai,lda,d_out,e_out,e2_out,
!     &             tau,ldtau,nv,m,
!     &             ur_x, ui_x, vr_x, vi_x,
!     &             ur_y, ui_y, vr_y, vi_y,
!     &             wr, wi,
!     &             ur_t, ui_t,
!     &             vr_t, vi_t,
!     &             d_t,
!     &             ar_,ai_,n_,nm_
      subroutine ddeigen_hrd_main2(
     &             n,arh,arl,aih,ail,lda,
     &             d_outh,d_outl,e_outh,e_outl,e2_outh,e2_outl,
     &             tauh,taul,ldtau,nv,m,
     &             ur_xh, ur_xl, ui_xh, ui_xl,
     &             vr_xh, vr_xl, vi_xh, vi_xl,
     &             ur_yh, ur_yl, ui_yh, ui_yl,
     &             vr_yh, vr_yl, vi_yh, vi_yl,
     &             wrh, wrl, wih, wil,
     &             ur_th, ur_tl, ui_th, ui_tl,
     &             vr_th, vr_tl, vi_th, vi_tl,
     &             d_th, d_tl,
     &             ar_h, ar_l, ai_h, ai_l, n_, nm_
#ifdef MEMORY1
     &            ,nxx_ur_x, nxx_ui_x, nxx_vr_x, nxx_vi_x
     &            ,nxx_ur_y, nxx_ui_y, nxx_vr_y, nxx_vi_y
     &            ,nxx_wr  , nxx_wi
     &            ,nxx_ur_t, nxx_ui_t
     &            ,nxx_vr_t, nxx_vi_t
     &            ,nxx_d_t
#endif
     &           )
!----
!      use communication_h, only : reduce_dbl
!     &               , bcast_dbl
!     &               , get_loop_start
!     &               , get_loop_end
!     &               , get_owner_node
!     &               , translate_l2g
!     &               , translate_g2l
      use ddcommunication_h, only : ddreduce_dbl
     &                            , ddbcast_dbl
     &                            , get_loop_start
     &                            , get_loop_end
     &                            , get_owner_node
     &                            , translate_l2g
     &                            , translate_g2l
!----
      implicit integer         (i-n)
      implicit real(8)(a-h,o-z)
!      implicit none
!----
      integer  ::  i,j,l,n,lda,ldtau,nv
!      real(8)  ::  ar(lda,n),ai(lda,n)
!      real(8)  ::  d_out(n),e_out(n),e2_out(n)
!      real(8)  ::  tau(ldtau,2)
!      real(8)  ::  g,h,scale
!      real(8)  ::  sr,si,tr,ti
      real(8)  ::  arh(lda,n),arl(lda,n),aih(lda,n),ail(lda,n)
      real(8)  ::  d_outh(n),d_outl(n),e_outh(n),e_outl(n)
      real(8)  ::  e2_outh(n), e2_outl(n)
      real(8)  ::  tauh(ldtau,2), taul(ldtau,2)
      double precision gh, gl
      double precision hh, hl
      double precision scaleh, scalel
      double precision srh, srl
      double precision sih, sil
      double precision trh, trl
      double precision tih, til
!----
      integer  ::  m_orig
      integer  ::  m,mm,m0
      integer  ::  i_block,i_base
!----
      integer  ::  y_root, y_pos
      integer  ::  x_root, x_pos
!----
!      real(8)  ::  ur_x(nv,m),ui_x(nv,m)
!      real(8)  ::  ur_y(nv,m),ui_y(nv,m)
!      real(8)  ::  vr_x(nv,m),vi_x(nv,m)
!      real(8)  ::  vr_y(nv,m),vi_y(nv,m)
!      real(8)  ::  wr(nv,m),wi(nv,m)
!      real(8)  ::  ur_t(1:8*max(nv+4,4*m))
!      real(8)  ::  ui_t(1:8*max(nv+4,4*m))
!      real(8)  ::  vr_t(1:8*max(nv+4,4*m))
!      real(8)  ::  vi_t(1:8*max(nv+4,4*m))
!      real(8)  ::  d_t(nv)
      real(8)  ::  ur_xh(nv,m),ui_xh(nv,m)
      real(8)  ::  ur_xl(nv,m),ui_xl(nv,m)
      real(8)  ::  ur_yh(nv,m),ui_yh(nv,m)
      real(8)  ::  ur_yl(nv,m),ui_yl(nv,m)
      real(8)  ::  vr_xh(nv,m),vi_xh(nv,m)
      real(8)  ::  vr_xl(nv,m),vi_xl(nv,m)
      real(8)  ::  vr_yh(nv,m),vi_yh(nv,m)
      real(8)  ::  vr_yl(nv,m),vi_yl(nv,m)
      real(8)  ::  wrh(nv,m),wih(nv,m)
      real(8)  ::  wrl(nv,m),wil(nv,m)
      real(8)  ::  ur_th(1:8*max(nv+4,4*m))
      real(8)  ::  ur_tl(1:8*max(nv+4,4*m))
      real(8)  ::  ui_th(1:8*max(nv+4,4*m))
      real(8)  ::  ui_tl(1:8*max(nv+4,4*m))
      real(8)  ::  vr_th(1:8*max(nv+4,4*m))
      real(8)  ::  vr_tl(1:8*max(nv+4,4*m))
      real(8)  ::  vi_th(1:8*max(nv+4,4*m))
      real(8)  ::  vi_tl(1:8*max(nv+4,4*m))
      real(8)  ::  d_th(nv), d_tl(nv)
!----
      integer  ::  n_, nm_
!      real(8)  ::  ar_(nm_,n_), ai_(nm_,n_)
      real(8)  ::  ar_h(nm_,n_), ai_h(nm_,n_)
      real(8)  ::  ar_l(nm_,n_), ai_l(nm_,n_)

      integer  :: local_rank, local_size
!----
      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
!----
      real(8)  :: dd(10),d1,d2
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_vr_y
      integer,intent(in) :: nxx_vi_y
      integer,intent(in) :: nxx_wr
      integer,intent(in) :: nxx_wi
      integer,intent(in) :: nxx_ur_t
      integer,intent(in) :: nxx_ui_t
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
#endif
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision ttwoh, ttwol
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l
      ttwoh = 2.0d0
      ttwol = 0.0d+0
!----
      dd=0d0
!----
!$omp parallel private(local_rank,local_size)
#ifdef DETAIL
!$omp master
      if ( myrank == 1 ) then
         local_rank = 0
         local_size = 1
!$       local_rank = omp_get_thread_num()
!$       local_size = omp_get_num_threads()
!$       if ( local_rank == 0 ) then
            print*,"num.of.process=",nprocs,
     &             "(",size_of_col,size_of_row,")"
!$          print*,"num.of.threads=",local_size
!$       endif
      endif
!$omp end master
#endif
!      call eigen_hrd_Au(
!     &       ar,ai,lda,
!     &       ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
!     &       ur_t,ui_t, vr_t,vi_t, d_t,
!     &       -1, x_pos,y_pos, nv,k_1-k_2,
!     &       ar_,ai_,n_,nm_
      call ddeigen_hrd_Au(
     &       arh,arl,aih,ail,lda,
     &       ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &       vr_xh,vr_xl,vi_xh,vi_xl,
     &       ur_th,ur_tl,ui_th,ui_tl,vr_th,vr_tl,vi_th,vi_tl,d_th,d_tl,
     &       -1, x_pos,y_pos, nv,k_1-k_2,
     &       ar_h,ar_l,ai_h,ai_l,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_ur_t(0,1)  ,xx_ui_t(0,1)
     &      ,xx_vr_t(0,1)  ,xx_vi_t(0,1)
     &      ,xx_d_t (0,1)
#endif
     &     )
!      call eigen_hrd_2update(
!     &       ar,ai,lda,
!     &       ur_x,ui_x,ur_y,ui_y,
!     &       vr_x,vi_x,vr_y,vi_y,
!     &       nv,m0,-1,
!     &       ar_,ai_,n_,nm_
      call ddeigen_hrd_2update(
     &       arh,arl,aih,ail,lda,
     &       ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &       vr_xh,vr_xl,vi_xh,vi_xl,vr_yh,vr_yl,vi_yh,vi_yl,
     &       nv,m0,-1,
     &       ar_h,ar_l,ai_h,ai_l,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_vr_y(0,1,1),xx_vi_y(0,1,1)
#endif
     &     )
!$omp end parallel

!----
!      d_out(1:n)  = 0.0d0
!      e_out(1:n)  = 0.0d0
!      e2_out(1:n) = 0.0d0
!      tau(1:n,1) = 1.0d0
!      tau(1:n,2) = 0.0d0
      d_outh(1:n) = 0.0d+0
      d_outl(1:n) = 0.0d+0
      e_outh(1:n) = 0.0d+0
      e_outl(1:n) = 0.0d+0
      e2_outh(1:n) = 0.0d+0
      e2_outl(1:n) = 0.0d+0
      tauh(1:n,1) = 1.0d+0
      taul(1:n,1) = 0.0d+0
      tauh(1:n,2) = 0.0d+0
      taul(1:n,2) = 0.0d+0
!----
      if(diag_0>0)then
         i_2=diag_0
         i_3=((n)+size_of_row-my_row)/size_of_row
         i_4=size_of_col/n_common
         if(i_2<=n_)then
            do i_1=i_2,min(i_3,n_),i_4
               j=(i_1-1)*size_of_row+my_row
               j_1=(j-1)/size_of_col+1
!               d_out(j)     = ar_(j_1,i_1)
!               ai_(j_1,i_1) = 0.0d0
               d_outh(j) = ar_h(j_1,i_1)
               d_outl(j) = ar_l(j_1,i_1)
               ai_h(j_1,i_1) = 0.0d+0
               ai_l(j_1,i_1) = 0.0d+0
            enddo! i_1
            i_2=((n_-i_2)/i_4+1)*i_4+i_2
         endif
*poption indep(a,d_out)
         do i_1=i_2,i_3,i_4
            j=(i_1-1)*size_of_row+my_row
            j_1=(j-1)/size_of_col+1
!            d_out(j)     = ar(j_1,i_1)
!            ai(j_1,i_1)  = 0.0d0
            d_outh(j) = arh(j_1,i_1)
            d_outl(j) = arl(j_1,i_1)
            aih(j_1,i_1) = 0.0d+0
            ail(j_1,i_1) = 0.0d+0
         enddo! i_1
      endif
!----
      i_2=1
      i_3=((n)+size_of_row-my_row)/size_of_row
      do i_1=i_2,min(n_,i_3)
         j=(i_1-1)*size_of_row+my_row
         j_2=((j+1)+size_of_col-1-my_col)/size_of_col+1
         j_3=((n)+size_of_col-my_col)/size_of_col
         do j_1=j_2,nm_
!            ar_(j_1,i_1) = 0.0d+00
!            ai_(j_1,i_1) = 0.0d+00
            ar_h(j_1,i_1) = 0.0d+0
            ar_l(j_1,i_1) = 0.0d+0
            ai_h(j_1,i_1) = 0.0d+0
            ai_l(j_1,i_1) = 0.0d+0
         enddo! j_1
      enddo! i_1
      do i_1=max(i_2,n_+1),i_3
         j=(i_1-1)*size_of_row+my_row
         j_2=((j+1)+size_of_col-1-my_col)/size_of_col+1
         j_3=((n)+size_of_col-my_col)/size_of_col
         do j_1=j_2,lda
!            ar(j_1,i_1)  = 0.0d+00
!            ai(j_1,i_1)  = 0.0d+00
            arh(j_1,i_1) = 0.0d+0
            arl(j_1,i_1) = 0.0d+0
            aih(j_1,i_1) = 0.0d+0
            ail(j_1,i_1) = 0.0d+0
         enddo! j_1
      enddo! i_1
!----
      m_orig = m
      if ( m > n ) then
         m = n
      endif
      mm = (n-1)/m+1

      do  i_block = mm,max(1,3*(2-m)),-1

         i_base = (i_block-1)*m
         m0 = min(m,n-i_base)

         i = i_base + m0
         l = i_base + m0 - 1

         i_2=((i_base+1)+size_of_row-1-my_row)/size_of_row+1
         i_3=((i_base+m0)+size_of_row-my_row)/size_of_row
         j_2=1
         j_3=((i_base+m0)+size_of_col-my_col)/size_of_col

#ifdef MEMORY1
!     nxx = xx_wr(2000,        j_3
!    &         ,(min(n_,i_3)-1)*size_of_row+my_row-i_base)
!     nxx = xx_wi(2010,        j_3
!    &         ,(min(n_,i_3)-1)*size_of_row+my_row-i_base)
      nxx = xx_wr(2020,        j_3
     &         ,    (   i_3 -1)*size_of_row+my_row-i_base)
      nxx = xx_wi(2030,        j_3
     &         ,    (   i_3 -1)*size_of_row+my_row-i_base)
#endif
         do i_1=i_2,min(n_,i_3)
            j=(i_1-1)*size_of_row+my_row
            do j_1=j_2,min(nm_,j_3)
!               wr(j_1,j-i_base) = ar_(j_1,i_1)
!               wi(j_1,j-i_base) = ai_(j_1,i_1)
               wrh(j_1,j-i_base) = ar_h(j_1,i_1)
               wrl(j_1,j-i_base) = ar_l(j_1,i_1)
               wih(j_1,j-i_base) = ai_h(j_1,i_1)
               wil(j_1,j-i_base) = ai_l(j_1,i_1)
            enddo
            do j_1=min(nm_,j_3)+1,j_3
!               wr(j_1,j-i_base) = 0.0d0+00
!               wi(j_1,j-i_base) = 0.0d0+00
               wrh(j_1,j-i_base) = 0.0d+0
               wrl(j_1,j-i_base) = 0.0d+0
               wih(j_1,j-i_base) = 0.0d+0
               wil(j_1,j-i_base) = 0.0d+0
            enddo
         enddo
         do i_1=max(i_2,n_+1),i_3
            j=(i_1-1)*size_of_row+my_row
            do j_1=j_2,j_3
!               wr(j_1,j-i_base) = ar(j_1,i_1)
!               wi(j_1,j-i_base) = ai(j_1,i_1)
               wrh(j_1,j-i_base) = arh(j_1,i_1)
               wrl(j_1,j-i_base) = arl(j_1,i_1)
               wih(j_1,j-i_base) = aih(j_1,i_1)
               wil(j_1,j-i_base) = ail(j_1,i_1)
            enddo
         enddo
         if(diag_0>0)then
            i_2=diag_0
            i_3=((i_base+m0-1)+size_of_row-my_row)/size_of_row
            i_4=size_of_col/n_common
            if(i_2<=n_)then
#ifdef MEMORY1
      nxx = xx_d_t(2040,int((min(i_3,n_)-i_2)/i_4)*i_4+i_2)
#endif
               if(size_of_row==size_of_col)then
*poption indep(a,d_out)
                  do i_1=i_2,min(i_3,n_),i_4
!                     d_t(i_1)     = ar_(i_1,i_1)
!                     ar_(i_1,i_1) = 0.0d+00
!                     ai_(i_1,i_1) = 0.0d+00
                  d_th(i_1) = ar_h(i_1,i_1)
                  d_tl(i_1) = ar_l(i_1,i_1)
                  ar_h(i_1,i_1) = 0.0d+0
                  ar_l(i_1,i_1) = 0.0d+0
                  ai_h(i_1,i_1) = 0.0d+0
                  ai_l(i_1,i_1) = 0.0d+0
                  enddo! i_1
               else
*poption indep(a,d_out)
                  do i_1=i_2,min(i_3,n_),i_4
                     j=(i_1-1)*size_of_row+my_row
                     j_1 = (j-1)/size_of_col +1
!                     d_t(i_1)     = ar_(j_1,i_1)
!                     ar_(j_1,i_1) = 0.0d+00
!                     ai_(j_1,i_1) = 0.0d+00
                  d_th(i_1) = ar_h(j_1,i_1)
                  d_tl(i_1) = ar_l(j_1,i_1)
                  ar_h(j_1,i_1) = 0.0d+0
                  ar_l(j_1,i_1) = 0.0d+0
                  ai_h(j_1,i_1) = 0.0d+0
                  ai_l(j_1,i_1) = 0.0d+0
                  enddo! i_1
               endif
               i_2=((n_-i_2)/i_4+1)*i_4+i_2
            endif
#ifdef MEMORY1
      nxx = xx_d_t(2050,int((    i_3    -i_2)/i_4)*i_4+i_2)
#endif
            if(size_of_row==size_of_col)then
*poption indep(a,d_out)
               do i_1=i_2,i_3,i_4
!                  d_t(i_1)    = ar(i_1,i_1)
!                  ar(i_1,i_1) = 0.0d+00
!                  ai(i_1,i_1) = 0.0d+00
                  d_th(i_1) = arh(i_1,i_1)
                  d_tl(i_1) = arl(i_1,i_1)
                  arh(i_1,i_1) = 0.0d+0
                  arl(i_1,i_1) = 0.0d+0
                  aih(i_1,i_1) = 0.0d+0
                  ail(i_1,i_1) = 0.0d+0
               enddo! i_1
            else
*poption indep(a,d_out)
               do i_1=i_2,i_3,i_4
                  j=(i_1-1)*size_of_row+my_row
                  j_1 = (j-1)/size_of_col +1
!                  d_t(i_1)    = ar(j_1,i_1)
!                  ar(j_1,i_1) = 0.0d+00
!                  ai(j_1,i_1) = 0.0d+00
                  d_th(i_1) = arh(j_1,i_1)
                  d_tl(i_1) = arl(j_1,i_1)
                  arh(j_1,i_1) = 0.0d+0
                  arl(j_1,i_1) = 0.0d+0
                  aih(j_1,i_1) = 0.0d+0
                  ail(j_1,i_1) = 0.0d+0
               enddo! i_1
            endif
         endif

         k_2=m0
         k_3=max(1,3*(2-i_block))

         i=i_base+k_2
         l=i-1
         y_pos =   (i-1)/size_of_row +1
         x_pos =   (l-1)/size_of_col +1
         j_2=max(1,x_pos-m0)
         j_3=max(1,y_pos-m0)
#ifdef MEMORY1
      if(j_2<=x_pos)then
        nxx = xx_ur_x(2060,x_pos,k_2)
        nxx = xx_ui_x(2070,x_pos,k_2)
        nxx = xx_vr_x(2080,x_pos,k_2)
        nxx = xx_vi_x(2090,x_pos,k_2)
      end if
      if(j_3<=y_pos)then
        nxx = xx_ur_y(2100,y_pos,k_2)
        nxx = xx_ui_y(2110,y_pos,k_2)
        nxx = xx_vr_y(2120,y_pos,k_2)
        nxx = xx_vi_y(2130,y_pos,k_2)
      end if
#endif
         do  k_1 = k_3,k_2,1
            if(j_2<=x_pos)then
!               ur_x(j_2:x_pos,k_1)=0.0d+00
!               ui_x(j_2:x_pos,k_1)=0.0d+00
!               vr_x(j_2:x_pos,k_1)=0.0d+00
!               vi_x(j_2:x_pos,k_1)=0.0d+00
               ur_xh(j_2:x_pos,k_1) = 0.0d+0
               ur_xl(j_2:x_pos,k_1) = 0.0d+0
               ui_xh(j_2:x_pos,k_1) = 0.0d+0
               ui_xl(j_2:x_pos,k_1) = 0.0d+0
               vr_xh(j_2:x_pos,k_1) = 0.0d+0
               vr_xl(j_2:x_pos,k_1) = 0.0d+0
               vi_xh(j_2:x_pos,k_1) = 0.0d+0
               vi_xl(j_2:x_pos,k_1) = 0.0d+0
            endif
            if(j_3<=y_pos)then
!               ur_y(j_3:y_pos,k_1)=0.0d+00
!               ui_y(j_3:y_pos,k_1)=0.0d+00
!               vr_y(j_3:y_pos,k_1)=0.0d+00
!               vi_y(j_3:y_pos,k_1)=0.0d+00
               ur_yh(j_3:y_pos,k_1) = 0.0d+0
               ur_yl(j_3:y_pos,k_1) = 0.0d+0
               ui_yh(j_3:y_pos,k_1) = 0.0d+0
               ui_yl(j_3:y_pos,k_1) = 0.0d+0
               vr_yh(j_3:y_pos,k_1) = 0.0d+0
               vr_yl(j_3:y_pos,k_1) = 0.0d+0
               vi_yh(j_3:y_pos,k_1) = 0.0d+0
               vi_yl(j_3:y_pos,k_1) = 0.0d+0
            endif
         enddo! k_1

         do  k_1 = k_2,k_3,-1

            i = i_base+k_1
            l = i-1

            i_2 = get_loop_start(1, size_of_row,my_row)
            i_3 = get_loop_end  (l, size_of_row,my_row)
            j_2 = get_loop_start(1, size_of_col,my_col)
            j_3 = get_loop_end  (l, size_of_col,my_col)
!----
            y_root = get_owner_node (i, size_of_row,my_row)
            y_pos  = translate_g2l(i, size_of_row,my_row)

            x_root = get_owner_node (l, size_of_col,my_col)
            x_pos  = translate_g2l(l, size_of_col,my_col)

           d1=mpi_wtime()
!            call eigen_hrd_u(
!     &             wr(1,k_1),wi(1,k_1),
!     &             ur_x(1,k_1),ui_x(1,k_1),
!     &             ur_y(1,k_1),ui_y(1,k_1),
!     &             ur_t(1),vr_t(1),
!     &             x_root,y_root,x_pos, j_3,lda,nv
           call ddeigen_hrd_u(
     &             wrh(1,k_1),wrl(1,k_1),wih(1,k_1),wil(1,k_1),
     &             ur_xh(1,k_1),ur_xl(1,k_1),ui_xh(1,k_1),ui_xl(1,k_1),
     &             ur_yh(1,k_1),ur_yl(1,k_1),ui_yh(1,k_1),ui_yl(1,k_1),
     &             ur_th(1),ur_tl(1),vr_th(1),vr_tl(1),
     &             x_root,y_root,x_pos, j_3,lda,nv
#ifdef MEMORY1
     &            ,xx_wr  (0,1,k_1),xx_wi  (0,1,k_1)
     &            ,xx_ur_x(0,1,k_1),xx_ui_x(0,1,k_1)
     &            ,xx_ur_y(0,1,k_1),xx_ui_y(0,1,k_1)
     &            ,xx_ur_t(0,1)    ,xx_vr_t(0,1)
#endif
     &           )

!            scale = ur_t(x_pos+1)
            scaleh = ur_th(x_pos+1)
            scalel = ur_tl(x_pos+1)
#ifdef MEMORY1
!      if ( scale == 0.0d+00 ) then
      if (
!          (scale .eq. 0.0)
     +    ((scaleh .eq. 0.0d+0) .and.
     +     (scalel .eq. 0.0d+0))
     &) then
        nxx = xx_ur_x(2140,x_pos,k_1)
        nxx = xx_ui_x(2150,x_pos,k_1)
        nxx = xx_vr_x(2160,x_pos,k_1)
        nxx = xx_vi_x(2170,x_pos,k_1)
        nxx = xx_ur_y(2180,y_pos,k_1)
        nxx = xx_ui_y(2190,y_pos,k_1)
        nxx = xx_vr_y(2200,y_pos,k_1)
        nxx = xx_vi_y(2210,y_pos,k_1)
      end if
#endif
!            if ( scale == 0.0d+00 ) then
            if (
!                (scale .eq. 0.0)
     +          ((scaleh .eq. 0.0d+0) .and.
     +           (scalel .eq. 0.0d+0))
     &      ) then
               do j=1,x_pos
!                  ur_x(j,k_1)=0.0d+00
!                  ui_x(j,k_1)=0.0d+00
!                  vr_x(j,k_1)=0.0d+00
!                  vi_x(j,k_1)=0.0d+00
                  ur_xh(j,k_1) = 0.0d+0
                  ur_xl(j,k_1) = 0.0d+0
                  ui_xh(j,k_1) = 0.0d+0
                  ui_xl(j,k_1) = 0.0d+0
                  vr_xh(j,k_1) = 0.0d+0
                  vr_xl(j,k_1) = 0.0d+0
                  vi_xh(j,k_1) = 0.0d+0
                  vi_xl(j,k_1) = 0.0d+0
               enddo
               do j=1,y_pos
!                  ur_y(j,k_1)=0.0d+00
!                  ui_y(j,k_1)=0.0d+00
!                  vr_y(j,k_1)=0.0d+00
!                  vi_y(j,k_1)=0.0d+00
                  ur_yh(j,k_1) = 0.0d+0
                  ur_yl(j,k_1) = 0.0d+0
                  ui_yh(j,k_1) = 0.0d+0
                  ui_yl(j,k_1) = 0.0d+0
                  vr_yh(j,k_1) = 0.0d+0
                  vr_yl(j,k_1) = 0.0d+0
                  vi_yh(j,k_1) = 0.0d+0
                  vi_yl(j,k_1) = 0.0d+0
               enddo
               goto 1000
            endif
            d2=mpi_wtime()
            dd(1)=dd(1)+(d2-d1)

!            if ( vr_t(x_pos+3) == 0.0d+00 ) then
            if (
!                (vr_t(x_pos+3) .eq. 0.0)
     +          ((vr_th(x_pos+3) .eq. 0.0d+0) .and.
     +           (vr_tl(x_pos+3) .eq. 0.0d+0))
     &      ) then
#ifdef MEMORY1
      nxx = xx_wr(2220,x_pos,k_1)
      nxx = xx_ur_t(2230,x_pos+3)
#endif
!               tau(l,1) = -tau(i,1)
!               tau(l,2) = -tau(i,2)
!               wr(x_pos,k_1) = ur_t(x_pos+3)
!<<<           tau(l,1) = -tau(i,1)
               tauh(l,1) = -tauh(i,1)
               taul(l,1) = -taul(i,1)
!>>>           tau(l,1) = -tau(i,1)
!<<<           tau(l,2) = -tau(i,2)
               tauh(l,2) = -tauh(i,2)
               taul(l,2) = -taul(i,2)
!>>>           tau(l,2) = -tau(i,2)
               wrh(x_pos,k_1) = ur_th(x_pos+3)
               wrl(x_pos,k_1) = ur_tl(x_pos+3)
            else
#ifdef MEMORY1
      nxx = xx_vr_t(2240,x_pos+3)
#endif
!               sr       =  vr_t(x_pos+1)
!               si       =  vr_t(x_pos+2)
!               tr       =  si*tau(i,2) - sr*tau(i,1)
!               ti       = -sr*tau(i,2) - si*tau(i,1)
!               tau(l,1) =  tr / vr_t(x_pos+3)
!               tau(l,2) =  ti / vr_t(x_pos+3)
               srh = vr_th(x_pos+1)
               srl = vr_tl(x_pos+1)
               sih = vr_th(x_pos+2)
               sil = vr_tl(x_pos+2)
!<<<           tmp1 = si * tau(i,2)
               tmp1h = sih * tauh(i,2)
               t_u1 = 134217729.0 * sih
               t_p1 = t_u1
     +                  - (t_u1 - sih)
               t_p2 = sih - t_p1
               t_u1 = 134217729.0 * tauh(i,2)
               t_r1 = t_u1
     +                  - (t_u1 - tauh(i,2))
               t_r2 = tauh(i,2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (sih*taul(i,2)
     +               + sil*tauh(i,2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = si * tau(i,2)
!<<<           tmp2 = sr * tau(i,1)
               tmp2h = srh * tauh(i,1)
               t_u1 = 134217729.0 * srh
               t_p1 = t_u1
     +                  - (t_u1 - srh)
               t_p2 = srh - t_p1
               t_u1 = 134217729.0 * tauh(i,1)
               t_r1 = t_u1
     +                  - (t_u1 - tauh(i,1))
               t_r2 = tauh(i,1) - t_r1
               tmp2l = ((t_p1*t_r1
     +                 - tmp2h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp2l = tmp2l
     +               + (srh*taul(i,1)
     +               + srl*tauh(i,1))
               t_s1 = tmp2h + tmp2l
               tmp2l = tmp2l - (t_s1 - tmp2h)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp2 = sr * tau(i,1)
!<<<           tr = tmp1 - tmp2
               t_p1 = tmp1h - tmp2h
               t_p2 = t_p1 - tmp1h
               trh = t_p1
               trl = (tmp1h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               trl = trl + tmp1l - tmp2l
               t_s1 = trh + trl
               trl = trl - (t_s1 - trh)
               trh = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>           tr = tmp1 - tmp2
!<<<           tmp1 = sr * tau(i,2)
               tmp1h = srh * tauh(i,2)
               t_u1 = 134217729.0 * srh
               t_p1 = t_u1
     +                  - (t_u1 - srh)
               t_p2 = srh - t_p1
               t_u1 = 134217729.0 * tauh(i,2)
               t_r1 = t_u1
     +                  - (t_u1 - tauh(i,2))
               t_r2 = tauh(i,2) - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (srh*taul(i,2)
     +               + srl*tauh(i,2))
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = sr * tau(i,2)
!<<<           tmp1 = -tmp1
               tmp1h = -tmp1h
               tmp1l = -tmp1l
!>>>           tmp1 = -tmp1
!<<<           tmp2 = si * tau(i,1)
               tmp2h = sih * tauh(i,1)
               t_u1 = 134217729.0 * sih
               t_p1 = t_u1
     +                  - (t_u1 - sih)
               t_p2 = sih - t_p1
               t_u1 = 134217729.0 * tauh(i,1)
               t_r1 = t_u1
     +                  - (t_u1 - tauh(i,1))
               t_r2 = tauh(i,1) - t_r1
               tmp2l = ((t_p1*t_r1
     +                 - tmp2h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp2l = tmp2l
     +               + (sih*taul(i,1)
     +               + sil*tauh(i,1))
               t_s1 = tmp2h + tmp2l
               tmp2l = tmp2l - (t_s1 - tmp2h)
               tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp2 = si * tau(i,1)
!<<<           ti = tmp1 - tmp2
               t_p1 = tmp1h - tmp2h
               t_p2 = t_p1 - tmp1h
               tih = t_p1
               til = (tmp1h - (t_p1 - t_p2))
     +                  - (tmp2h + t_p2)
               til = til + tmp1l - tmp2l
               t_s1 = tih + til
               til = til - (t_s1 - tih)
               tih = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!>>>           ti = tmp1 - tmp2
!<<<           tau(l,1) = tr / vr_t(x_pos+3)
               t_q1 = trh / vr_th(x_pos+3)
               tauh(l,1) = vr_th(x_pos+3) * t_q1
               t_u1 = 134217729.0 * vr_th(x_pos+3)
               t_p1 = t_u1
     +                  - (t_u1 - vr_th(x_pos+3))
               t_p2 = vr_th(x_pos+3) - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               taul(l,1) = ((t_p1*t_r1
     +                - tauh(l,1))
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               taul(l,1) = taul(l,1) + (vr_tl(x_pos+3)*t_q1)
               t_s1 = tauh(l,1) + taul(l,1)
               taul(l,1) = taul(l,1) - (t_s1 - tauh(l,1))
               tauh(l,1) = t_s1
               t_s1 = trh - tauh(l,1)
               t_r1 = t_s1 - trh
               t_s2 = (trh 
     +                  - (t_s1 - t_r1))
     +                  - (tauh(l,1) + t_r1)
               t_s2 = t_s2 - taul(l,1)
               t_s2 = t_s2 + trl
               t_q2 = (t_s1 + t_s2)
     +                  / vr_th(x_pos+3)
               tauh(l,1) = t_q1 + t_q2
               taul(l,1) = t_q2
     +               - (tauh(l,1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tau(l,1) = tr / vr_t(x_pos+3)
!<<<           tau(l,2) = ti / vr_t(x_pos+3)
               t_q1 = tih / vr_th(x_pos+3)
               tauh(l,2) = vr_th(x_pos+3) * t_q1
               t_u1 = 134217729.0 * vr_th(x_pos+3)
               t_p1 = t_u1
     +                  - (t_u1 - vr_th(x_pos+3))
               t_p2 = vr_th(x_pos+3) - t_p1
               t_u1 = 134217729.0 * t_q1
               t_r1 = t_u1
     +                  - (t_u1 - t_q1)
               t_r2 = t_q1 - t_r1
               taul(l,2) = ((t_p1*t_r1
     +                - tauh(l,2))
     +                + t_p1*t_r2
     +                + t_p2*t_r1)
     +                + t_p2*t_r2
               taul(l,2) = taul(l,2) + (vr_tl(x_pos+3)*t_q1)
               t_s1 = tauh(l,2) + taul(l,2)
               taul(l,2) = taul(l,2) - (t_s1 - tauh(l,2))
               tauh(l,2) = t_s1
               t_s1 = tih - tauh(l,2)
               t_r1 = t_s1 - tih
               t_s2 = (tih 
     +                  - (t_s1 - t_r1))
     +                  - (tauh(l,2) + t_r1)
               t_s2 = t_s2 - taul(l,2)
               t_s2 = t_s2 + til
               t_q2 = (t_s1 + t_s2)
     +                  / vr_th(x_pos+3)
               tauh(l,2) = t_q1 + t_q2
               taul(l,2) = t_q2
     +               - (tauh(l,2) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>           tau(l,2) = ti / vr_t(x_pos+3)
            endif

!            beta  = ur_t(x_pos+4)
               betah = ur_th(x_pos+4)
               betal = ur_tl(x_pos+4)
            if ( x_root == my_col .and. y_root == my_row ) then
#ifdef MEMORY1
      nxx = xx_ur_t(2250,x_pos+3)
      nxx = xx_vr_t(2260,x_pos)
      nxx = xx_wr(2270,x_pos,k_1)
      nxx = xx_wi(2280,x_pos,k_1)
#endif
!               e_out(i)      = scale*ur_t(x_pos+3)
!               e2_out(i)     = scale*scale*ur_t(x_pos+2)
!               wr(x_pos,k_1) = scale*ur_t(x_pos)
!               wi(x_pos,k_1) = scale*vr_t(x_pos)
!<<<           e_out(i) = scale * ur_t(x_pos+3)
               e_outh(i) = scaleh * ur_th(x_pos+3)
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * ur_th(x_pos+3)
               t_r1 = t_u1
     +                  - (t_u1 - ur_th(x_pos+3))
               t_r2 = ur_th(x_pos+3) - t_r1
               e_outl(i) = ((t_p1*t_r1
     +                 - e_outh(i))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               e_outl(i) = e_outl(i)
     +               + (scaleh*ur_tl(x_pos+3)
     +               + scalel*ur_th(x_pos+3))
               t_s1 = e_outh(i) + e_outl(i)
               e_outl(i) = e_outl(i) - (t_s1 - e_outh(i))
               e_outh(i) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           e_out(i) = scale * ur_t(x_pos+3)
!<<<           tmp1 = scale * scale
               tmp1h = scaleh * scaleh
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * scaleh
               t_r1 = t_u1
     +                  - (t_u1 - scaleh)
               t_r2 = scaleh - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (scaleh*scalel
     +               + scalel*scaleh)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = scale * scale
!<<<           e2_out(i) = tmp1 * ur_t(x_pos+2)
               e2_outh(i) = tmp1h * ur_th(x_pos+2)
               t_u1 = 134217729.0 * tmp1h
               t_p1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_p2 = tmp1h - t_p1
               t_u1 = 134217729.0 * ur_th(x_pos+2)
               t_r1 = t_u1
     +                  - (t_u1 - ur_th(x_pos+2))
               t_r2 = ur_th(x_pos+2) - t_r1
               e2_outl(i) = ((t_p1*t_r1
     +                 - e2_outh(i))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               e2_outl(i) = e2_outl(i)
     +               + (tmp1h*ur_tl(x_pos+2)
     +               + tmp1l*ur_th(x_pos+2))
               t_s1 = e2_outh(i) + e2_outl(i)
               e2_outl(i) = e2_outl(i) - (t_s1 - e2_outh(i))
               e2_outh(i) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           e2_out(i) = tmp1 * ur_t(x_pos+2)
!<<<           wr(x_pos,k_1) = scale * ur_t(x_pos)
               wrh(x_pos,k_1) = scaleh * ur_th(x_pos)
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * ur_th(x_pos)
               t_r1 = t_u1
     +                  - (t_u1 - ur_th(x_pos))
               t_r2 = ur_th(x_pos) - t_r1
               wrl(x_pos,k_1) = ((t_p1*t_r1
     +                 - wrh(x_pos,k_1))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               wrl(x_pos,k_1) = wrl(x_pos,k_1)
     +               + (scaleh*ur_tl(x_pos)
     +               + scalel*ur_th(x_pos))
               t_s1 = wrh(x_pos,k_1) + wrl(x_pos,k_1)
               wrl(x_pos,k_1) = wrl(x_pos,k_1) - (t_s1 - wrh(x_pos,k_1))
               wrh(x_pos,k_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           wr(x_pos,k_1) = scale * ur_t(x_pos)
!<<<           wi(x_pos,k_1) = scale * vr_t(x_pos)
               wih(x_pos,k_1) = scaleh * vr_th(x_pos)
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * vr_th(x_pos)
               t_r1 = t_u1
     +                  - (t_u1 - vr_th(x_pos))
               t_r2 = vr_th(x_pos) - t_r1
               wil(x_pos,k_1) = ((t_p1*t_r1
     +                 - wih(x_pos,k_1))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               wil(x_pos,k_1) = wil(x_pos,k_1)
     +               + (scaleh*vr_tl(x_pos)
     +               + scalel*vr_th(x_pos))
               t_s1 = wih(x_pos,k_1) + wil(x_pos,k_1)
               wil(x_pos,k_1) = wil(x_pos,k_1) - (t_s1 - wih(x_pos,k_1))
               wih(x_pos,k_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           wi(x_pos,k_1) = scale * vr_t(x_pos)
            endif
            i_1 = get_owner_node(i, size_of_col,my_col)
            if ( i_1 == my_col .and. y_root == my_row ) then
               j_1 = translate_g2l(i, size_of_col,my_col)
#ifdef MEMORY1
      nxx = xx_ur_t(2290,x_pos+4)
      nxx = xx_wi(2300,j_1,k_1)
#endif
!               wi(j_1,k_1) = scale*sqrt(ur_t(x_pos+4))
!<<<           tmp1 = sqrt(ur_t(x_pos+4))
               if (ur_th(x_pos+4).eq.0.0D+0
     +                  .and.ur_tl(x_pos+4).eq.0.0D+0) then
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
               endif
               if (ur_th(x_pos+4).lt.0.0d+0.or.
     +            (ur_th(x_pos+4).eq.0.0d+0
     +                  .and.ur_tl(x_pos+4).lt.0.0d+0)) then
                 write(6,'(a)')
     +              'SQRT CALLED WITH NEGATIVE ARGUMENT'
                 tmp1h = 0.0d+0
                 tmp1l = 0.0d+0
                 return
               endif
               t_x = 1.0D+0/sqrt(ur_th(x_pos+4))
               t_ax = ur_th(x_pos+4) * t_x
!                  call dd_mul(t_y1,t_y2,t_x,
!                              0.0,0.5,0.0)
                   t_y1 = t_x * 0.5d+0
                   t_u1 = 134217729.0 * t_x
                   t_p1 = t_u1
     +                      - (t_u1 - t_x)
                   t_p2 = t_x - t_p1
                   t_u1 = 134217729.0 * 0.5d+0
                   t_r1 = t_u1
     +                      - (t_u1 - 0.5d+0)
                   t_r2 = 0.5d+0 - t_r1
                   t_y2 = ((t_p1*t_r1
     +                      - t_y1)
     +                      + t_p1*t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2 * t_r2
                   t_s1 = t_y1 + t_y2
                   t_y2 = t_y2
     +                      - (t_s1 - t_y1)
                   t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_mul(t_z1,t_z2,t_ax,
!                              0.0,t_ax,0.0)
                   t_z1 = t_ax * t_ax
                   t_u1 = 134217729.0 * t_ax
                   t_p1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_p2 = t_ax - t_p1
                   t_u1 = 134217729.0 * t_ax
                   t_r1 = t_u1
     +                      - (t_u1 - t_ax)
                   t_r2 = t_ax - t_r1
                   t_z2 = ((t_p1 * t_r1
     +                      - t_z1)
     +                      + t_p1 * t_r2
     +                      + t_p2 * t_r1)
     +                      + t_p2*t_r2
                   t_s1 = t_z1 + t_z2
                   t_z2 = t_z2
     +                      - (t_s1 - t_z1)
                   t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_sub(t_t2h,t_t2l,
!                           ur_th(x_pos+4),ur_tl(x_pos+4),t_z1,t_z2)
                   t_p1 = ur_th(x_pos+4) - t_z1
                   t_p2 = t_p1 - ur_th(x_pos+4)
                   t_t2l = (ur_th(x_pos+4)
     +                      -(t_p1 - t_p2))
     +                      -(t_z1 + t_p2)
                   t_t2h = t_p1
                   t_t2l = t_t2l
     +                      + ur_tl(x_pos+4) - t_z2
                   t_s1 = t_t2h + t_t2l
                   t_t2l = t_t2l
     +                      - (t_s1 - t_t2h)
                   t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                  call dd_mul(t_t1h,t_t1l,
!                              t_t2h,t_t2l,
!                              t_y1,t_y2)
                   t_t1h = t_t2h * t_y1
                   t_u1 = 134217729.0 * t_t2h
                   t_p1 = t_u1
     +                      - (t_u1 - t_t2h)
                   t_p2 = t_t2h - t_p1
                   t_u1 = 134217729.0 * t_y1
                   t_r1 = t_u1
     +                      - (t_u1 - t_y1)
                   t_r2 = t_y1 - t_r1
                   t_t1l = ((t_p1*t_r1
     +                      - t_t1h)
     +                      + t_p1*t_r2
     +                      + t_p2*t_r1)
     +                      + t_p2*t_r2
                   t_t1l = t_t1l
     +                      + (t_t2h * t_y2
     +                      +  t_t2l * t_y1)
                   t_s1 = t_t1h + t_t1l
                   t_t1l = t_t1l - (t_s1
     +                       - t_t1h)
                   t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                  call dd_selfadd(t_t1h,t_t1l,
!                              t_ax,0.0)
                   t_p1 = t_t1h + t_ax
                   t_p2 = t_p1 - t_t1h
                   t_q2 = (t_t1h
     +                      - (t_p1 - t_p2))
     +                      + (t_ax - t_p2)
                   t_q1 = t_p1
                   t_q2 = t_q2 + t_t1l
                   t_t1h = t_q1 + t_q2
                   t_t1l = t_q2
     +                       - (t_t1h - t_q1)
                   tmp1h = t_t1h
                   tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>           tmp1 = sqrt(ur_t(x_pos+4))
!<<<           wi(j_1,k_1) = scale * tmp1
               wih(j_1,k_1) = scaleh * tmp1h
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * tmp1h
               t_r1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_r2 = tmp1h - t_r1
               wil(j_1,k_1) = ((t_p1*t_r1
     +                 - wih(j_1,k_1))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               wil(j_1,k_1) = wil(j_1,k_1)
     +               + (scaleh*tmp1l
     +               + scalel*tmp1h)
               t_s1 = wih(j_1,k_1) + wil(j_1,k_1)
               wil(j_1,k_1) = wil(j_1,k_1) - (t_s1 - wih(j_1,k_1))
               wih(j_1,k_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           wi(j_1,k_1) = scale * tmp1
            endif
!----
!---- v = au
!----
            d1=mpi_wtime() 
!$omp parallel
!            call eigen_hrd_Au(
!     &             ar(1,1),ai(1,1),lda,
!     &             ur_x(1,k_1),ui_x(1,k_1),
!     &             ur_y(1,k_1),ui_y(1,k_1),
!     &             vr_x(1,k_1),vi_x(1,k_1),
!     &             ur_t(1),ui_t(1), vr_t(1),vi_t(1),
!     &             d_t(1),
!     &             i_3, x_pos,y_pos, nv,k_1-k_2,
!     &             ar_(1,1),ai_(1,1),n_,nm_
            call ddeigen_hrd_Au(
     &             arh(1,1),arl(1,1),aih(1,1),ail(1,1),lda,
     &             ur_xh(1,k_1),ur_xl(1,k_1),
     &             ui_xh(1,k_1),ui_xl(1,k_1),
     &             ur_yh(1,k_1),ur_yl(1,k_1),
     &             ui_yh(1,k_1),ui_yl(1,k_1),
     &             vr_xh(1,k_1),vr_xl(1,k_1),
     &             vi_xh(1,k_1),vi_xl(1,k_1),
     &             ur_th(1),ur_tl(1),ui_th(1),ui_tl(1),
     &             vr_th(1),vr_tl(1),vi_th(1),vi_tl(1),
     &             d_th(1),d_tl(1),
     &             i_3, x_pos,y_pos, nv,k_1-k_2,
     &             ar_h(1,1),ar_l(1,1),ai_h(1,1),ai_l(1,1),n_,nm_
#ifdef MEMORY1
     &            ,xx_ur_x(0,1,k_1),xx_ui_x(0,1,k_1)
     &            ,xx_ur_y(0,1,k_1),xx_ui_y(0,1,k_1)
     &            ,xx_vr_x(0,1,k_1),xx_vi_x(0,1,k_1)
     &            ,xx_ur_t(0,1)    ,xx_ui_t(0,1)
     &            ,xx_vr_t(0,1)    ,xx_vi_t(0,1)
     &            ,xx_d_t (0,1)
#endif
     &           )
!$omp end parallel

            d2=mpi_wtime() 
            dd(2)=dd(2)+d2-d1
!----
!---- v = (a+uv+vu)u = au+(vu)u+(uu)v
!----
            d1=mpi_wtime() 
           if(k_2>k_1)then
#ifdef MEMORY1
      nxx = xx_ur_x(2310,x_pos,k_1)
      nxx = xx_ui_x(2320,x_pos,k_1)
      nxx = xx_ur_x(2330,x_pos,k_2)
      nxx = xx_ui_x(2340,x_pos,k_2)
      nxx = xx_vr_x(2350,x_pos,k_2)
      nxx = xx_vi_x(2360,x_pos,k_2)
      nxx = xx_ur_t(2370,4*(k_2-l_1)+4)
#endif
*soption unroll(2)
               do l_1=k_2,k_1+1,-1
                  j=k_2-l_1
!                  sr = 0.0d+00
!                  si = 0.0d+00
!                  tr = 0.0d+00
!                  ti = 0.0d+00
                  srh = 0.0d+0
                  srl = 0.0d+0
                  sih = 0.0d+0
                  sil = 0.0d+0
                  trh = 0.0d+0
                  trl = 0.0d+0
                  tih = 0.0d+0
                  til = 0.0d+0
*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do  j_1 = 1, x_pos
!                     wr_x0 = ur_x(j_1,k_1)
!                     wi_x0 = ui_x(j_1,k_1)
!                     ur_x0 = ur_x(j_1,l_1)
!                     ui_x0 = ui_x(j_1,l_1)
!                     vr_x0 = vr_x(j_1,l_1)
!                     vi_x0 = vi_x(j_1,l_1)
                     wr_x0h = ur_xh(j_1,k_1)
                     wr_x0l = ur_xl(j_1,k_1)
                     wi_x0h = ui_xh(j_1,k_1)
                     wi_x0l = ui_xl(j_1,k_1)
                     ur_x0h = ur_xh(j_1,l_1)
                     ur_x0l = ur_xl(j_1,l_1)
                     ui_x0h = ui_xh(j_1,l_1)
                     ui_x0l = ui_xl(j_1,l_1)
                     vr_x0h = vr_xh(j_1,l_1)
                     vr_x0l = vr_xl(j_1,l_1)
                     vi_x0h = vi_xh(j_1,l_1)
                     vi_x0l = vi_xl(j_1,l_1)

!                     sr = sr
!     &                      + vr_x0*wr_x0
!                     sr = sr
!     &                      + vi_x0*wi_x0
!                     si = si
!     &                      + vi_x0*wr_x0
!                     si = si
!     &                      - vr_x0*wi_x0
!                     tr = tr
!     &                      + ur_x0*wr_x0
!                     tr = tr
!     &                      + ui_x0*wi_x0
!                     ti = ti
!     &                      + ui_x0*wr_x0
!                     ti = ti
!     &                      - ur_x0*wi_x0
!<<<                 tmp1 = vr_x0 * wr_x0
                     tmp1h = vr_x0h * wr_x0h
                     t_u1 = 134217729.0 * vr_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - vr_x0h)
                     t_p2 = vr_x0h - t_p1
                     t_u1 = 134217729.0 * wr_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wr_x0h)
                     t_r2 = wr_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (vr_x0h*wr_x0l
     +                     + vr_x0l*wr_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = vr_x0 * wr_x0
!<<<                 sr = sr + tmp1
                     t_p1 = srh + tmp1h
                     t_p2 = t_p1 - srh
                     t_q1 = t_p1
                     t_q2 = (srh - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + srl + tmp1l
                     srh = t_q1 + t_q2
                     srl = t_q2 - (srh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 sr = sr + tmp1
!<<<                 tmp1 = vi_x0 * wi_x0
                     tmp1h = vi_x0h * wi_x0h
                     t_u1 = 134217729.0 * vi_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - vi_x0h)
                     t_p2 = vi_x0h - t_p1
                     t_u1 = 134217729.0 * wi_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wi_x0h)
                     t_r2 = wi_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (vi_x0h*wi_x0l
     +                     + vi_x0l*wi_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = vi_x0 * wi_x0
!<<<                 sr = sr + tmp1
                     t_p1 = srh + tmp1h
                     t_p2 = t_p1 - srh
                     t_q1 = t_p1
                     t_q2 = (srh - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + srl + tmp1l
                     srh = t_q1 + t_q2
                     srl = t_q2 - (srh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 sr = sr + tmp1
!<<<                 tmp1 = vi_x0 * wr_x0
                     tmp1h = vi_x0h * wr_x0h
                     t_u1 = 134217729.0 * vi_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - vi_x0h)
                     t_p2 = vi_x0h - t_p1
                     t_u1 = 134217729.0 * wr_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wr_x0h)
                     t_r2 = wr_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (vi_x0h*wr_x0l
     +                     + vi_x0l*wr_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = vi_x0 * wr_x0
!<<<                 si = si + tmp1
                     t_p1 = sih + tmp1h
                     t_p2 = t_p1 - sih
                     t_q1 = t_p1
                     t_q2 = (sih - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + sil + tmp1l
                     sih = t_q1 + t_q2
                     sil = t_q2 - (sih - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 si = si + tmp1
!<<<                 tmp1 = vr_x0 * wi_x0
                     tmp1h = vr_x0h * wi_x0h
                     t_u1 = 134217729.0 * vr_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - vr_x0h)
                     t_p2 = vr_x0h - t_p1
                     t_u1 = 134217729.0 * wi_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wi_x0h)
                     t_r2 = wi_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (vr_x0h*wi_x0l
     +                     + vr_x0l*wi_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = vr_x0 * wi_x0
!<<<                 si = si - tmp1
                     t_p1 = sih - tmp1h
                     t_p2 = t_p1 - sih
                     t_ch = t_p1
                     t_cl = (sih - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + sil - tmp1l
                     t_s1 = t_ch + t_cl
                     sil = t_cl - (t_s1 - t_ch)
                     sih = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 si = si - tmp1
!<<<                 tmp1 = ur_x0 * wr_x0
                     tmp1h = ur_x0h * wr_x0h
                     t_u1 = 134217729.0 * ur_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - ur_x0h)
                     t_p2 = ur_x0h - t_p1
                     t_u1 = 134217729.0 * wr_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wr_x0h)
                     t_r2 = wr_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (ur_x0h*wr_x0l
     +                     + ur_x0l*wr_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = ur_x0 * wr_x0
!<<<                 tr = tr + tmp1
                     t_p1 = trh + tmp1h
                     t_p2 = t_p1 - trh
                     t_q1 = t_p1
                     t_q2 = (trh - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + trl + tmp1l
                     trh = t_q1 + t_q2
                     trl = t_q2 - (trh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 tr = tr + tmp1
!<<<                 tmp1 = ui_x0 * wi_x0
                     tmp1h = ui_x0h * wi_x0h
                     t_u1 = 134217729.0 * ui_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - ui_x0h)
                     t_p2 = ui_x0h - t_p1
                     t_u1 = 134217729.0 * wi_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wi_x0h)
                     t_r2 = wi_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (ui_x0h*wi_x0l
     +                     + ui_x0l*wi_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = ui_x0 * wi_x0
!<<<                 tr = tr + tmp1
                     t_p1 = trh + tmp1h
                     t_p2 = t_p1 - trh
                     t_q1 = t_p1
                     t_q2 = (trh - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + trl + tmp1l
                     trh = t_q1 + t_q2
                     trl = t_q2 - (trh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 tr = tr + tmp1
!<<<                 tmp1 = ui_x0 * wr_x0
                     tmp1h = ui_x0h * wr_x0h
                     t_u1 = 134217729.0 * ui_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - ui_x0h)
                     t_p2 = ui_x0h - t_p1
                     t_u1 = 134217729.0 * wr_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wr_x0h)
                     t_r2 = wr_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (ui_x0h*wr_x0l
     +                     + ui_x0l*wr_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = ui_x0 * wr_x0
!<<<                 ti = ti + tmp1
                     t_p1 = tih + tmp1h
                     t_p2 = t_p1 - tih
                     t_q1 = t_p1
                     t_q2 = (tih - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + til + tmp1l
                     tih = t_q1 + t_q2
                     til = t_q2 - (tih - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 ti = ti + tmp1
!<<<                 tmp1 = ur_x0 * wi_x0
                     tmp1h = ur_x0h * wi_x0h
                     t_u1 = 134217729.0 * ur_x0h
                     t_p1 = t_u1
     +                        - (t_u1 - ur_x0h)
                     t_p2 = ur_x0h - t_p1
                     t_u1 = 134217729.0 * wi_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - wi_x0h)
                     t_r2 = wi_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (ur_x0h*wi_x0l
     +                     + ur_x0l*wi_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = ur_x0 * wi_x0
!<<<                 ti = ti - tmp1
                     t_p1 = tih - tmp1h
                     t_p2 = t_p1 - tih
                     t_ch = t_p1
                     t_cl = (tih - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + til - tmp1l
                     t_s1 = t_ch + t_cl
                     til = t_cl - (t_s1 - t_ch)
                     tih = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 ti = ti - tmp1
                  enddo! k
!                  ur_t(4*j+1) = sr
!                  ur_t(4*j+2) = si
!                  ur_t(4*j+3) = tr
!                  ur_t(4*j+4) = ti
                  ur_th(4*j+1) = srh
                  ur_tl(4*j+1) = srl
                  ur_th(4*j+2) = sih
                  ur_tl(4*j+2) = sil
                  ur_th(4*j+3) = trh
                  ur_tl(4*j+3) = trl
                  ur_th(4*j+4) = tih
                  ur_tl(4*j+4) = til
               enddo! j0
               j=(k_2-k_1)*4
#ifdef MEMORY1
      nxx = xx_ur_t(2380,j)
      nxx = xx_vr_t(2390,j)
#endif
!               call reduce_dbl(ur_t(1), vr_t(1), j, mpi_comm_col)
               call ddreduce_dbl(
     &                ur_th(1), ur_tl(1), vr_th(1), vr_tl(1), 
     &                j, mpi_comm_col)
#ifdef MEMORY1
      nxx = xx_ur_t(2400,4*(k_2-(k_1+1))+4)
      nxx = xx_ur_x(2410,x_pos,k_2)
      nxx = xx_ui_x(2420,x_pos,k_2)
      nxx = xx_vr_x(2430,x_pos,k_2)
      nxx = xx_vi_x(2440,x_pos,k_2)
      nxx = xx_vr_x(2450,x_pos,k_1)
      nxx = xx_vi_x(2460,x_pos,k_1)
#endif
*soption unroll(2)
               do l_1=k_2,k_1+1,-1
                  j=k_2-l_1
!                  sr = ur_t(4*j+1)
!                  si = ur_t(4*j+2)
!                  tr = ur_t(4*j+3)
!                  ti = ur_t(4*j+4)
                  srh = ur_th(4*j+1)
                  srl = ur_tl(4*j+1)
                  sih = ur_th(4*j+2)
                  sil = ur_tl(4*j+2)
                  trh = ur_th(4*j+3)
                  trl = ur_tl(4*j+3)
                  tih = ur_th(4*j+4)
                  til = ur_tl(4*j+4)
*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do  j_1 = 1, x_pos
!                     wr_x0 = 0
!                     wi_x0 = 0
!                     ur_x0 = ur_x(j_1,l_1)
!                     ui_x0 = ui_x(j_1,l_1)
!                     vr_x0 = vr_x(j_1,l_1)
!                     vi_x0 = vi_x(j_1,l_1)
                     wr_x0h = 0.0d+0
                     wr_x0l = 0.0d+0
                     wi_x0h = 0.0d+0
                     wi_x0l = 0.0d+0
                     ur_x0h = ur_xh(j_1,l_1)
                     ur_x0l = ur_xl(j_1,l_1)
                     ui_x0h = ui_xh(j_1,l_1)
                     ui_x0l = ui_xl(j_1,l_1)
                     vr_x0h = vr_xh(j_1,l_1)
                     vr_x0l = vr_xl(j_1,l_1)
                     vi_x0h = vi_xh(j_1,l_1)
                     vi_x0l = vi_xl(j_1,l_1)
!                     wr_x0 = wr_x0
!     &                            - tr*vr_x0
!                     wi_x0 = wi_x0
!     &                            + ti*vr_x0
!                     wr_x0 = wr_x0
!     &                            - sr*ur_x0
!                     wi_x0 = wi_x0
!     &                            + si*ur_x0
!                     wr_x0 = wr_x0
!     &                            - ti*vi_x0
!                     wi_x0 = wi_x0
!     &                            - tr*vi_x0
!                     wr_x0 = wr_x0
!     &                            - si*ui_x0
!                     wi_x0 = wi_x0
!     &                            - sr*ui_x0 
!<<<                 tmp1 = tr * vr_x0
                     tmp1h = trh * vr_x0h
                     t_u1 = 134217729.0 * trh
                     t_p1 = t_u1
     +                        - (t_u1 - trh)
                     t_p2 = trh - t_p1
                     t_u1 = 134217729.0 * vr_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - vr_x0h)
                     t_r2 = vr_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (trh*vr_x0l
     +                     + trl*vr_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = tr * vr_x0
!<<<                 wr_x0 = wr_x0 - tmp1
                     t_p1 = wr_x0h - tmp1h
                     t_p2 = t_p1 - wr_x0h
                     t_ch = t_p1
                     t_cl = (wr_x0h - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + wr_x0l - tmp1l
                     t_s1 = t_ch + t_cl
                     wr_x0l = t_cl - (t_s1 - t_ch)
                     wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 wr_x0 = wr_x0 - tmp1
!<<<                 tmp1 = ti * vr_x0
                     tmp1h = tih * vr_x0h
                     t_u1 = 134217729.0 * tih
                     t_p1 = t_u1
     +                        - (t_u1 - tih)
                     t_p2 = tih - t_p1
                     t_u1 = 134217729.0 * vr_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - vr_x0h)
                     t_r2 = vr_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (tih*vr_x0l
     +                     + til*vr_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = ti * vr_x0
!<<<                 wi_x0 = wi_x0 + tmp1
                     t_p1 = wi_x0h + tmp1h
                     t_p2 = t_p1 - wi_x0h
                     t_q1 = t_p1
                     t_q2 = (wi_x0h - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + wi_x0l + tmp1l
                     wi_x0h = t_q1 + t_q2
                     wi_x0l = t_q2 - (wi_x0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 wi_x0 = wi_x0 + tmp1
!<<<                 tmp1 = sr * ur_x0
                     tmp1h = srh * ur_x0h
                     t_u1 = 134217729.0 * srh
                     t_p1 = t_u1
     +                        - (t_u1 - srh)
                     t_p2 = srh - t_p1
                     t_u1 = 134217729.0 * ur_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - ur_x0h)
                     t_r2 = ur_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (srh*ur_x0l
     +                     + srl*ur_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = sr * ur_x0
!<<<                 wr_x0 = wr_x0 - tmp1
                     t_p1 = wr_x0h - tmp1h
                     t_p2 = t_p1 - wr_x0h
                     t_ch = t_p1
                     t_cl = (wr_x0h - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + wr_x0l - tmp1l
                     t_s1 = t_ch + t_cl
                     wr_x0l = t_cl - (t_s1 - t_ch)
                     wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 wr_x0 = wr_x0 - tmp1
!<<<                 tmp1 = si * ur_x0
                     tmp1h = sih * ur_x0h
                     t_u1 = 134217729.0 * sih
                     t_p1 = t_u1
     +                        - (t_u1 - sih)
                     t_p2 = sih - t_p1
                     t_u1 = 134217729.0 * ur_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - ur_x0h)
                     t_r2 = ur_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (sih*ur_x0l
     +                     + sil*ur_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = si * ur_x0
!<<<                 wi_x0 = wi_x0 + tmp1
                     t_p1 = wi_x0h + tmp1h
                     t_p2 = t_p1 - wi_x0h
                     t_q1 = t_p1
                     t_q2 = (wi_x0h - (t_p1 - t_p2))
     +                        + (tmp1h - t_p2)
                     t_q2 = t_q2 + wi_x0l + tmp1l
                     wi_x0h = t_q1 + t_q2
                     wi_x0l = t_q2 - (wi_x0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 wi_x0 = wi_x0 + tmp1
!<<<                 tmp1 = ti * vi_x0
                     tmp1h = tih * vi_x0h
                     t_u1 = 134217729.0 * tih
                     t_p1 = t_u1
     +                        - (t_u1 - tih)
                     t_p2 = tih - t_p1
                     t_u1 = 134217729.0 * vi_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - vi_x0h)
                     t_r2 = vi_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (tih*vi_x0l
     +                     + til*vi_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = ti * vi_x0
!<<<                 wr_x0 = wr_x0 - tmp1
                     t_p1 = wr_x0h - tmp1h
                     t_p2 = t_p1 - wr_x0h
                     t_ch = t_p1
                     t_cl = (wr_x0h - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + wr_x0l - tmp1l
                     t_s1 = t_ch + t_cl
                     wr_x0l = t_cl - (t_s1 - t_ch)
                     wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 wr_x0 = wr_x0 - tmp1
!<<<                 tmp1 = tr * vi_x0
                     tmp1h = trh * vi_x0h
                     t_u1 = 134217729.0 * trh
                     t_p1 = t_u1
     +                        - (t_u1 - trh)
                     t_p2 = trh - t_p1
                     t_u1 = 134217729.0 * vi_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - vi_x0h)
                     t_r2 = vi_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (trh*vi_x0l
     +                     + trl*vi_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = tr * vi_x0
!<<<                 wi_x0 = wi_x0 - tmp1
                     t_p1 = wi_x0h - tmp1h
                     t_p2 = t_p1 - wi_x0h
                     t_ch = t_p1
                     t_cl = (wi_x0h - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + wi_x0l - tmp1l
                     t_s1 = t_ch + t_cl
                     wi_x0l = t_cl - (t_s1 - t_ch)
                     wi_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 wi_x0 = wi_x0 - tmp1
!<<<                 tmp1 = si * ui_x0
                     tmp1h = sih * ui_x0h
                     t_u1 = 134217729.0 * sih
                     t_p1 = t_u1
     +                        - (t_u1 - sih)
                     t_p2 = sih - t_p1
                     t_u1 = 134217729.0 * ui_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - ui_x0h)
                     t_r2 = ui_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (sih*ui_x0l
     +                     + sil*ui_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = si * ui_x0
!<<<                 wr_x0 = wr_x0 - tmp1
                     t_p1 = wr_x0h - tmp1h
                     t_p2 = t_p1 - wr_x0h
                     t_ch = t_p1
                     t_cl = (wr_x0h - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + wr_x0l - tmp1l
                     t_s1 = t_ch + t_cl
                     wr_x0l = t_cl - (t_s1 - t_ch)
                     wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 wr_x0 = wr_x0 - tmp1
!<<<                 tmp1 = sr * ui_x0
                     tmp1h = srh * ui_x0h
                     t_u1 = 134217729.0 * srh
                     t_p1 = t_u1
     +                        - (t_u1 - srh)
                     t_p2 = srh - t_p1
                     t_u1 = 134217729.0 * ui_x0h
                     t_r1 = t_u1
     +                        - (t_u1 - ui_x0h)
                     t_r2 = ui_x0h - t_r1
                     tmp1l = ((t_p1*t_r1
     +                       - tmp1h)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                     tmp1l = tmp1l
     +                     + (srh*ui_x0l
     +                     + srl*ui_x0h)
                     t_s1 = tmp1h + tmp1l
                     tmp1l = tmp1l - (t_s1 - tmp1h)
                     tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>                 tmp1 = sr * ui_x0
!<<<                 wi_x0 = wi_x0 - tmp1
                     t_p1 = wi_x0h - tmp1h
                     t_p2 = t_p1 - wi_x0h
                     t_ch = t_p1
                     t_cl = (wi_x0h - (t_p1 - t_p2))
     +                        - (tmp1h + t_p2)
                     t_cl = t_cl + wi_x0l - tmp1l
                     t_s1 = t_ch + t_cl
                     wi_x0l = t_cl - (t_s1 - t_ch)
                     wi_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>                 wi_x0 = wi_x0 - tmp1
!                     vr_x(j_1,k_1) = wr_x0+vr_x(j_1,k_1)
!                     vi_x(j_1,k_1) = wi_x0+vi_x(j_1,k_1)
!<<<                 vr_x(j_1,k_1) = wr_x0 + vr_x(j_1,k_1)
                     t_p1 = wr_x0h + vr_xh(j_1,k_1)
                     t_p2 = t_p1 - wr_x0h
                     t_q1 = t_p1
                     t_q2 = (wr_x0h - (t_p1 - t_p2))
     +                        + (vr_xh(j_1,k_1) - t_p2)
                     t_q2 = t_q2 + wr_x0l + vr_xl(j_1,k_1)
                     vr_xh(j_1,k_1) = t_q1 + t_q2
                     vr_xl(j_1,k_1) = t_q2 - (vr_xh(j_1,k_1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 vr_x(j_1,k_1) = wr_x0 + vr_x(j_1,k_1)
!<<<                 vi_x(j_1,k_1) = wi_x0 + vi_x(j_1,k_1)
                     t_p1 = wi_x0h + vi_xh(j_1,k_1)
                     t_p2 = t_p1 - wi_x0h
                     t_q1 = t_p1
                     t_q2 = (wi_x0h - (t_p1 - t_p2))
     +                        + (vi_xh(j_1,k_1) - t_p2)
                     t_q2 = t_q2 + wi_x0l + vi_xl(j_1,k_1)
                     vi_xh(j_1,k_1) = t_q1 + t_q2
                     vi_xl(j_1,k_1) = t_q2 - (vi_xh(j_1,k_1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>                 vi_x(j_1,k_1) = wi_x0 + vi_x(j_1,k_1)
                  enddo! k
               enddo! j0
            endif
            d2=mpi_wtime()
            dd(5)=dd(5)+d2-d1

            d1=mpi_wtime()
!            call  eigen_hrd_v(
!     &              ur_x(1,k_1),ui_x(1,k_1),
!     &              vr_x(1,k_1),vi_x(1,k_1),
!     &              vr_y(1,k_1),vi_y(1,k_1),
!     &              ur_t(1),vr_t(1),
!     &              beta, j_3,x_pos,nv
            call  ddeigen_hrd_v(
     &              ur_xh(1,k_1),ur_xl(1,k_1),
     &              ui_xh(1,k_1),ui_xl(1,k_1),
     &              vr_xh(1,k_1),vr_xl(1,k_1),
     &              vi_xh(1,k_1),vi_xl(1,k_1),
     &              vr_yh(1,k_1),vr_yl(1,k_1),
     &              vi_yh(1,k_1),vi_yl(1,k_1),
     &              ur_th(1),ur_tl(1),vr_th(1),vr_tl(1),
     &              betah, betal, j_3,x_pos,nv
#ifdef MEMORY1
     &             ,xx_ur_x(0,1,k_1),xx_ui_x(0,1,k_1)
     &             ,xx_vr_x(0,1,k_1),xx_vi_x(0,1,k_1)
     &             ,xx_vr_y(0,1,k_1),xx_vi_y(0,1,k_1)
     &             ,xx_ur_t(0,1)    ,xx_vr_t(0,1)
#endif
     &            )
            d2=mpi_wtime()
            dd(4)=dd(4)+d2-d1

            d1=mpi_wtime()
            if(k_1>1)then

               i_2 = get_loop_start(i_base+1,     size_of_row,my_row)
               i_3 = get_loop_end  (i_base+k_1-1, size_of_row,my_row)
#ifdef MEMORY1
      nxx = xx_ur_y(2470,i_3,k_1)
      nxx = xx_vr_y(2480,i_3,k_1)
      nxx = xx_ui_y(2490,i_3,k_1)
      nxx = xx_vi_y(2500,i_3,k_1)
      nxx = xx_ur_x(2510,j_3,k_1)
      nxx = xx_ui_x(2520,j_3,k_1)
      nxx = xx_vr_x(2530,j_3,k_1)
      nxx = xx_vi_x(2540,j_3,k_1)
#endif

               do i_1=i_2,i_3

                  j   = translate_l2g(i_1, size_of_row,my_row)
                  l_1 = j-i_base

#ifdef MEMORY1
      nxx = xx_wr(2550,j_3,l_1)
      nxx = xx_wi(2560,j_3,l_1)
#endif
!                  ur_y0=ur_y(i_1,k_1)
!                  vr_y0=vr_y(i_1,k_1)
!                  ui_y0=ui_y(i_1,k_1)
!                  vi_y0=vi_y(i_1,k_1)
                  ur_y0h = ur_yh(i_1,k_1)
                  ur_y0l = ur_yl(i_1,k_1)
                  vr_y0h = vr_yh(i_1,k_1)
                  vr_y0l = vr_yl(i_1,k_1)
                  ui_y0h = ui_yh(i_1,k_1)
                  ui_y0l = ui_yl(i_1,k_1)
                  vi_y0h = vi_yh(i_1,k_1)
                  vi_y0l = vi_yl(i_1,k_1)

*soption unroll(4)
!dir$ ivdep
!dir$ vector always
                  do j_1=j_2,j_3

!                     wr_x0 = 0
!                     wi_x0 = 0
!                     ur_x0 = ur_x(j_1,k_1)
!                     ui_x0 = ui_x(j_1,k_1)
!                     vr_x0 = vr_x(j_1,k_1)
!                     vi_x0 = vi_x(j_1,k_1)
                  wr_x0h = 0.0d+0
                  wr_x0l = 0.0d+0
                  wi_x0h = 0.0d+0
                  wi_x0l = 0.0d+0
                  ur_x0h = ur_xh(j_1,k_1)
                  ur_x0l = ur_xl(j_1,k_1)
                  ui_x0h = ui_xh(j_1,k_1)
                  ui_x0l = ui_xl(j_1,k_1)
                  vr_x0h = vr_xh(j_1,k_1)
                  vr_x0l = vr_xl(j_1,k_1)
                  vi_x0h = vi_xh(j_1,k_1)
                  vi_x0l = vi_xl(j_1,k_1)

!                     wr_x0 = wr_x0
!     &                            - vr_x0*ur_y0
!                     wi_x0 = wi_x0
!     &                            - vi_x0*ur_y0
!                     wr_x0 = wr_x0
!     &                            - ur_x0*vr_y0
!                     wi_x0 = wi_x0
!     &                            - ui_x0*vr_y0
!                     wr_x0 = wr_x0
!     &                            - vi_x0*ui_y0
!                     wi_x0 = wi_x0
!     &                            + vr_x0*ui_y0
!                     wr_x0 = wr_x0
!     &                            - ui_x0*vi_y0
!                     wi_x0 = wi_x0
!     &                            + ur_x0*vi_y0
!
!<<<              tmp1 = vr_x0 * ur_y0
                  tmp1h = vr_x0h * ur_y0h
                  t_u1 = 134217729.0 * vr_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - vr_x0h)
                  t_p2 = vr_x0h - t_p1
                  t_u1 = 134217729.0 * ur_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - ur_y0h)
                  t_r2 = ur_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (vr_x0h*ur_y0l
     +                  + vr_x0l*ur_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = vr_x0 * ur_y0
!<<<              wr_x0 = wr_x0 - tmp1
                  t_p1 = wr_x0h - tmp1h
                  t_p2 = t_p1 - wr_x0h
                  t_ch = t_p1
                  t_cl = (wr_x0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + wr_x0l - tmp1l
                  t_s1 = t_ch + t_cl
                  wr_x0l = t_cl - (t_s1 - t_ch)
                  wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              wr_x0 = wr_x0 - tmp1
!<<<              tmp1 = vi_x0 * ur_y0
                  tmp1h = vi_x0h * ur_y0h
                  t_u1 = 134217729.0 * vi_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - vi_x0h)
                  t_p2 = vi_x0h - t_p1
                  t_u1 = 134217729.0 * ur_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - ur_y0h)
                  t_r2 = ur_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (vi_x0h*ur_y0l
     +                  + vi_x0l*ur_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = vi_x0 * ur_y0
!<<<              wi_x0 = wi_x0 - tmp1
                  t_p1 = wi_x0h - tmp1h
                  t_p2 = t_p1 - wi_x0h
                  t_ch = t_p1
                  t_cl = (wi_x0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + wi_x0l - tmp1l
                  t_s1 = t_ch + t_cl
                  wi_x0l = t_cl - (t_s1 - t_ch)
                  wi_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              wi_x0 = wi_x0 - tmp1
!<<<              tmp1 = ur_x0 * vr_y0
                  tmp1h = ur_x0h * vr_y0h
                  t_u1 = 134217729.0 * ur_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - ur_x0h)
                  t_p2 = ur_x0h - t_p1
                  t_u1 = 134217729.0 * vr_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - vr_y0h)
                  t_r2 = vr_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (ur_x0h*vr_y0l
     +                  + ur_x0l*vr_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = ur_x0 * vr_y0
!<<<              wr_x0 = wr_x0 - tmp1
                  t_p1 = wr_x0h - tmp1h
                  t_p2 = t_p1 - wr_x0h
                  t_ch = t_p1
                  t_cl = (wr_x0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + wr_x0l - tmp1l
                  t_s1 = t_ch + t_cl
                  wr_x0l = t_cl - (t_s1 - t_ch)
                  wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              wr_x0 = wr_x0 - tmp1
!<<<              tmp1 = ui_x0 * vr_y0
                  tmp1h = ui_x0h * vr_y0h
                  t_u1 = 134217729.0 * ui_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - ui_x0h)
                  t_p2 = ui_x0h - t_p1
                  t_u1 = 134217729.0 * vr_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - vr_y0h)
                  t_r2 = vr_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (ui_x0h*vr_y0l
     +                  + ui_x0l*vr_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = ui_x0 * vr_y0
!<<<              wi_x0 = wi_x0 - tmp1
                  t_p1 = wi_x0h - tmp1h
                  t_p2 = t_p1 - wi_x0h
                  t_ch = t_p1
                  t_cl = (wi_x0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + wi_x0l - tmp1l
                  t_s1 = t_ch + t_cl
                  wi_x0l = t_cl - (t_s1 - t_ch)
                  wi_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              wi_x0 = wi_x0 - tmp1
!<<<              tmp1 = vi_x0 * ui_y0
                  tmp1h = vi_x0h * ui_y0h
                  t_u1 = 134217729.0 * vi_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - vi_x0h)
                  t_p2 = vi_x0h - t_p1
                  t_u1 = 134217729.0 * ui_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - ui_y0h)
                  t_r2 = ui_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (vi_x0h*ui_y0l
     +                  + vi_x0l*ui_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = vi_x0 * ui_y0
!<<<              wr_x0 = wr_x0 - tmp1
                  t_p1 = wr_x0h - tmp1h
                  t_p2 = t_p1 - wr_x0h
                  t_ch = t_p1
                  t_cl = (wr_x0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + wr_x0l - tmp1l
                  t_s1 = t_ch + t_cl
                  wr_x0l = t_cl - (t_s1 - t_ch)
                  wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              wr_x0 = wr_x0 - tmp1
!<<<              tmp1 = vr_x0 * ui_y0
                  tmp1h = vr_x0h * ui_y0h
                  t_u1 = 134217729.0 * vr_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - vr_x0h)
                  t_p2 = vr_x0h - t_p1
                  t_u1 = 134217729.0 * ui_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - ui_y0h)
                  t_r2 = ui_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (vr_x0h*ui_y0l
     +                  + vr_x0l*ui_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = vr_x0 * ui_y0
!<<<              wi_x0 = wi_x0 + tmp1
                  t_p1 = wi_x0h + tmp1h
                  t_p2 = t_p1 - wi_x0h
                  t_q1 = t_p1
                  t_q2 = (wi_x0h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + wi_x0l + tmp1l
                  wi_x0h = t_q1 + t_q2
                  wi_x0l = t_q2 - (wi_x0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              wi_x0 = wi_x0 + tmp1
!<<<              tmp1 = ui_x0 * vi_y0
                  tmp1h = ui_x0h * vi_y0h
                  t_u1 = 134217729.0 * ui_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - ui_x0h)
                  t_p2 = ui_x0h - t_p1
                  t_u1 = 134217729.0 * vi_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - vi_y0h)
                  t_r2 = vi_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (ui_x0h*vi_y0l
     +                  + ui_x0l*vi_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = ui_x0 * vi_y0
!<<<              wr_x0 = wr_x0 - tmp1
                  t_p1 = wr_x0h - tmp1h
                  t_p2 = t_p1 - wr_x0h
                  t_ch = t_p1
                  t_cl = (wr_x0h - (t_p1 - t_p2))
     +                     - (tmp1h + t_p2)
                  t_cl = t_cl + wr_x0l - tmp1l
                  t_s1 = t_ch + t_cl
                  wr_x0l = t_cl - (t_s1 - t_ch)
                  wr_x0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>              wr_x0 = wr_x0 - tmp1
!<<<              tmp1 = ur_x0 * vi_y0
                  tmp1h = ur_x0h * vi_y0h
                  t_u1 = 134217729.0 * ur_x0h
                  t_p1 = t_u1
     +                     - (t_u1 - ur_x0h)
                  t_p2 = ur_x0h - t_p1
                  t_u1 = 134217729.0 * vi_y0h
                  t_r1 = t_u1
     +                     - (t_u1 - vi_y0h)
                  t_r2 = vi_y0h - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (ur_x0h*vi_y0l
     +                  + ur_x0l*vi_y0h)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = ur_x0 * vi_y0
!<<<              wi_x0 = wi_x0 + tmp1
                  t_p1 = wi_x0h + tmp1h
                  t_p2 = t_p1 - wi_x0h
                  t_q1 = t_p1
                  t_q2 = (wi_x0h - (t_p1 - t_p2))
     +                     + (tmp1h - t_p2)
                  t_q2 = t_q2 + wi_x0l + tmp1l
                  wi_x0h = t_q1 + t_q2
                  wi_x0l = t_q2 - (wi_x0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              wi_x0 = wi_x0 + tmp1

!                     wr(j_1,l_1) = wr_x0+wr(j_1,l_1)
!                     wi(j_1,l_1) = wi_x0+wi(j_1,l_1)
!<<<              wr(j_1,l_1) = wr_x0 + wr(j_1,l_1)
                  t_p1 = wr_x0h + wrh(j_1,l_1)
                  t_p2 = t_p1 - wr_x0h
                  t_q1 = t_p1
                  t_q2 = (wr_x0h - (t_p1 - t_p2))
     +                     + (wrh(j_1,l_1) - t_p2)
                  t_q2 = t_q2 + wr_x0l + wrl(j_1,l_1)
                  wrh(j_1,l_1) = t_q1 + t_q2
                  wrl(j_1,l_1) = t_q2 - (wrh(j_1,l_1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              wr(j_1,l_1) = wr_x0 + wr(j_1,l_1)
!<<<              wi(j_1,l_1) = wi_x0 + wi(j_1,l_1)
                  t_p1 = wi_x0h + wih(j_1,l_1)
                  t_p2 = t_p1 - wi_x0h
                  t_q1 = t_p1
                  t_q2 = (wi_x0h - (t_p1 - t_p2))
     +                     + (wih(j_1,l_1) - t_p2)
                  t_q2 = t_q2 + wi_x0l + wil(j_1,l_1)
                  wih(j_1,l_1) = t_q1 + t_q2
                  wil(j_1,l_1) = t_q2 - (wih(j_1,l_1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              wi(j_1,l_1) = wi_x0 + wi(j_1,l_1)

                  enddo! j_1
               enddo! i_1
            endif
            d2=mpi_wtime()
            dd(6)=dd(6)+d2-d1

1000        continue
         enddo! k_1

         i_2 = get_loop_start(i_base+1,  size_of_row,my_row)
         i_3 = get_loop_end  (i_base+m0, size_of_row,my_row)
         do i_1=i_2,min(n_,i_3)
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_2 = 1
            j_3 = get_loop_end  (j, size_of_col,my_col)
#ifdef MEMORY1
      nxx = xx_wr(2570,j_3,j-i_base)
      nxx = xx_wi(2580,j_3,j-i_base)
#endif
            do j_1=j_2,j_3
!               ar_(j_1,i_1) = wr(j_1,j-i_base)
!               ai_(j_1,i_1) = wi(j_1,j-i_base)
               ar_h(j_1,i_1) = wrh(j_1,j-i_base)
               ar_l(j_1,i_1) = wrl(j_1,j-i_base)
               ai_h(j_1,i_1) = wih(j_1,j-i_base)
               ai_l(j_1,i_1) = wil(j_1,j-i_base)
            enddo! j_1
         enddo! i_1
         do i_1=max(i_2,n_+1),i_3
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_2 = 1
            j_3 = get_loop_end  (j, size_of_col,my_col)
#ifdef MEMORY1
      nxx = xx_wr(2590,j_3,j-i_base)
      nxx = xx_wi(2600,j_3,j-i_base)
#endif
            do j_1=j_2,j_3
!               ar(j_1,i_1) = wr(j_1,j-i_base)
!               ai(j_1,i_1) = wi(j_1,j-i_base)
               arh(j_1,i_1) = wrh(j_1,j-i_base)
               arl(j_1,i_1) = wrl(j_1,j-i_base)
               aih(j_1,i_1) = wih(j_1,j-i_base)
               ail(j_1,i_1) = wil(j_1,j-i_base)
            enddo! j_1
         enddo! i_1

         if ( diag_0 > 0 ) then
            i_2 = diag_0
            i_3 = get_loop_end  (i_base, size_of_row,my_row)
            i_4 = size_of_col/n_common
            if ( i_2 <= n_ ) then
#ifdef MEMORY1
      nxx = xx_d_t(2610,int((min(i_3,n_)-i_2)/i_4)*i_4+i_2)
#endif
               if ( size_of_row == size_of_col ) then
                  do i_1=i_2,min(i_3,n_),i_4
                     j_1 = i_1
!                     ar_(j_1,i_1) = d_t(i_1)
                     ar_h(j_1,i_1) = d_th(i_1)
                     ar_l(j_1,i_1) = d_tl(i_1)
                  enddo! i_1
               else
                  do i_1=i_2,min(i_3,n_),i_4
                     j   = (i_1-1)*size_of_row+my_row
                     j_1 = (j-1)/size_of_col +1
!                     ar_(j_1,i_1) = d_t(i_1)
                     ar_h(j_1,i_1) = d_th(i_1)
                     ar_l(j_1,i_1) = d_tl(i_1)
                  enddo! i_1
               endif
               i_2=((n_-i_2)/i_4+1)*i_4+i_2
            endif
#ifdef MEMORY1
      nxx = xx_d_t(2620,int((    i_3    -i_2)/i_4)*i_4+i_2)
#endif
            if ( size_of_row == size_of_col ) then
               do i_1=i_2,i_3,i_4
                  j_1 = i_1
!                  ar(j_1,i_1)  = d_t(i_1)
                  arh(j_1,i_1) = d_th(i_1)
                  arl(j_1,i_1) = d_tl(i_1)
               enddo! i_1
            else
               do i_1=i_2,i_3,i_4
                  j   = (i_1-1)*size_of_row+my_row
                  j_1 = (j-1)/size_of_col +1
!                  ar(j_1,i_1)  = d_t(i_1)
                  arh(j_1,i_1) = d_th(i_1)
                  arl(j_1,i_1) = d_tl(i_1)
               enddo! i_1
            endif
         endif

         if ( i_block > 1 ) then
            i_2 = 1
!----       i_3 = get_loop_end  (i_base, size_of_row,my_row)
            i_3 = i_base
            d1=mpi_wtime() 
!$omp parallel
!            call eigen_hrd_2update(
!     &             ar(1,1),ai(1,1),lda,
!     &             ur_x(1,1),ui_x(1,1),
!     &             ur_y(1,1),ui_y(1,1),
!     &             vr_x(1,1),vi_x(1,1),
!     &             vr_y(1,1),vi_y(1,1),   
!     &             nv,m0,i_3,
!     &             ar_(1,1),ai_(1,1),n_,nm_
            call ddeigen_hrd_2update(
     &             arh(1,1),arl(1,1),aih(1,1),ail(1,1),lda,
     &             ur_xh(1,1),ur_xl(1,1),ui_xh(1,1),ui_xl(1,1),
     &             ur_yh(1,1),ur_yl(1,1),ui_yh(1,1),ui_yl(1,1),
     &             vr_xh(1,1),vr_xl(1,1),vi_xh(1,1),vi_xl(1,1),
     &             vr_yh(1,1),vr_yl(1,1),vi_yh(1,1),vi_yl(1,1),
     &             nv,m0,i_3,
     &             ar_h(1,1),ar_l(1,1),ai_h(1,1),ai_l(1,1),n_,nm_
#ifdef MEMORY1
     &            ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &            ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &            ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &            ,xx_vr_y(0,1,1),xx_vi_y(0,1,1)
#endif
     &           )
!$omp end parallel
            d2=mpi_wtime() 
            dd(3)=dd(3)+d2-d1

         endif

      enddo! i_block

      if ( n >= 2 ) then
         i = 2; l = i-1
         y_root = get_owner_node (i, size_of_row,my_row)
         x_root = get_owner_node (l, size_of_col,my_col)
         if ( y_root == my_row .and. x_root == my_col ) then
            i_1 = translate_g2l(i, size_of_row,my_row)
            j_1 = translate_g2l(l, size_of_col,my_col)
            if(i_1<=n_)then
!               ur_t(1) = ar_(j_1,i_1)
!               ur_t(2) = ai_(j_1,i_1)
               ur_th(1) = ar_h(j_1,i_1)
               ur_tl(1) = ar_l(j_1,i_1)
               ur_th(2) = ai_h(j_1,i_1)
               ur_tl(2) = ai_l(j_1,i_1)
            else
!               ur_t(1) = ar(j_1,i_1)
!               ur_t(2) = ai(j_1,i_1)
               ur_th(1) = arh(j_1,i_1)
               ur_tl(1) = arl(j_1,i_1)
               ur_th(2) = aih(j_1,i_1)
               ur_tl(2) = ail(j_1,i_1)
            endif
         endif
#ifdef MEMORY1
      nxx = xx_ur_t(2630,2)
#endif
!         call bcast_dbl(ur_t(1), 2, x_root, mpi_comm_col)
!         call bcast_dbl(ur_t(1), 2, y_root, mpi_comm_row)
         call ddbcast_dbl(ur_th(1), ur_tl(1), 2, x_root, mpi_comm_col)
         call ddbcast_dbl(ur_th(1), ur_tl(1), 2, y_root, mpi_comm_row)
!         scale = abs(ur_t(1)) + abs(ur_t(2))
!<<<     tmp1 = abs(ur_t(1))
         if (ur_th(1) .lt. 0.0d+0) then
           tmp1h = -ur_th(1)
           tmp1l = -ur_tl(1)
         elseif (
     +     (ur_th(1) .eq. 0.0d+0).and.
     +     (ur_tl(1) .lt. 0.0d+0)) then
           tmp1h = ur_th(1)
           tmp1l = -ur_tl(1)
         else
           tmp1h = ur_th(1)
           tmp1l = ur_tl(1)
         endif
!>>>     tmp1 = abs(ur_t(1))
!<<<     tmp2 = abs(ur_t(2))
         if (ur_th(2) .lt. 0.0d+0) then
           tmp2h = -ur_th(2)
           tmp2l = -ur_tl(2)
         elseif (
     +     (ur_th(2) .eq. 0.0d+0).and.
     +     (ur_tl(2) .lt. 0.0d+0)) then
           tmp2h = ur_th(2)
           tmp2l = -ur_tl(2)
         else
           tmp2h = ur_th(2)
           tmp2l = ur_tl(2)
         endif
!>>>     tmp2 = abs(ur_t(2))
!<<<     scale = tmp1 + tmp2
         t_p1 = tmp1h + tmp2h
         t_p2 = t_p1 - tmp1h
         scaleh = t_p1
         scalel = (tmp1h - (t_p1 - t_p2))
     +         + (tmp2h - t_p2)
         scalel = scalel + tmp1l + tmp2l
         t_s1 = scaleh + scalel
         scalel = scalel - (t_s1 - scaleh)
         scaleh = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>     scale = tmp1 + tmp2

!         if ( scale > 0.0d0 ) then
         if (
!             (scale .gt. 0.0)
     +       ((scaleh .gt. 0.0d+0) .or.
     +        ((scaleh .eq. 0.0d+0) .and.
     +         (scalel .gt. 0.0d+0)))
     &   ) then
!            sr = ur_t(1) / scale
!            si = ur_t(2) / scale
!<<<        sr = ur_t(1) / scale
            t_q1 = ur_th(1) / scaleh
            srh = scaleh * t_q1
            t_u1 = 134217729.0 * scaleh
            t_p1 = t_u1
     +               - (t_u1 - scaleh)
            t_p2 = scaleh - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            srl = ((t_p1*t_r1
     +             - srh)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            srl = srl + (scalel*t_q1)
            t_s1 = srh + srl
            srl = srl - (t_s1 - srh)
            srh = t_s1
            t_s1 = ur_th(1) - srh
            t_r1 = t_s1 - ur_th(1)
            t_s2 = (ur_th(1) 
     +               - (t_s1 - t_r1))
     +               - (srh + t_r1)
            t_s2 = t_s2 - srl
            t_s2 = t_s2 + ur_tl(1)
            t_q2 = (t_s1 + t_s2)
     +               / scaleh
            srh = t_q1 + t_q2
            srl = t_q2
     +            - (srh - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        sr = ur_t(1) / scale
!<<<        si = ur_t(2) / scale
            t_q1 = ur_th(2) / scaleh
            sih = scaleh * t_q1
            t_u1 = 134217729.0 * scaleh
            t_p1 = t_u1
     +               - (t_u1 - scaleh)
            t_p2 = scaleh - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            sil = ((t_p1*t_r1
     +             - sih)
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            sil = sil + (scalel*t_q1)
            t_s1 = sih + sil
            sil = sil - (t_s1 - sih)
            sih = t_s1
            t_s1 = ur_th(2) - sih
            t_r1 = t_s1 - ur_th(2)
            t_s2 = (ur_th(2) 
     +               - (t_s1 - t_r1))
     +               - (sih + t_r1)
            t_s2 = t_s2 - sil
            t_s2 = t_s2 + ur_tl(2)
            t_q2 = (t_s1 + t_s2)
     +               / scaleh
            sih = t_q1 + t_q2
            sil = t_q2
     +            - (sih - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        si = ur_t(2) / scale
!            h = sr**2 + si**2
!            g = sqrt(h)
!<<<        tmp1 = sr * sr
            tmp1h = srh * srh
            t_u1 = 134217729.0 * srh
            t_p1 = t_u1
     +               - (t_u1 - srh)
            t_p2 = srh - t_p1
            t_u1 = 134217729.0 * srh
            t_r1 = t_u1
     +               - (t_u1 - srh)
            t_r2 = srh - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (srh*srl
     +            + srl*srh)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = sr * sr
!<<<        tmp2 = si * si
            tmp2h = sih * sih
            t_u1 = 134217729.0 * sih
            t_p1 = t_u1
     +               - (t_u1 - sih)
            t_p2 = sih - t_p1
            t_u1 = 134217729.0 * sih
            t_r1 = t_u1
     +               - (t_u1 - sih)
            t_r2 = sih - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (sih*sil
     +            + sil*sih)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = si * si
!<<<        h = tmp1 + tmp2
            t_p1 = tmp1h + tmp2h
            t_p2 = t_p1 - tmp1h
            hh = t_p1
            hl = (tmp1h - (t_p1 - t_p2))
     +            + (tmp2h - t_p2)
            hl = hl + tmp1l + tmp2l
            t_s1 = hh + hl
            hl = hl - (t_s1 - hh)
            hh = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        h = tmp1 + tmp2
!<<<        g = sqrt(h)
            if (hh.eq.0.0D+0.and.hl.eq.0.0D+0) then
              gh = 0.0d+0
              gl = 0.0d+0
            endif
            if (hh.lt.0.0d+0.or.
     +         (hh.eq.0.0d+0.and.hl.lt.0.0d+0)) then
              write(6,'(a)')
     +           'SQRT CALLED WITH NEGATIVE ARGUMENT'
              gh = 0.0d+0
              gl = 0.0d+0
              return
            endif
            t_x = 1.0D+0/sqrt(hh)
            t_ax = hh * t_x
!               call dd_mul(t_y1,t_y2,t_x,
!                           0.0,0.5,0.0)
                t_y1 = t_x * 0.5d+0
                t_u1 = 134217729.0 * t_x
                t_p1 = t_u1
     +                   - (t_u1 - t_x)
                t_p2 = t_x - t_p1
                t_u1 = 134217729.0 * 0.5d+0
                t_r1 = t_u1
     +                   - (t_u1 - 0.5d+0)
                t_r2 = 0.5d+0 - t_r1
                t_y2 = ((t_p1*t_r1
     +                   - t_y1)
     +                   + t_p1*t_r2
     +                   + t_p2 * t_r1)
     +                   + t_p2 * t_r2
                t_s1 = t_y1 + t_y2
                t_y2 = t_y2
     +                   - (t_s1 - t_y1)
                t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!               call dd_mul(t_z1,t_z2,t_ax,
!                           0.0,t_ax,0.0)
                t_z1 = t_ax * t_ax
                t_u1 = 134217729.0 * t_ax
                t_p1 = t_u1
     +                   - (t_u1 - t_ax)
                t_p2 = t_ax - t_p1
                t_u1 = 134217729.0 * t_ax
                t_r1 = t_u1
     +                   - (t_u1 - t_ax)
                t_r2 = t_ax - t_r1
                t_z2 = ((t_p1 * t_r1
     +                   - t_z1)
     +                   + t_p1 * t_r2
     +                   + t_p2 * t_r1)
     +                   + t_p2*t_r2
                t_s1 = t_z1 + t_z2
                t_z2 = t_z2
     +                   - (t_s1 - t_z1)
                t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!               call dd_sub(t_t2h,t_t2l,
!                           hh,hl,t_z1,t_z2)
                t_p1 = hh - t_z1
                t_p2 = t_p1 - hh
                t_t2l = (hh
     +                   -(t_p1 - t_p2))
     +                   -(t_z1 + t_p2)
                t_t2h = t_p1
                t_t2l = t_t2l
     +                   + hl - t_z2
                t_s1 = t_t2h + t_t2l
                t_t2l = t_t2l
     +                   - (t_s1 - t_t2h)
                t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!               call dd_mul(t_t1h,t_t1l,
!                           t_t2h,t_t2l,
!                           t_y1,t_y2)
                t_t1h = t_t2h * t_y1
                t_u1 = 134217729.0 * t_t2h
                t_p1 = t_u1
     +                   - (t_u1 - t_t2h)
                t_p2 = t_t2h - t_p1
                t_u1 = 134217729.0 * t_y1
                t_r1 = t_u1
     +                   - (t_u1 - t_y1)
                t_r2 = t_y1 - t_r1
                t_t1l = ((t_p1*t_r1
     +                   - t_t1h)
     +                   + t_p1*t_r2
     +                   + t_p2*t_r1)
     +                   + t_p2*t_r2
                t_t1l = t_t1l
     +                   + (t_t2h * t_y2
     +                   +  t_t2l * t_y1)
                t_s1 = t_t1h + t_t1l
                t_t1l = t_t1l - (t_s1
     +                    - t_t1h)
                t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!               call dd_selfadd(t_t1h,t_t1l,
!                           t_ax,0.0)
                t_p1 = t_t1h + t_ax
                t_p2 = t_p1 - t_t1h
                t_q2 = (t_t1h
     +                   - (t_p1 - t_p2))
     +                   + (t_ax - t_p2)
                t_q1 = t_p1
                t_q2 = t_q2 + t_t1l
                t_t1h = t_q1 + t_q2
                t_t1l = t_q2
     +                    - (t_t1h - t_q1)
                gh = t_t1h
                gl = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        g = sqrt(h)
!            tau(l,1) =  (si * tau(i,2) - sr * tau(i,1)) / g
!            tau(l,2) = -(sr * tau(i,2) + si * tau(i,1)) / g
!<<<        tmp1 = si * tau(i,2)
            tmp1h = sih * tauh(i,2)
            t_u1 = 134217729.0 * sih
            t_p1 = t_u1
     +               - (t_u1 - sih)
            t_p2 = sih - t_p1
            t_u1 = 134217729.0 * tauh(i,2)
            t_r1 = t_u1
     +               - (t_u1 - tauh(i,2))
            t_r2 = tauh(i,2) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (sih*taul(i,2)
     +            + sil*tauh(i,2))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = si * tau(i,2)
!<<<        tmp2 = sr * tau(i,1)
            tmp2h = srh * tauh(i,1)
            t_u1 = 134217729.0 * srh
            t_p1 = t_u1
     +               - (t_u1 - srh)
            t_p2 = srh - t_p1
            t_u1 = 134217729.0 * tauh(i,1)
            t_r1 = t_u1
     +               - (t_u1 - tauh(i,1))
            t_r2 = tauh(i,1) - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (srh*taul(i,1)
     +            + srl*tauh(i,1))
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = sr * tau(i,1)
!<<<        tmp1 = tmp1 - tmp2
            t_p1 = tmp1h - tmp2h
            t_p2 = t_p1 - tmp1h
            t_ch = t_p1
            t_cl = (tmp1h - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + tmp1l - tmp2l
            t_s1 = t_ch + t_cl
            tmp1l = t_cl - (t_s1 - t_ch)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        tmp1 = tmp1 - tmp2
!<<<        tau(l,1) = tmp1 / g
            t_q1 = tmp1h / gh
            tauh(l,1) = gh * t_q1
            t_u1 = 134217729.0 * gh
            t_p1 = t_u1
     +               - (t_u1 - gh)
            t_p2 = gh - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            taul(l,1) = ((t_p1*t_r1
     +             - tauh(l,1))
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            taul(l,1) = taul(l,1) + (gl*t_q1)
            t_s1 = tauh(l,1) + taul(l,1)
            taul(l,1) = taul(l,1) - (t_s1 - tauh(l,1))
            tauh(l,1) = t_s1
            t_s1 = tmp1h - tauh(l,1)
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h 
     +               - (t_s1 - t_r1))
     +               - (tauh(l,1) + t_r1)
            t_s2 = t_s2 - taul(l,1)
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / gh
            tauh(l,1) = t_q1 + t_q2
            taul(l,1) = t_q2
     +            - (tauh(l,1) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tau(l,1) = tmp1 / g
!<<<        tmp1 = sr * tau(i,2)
            tmp1h = srh * tauh(i,2)
            t_u1 = 134217729.0 * srh
            t_p1 = t_u1
     +               - (t_u1 - srh)
            t_p2 = srh - t_p1
            t_u1 = 134217729.0 * tauh(i,2)
            t_r1 = t_u1
     +               - (t_u1 - tauh(i,2))
            t_r2 = tauh(i,2) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (srh*taul(i,2)
     +            + srl*tauh(i,2))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = sr * tau(i,2)
!<<<        tmp2 = si * tau(i,1)
            tmp2h = sih * tauh(i,1)
            t_u1 = 134217729.0 * sih
            t_p1 = t_u1
     +               - (t_u1 - sih)
            t_p2 = sih - t_p1
            t_u1 = 134217729.0 * tauh(i,1)
            t_r1 = t_u1
     +               - (t_u1 - tauh(i,1))
            t_r2 = tauh(i,1) - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (sih*taul(i,1)
     +            + sil*tauh(i,1))
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = si * tau(i,1)
!<<<        tmp1 = tmp1 + tmp2
            t_p1 = tmp1h + tmp2h
            t_p2 = t_p1 - tmp1h
            t_q1 = t_p1
            t_q2 = (tmp1h - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + tmp1l + tmp2l
            tmp1h = t_q1 + t_q2
            tmp1l = t_q2 - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        tmp1 = tmp1 + tmp2
!<<<        tau(l,2) = tmp1 / g
            t_q1 = tmp1h / gh
            tauh(l,2) = gh * t_q1
            t_u1 = 134217729.0 * gh
            t_p1 = t_u1
     +               - (t_u1 - gh)
            t_p2 = gh - t_p1
            t_u1 = 134217729.0 * t_q1
            t_r1 = t_u1
     +               - (t_u1 - t_q1)
            t_r2 = t_q1 - t_r1
            taul(l,2) = ((t_p1*t_r1
     +             - tauh(l,2))
     +             + t_p1*t_r2
     +             + t_p2*t_r1)
     +             + t_p2*t_r2
            taul(l,2) = taul(l,2) + (gl*t_q1)
            t_s1 = tauh(l,2) + taul(l,2)
            taul(l,2) = taul(l,2) - (t_s1 - tauh(l,2))
            tauh(l,2) = t_s1
            t_s1 = tmp1h - tauh(l,2)
            t_r1 = t_s1 - tmp1h
            t_s2 = (tmp1h 
     +               - (t_s1 - t_r1))
     +               - (tauh(l,2) + t_r1)
            t_s2 = t_s2 - taul(l,2)
            t_s2 = t_s2 + tmp1l
            t_q2 = (t_s1 + t_s2)
     +               / gh
            tauh(l,2) = t_q1 + t_q2
            taul(l,2) = t_q2
     +            - (tauh(l,2) - t_q1)
#ifdef FPCOUNTER
#include "fdiv.h"
#endif
!>>>        tau(l,2) = tmp1 / g
!<<<        tau(l,2) = -tau(l,2)
            tauh(l,2) = -tauh(l,2)
            taul(l,2) = -taul(l,2)
!>>>        tau(l,2) = -tau(l,2)
            y_root = get_owner_node (i, size_of_row,my_row)
            x_root = get_owner_node (l, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(i, size_of_row,my_row)
               j_1 = translate_g2l(l, size_of_col,my_col)
!               e_out(i)  = scale * g
!               e2_out(i) = scale * scale * h
!<<<           e_out(i) = scale * g
               e_outh(i) = scaleh * gh
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * gh
               t_r1 = t_u1
     +                  - (t_u1 - gh)
               t_r2 = gh - t_r1
               e_outl(i) = ((t_p1*t_r1
     +                 - e_outh(i))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               e_outl(i) = e_outl(i)
     +               + (scaleh*gl
     +               + scalel*gh)
               t_s1 = e_outh(i) + e_outl(i)
               e_outl(i) = e_outl(i) - (t_s1 - e_outh(i))
               e_outh(i) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           e_out(i) = scale * g
!<<<           tmp1 = scale * scale
               tmp1h = scaleh * scaleh
               t_u1 = 134217729.0 * scaleh
               t_p1 = t_u1
     +                  - (t_u1 - scaleh)
               t_p2 = scaleh - t_p1
               t_u1 = 134217729.0 * scaleh
               t_r1 = t_u1
     +                  - (t_u1 - scaleh)
               t_r2 = scaleh - t_r1
               tmp1l = ((t_p1*t_r1
     +                 - tmp1h)
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               tmp1l = tmp1l
     +               + (scaleh*scalel
     +               + scalel*scaleh)
               t_s1 = tmp1h + tmp1l
               tmp1l = tmp1l - (t_s1 - tmp1h)
               tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           tmp1 = scale * scale
!<<<           e2_out(i) = tmp1 * h
               e2_outh(i) = tmp1h * hh
               t_u1 = 134217729.0 * tmp1h
               t_p1 = t_u1
     +                  - (t_u1 - tmp1h)
               t_p2 = tmp1h - t_p1
               t_u1 = 134217729.0 * hh
               t_r1 = t_u1
     +                  - (t_u1 - hh)
               t_r2 = hh - t_r1
               e2_outl(i) = ((t_p1*t_r1
     +                 - e2_outh(i))
     +                 + t_p1 * t_r2
     +                 + t_p2 * t_r1)
     +                 + t_p2 * t_r2
               e2_outl(i) = e2_outl(i)
     +               + (tmp1h*hl
     +               + tmp1l*hh)
               t_s1 = e2_outh(i) + e2_outl(i)
               e2_outl(i) = e2_outl(i) - (t_s1 - e2_outh(i))
               e2_outh(i) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>           e2_out(i) = tmp1 * h
               if ( i_1 <= n_ ) then
!                  ar_(j_1,i_1) = scale * 2 * sr
!                  ai_(j_1,i_1) = scale * 2 * si
!<<<              tmp1 = scale * ttwo
                  tmp1h = scaleh * ttwoh
                  t_u1 = 134217729.0 * scaleh
                  t_p1 = t_u1
     +                     - (t_u1 - scaleh)
                  t_p2 = scaleh - t_p1
                  t_u1 = 134217729.0 * ttwoh
                  t_r1 = t_u1
     +                     - (t_u1 - ttwoh)
                  t_r2 = ttwoh - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (scaleh*ttwol
     +                  + scalel*ttwoh)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = scale * ttwo
!<<<              ar_(j_1,i_1) = tmp1 * sr
                  ar_h(j_1,i_1) = tmp1h * srh
                  t_u1 = 134217729.0 * tmp1h
                  t_p1 = t_u1
     +                     - (t_u1 - tmp1h)
                  t_p2 = tmp1h - t_p1
                  t_u1 = 134217729.0 * srh
                  t_r1 = t_u1
     +                     - (t_u1 - srh)
                  t_r2 = srh - t_r1
                  ar_l(j_1,i_1) = ((t_p1*t_r1
     +                    - ar_h(j_1,i_1))
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  ar_l(j_1,i_1) = ar_l(j_1,i_1)
     +                  + (tmp1h*srl
     +                  + tmp1l*srh)
                  t_s1 = ar_h(j_1,i_1) + ar_l(j_1,i_1)
                  ar_l(j_1,i_1) = ar_l(j_1,i_1) - (t_s1 - ar_h(j_1,i_1))
                  ar_h(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              ar_(j_1,i_1) = tmp1 * sr
!<<<              tmp1 = scale * ttwo
                  tmp1h = scaleh * ttwoh
                  t_u1 = 134217729.0 * scaleh
                  t_p1 = t_u1
     +                     - (t_u1 - scaleh)
                  t_p2 = scaleh - t_p1
                  t_u1 = 134217729.0 * ttwoh
                  t_r1 = t_u1
     +                     - (t_u1 - ttwoh)
                  t_r2 = ttwoh - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (scaleh*ttwol
     +                  + scalel*ttwoh)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = scale * ttwo
!<<<              ai_(j_1,i_1) = tmp1 * si
                  ai_h(j_1,i_1) = tmp1h * sih
                  t_u1 = 134217729.0 * tmp1h
                  t_p1 = t_u1
     +                     - (t_u1 - tmp1h)
                  t_p2 = tmp1h - t_p1
                  t_u1 = 134217729.0 * sih
                  t_r1 = t_u1
     +                     - (t_u1 - sih)
                  t_r2 = sih - t_r1
                  ai_l(j_1,i_1) = ((t_p1*t_r1
     +                    - ai_h(j_1,i_1))
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  ai_l(j_1,i_1) = ai_l(j_1,i_1)
     +                  + (tmp1h*sil
     +                  + tmp1l*sih)
                  t_s1 = ai_h(j_1,i_1) + ai_l(j_1,i_1)
                  ai_l(j_1,i_1) = ai_l(j_1,i_1) - (t_s1 - ai_h(j_1,i_1))
                  ai_h(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              ai_(j_1,i_1) = tmp1 * si
               else
!                  ar(j_1,i_1)  = scale * 2 * sr
!                  ai(j_1,i_1)  = scale * 2 * si
!<<<              tmp1 = scale * ttwo
                  tmp1h = scaleh * ttwoh
                  t_u1 = 134217729.0 * scaleh
                  t_p1 = t_u1
     +                     - (t_u1 - scaleh)
                  t_p2 = scaleh - t_p1
                  t_u1 = 134217729.0 * ttwoh
                  t_r1 = t_u1
     +                     - (t_u1 - ttwoh)
                  t_r2 = ttwoh - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (scaleh*ttwol
     +                  + scalel*ttwoh)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = scale * ttwo
!<<<              ar(j_1,i_1) = tmp1 * sr
                  arh(j_1,i_1) = tmp1h * srh
                  t_u1 = 134217729.0 * tmp1h
                  t_p1 = t_u1
     +                     - (t_u1 - tmp1h)
                  t_p2 = tmp1h - t_p1
                  t_u1 = 134217729.0 * srh
                  t_r1 = t_u1
     +                     - (t_u1 - srh)
                  t_r2 = srh - t_r1
                  arl(j_1,i_1) = ((t_p1*t_r1
     +                    - arh(j_1,i_1))
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  arl(j_1,i_1) = arl(j_1,i_1)
     +                  + (tmp1h*srl
     +                  + tmp1l*srh)
                  t_s1 = arh(j_1,i_1) + arl(j_1,i_1)
                  arl(j_1,i_1) = arl(j_1,i_1) - (t_s1 - arh(j_1,i_1))
                  arh(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              ar(j_1,i_1) = tmp1 * sr
!<<<              tmp1 = scale * ttwo
                  tmp1h = scaleh * ttwoh
                  t_u1 = 134217729.0 * scaleh
                  t_p1 = t_u1
     +                     - (t_u1 - scaleh)
                  t_p2 = scaleh - t_p1
                  t_u1 = 134217729.0 * ttwoh
                  t_r1 = t_u1
     +                     - (t_u1 - ttwoh)
                  t_r2 = ttwoh - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (scaleh*ttwol
     +                  + scalel*ttwoh)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = scale * ttwo
!<<<              ai(j_1,i_1) = tmp1 * si
                  aih(j_1,i_1) = tmp1h * sih
                  t_u1 = 134217729.0 * tmp1h
                  t_p1 = t_u1
     +                     - (t_u1 - tmp1h)
                  t_p2 = tmp1h - t_p1
                  t_u1 = 134217729.0 * sih
                  t_r1 = t_u1
     +                     - (t_u1 - sih)
                  t_r2 = sih - t_r1
                  ail(j_1,i_1) = ((t_p1*t_r1
     +                    - aih(j_1,i_1))
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  ail(j_1,i_1) = ail(j_1,i_1)
     +                  + (tmp1h*sil
     +                  + tmp1l*sih)
                  t_s1 = aih(j_1,i_1) + ail(j_1,i_1)
                  ail(j_1,i_1) = ail(j_1,i_1) - (t_s1 - aih(j_1,i_1))
                  aih(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              ai(j_1,i_1) = tmp1 * si
               endif
            endif
            y_root = get_owner_node (i, size_of_row,my_row)
            x_root = get_owner_node (i, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(i, size_of_row,my_row)
               j_1 = translate_g2l(i, size_of_col,my_col)
               if ( i_1 <= n_ ) then
!                  ai_(j_1,i_1) = scale * sqrt(2*h)
!<<<              tmp1 = ttwo * h
                  tmp1h = ttwoh * hh
                  t_u1 = 134217729.0 * ttwoh
                  t_p1 = t_u1
     +                     - (t_u1 - ttwoh)
                  t_p2 = ttwoh - t_p1
                  t_u1 = 134217729.0 * hh
                  t_r1 = t_u1
     +                     - (t_u1 - hh)
                  t_r2 = hh - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (ttwoh*hl
     +                  + ttwol*hh)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = ttwo * h
!<<<              tmp1 = sqrt(tmp1)
                  if (tmp1h.eq.0.0D+0.and.tmp1l.eq.0.0D+0) then
                    tmp1h = 0.0d+0
                    tmp1l = 0.0d+0
                  endif
                  if (tmp1h.lt.0.0d+0.or.
     +               (tmp1h.eq.0.0d+0.and.tmp1l.lt.0.0d+0)) then
                    write(6,'(a)')
     +                 'SQRT CALLED WITH NEGATIVE ARGUMENT'
                    tmp1h = 0.0d+0
                    tmp1l = 0.0d+0
                    return
                  endif
                  t_x = 1.0D+0/sqrt(tmp1h)
                  t_ax = tmp1h * t_x
!                     call dd_mul(t_y1,t_y2,t_x,
!                                 0.0,0.5,0.0)
                      t_y1 = t_x * 0.5d+0
                      t_u1 = 134217729.0 * t_x
                      t_p1 = t_u1
     +                         - (t_u1 - t_x)
                      t_p2 = t_x - t_p1
                      t_u1 = 134217729.0 * 0.5d+0
                      t_r1 = t_u1
     +                         - (t_u1 - 0.5d+0)
                      t_r2 = 0.5d+0 - t_r1
                      t_y2 = ((t_p1*t_r1
     +                         - t_y1)
     +                         + t_p1*t_r2
     +                         + t_p2 * t_r1)
     +                         + t_p2 * t_r2
                      t_s1 = t_y1 + t_y2
                      t_y2 = t_y2
     +                         - (t_s1 - t_y1)
                      t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                     call dd_mul(t_z1,t_z2,t_ax,
!                                 0.0,t_ax,0.0)
                      t_z1 = t_ax * t_ax
                      t_u1 = 134217729.0 * t_ax
                      t_p1 = t_u1
     +                         - (t_u1 - t_ax)
                      t_p2 = t_ax - t_p1
                      t_u1 = 134217729.0 * t_ax
                      t_r1 = t_u1
     +                         - (t_u1 - t_ax)
                      t_r2 = t_ax - t_r1
                      t_z2 = ((t_p1 * t_r1
     +                         - t_z1)
     +                         + t_p1 * t_r2
     +                         + t_p2 * t_r1)
     +                         + t_p2*t_r2
                      t_s1 = t_z1 + t_z2
                      t_z2 = t_z2
     +                         - (t_s1 - t_z1)
                      t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                     call dd_sub(t_t2h,t_t2l,
!                           tmp1h,tmp1l,t_z1,t_z2)
                      t_p1 = tmp1h - t_z1
                      t_p2 = t_p1 - tmp1h
                      t_t2l = (tmp1h
     +                         -(t_p1 - t_p2))
     +                         -(t_z1 + t_p2)
                      t_t2h = t_p1
                      t_t2l = t_t2l
     +                         + tmp1l - t_z2
                      t_s1 = t_t2h + t_t2l
                      t_t2l = t_t2l
     +                         - (t_s1 - t_t2h)
                      t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                     call dd_mul(t_t1h,t_t1l,
!                                 t_t2h,t_t2l,
!                                 t_y1,t_y2)
                      t_t1h = t_t2h * t_y1
                      t_u1 = 134217729.0 * t_t2h
                      t_p1 = t_u1
     +                         - (t_u1 - t_t2h)
                      t_p2 = t_t2h - t_p1
                      t_u1 = 134217729.0 * t_y1
                      t_r1 = t_u1
     +                         - (t_u1 - t_y1)
                      t_r2 = t_y1 - t_r1
                      t_t1l = ((t_p1*t_r1
     +                         - t_t1h)
     +                         + t_p1*t_r2
     +                         + t_p2*t_r1)
     +                         + t_p2*t_r2
                      t_t1l = t_t1l
     +                         + (t_t2h * t_y2
     +                         +  t_t2l * t_y1)
                      t_s1 = t_t1h + t_t1l
                      t_t1l = t_t1l - (t_s1
     +                          - t_t1h)
                      t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                     call dd_selfadd(t_t1h,t_t1l,
!                                 t_ax,0.0)
                      t_p1 = t_t1h + t_ax
                      t_p2 = t_p1 - t_t1h
                      t_q2 = (t_t1h
     +                         - (t_p1 - t_p2))
     +                         + (t_ax - t_p2)
                      t_q1 = t_p1
                      t_q2 = t_q2 + t_t1l
                      t_t1h = t_q1 + t_q2
                      t_t1l = t_q2
     +                          - (t_t1h - t_q1)
                      tmp1h = t_t1h
                      tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              tmp1 = sqrt(tmp1)
!<<<              ai_(j_1,i_1) = scale * tmp1
                  ai_h(j_1,i_1) = scaleh * tmp1h
                  t_u1 = 134217729.0 * scaleh
                  t_p1 = t_u1
     +                     - (t_u1 - scaleh)
                  t_p2 = scaleh - t_p1
                  t_u1 = 134217729.0 * tmp1h
                  t_r1 = t_u1
     +                     - (t_u1 - tmp1h)
                  t_r2 = tmp1h - t_r1
                  ai_l(j_1,i_1) = ((t_p1*t_r1
     +                    - ai_h(j_1,i_1))
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  ai_l(j_1,i_1) = ai_l(j_1,i_1)
     +                  + (scaleh*tmp1l
     +                  + scalel*tmp1h)
                  t_s1 = ai_h(j_1,i_1) + ai_l(j_1,i_1)
                  ai_l(j_1,i_1) = ai_l(j_1,i_1) - (t_s1 - ai_h(j_1,i_1))
                  ai_h(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              ai_(j_1,i_1) = scale * tmp1
               else
!                  ai(j_1,i_1)  = scale * sqrt(2*h)
!<<<              tmp1 = ttwo * h
                  tmp1h = ttwoh * hh
                  t_u1 = 134217729.0 * ttwoh
                  t_p1 = t_u1
     +                     - (t_u1 - ttwoh)
                  t_p2 = ttwoh - t_p1
                  t_u1 = 134217729.0 * hh
                  t_r1 = t_u1
     +                     - (t_u1 - hh)
                  t_r2 = hh - t_r1
                  tmp1l = ((t_p1*t_r1
     +                    - tmp1h)
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  tmp1l = tmp1l
     +                  + (ttwoh*hl
     +                  + ttwol*hh)
                  t_s1 = tmp1h + tmp1l
                  tmp1l = tmp1l - (t_s1 - tmp1h)
                  tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              tmp1 = ttwo * h
!<<<              tmp1 = sqrt(tmp1)
                  if (tmp1h.eq.0.0D+0.and.tmp1l.eq.0.0D+0) then
                    tmp1h = 0.0d+0
                    tmp1l = 0.0d+0
                  endif
                  if (tmp1h.lt.0.0d+0.or.
     +               (tmp1h.eq.0.0d+0.and.tmp1l.lt.0.0d+0)) then
                    write(6,'(a)')
     +                 'SQRT CALLED WITH NEGATIVE ARGUMENT'
                    tmp1h = 0.0d+0
                    tmp1l = 0.0d+0
                    return
                  endif
                  t_x = 1.0D+0/sqrt(tmp1h)
                  t_ax = tmp1h * t_x
!                     call dd_mul(t_y1,t_y2,t_x,
!                                 0.0,0.5,0.0)
                      t_y1 = t_x * 0.5d+0
                      t_u1 = 134217729.0 * t_x
                      t_p1 = t_u1
     +                         - (t_u1 - t_x)
                      t_p2 = t_x - t_p1
                      t_u1 = 134217729.0 * 0.5d+0
                      t_r1 = t_u1
     +                         - (t_u1 - 0.5d+0)
                      t_r2 = 0.5d+0 - t_r1
                      t_y2 = ((t_p1*t_r1
     +                         - t_y1)
     +                         + t_p1*t_r2
     +                         + t_p2 * t_r1)
     +                         + t_p2 * t_r2
                      t_s1 = t_y1 + t_y2
                      t_y2 = t_y2
     +                         - (t_s1 - t_y1)
                      t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                     call dd_mul(t_z1,t_z2,t_ax,
!                                 0.0,t_ax,0.0)
                      t_z1 = t_ax * t_ax
                      t_u1 = 134217729.0 * t_ax
                      t_p1 = t_u1
     +                         - (t_u1 - t_ax)
                      t_p2 = t_ax - t_p1
                      t_u1 = 134217729.0 * t_ax
                      t_r1 = t_u1
     +                         - (t_u1 - t_ax)
                      t_r2 = t_ax - t_r1
                      t_z2 = ((t_p1 * t_r1
     +                         - t_z1)
     +                         + t_p1 * t_r2
     +                         + t_p2 * t_r1)
     +                         + t_p2*t_r2
                      t_s1 = t_z1 + t_z2
                      t_z2 = t_z2
     +                         - (t_s1 - t_z1)
                      t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                     call dd_sub(t_t2h,t_t2l,
!                           tmp1h,tmp1l,t_z1,t_z2)
                      t_p1 = tmp1h - t_z1
                      t_p2 = t_p1 - tmp1h
                      t_t2l = (tmp1h
     +                         -(t_p1 - t_p2))
     +                         -(t_z1 + t_p2)
                      t_t2h = t_p1
                      t_t2l = t_t2l
     +                         + tmp1l - t_z2
                      t_s1 = t_t2h + t_t2l
                      t_t2l = t_t2l
     +                         - (t_s1 - t_t2h)
                      t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                     call dd_mul(t_t1h,t_t1l,
!                                 t_t2h,t_t2l,
!                                 t_y1,t_y2)
                      t_t1h = t_t2h * t_y1
                      t_u1 = 134217729.0 * t_t2h
                      t_p1 = t_u1
     +                         - (t_u1 - t_t2h)
                      t_p2 = t_t2h - t_p1
                      t_u1 = 134217729.0 * t_y1
                      t_r1 = t_u1
     +                         - (t_u1 - t_y1)
                      t_r2 = t_y1 - t_r1
                      t_t1l = ((t_p1*t_r1
     +                         - t_t1h)
     +                         + t_p1*t_r2
     +                         + t_p2*t_r1)
     +                         + t_p2*t_r2
                      t_t1l = t_t1l
     +                         + (t_t2h * t_y2
     +                         +  t_t2l * t_y1)
                      t_s1 = t_t1h + t_t1l
                      t_t1l = t_t1l - (t_s1
     +                          - t_t1h)
                      t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                     call dd_selfadd(t_t1h,t_t1l,
!                                 t_ax,0.0)
                      t_p1 = t_t1h + t_ax
                      t_p2 = t_p1 - t_t1h
                      t_q2 = (t_t1h
     +                         - (t_p1 - t_p2))
     +                         + (t_ax - t_p2)
                      t_q1 = t_p1
                      t_q2 = t_q2 + t_t1l
                      t_t1h = t_q1 + t_q2
                      t_t1l = t_q2
     +                          - (t_t1h - t_q1)
                      tmp1h = t_t1h
                      tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>              tmp1 = sqrt(tmp1)
!<<<              ai(j_1,i_1) = scale * tmp1
                  aih(j_1,i_1) = scaleh * tmp1h
                  t_u1 = 134217729.0 * scaleh
                  t_p1 = t_u1
     +                     - (t_u1 - scaleh)
                  t_p2 = scaleh - t_p1
                  t_u1 = 134217729.0 * tmp1h
                  t_r1 = t_u1
     +                     - (t_u1 - tmp1h)
                  t_r2 = tmp1h - t_r1
                  ail(j_1,i_1) = ((t_p1*t_r1
     +                    - aih(j_1,i_1))
     +                    + t_p1 * t_r2
     +                    + t_p2 * t_r1)
     +                    + t_p2 * t_r2
                  ail(j_1,i_1) = ail(j_1,i_1)
     +                  + (scaleh*tmp1l
     +                  + scalel*tmp1h)
                  t_s1 = aih(j_1,i_1) + ail(j_1,i_1)
                  ail(j_1,i_1) = ail(j_1,i_1) - (t_s1 - aih(j_1,i_1))
                  aih(j_1,i_1) = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>              ai(j_1,i_1) = scale * tmp1
               endif
            endif
            y_root = get_owner_node (l, size_of_row,my_row)
            x_root = get_owner_node (l, size_of_col,my_col)
            if ( y_root == my_row .and. x_root == my_col ) then
               i_1 = translate_g2l(l, size_of_row,my_row)
               j_1 = translate_g2l(l, size_of_col,my_col)
               if ( i_1 <= n_ ) then
!                  ai_(j_1,i_1) = 0.0d0
                  ai_h(j_1,i_1) = 0.0d+0
                  ai_l(j_1,i_1) = 0.0d+0
               else
!                  ai(j_1,i_1)  = 0.0d0
                  aih(j_1,i_1) = 0.0d+0
                  ail(j_1,i_1) = 0.0d+0
               endif
            endif
         endif
      endif

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = get_loop_end  (n, size_of_row,my_row)
         i_4 = size_of_col/n_common
         if ( i_2 <= n_ ) then
         do i_1=i_2,min(i_3,n_),i_4
            j   = (i_1-1)*size_of_row+my_row
            j_1 = (j-1)/size_of_col +1
!            t1           = d_out(j)
!            d_out(j)     = ar_(j_1,i_1)
!            ar_(j_1,i_1) = t1
            t1h = d_outh(j)
            t1l = d_outl(j)
            d_outh(j) = ar_h(j_1,i_1)
            d_outl(j) = ar_l(j_1,i_1)
            ar_h(j_1,i_1) = t1h
            ar_l(j_1,i_1) = t1l
         enddo! i_1
         i_2=((n_-i_2)/i_4+1)*i_4+i_2
         endif
         do i_1=i_2,i_3,i_4
            j   = (i_1-1)*size_of_row+my_row
            j_1 = (j-1)/size_of_col +1
!            t1           = d_out(j)
!            d_out(j)     = ar(j_1,i_1)
!            ar(j_1,i_1)  = t1
            t1h = d_outh(j)
            t1l = d_outl(j)
            d_outh(j) = arh(j_1,i_1)
            d_outl(j) = arl(j_1,i_1)
            arh(j_1,i_1) = t1h
            arl(j_1,i_1) = t1l
         enddo! i_1
      endif

#ifdef MEMORY1
      nxx = xx_ur_t(2640,n)
#endif
!      call reduce_dbl(d_out(1), ur_t(1), n, mpi_comm_world)
!      call reduce_dbl(e_out(1), ur_t(1), n, mpi_comm_world)
!      call reduce_dbl(e2_out(1),ur_t(1), n, mpi_comm_world)
      call ddreduce_dbl(d_outh(1), d_outl(1), ur_th(1), ur_tl(1), n,
     &                  mpi_comm_world)
      call ddreduce_dbl(e_outh(1), e_outl(1), ur_th(1), ur_tl(1), n,
     &                  mpi_comm_world)
      call ddreduce_dbl(e2_outh(1), e2_outl(1), ur_th(1), ur_tl(1), n,
     &                  mpi_comm_world)

!$omp parallel
!      call eigen_hrd_Au(
!     &       ar,ai,lda,
!     &       ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
!     &       ur_t,ui_t, vr_t,vi_t, d_t,
!     &       -2, x_pos,y_pos, nv,k_1-k_2,
!     &       ar_,ai_,n_,nm_
      call ddeigen_hrd_Au(
     &       arh,arl,aih,ail,lda,
     &       ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &       vr_xh,vr_xl,vi_xh,vi_xl,
     &       ur_th,ur_tl,ui_th,ui_tl,vr_th,vr_tl,vi_th,vi_tl,d_th,d_tl,
     &       -2, x_pos,y_pos, nv,k_1-k_2,
     &       ar_h,ar_l,ai_h,ai_l,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_ur_t(0,1)  ,xx_ui_t(0,1)
     &      ,xx_vr_t(0,1)  ,xx_vi_t(0,1)
!-------
     &      ,xx_d_t (0,1)
!-------
#endif
     &     )
!      call eigen_hrd_2update(
!     &       ar,ai,lda,
!     &       ur_x,ui_x,ur_y,ui_y,
!     &       vr_x,vi_x,vr_y,vi_y,   
!     &       nv,m0,-2,
!     &       ar_,ai_,n_,nm_
      call ddeigen_hrd_2update(
     &       arh,arl,aih,ail,lda,
     &       ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &       vr_xh,vr_xl,vi_xh,vi_xl,vr_yh,vr_yl,vi_yh,vi_yl,
     &       nv,m0,-2,
     &       ar_h,ar_l,ai_h,ai_l,n_,nm_
#ifdef MEMORY1
     &      ,xx_ur_x(0,1,1),xx_ui_x(0,1,1)
     &      ,xx_ur_y(0,1,1),xx_ui_y(0,1,1)
     &      ,xx_vr_x(0,1,1),xx_vi_x(0,1,1)
     &      ,xx_vr_y(0,1,1),xx_vi_y(0,1,1)
#endif
     &     )
!$omp end parallel

!----
#ifdef DETAIL
      if(myrank==1)then
         print*," "
         print*,"detail of exectime in 'eigen_hrd'"
         print*,"   calc (u,beta)    ",dd(1),"(sec)"
         print*,"   mat-vec (au)     ",dd(2),"(sec)"
         print*,"   2update (a-uv-vu)",dd(3),"(sec)"
!----    print*,"   mat-vec (au)     ",dd(2),(dble(n)**3*8d-9/3)/dd(2)
!----    print*,"   2update (a-uv-vu)",dd(3),(dble(n)**3*8d-9/3)/dd(3)
         print*,"   calc v           ",dd(4),"(sec)"
         print*,"   v=v-(uv+vu)u     ",dd(5),"(sec)"
         print*,"   uv post reduction",dd(6),"(sec)"
      endif
#endif
!----
      m = m_orig

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1,i2
      xx_ur_x = nxx_ur_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_main2:ur_x")
      end function

      function xx_ui_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1,i2
      xx_ui_x = nxx_ui_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_main2:ui_x")
      end function

      function xx_vr_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1,i2
      xx_vr_x = nxx_vr_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_main2:vr_x")
      end function

      function xx_vi_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1,i2
      xx_vi_x = nxx_vi_x + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_main2:vi_x")
      end function

      function xx_ur_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1,i2
      xx_ur_y = nxx_ur_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_main2:ur_y")
      end function

      function xx_ui_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1,i2
      xx_ui_y = nxx_ui_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_main2:ui_y")
      end function

      function xx_vr_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_y
      integer :: i0,i1,i2
      xx_vr_y = nxx_vr_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vr_y,kxx_vr_y,"ddeigen_hrd_main2:vr_y")
      end function

      function xx_vi_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_y
      integer :: i0,i1,i2
      xx_vi_y = nxx_vi_y + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_vi_y,kxx_vi_y,"ddeigen_hrd_main2:vi_y")
      end function

      function xx_wr(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_wr
      integer :: i0,i1,i2
      xx_wr = nxx_wr + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_wr,kxx_wr,"ddeigen_hrd_main2:wr_x")
      end function

      function xx_wi(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_wi
      integer :: i0,i1,i2
      xx_wi = nxx_wi + i1 - 1 + (i2 - 1)*nv
      call accessor(i0,xx_wi,kxx_wi,"ddeigen_hrd_main2:wi_x")
      end function

      function xx_ur_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_t
      integer :: i0,i1
      xx_ur_t = nxx_ur_t + i1 - 1
      call accessor(i0,xx_ur_t,kxx_ur_t,"ddeigen_hrd_main2:ur_t")
      end function

      function xx_ui_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_t
      integer :: i0,i1
      xx_ui_t = nxx_ui_t + i1 - 1
      call accessor(i0,xx_ui_t,kxx_ui_t,"ddeigen_hrd_main2:ui_t")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_main2:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_main2:vi_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_main2:d_t")
      end function
#endif
      end
