!      subroutine  eigen_hrd_Au(
!     &              ar, ai, nm,
!     &              ur_x, ui_x,
!     &              ur_y, ui_y,
!     &              vr_x, vi_x,
!     &              ur_t, ui_t, vr_t, vi_t,
!     &              d_t,
!     &              n, x_pos,y_pos, nv,blk_0,
!     &              ar_,ai_,n_,nm_
      subroutine  ddeigen_hrd_Au(
     &              arh, arl, aih, ail, nm,
     &              ur_xh, ur_xl, ui_xh, ui_xl,
     &              ur_yh, ur_yl, ui_yh, ui_yl,
     &              vr_xh, vr_xl, vi_xh, vi_xl,
     &              ur_th, ur_tl, ui_th, ui_tl,
     &              vr_th, vr_tl, vi_th, vi_tl,
     &              d_th, d_tl,
     &              n, x_pos,y_pos, nv,blk_0,
     &              ar_h, ar_l, ai_h, ai_l, n_, nm_
#ifdef MEMORY1
     &             ,nxx_ur_x, nxx_ui_x
     &             ,nxx_ur_y, nxx_ui_y
     &             ,nxx_vr_x, nxx_vi_x
     &             ,nxx_ur_t, nxx_ui_t, nxx_vr_t, nxx_vi_t
     &             ,nxx_d_t
#endif
     &            )
!----
!      use communication_h, only : send_dbl
!     &               , recv_dbl
!     &               , reduce_dbl
      use ddcommunication_h, only : ddsend_dbl
     &                            , ddrecv_dbl
     &                            , ddreduce_dbl
!----
      implicit none

      integer, intent(in)    :: nm, nv, n
!      real(8), intent(inout) :: ar(1:nm,*), ai(1:nm,*)
!      real(8), intent(inout) :: ur_x(1:nv), ui_x(1:nv)
!      real(8), intent(inout) :: ur_y(1:nv), ui_y(1:nv)
!      real(8), intent(inout) :: vr_x(1:nv), vi_x(1:nv)
!      real(8), intent(inout) :: vr_t(1:nv), vi_t(1:nv)
!      real(8), intent(inout) :: ur_t(1:nv), ui_t(1:nv)
!      real(8), intent(in)    :: d_t(1:nv)
      real(8), intent(inout) :: arh(1:nm,*), aih(1:nm,*)
      real(8), intent(inout) :: arl(1:nm,*), ail(1:nm,*)
      real(8), intent(inout) :: ur_xh(1:nv), ui_xh(1:nv)
      real(8), intent(inout) :: ur_xl(1:nv), ui_xl(1:nv)
      real(8), intent(inout) :: ur_yh(1:nv), ui_yh(1:nv)
      real(8), intent(inout) :: ur_yl(1:nv), ui_yl(1:nv)
      real(8), intent(inout) :: vr_xh(1:nv), vi_xh(1:nv)
      real(8), intent(inout) :: vr_xl(1:nv), vi_xl(1:nv)
      real(8), intent(inout) :: vr_th(1:nv), vi_th(1:nv)
      real(8), intent(inout) :: vr_tl(1:nv), vi_tl(1:nv)
      real(8), intent(inout) :: ur_th(1:nv), ui_th(1:nv)
      real(8), intent(inout) :: ur_tl(1:nv), ui_tl(1:nv)
      real(8), intent(in)    :: d_th(1:nv), d_tl(1:nv)
      integer, intent(in)    :: blk_0
      integer, intent(in)    :: n_,nm_
!      real(8), intent(inout) :: ar_(1:nm_,*), ai_(1:nm_,*)
      real(8), intent(inout) :: ar_h(1:nm_,*), ai_h(1:nm_,*)
      real(8), intent(inout) :: ar_l(1:nm_,*), ai_l(1:nm_,*)
      integer                :: x_pos, y_pos
      integer                :: local_size, local_rank
!      real(8), pointer       :: ur_z(:),ui_z(:),vr_z(:),vi_z(:)
      real(8), pointer,save   :: ur_zh(:),ur_zl(:),ui_zh(:),ui_zl(:),
     &                          vr_zh(:),vr_zl(:),vi_zh(:),vi_zl(:)
!      save                   :: ur_z,   ui_z,   vr_z   ,vi_z

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_ur_t
      integer,intent(in) :: nxx_ui_t
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      if ( n == -1 ) then
         if ( local_rank == 0 ) then
!            allocate(ur_z(nv*local_size), ui_z(nv*local_size),
!     &               vr_z(nv*local_size), vi_z(nv*local_size))
            allocate(ur_zh(nv*local_size), ur_zl(nv*local_size),
     &               ui_zh(nv*local_size), ui_zl(nv*local_size),
     &               vr_zh(nv*local_size), vr_zl(nv*local_size),
     &               vi_zh(nv*local_size), vi_zl(nv*local_size))
         end if
         return
      end if
      if ( n <  -1 ) then
         if ( local_rank == 0 ) then
!            deallocate(ur_z, ui_z, vr_z, vi_z)
            deallocate(
     &          ur_zh, ur_zl, ui_zh, ui_zl, vr_zh, vr_zl, vi_zh, vi_zl)
         end if
         return
      end if

!      call eigen_hrd_Au_step1(
!     &       ar,ai, nm,
!     &       ur_x,ui_x, ur_y,ui_y,
!     &       ur_z(1+nv*local_rank),
!     &       ui_z(1+nv*local_rank),
!     &       vr_z(1+nv*local_rank),
!     &       vi_z(1+nv*local_rank),
!     &       1,n,x_pos,y_pos,nv,blk_0,
!     &       local_rank, local_size
      call ddeigen_hrd_Au_step1(
     &       arh,arl,aih,ail, nm,
     &       ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &       ur_zh(1+nv*local_rank), ur_zl(1+nv*local_rank),
     &       ui_zh(1+nv*local_rank), ui_zl(1+nv*local_rank),
     &       vr_zh(1+nv*local_rank), vr_zl(1+nv*local_rank),
     &       vi_zh(1+nv*local_rank), vi_zl(1+nv*local_rank),
     &       1,n,x_pos,y_pos,nv,blk_0,
     &       local_rank, local_size
#ifdef MEMORY1
     &      ,xx_ur_x(0,1),xx_ui_x(0,1)
     &      ,xx_ur_y(0,1),xx_ui_y(0,1)
#endif
     &     )

!$omp barrier

!      call eigen_hrd_Au_step2(
!     &       vr_x,vi_x, ur_z,ui_z,
!     &       vr_t,vi_t, vr_z,vi_z,
!     &       nv, x_pos, y_pos,
!     &       local_rank, local_size
      call ddeigen_hrd_Au_step2(
     &       vr_xh,vr_xl,vi_xh,vi_xl,ur_zh,ur_zl,ui_zh,ui_zl,
     &       vr_th,vr_tl,vi_th,vi_tl,vr_zh,vr_zl,vi_zh,vi_zl,
     &       nv, x_pos, y_pos,
     &       local_rank, local_size
#ifdef MEMORY1
     &      ,xx_vr_x(0,1),xx_vi_x(0,1)
     &      ,xx_vr_t(0,1),xx_vi_t(0,1)
#endif
     &     )

!$omp barrier

      if ( local_rank == 0 ) then

         if(n+1<=y_pos)then
#ifdef MEMORY1
      nxx = xx_vr_t(4000,y_pos)
      nxx = xx_vi_t(4010,y_pos)
#endif
!            vr_t(n+1:y_pos) = 0.0d0
!            vi_t(n+1:y_pos) = 0.0d0
            vr_th(n+1:y_pos) = 0.0d+0
            vr_tl(n+1:y_pos) = 0.0d+0
            vi_th(n+1:y_pos) = 0.0d+0
            vi_tl(n+1:y_pos) = 0.0d+0
         endif
         if ( nprocs > 1 ) then
#ifdef MEMORY1
      nxx = xx_vr_t(4020,y_pos)
      nxx = xx_ur_t(4030,y_pos)
      nxx = xx_vi_t(4040,y_pos)
      nxx = xx_ui_t(4050,y_pos)
#endif
!            call reduce_dbl(vr_t, ur_t, y_pos, mpi_comm_col)
!            call reduce_dbl(vi_t, ui_t, y_pos, mpi_comm_col)
            call ddreduce_dbl(vr_th, vr_tl, ur_th, ur_tl, y_pos,
     &                        mpi_comm_col)
            call ddreduce_dbl(vi_th, vi_tl, ui_th, ui_tl, y_pos,
     &                        mpi_comm_col)
         end if

!         call eigen_hrd_Au_step3(
!     &          ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
!     &          ur_t,ui_t,vr_t,vi_t,d_t,
!     &          1,n,x_pos,y_pos,nv
         call ddeigen_hrd_Au_step3(
     &          ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &          vr_xh,vr_xl,vi_xh,vi_xl,
     &          ur_th,ur_tl,ui_th,ui_tl,vr_th,vr_tl,vi_th,vi_tl,
     &          d_th,d_tl,
     &          1,n,x_pos,y_pos,nv
#ifdef MEMORY1
     &         ,xx_ur_x(0,1),xx_ui_x(0,1)
     &         ,xx_ur_y(0,1),xx_ui_y(0,1)
     &         ,xx_vr_x(0,1),xx_vi_x(0,1)
     &         ,xx_ur_t(0,1),xx_ui_t(0,1)
     &         ,xx_vr_t(0,1),xx_vi_t(0,1)
     &         ,xx_d_t (0,1)
#endif
     &        )

         if ( nprocs > 1 ) then
            if ( nprocs >= es_cluster**2 .and.
     &                       size_of_col > 1 .and. es_icnod > 1 ) then
!               call recv_dbl(vr_x(1), 0, es_icnod-1, es_ccomm_world)
               call ddrecv_dbl(vr_xh(1), vr_xl(1), 0,
     &                         es_icnod-1, es_ccomm_world)
            endif
#ifdef MEMORY1
      nxx = xx_vr_x(4060,x_pos)
      nxx = xx_vr_t(4070,x_pos)
      nxx = xx_vi_x(4080,x_pos)
      nxx = xx_vi_t(4090,x_pos)
#endif
!            call reduce_dbl(vr_x, vr_t, x_pos, mpi_comm_row)
!            call reduce_dbl(vi_x, vi_t, x_pos, mpi_comm_row)
            call ddreduce_dbl(vr_xh, vr_xl, vr_th, vr_tl, x_pos,
     &                        mpi_comm_row)
            call ddreduce_dbl(vi_xh, vi_xl, vi_th, vi_tl, x_pos,
     &                        mpi_comm_row)
            if ( nprocs >= es_cluster**2 .and.
     &           size_of_col > 1 .and. 
     &           es_icnod < es_ncnod ) then
!               call send_dbl(vr_x(1), 0, es_icnod+1, es_ccomm_world)
               call ddsend_dbl(vr_xh(1), vr_xl(1), 0, es_icnod+1,
     &                         es_ccomm_world)
            endif
         end if

      endif

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_Au:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_Au:ui_x")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_Au:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_Au:ui_y")
      end function

      function xx_vr_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1
      xx_vr_x = nxx_vr_x + i1 - 1
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_Au:vr_x")
      end function

      function xx_vi_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1
      xx_vi_x = nxx_vi_x + i1 - 1
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_Au:vi_x")
      end function

      function xx_ur_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_t
      integer :: i0,i1
      xx_ur_t = nxx_ur_t + i1 - 1
      call accessor(i0,xx_ur_t,kxx_ur_t,"ddeigen_hrd_Au:ur_t")
      end function

      function xx_ui_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_t
      integer :: i0,i1
      xx_ui_t = nxx_ui_t + i1 - 1
      call accessor(i0,xx_ui_t,kxx_ui_t,"ddeigen_hrd_Au:ui_t")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_Au:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_Au:vi_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_Au:d_t")
      end function
#endif
      end subroutine ! eigen_hrd_Au

!      subroutine  eigen_hrd_Au_step1(
!     &              ar,ai,nm,
!     &              ur_x,ui_x,ur_y,ui_y,
!     &              ur_t,ui_t,vr_t,vi_t,
!     &              n1,n2,x_pos,y_pos,nv,blk_0,
!     &              local_rank, local_size
      subroutine  ddeigen_hrd_Au_step1(
     &              arh,arl,aih,ail,nm,
     &              ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &              ur_th,ur_tl,ui_th,ui_tl,vr_th,vr_tl,vi_th,vi_tl,
     &              n1,n2,x_pos,y_pos,nv,blk_0,
     &              local_rank, local_size
#ifdef MEMORY1
     &      ,nxx_ur_x,nxx_ui_x
     &      ,nxx_ur_y,nxx_ui_y
#endif
     &            )
!----
!      use communication_h, only : get_loop_end
!     &               , translate_l2g
      use ddcommunication_h, only : get_loop_end
     &                            , translate_l2g
!----
      implicit none

      integer, intent(in)    :: nm, nv, n1, n2
!      real(8), intent(inout) :: ar(1:nm,*), ai(1:nm,*)
!      real(8), intent(inout) :: ur_x(1:nv), ui_x(1:nv)
!      real(8), intent(inout) :: ur_y(1:nv), ui_y(1:nv)
!      real(8), intent(inout) :: ur_t(1:nv), ui_t(1:nv)
!      real(8), intent(inout) :: vr_t(1:nv), vi_t(1:nv)
      real(8), intent(inout) :: arh(1:nm,*), aih(1:nm,*)
      real(8), intent(inout) :: arl(1:nm,*), ail(1:nm,*)
      real(8), intent(inout) :: ur_xh(1:nv), ui_xh(1:nv)
      real(8), intent(inout) :: ur_xl(1:nv), ui_xl(1:nv)
      real(8), intent(inout) :: ur_yh(1:nv), ui_yh(1:nv)
      real(8), intent(inout) :: ur_yl(1:nv), ui_yl(1:nv)
      real(8), intent(inout) :: ur_th(1:nv), ui_th(1:nv)
      real(8), intent(inout) :: ur_tl(1:nv), ui_tl(1:nv)
      real(8), intent(inout) :: vr_th(1:nv), vi_th(1:nv)
      real(8), intent(inout) :: vr_tl(1:nv), vi_tl(1:nv)
      integer, intent(in)    :: blk_0
      integer                :: x_pos, y_pos
      integer                :: local_size, local_rank
      integer                :: i_1, i_2, i_3, i_4
      integer                :: j_1, j_2, j_3, j_4
      integer                :: k_1, k_2, k_3, k_4
      integer                :: i, j, k

!      real(8)                :: vr0, vi0, ur0, ui0
!      real(8)                :: ar0_0, ai0_0
!      real(8)                :: ar0_1, ai0_1
!      real(8)                :: ar0_2, ai0_2
!      real(8)                :: ar0_3, ai0_3
!      real(8)                :: ar0_4, ai0_4
!      real(8)                :: ar0_5, ai0_5
!      real(8)                :: ar0_6, ai0_6
!      real(8)                :: ar0_7, ai0_7
!      real(8)                :: ar0_8, ai0_8
!      real(8)                :: ar0_9, ai0_9
!      real(8)                :: vr_t0,vi_t0, ur_y0,ui_y0
!      real(8)                :: vr_t1,vi_t1, ur_y1,ui_y1
!      real(8)                :: vr_t2,vi_t2, ur_y2,ui_y2
!      real(8)                :: vr_t3,vi_t3, ur_y3,ui_y3
!      real(8)                :: vr_t4,vi_t4, ur_y4,ui_y4
!      real(8)                :: vr_t5,vi_t5, ur_y5,ui_y5
!      real(8)                :: vr_t6,vi_t6, ur_y6,ui_y6
!      real(8)                :: vr_t7,vi_t7, ur_y7,ui_y7
!      real(8)                :: vr_t8,vi_t8, ur_y8,ui_y8
!      real(8)                :: vr_t9,vi_t9, ur_y9,ui_y9
      double precision vr0h, vr0l
      double precision vi0h, vi0l
      double precision ur0h, ur0l
      double precision ui0h, ui0l
      double precision ar0_0h, ar0_0l
      double precision ai0_0h, ai0_0l
      double precision ar0_1h, ar0_1l
      double precision ai0_1h, ai0_1l
      double precision ar0_2h, ar0_2l
      double precision ai0_2h, ai0_2l
      double precision ar0_3h, ar0_3l
      double precision ai0_3h, ai0_3l
      double precision ar0_4h, ar0_4l
      double precision ai0_4h, ai0_4l
      double precision ar0_5h, ar0_5l
      double precision ai0_5h, ai0_5l
      double precision ar0_6h, ar0_6l
      double precision ai0_6h, ai0_6l
      double precision ar0_7h, ar0_7l
      double precision ai0_7h, ai0_7l
      double precision ar0_8h, ar0_8l
      double precision ai0_8h, ai0_8l
      double precision ar0_9h, ar0_9l
      double precision ai0_9h, ai0_9l
      double precision vr_t0h, vr_t0l
      double precision vi_t0h, vi_t0l
      double precision ur_y0h, ur_y0l
      double precision ui_y0h, ui_y0l
      double precision vr_t1h, vr_t1l
      double precision vi_t1h, vi_t1l
      double precision ur_y1h, ur_y1l
      double precision ui_y1h, ui_y1l
      double precision vr_t2h, vr_t2l
      double precision vi_t2h, vi_t2l
      double precision ur_y2h, ur_y2l
      double precision ui_y2h, ui_y2l
      double precision vr_t3h, vr_t3l
      double precision vi_t3h, vi_t3l
      double precision ur_y3h, ur_y3l
      double precision ui_y3h, ui_y3l
      double precision vr_t4h, vr_t4l
      double precision vi_t4h, vi_t4l
      double precision ur_y4h, ur_y4l
      double precision ui_y4h, ui_y4l
      double precision vr_t5h, vr_t5l
      double precision vi_t5h, vi_t5l
      double precision ur_y5h, ur_y5l
      double precision ui_y5h, ui_y5l
      double precision vr_t6h, vr_t6l
      double precision vi_t6h, vi_t6l
      double precision ur_y6h, ur_y6l
      double precision ui_y6h, ui_y6l
      double precision vr_t7h, vr_t7l
      double precision vi_t7h, vi_t7l
      double precision ur_y7h, ur_y7l
      double precision ui_y7h, ui_y7l
      double precision vr_t8h, vr_t8l
      double precision vi_t8h, vi_t8l
      double precision ur_y8h, ur_y8l
      double precision ui_y8h, ui_y8l
      double precision vr_t9h, vr_t9l
      double precision vi_t9h, vi_t9l
      double precision ur_y9h, ur_y9l
      double precision ui_y9h, ui_y9l
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l


      integer                ::   ii_1, ii_2, ii_3, ii_4
      integer                ::   jj_1, jj_2, jj_3, jj_4

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

      i_2 = n1
      i_3 = n2
!----
! v:= au
!----
      if ( n1 == 1 ) then
!         ur_t(1:x_pos) = 0.0d+00
!         ui_t(1:x_pos) = 0.0d+00
!         vr_t(1:y_pos) = 0.0d+00
!         vi_t(1:y_pos) = 0.0d+00
         ur_th(1:x_pos) = 0.0d+0
         ur_tl(1:x_pos) = 0.0d+0
         ui_th(1:x_pos) = 0.0d+0
         ui_tl(1:x_pos) = 0.0d+0
         vr_th(1:y_pos) = 0.0d+0
         vr_tl(1:y_pos) = 0.0d+0
         vi_th(1:y_pos) = 0.0d+0
         vi_tl(1:y_pos) = 0.0d+0
      end if

      if ( blk_0 == 0 ) then
         do i_1=i_2+local_rank,i_3,local_size
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_3 = get_loop_end  (j, size_of_col,my_col)
            j   = j+size_of_row*(10-1)
            j_4 = get_loop_end  (j, size_of_col,my_col)
            do j_1=j_3+1,min(j_4,nm)
!               ar(j_1,i_1) = 0.0d+00
!               ai(j_1,i_1) = 0.0d+00
               arh(j_1,i_1) = 0.0d+0
               arl(j_1,i_1) = 0.0d+0
               aih(j_1,i_1) = 0.0d+0
               ail(j_1,i_1) = 0.0d+0
            end do! j_1
         end do! i_1
!$omp barrier
      end if
!----
      k_1 = 1
      ii_2 = i_2; ii_3 = i_3
      ii_4 = mod(ii_3-ii_2+1,10)+ii_2

      do i_1=ii_2+local_rank,ii_4-1,local_size

         j    = translate_l2g(i_1, size_of_row,my_row)
         j    = j+(1-1)*size_of_row
         jj_2 = k_1
         jj_3 = get_loop_end  (j-1, size_of_col,my_col)
         if ( jj_2 > jj_3 ) cycle

#ifdef MEMORY1
      nxx = xx_ur_x(4140,jj_3+0)
      nxx = xx_ui_x(4150,jj_3+0)
      nxx = xx_ur_y(4160,i_1 +0)
      nxx = xx_ui_y(4170,i_1 +0)
#endif
         do j_1=jj_2,jj_3

!            ur0 = ur_x(j_1+0)
!            ui0 = ui_x(j_1+0)
!            vr0 = 0
!            vi0 = 0
            ur0h = ur_xh(j_1+0)
            ur0l = ur_xl(j_1+0)
            ui0h = ui_xh(j_1+0)
            ui0l = ui_xl(j_1+0)
            vr0h = 0.0d+0
            vr0l = 0.0d+0
            vi0h = 0.0d+0
            vi0l = 0.0d+0
!----       vr0 = ur_t(j_1+0)
!----       vi0 = ui_t(j_1+0)

!            ar0_0 = ar(j_1+0,i_1+0)
!            ai0_0 = ai(j_1+0,i_1+0)
            ar0_0h = arh(j_1+0,i_1+0)
            ar0_0l = arl(j_1+0,i_1+0)
            ai0_0h = aih(j_1+0,i_1+0)
            ai0_0l = ail(j_1+0,i_1+0)
!            vr_t(i_1+0) = vr_t(i_1+0)
!     &                  + (ar0_0*ur0)
!     &                  + (ai0_0*ui0)
!<<<        tmp1 = ar0_0 * ur0
            tmp1h = ar0_0h * ur0h
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ur0l
     +            + ar0_0l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ur0
!<<<        tmp2 = ai0_0 * ui0
            tmp2h = ai0_0h * ui0h
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_0h*ui0l
     +            + ai0_0l*ui0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_0 * ui0
!<<<        vr_t(i_1+0) = vr_t(i_1+0) + tmp1
            t_p1 = vr_th(i_1+0) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+0)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+0) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+0) + tmp1l
            vr_th(i_1+0) = t_q1 + t_q2
            vr_tl(i_1+0) = t_q2 - (vr_th(i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+0) = vr_t(i_1+0) + tmp1
!<<<        vr_t(i_1+0) = vr_t(i_1+0) + tmp2
            t_p1 = vr_th(i_1+0) + tmp2h
            t_p2 = t_p1 - vr_th(i_1+0)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+0) - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+0) + tmp2l
            vr_th(i_1+0) = t_q1 + t_q2
            vr_tl(i_1+0) = t_q2 - (vr_th(i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+0) = vr_t(i_1+0) + tmp2
!            vi_t(i_1+0) = vi_t(i_1+0)
!     &                  + (ar0_0*ui0)
!     &                  - (ai0_0*ur0)
!<<<        tmp1 = ar0_0 * ui0
            tmp1h = ar0_0h * ui0h
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ui0l
     +            + ar0_0l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ui0
!<<<        tmp2 = ai0_0 * ur0
            tmp2h = ai0_0h * ur0h
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_0h*ur0l
     +            + ai0_0l*ur0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_0 * ur0
!<<<        vi_t(i_1+0) = vi_t(i_1+0) + tmp1
            t_p1 = vi_th(i_1+0) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+0)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+0) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+0) + tmp1l
            vi_th(i_1+0) = t_q1 + t_q2
            vi_tl(i_1+0) = t_q2 - (vi_th(i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+0) = vi_t(i_1+0) + tmp1
!<<<        vi_t(i_1+0) = vi_t(i_1+0) - tmp2
            t_p1 = vi_th(i_1+0) - tmp2h
            t_p2 = t_p1 - vi_th(i_1+0)
            t_ch = t_p1
            t_cl = (vi_th(i_1+0) - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + vi_tl(i_1+0) - tmp2l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+0) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+0) = vi_t(i_1+0) - tmp2
!            vr0 = vr0
!     &          + (ar0_0*ur_y(i_1+0))
!     &          - (ai0_0*ui_y(i_1+0))
!<<<        tmp1 = ar0_0 * ur_y(i_1+0)
            tmp1h = ar0_0h * ur_yh(i_1+0)
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+0))
            t_r2 = ur_yh(i_1+0) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ur_yl(i_1+0)
     +            + ar0_0l*ur_yh(i_1+0))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ur_y(i_1+0)
!<<<        tmp2 = ai0_0 * ui_y(i_1+0)
            tmp2h = ai0_0h * ui_yh(i_1+0)
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+0))
            t_r2 = ui_yh(i_1+0) - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_0h*ui_yl(i_1+0)
     +            + ai0_0l*ui_yh(i_1+0))
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_0 * ui_y(i_1+0)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        vr0 = vr0 - tmp2
            t_p1 = vr0h - tmp2h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + vr0l - tmp2l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp2
!            vi0 = vi0
!     &          + (ar0_0*ui_y(i_1+0))
!     &          + (ai0_0*ur_y(i_1+0))
!<<<        tmp1 = ar0_0 * ui_y(i_1+0)
            tmp1h = ar0_0h * ui_yh(i_1+0)
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+0))
            t_r2 = ui_yh(i_1+0) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ui_yl(i_1+0)
     +            + ar0_0l*ui_yh(i_1+0))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ui_y(i_1+0)
!<<<        tmp2 = ai0_0 * ur_y(i_1+0)
            tmp2h = ai0_0h * ur_yh(i_1+0)
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+0))
            t_r2 = ur_yh(i_1+0) - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_0h*ur_yl(i_1+0)
     +            + ai0_0l*ur_yh(i_1+0))
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_0 * ur_y(i_1+0)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        vi0 = vi0 + tmp2
            t_p1 = vi0h + tmp2h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + vi0l + tmp2l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp2

!            ur_t(j_1+0) = vr0 + ur_t(j_1+0)
!            ui_t(j_1+0) = vi0 + ui_t(j_1+0)
!<<<        ur_t(j_1+0) = vr0 + ur_t(j_1+0)
            t_p1 = vr0h + ur_th(j_1+0)
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (ur_th(j_1+0) - t_p2)
            t_q2 = t_q2 + vr0l + ur_tl(j_1+0)
            ur_th(j_1+0) = t_q1 + t_q2
            ur_tl(j_1+0) = t_q2 - (ur_th(j_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        ur_t(j_1+0) = vr0 + ur_t(j_1+0)
!<<<        ui_t(j_1+0) = vi0 + ui_t(j_1+0)
            t_p1 = vi0h + ui_th(j_1+0)
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (ui_th(j_1+0) - t_p2)
            t_q2 = t_q2 + vi0l + ui_tl(j_1+0)
            ui_th(j_1+0) = t_q1 + t_q2
            ui_tl(j_1+0) = t_q2 - (ui_th(j_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        ui_t(j_1+0) = vi0 + ui_t(j_1+0)

         end do! j_1

      end do! i_1

      do i_1=ii_4+local_rank*10,ii_3, local_size*10

         j    = translate_l2g(i_1, size_of_row,my_row)
         j    = j+(10-1)*size_of_row
         jj_2 = k_1
         jj_3 = get_loop_end  (j-1, size_of_col,my_col)
         if ( jj_2 > jj_3 ) cycle

#ifdef MEMORY1
      nxx = xx_ur_x(4200,jj_3+0)
      nxx = xx_ui_x(4210,jj_3+0)
      nxx = xx_ur_y(4220,i_1+9)
      nxx = xx_ui_y(4230,i_1+9)
#endif
         do j_1=jj_2,jj_3

!            ur0 = ur_x(j_1+0)
!            ui0 = ui_x(j_1+0)
!            vr0 = 0
!            vi0 = 0
            ur0h = ur_xh(j_1+0)
            ur0l = ur_xl(j_1+0)
            ui0h = ui_xh(j_1+0)
            ui0l = ui_xl(j_1+0)
            vr0h = 0.0d+0
            vr0l = 0.0d+0
            vi0h = 0.0d+0
            vi0l = 0.0d+0
!----       vr0 = ur_t(j_1+0)
!----       vi0 = ui_t(j_1+0)

!            ar0_0 = ar(j_1+0,i_1+0)
!            ai0_0 = ai(j_1+0,i_1+0)
!            ar0_1 = ar(j_1+0,i_1+1)
!            ai0_1 = ai(j_1+0,i_1+1)
!            ar0_2 = ar(j_1+0,i_1+2)
!            ai0_2 = ai(j_1+0,i_1+2)
!            ar0_3 = ar(j_1+0,i_1+3)
!            ai0_3 = ai(j_1+0,i_1+3)
            ar0_0h = arh(j_1+0,i_1+0)
            ar0_0l = arl(j_1+0,i_1+0)
            ai0_0h = aih(j_1+0,i_1+0)
            ai0_0l = ail(j_1+0,i_1+0)
            ar0_1h = arh(j_1+0,i_1+1)
            ar0_1l = arl(j_1+0,i_1+1)
            ai0_1h = aih(j_1+0,i_1+1)
            ai0_1l = ail(j_1+0,i_1+1)
            ar0_2h = arh(j_1+0,i_1+2)
            ar0_2l = arl(j_1+0,i_1+2)
            ai0_2h = aih(j_1+0,i_1+2)
            ai0_2l = ail(j_1+0,i_1+2)
            ar0_3h = arh(j_1+0,i_1+3)
            ar0_3l = arl(j_1+0,i_1+3)
            ai0_3h = aih(j_1+0,i_1+3)
            ai0_3l = ail(j_1+0,i_1+3)
!            vr_t(i_1+0) = vr_t(i_1+0)
!     &                  + (ar0_0*ur0)
!     &                  + (ai0_0*ui0)
!<<<        tmp1 = ar0_0 * ur0
            tmp1h = ar0_0h * ur0h
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ur0l
     +            + ar0_0l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ur0
!<<<        tmp2 = ai0_0 * ui0
            tmp2h = ai0_0h * ui0h
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_0h*ui0l
     +            + ai0_0l*ui0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_0 * ui0
!<<<        vr_t(i_1+0) = vr_t(i_1+0) + tmp1
            t_p1 = vr_th(i_1+0) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+0)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+0) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+0) + tmp1l
            vr_th(i_1+0) = t_q1 + t_q2
            vr_tl(i_1+0) = t_q2 - (vr_th(i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+0) = vr_t(i_1+0) + tmp1
!<<<        vr_t(i_1+0) = vr_t(i_1+0) + tmp2
            t_p1 = vr_th(i_1+0) + tmp2h
            t_p2 = t_p1 - vr_th(i_1+0)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+0) - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+0) + tmp2l
            vr_th(i_1+0) = t_q1 + t_q2
            vr_tl(i_1+0) = t_q2 - (vr_th(i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+0) = vr_t(i_1+0) + tmp2

!            vi_t(i_1+0) = vi_t(i_1+0)
!     &                  + (ar0_0*ui0)
!     &                  - (ai0_0*ur0)
!            vr_t(i_1+1) = vr_t(i_1+1)
!     &                  + (ar0_1*ur0)
!     &                  + (ai0_1*ui0)
!<<<        tmp1 = ar0_0 * ui0
            tmp1h = ar0_0h * ui0h
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ui0l
     +            + ar0_0l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ui0
!<<<        tmp2 = ai0_0 * ur0
            tmp2h = ai0_0h * ur0h
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_0h*ur0l
     +            + ai0_0l*ur0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_0 * ur0
!<<<        vi_t(i_1+0) = vi_t(i_1+0) + tmp1
            t_p1 = vi_th(i_1+0) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+0)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+0) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+0) + tmp1l
            vi_th(i_1+0) = t_q1 + t_q2
            vi_tl(i_1+0) = t_q2 - (vi_th(i_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+0) = vi_t(i_1+0) + tmp1
!<<<        vi_t(i_1+0) = vi_t(i_1+0) - tmp2
            t_p1 = vi_th(i_1+0) - tmp2h
            t_p2 = t_p1 - vi_th(i_1+0)
            t_ch = t_p1
            t_cl = (vi_th(i_1+0) - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + vi_tl(i_1+0) - tmp2l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+0) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+0) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+0) = vi_t(i_1+0) - tmp2
!<<<        tmp1 = ar0_1 * ur0
            tmp1h = ar0_1h * ur0h
            t_u1 = 134217729.0 * ar0_1h
            t_p1 = t_u1
     +               - (t_u1 - ar0_1h)
            t_p2 = ar0_1h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_1h*ur0l
     +            + ar0_1l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_1 * ur0
!<<<        tmp2 = ai0_1 * ui0
            tmp2h = ai0_1h * ui0h
            t_u1 = 134217729.0 * ai0_1h
            t_p1 = t_u1
     +               - (t_u1 - ai0_1h)
            t_p2 = ai0_1h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_1h*ui0l
     +            + ai0_1l*ui0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_1 * ui0
!<<<        vr_t(i_1+1) = vr_t(i_1+1) + tmp1
            t_p1 = vr_th(i_1+1) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+1)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+1) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+1) + tmp1l
            vr_th(i_1+1) = t_q1 + t_q2
            vr_tl(i_1+1) = t_q2 - (vr_th(i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+1) = vr_t(i_1+1) + tmp1
!<<<        vr_t(i_1+1) = vr_t(i_1+1) + tmp2
            t_p1 = vr_th(i_1+1) + tmp2h
            t_p2 = t_p1 - vr_th(i_1+1)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+1) - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+1) + tmp2l
            vr_th(i_1+1) = t_q1 + t_q2
            vr_tl(i_1+1) = t_q2 - (vr_th(i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+1) = vr_t(i_1+1) + tmp2

!            vi_t(i_1+1) = vi_t(i_1+1)
!     &                  + (ar0_1*ui0)
!     &                  - (ai0_1*ur0)
!            vr_t(i_1+2) = vr_t(i_1+2)
!     &                  + (ar0_2*ur0)
!     &                  + (ai0_2*ui0)
!<<<        tmp1 = ar0_1 * ui0
            tmp1h = ar0_1h * ui0h
            t_u1 = 134217729.0 * ar0_1h
            t_p1 = t_u1
     +               - (t_u1 - ar0_1h)
            t_p2 = ar0_1h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_1h*ui0l
     +            + ar0_1l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_1 * ui0
!<<<        tmp2 = ai0_1 * ur0
            tmp2h = ai0_1h * ur0h
            t_u1 = 134217729.0 * ai0_1h
            t_p1 = t_u1
     +               - (t_u1 - ai0_1h)
            t_p2 = ai0_1h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_1h*ur0l
     +            + ai0_1l*ur0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_1 * ur0
!<<<        vi_t(i_1+1) = vi_t(i_1+1) + tmp1
            t_p1 = vi_th(i_1+1) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+1)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+1) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+1) + tmp1l
            vi_th(i_1+1) = t_q1 + t_q2
            vi_tl(i_1+1) = t_q2 - (vi_th(i_1+1) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+1) = vi_t(i_1+1) + tmp1
!<<<        vi_t(i_1+1) = vi_t(i_1+1) - tmp2
            t_p1 = vi_th(i_1+1) - tmp2h
            t_p2 = t_p1 - vi_th(i_1+1)
            t_ch = t_p1
            t_cl = (vi_th(i_1+1) - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + vi_tl(i_1+1) - tmp2l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+1) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+1) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+1) = vi_t(i_1+1) - tmp2
!<<<        tmp1 = ar0_2 * ur0
            tmp1h = ar0_2h * ur0h
            t_u1 = 134217729.0 * ar0_2h
            t_p1 = t_u1
     +               - (t_u1 - ar0_2h)
            t_p2 = ar0_2h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_2h*ur0l
     +            + ar0_2l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_2 * ur0
!<<<        tmp2 = ai0_2 * ui0
            tmp2h = ai0_2h * ui0h
            t_u1 = 134217729.0 * ai0_2h
            t_p1 = t_u1
     +               - (t_u1 - ai0_2h)
            t_p2 = ai0_2h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_2h*ui0l
     +            + ai0_2l*ui0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_2 * ui0
!<<<        vr_t(i_1+2) = vr_t(i_1+2) + tmp1
            t_p1 = vr_th(i_1+2) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+2)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+2) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+2) + tmp1l
            vr_th(i_1+2) = t_q1 + t_q2
            vr_tl(i_1+2) = t_q2 - (vr_th(i_1+2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+2) = vr_t(i_1+2) + tmp1
!<<<        vr_t(i_1+2) = vr_t(i_1+2) + tmp2
            t_p1 = vr_th(i_1+2) + tmp2h
            t_p2 = t_p1 - vr_th(i_1+2)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+2) - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+2) + tmp2l
            vr_th(i_1+2) = t_q1 + t_q2
            vr_tl(i_1+2) = t_q2 - (vr_th(i_1+2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+2) = vr_t(i_1+2) + tmp2

!            vi_t(i_1+2) = vi_t(i_1+2)
!     &                  + (ar0_2*ui0)
!     &                  - (ai0_2*ur0)
!            vr_t(i_1+3) = vr_t(i_1+3)
!     &                  + (ar0_3*ur0)
!     &                  + (ai0_3*ui0)
!<<<        tmp1 = ar0_2 * ui0
            tmp1h = ar0_2h * ui0h
            t_u1 = 134217729.0 * ar0_2h
            t_p1 = t_u1
     +               - (t_u1 - ar0_2h)
            t_p2 = ar0_2h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_2h*ui0l
     +            + ar0_2l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_2 * ui0
!<<<        tmp2 = ai0_2 * ur0
            tmp2h = ai0_2h * ur0h
            t_u1 = 134217729.0 * ai0_2h
            t_p1 = t_u1
     +               - (t_u1 - ai0_2h)
            t_p2 = ai0_2h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_2h*ur0l
     +            + ai0_2l*ur0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_2 * ur0
!<<<        vi_t(i_1+2) = vi_t(i_1+2) + tmp1
            t_p1 = vi_th(i_1+2) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+2)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+2) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+2) + tmp1l
            vi_th(i_1+2) = t_q1 + t_q2
            vi_tl(i_1+2) = t_q2 - (vi_th(i_1+2) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+2) = vi_t(i_1+2) + tmp1
!<<<        vi_t(i_1+2) = vi_t(i_1+2) - tmp2
            t_p1 = vi_th(i_1+2) - tmp2h
            t_p2 = t_p1 - vi_th(i_1+2)
            t_ch = t_p1
            t_cl = (vi_th(i_1+2) - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + vi_tl(i_1+2) - tmp2l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+2) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+2) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+2) = vi_t(i_1+2) - tmp2
!<<<        tmp1 = ar0_3 * ur0
            tmp1h = ar0_3h * ur0h
            t_u1 = 134217729.0 * ar0_3h
            t_p1 = t_u1
     +               - (t_u1 - ar0_3h)
            t_p2 = ar0_3h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_3h*ur0l
     +            + ar0_3l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_3 * ur0
!<<<        tmp2 = ai0_3 * ui0
            tmp2h = ai0_3h * ui0h
            t_u1 = 134217729.0 * ai0_3h
            t_p1 = t_u1
     +               - (t_u1 - ai0_3h)
            t_p2 = ai0_3h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_3h*ui0l
     +            + ai0_3l*ui0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_3 * ui0
!<<<        vr_t(i_1+3) = vr_t(i_1+3) + tmp1
            t_p1 = vr_th(i_1+3) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+3)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+3) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+3) + tmp1l
            vr_th(i_1+3) = t_q1 + t_q2
            vr_tl(i_1+3) = t_q2 - (vr_th(i_1+3) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+3) = vr_t(i_1+3) + tmp1
!<<<        vr_t(i_1+3) = vr_t(i_1+3) + tmp2
            t_p1 = vr_th(i_1+3) + tmp2h
            t_p2 = t_p1 - vr_th(i_1+3)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+3) - (t_p1 - t_p2))
     +               + (tmp2h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+3) + tmp2l
            vr_th(i_1+3) = t_q1 + t_q2
            vr_tl(i_1+3) = t_q2 - (vr_th(i_1+3) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+3) = vr_t(i_1+3) + tmp2

!            vi_t(i_1+3) = vi_t(i_1+3)
!     &                  + (ar0_3*ui0)
!     &                  - (ai0_3*ur0)
!<<<        tmp1 = ar0_3 * ui0
            tmp1h = ar0_3h * ui0h
            t_u1 = 134217729.0 * ar0_3h
            t_p1 = t_u1
     +               - (t_u1 - ar0_3h)
            t_p2 = ar0_3h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_3h*ui0l
     +            + ar0_3l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_3 * ui0
!<<<        tmp2 = ai0_3 * ur0
            tmp2h = ai0_3h * ur0h
            t_u1 = 134217729.0 * ai0_3h
            t_p1 = t_u1
     +               - (t_u1 - ai0_3h)
            t_p2 = ai0_3h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp2l = ((t_p1*t_r1
     +              - tmp2h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp2l = tmp2l
     +            + (ai0_3h*ur0l
     +            + ai0_3l*ur0h)
            t_s1 = tmp2h + tmp2l
            tmp2l = tmp2l - (t_s1 - tmp2h)
            tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp2 = ai0_3 * ur0
!<<<        vi_t(i_1+3) = vi_t(i_1+3) + tmp1
            t_p1 = vi_th(i_1+3) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+3)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+3) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+3) + tmp1l
            vi_th(i_1+3) = t_q1 + t_q2
            vi_tl(i_1+3) = t_q2 - (vi_th(i_1+3) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+3) = vi_t(i_1+3) + tmp1
!<<<        vi_t(i_1+3) = vi_t(i_1+3) - tmp2
            t_p1 = vi_th(i_1+3) - tmp2h
            t_p2 = t_p1 - vi_th(i_1+3)
            t_ch = t_p1
            t_cl = (vi_th(i_1+3) - (t_p1 - t_p2))
     +               - (tmp2h + t_p2)
            t_cl = t_cl + vi_tl(i_1+3) - tmp2l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+3) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+3) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+3) = vi_t(i_1+3) - tmp2
!            vr0 = vr0
!     &                  + (ar0_0*ur_y(i_1+0))
!     &                  - (ai0_0*ui_y(i_1+0))
!     &                  + (ar0_1*ur_y(i_1+1))
!     &                  - (ai0_1*ui_y(i_1+1))
!     &                  + (ar0_2*ur_y(i_1+2))
!     &                  - (ai0_2*ui_y(i_1+2))
!     &                  + (ar0_3*ur_y(i_1+3))
!     &                  - (ai0_3*ui_y(i_1+3))
!<<<        tmp1 = ar0_0 * ur_y(i_1+0)
            tmp1h = ar0_0h * ur_yh(i_1+0)
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+0))
            t_r2 = ur_yh(i_1+0) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ur_yl(i_1+0)
     +            + ar0_0l*ur_yh(i_1+0))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ur_y(i_1+0)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_0 * ui_y(i_1+0)
            tmp1h = ai0_0h * ui_yh(i_1+0)
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+0))
            t_r2 = ui_yh(i_1+0) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_0h*ui_yl(i_1+0)
     +            + ai0_0l*ui_yh(i_1+0))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_0 * ui_y(i_1+0)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_1 * ur_y(i_1+1)
            tmp1h = ar0_1h * ur_yh(i_1+1)
            t_u1 = 134217729.0 * ar0_1h
            t_p1 = t_u1
     +               - (t_u1 - ar0_1h)
            t_p2 = ar0_1h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+1)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+1))
            t_r2 = ur_yh(i_1+1) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_1h*ur_yl(i_1+1)
     +            + ar0_1l*ur_yh(i_1+1))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_1 * ur_y(i_1+1)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_1 * ui_y(i_1+1)
            tmp1h = ai0_1h * ui_yh(i_1+1)
            t_u1 = 134217729.0 * ai0_1h
            t_p1 = t_u1
     +               - (t_u1 - ai0_1h)
            t_p2 = ai0_1h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+1)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+1))
            t_r2 = ui_yh(i_1+1) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_1h*ui_yl(i_1+1)
     +            + ai0_1l*ui_yh(i_1+1))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_1 * ui_y(i_1+1)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_2 * ur_y(i_1+2)
            tmp1h = ar0_2h * ur_yh(i_1+2)
            t_u1 = 134217729.0 * ar0_2h
            t_p1 = t_u1
     +               - (t_u1 - ar0_2h)
            t_p2 = ar0_2h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+2)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+2))
            t_r2 = ur_yh(i_1+2) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_2h*ur_yl(i_1+2)
     +            + ar0_2l*ur_yh(i_1+2))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_2 * ur_y(i_1+2)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_2 * ui_y(i_1+2)
            tmp1h = ai0_2h * ui_yh(i_1+2)
            t_u1 = 134217729.0 * ai0_2h
            t_p1 = t_u1
     +               - (t_u1 - ai0_2h)
            t_p2 = ai0_2h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+2)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+2))
            t_r2 = ui_yh(i_1+2) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_2h*ui_yl(i_1+2)
     +            + ai0_2l*ui_yh(i_1+2))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_2 * ui_y(i_1+2)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_3 * ur_y(i_1+3)
            tmp1h = ar0_3h * ur_yh(i_1+3)
            t_u1 = 134217729.0 * ar0_3h
            t_p1 = t_u1
     +               - (t_u1 - ar0_3h)
            t_p2 = ar0_3h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+3)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+3))
            t_r2 = ur_yh(i_1+3) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_3h*ur_yl(i_1+3)
     +            + ar0_3l*ur_yh(i_1+3))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_3 * ur_y(i_1+3)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_3 * ui_y(i_1+3)
            tmp1h = ai0_3h * ui_yh(i_1+3)
            t_u1 = 134217729.0 * ai0_3h
            t_p1 = t_u1
     +               - (t_u1 - ai0_3h)
            t_p2 = ai0_3h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+3)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+3))
            t_r2 = ui_yh(i_1+3) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_3h*ui_yl(i_1+3)
     +            + ai0_3l*ui_yh(i_1+3))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_3 * ui_y(i_1+3)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!            vi0 = vi0
!     &                  + (ar0_0*ui_y(i_1+0))
!     &                  + (ai0_0*ur_y(i_1+0))
!     &                  + (ar0_1*ui_y(i_1+1))
!     &                  + (ai0_1*ur_y(i_1+1))
!     &                  + (ar0_2*ui_y(i_1+2))
!     &                  + (ai0_2*ur_y(i_1+2))
!     &                  + (ar0_3*ui_y(i_1+3))
!     &                  + (ai0_3*ur_y(i_1+3))
!<<<        tmp1 = ar0_0 * ui_y(i_1+0)
            tmp1h = ar0_0h * ui_yh(i_1+0)
            t_u1 = 134217729.0 * ar0_0h
            t_p1 = t_u1
     +               - (t_u1 - ar0_0h)
            t_p2 = ar0_0h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+0))
            t_r2 = ui_yh(i_1+0) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_0h*ui_yl(i_1+0)
     +            + ar0_0l*ui_yh(i_1+0))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_0 * ui_y(i_1+0)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_0 * ur_y(i_1+0)
            tmp1h = ai0_0h * ur_yh(i_1+0)
            t_u1 = 134217729.0 * ai0_0h
            t_p1 = t_u1
     +               - (t_u1 - ai0_0h)
            t_p2 = ai0_0h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+0)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+0))
            t_r2 = ur_yh(i_1+0) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_0h*ur_yl(i_1+0)
     +            + ai0_0l*ur_yh(i_1+0))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_0 * ur_y(i_1+0)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_1 * ui_y(i_1+1)
            tmp1h = ar0_1h * ui_yh(i_1+1)
            t_u1 = 134217729.0 * ar0_1h
            t_p1 = t_u1
     +               - (t_u1 - ar0_1h)
            t_p2 = ar0_1h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+1)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+1))
            t_r2 = ui_yh(i_1+1) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_1h*ui_yl(i_1+1)
     +            + ar0_1l*ui_yh(i_1+1))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_1 * ui_y(i_1+1)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_1 * ur_y(i_1+1)
            tmp1h = ai0_1h * ur_yh(i_1+1)
            t_u1 = 134217729.0 * ai0_1h
            t_p1 = t_u1
     +               - (t_u1 - ai0_1h)
            t_p2 = ai0_1h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+1)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+1))
            t_r2 = ur_yh(i_1+1) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_1h*ur_yl(i_1+1)
     +            + ai0_1l*ur_yh(i_1+1))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_1 * ur_y(i_1+1)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_2 * ui_y(i_1+2)
            tmp1h = ar0_2h * ui_yh(i_1+2)
            t_u1 = 134217729.0 * ar0_2h
            t_p1 = t_u1
     +               - (t_u1 - ar0_2h)
            t_p2 = ar0_2h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+2)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+2))
            t_r2 = ui_yh(i_1+2) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_2h*ui_yl(i_1+2)
     +            + ar0_2l*ui_yh(i_1+2))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_2 * ui_y(i_1+2)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_2 * ur_y(i_1+2)
            tmp1h = ai0_2h * ur_yh(i_1+2)
            t_u1 = 134217729.0 * ai0_2h
            t_p1 = t_u1
     +               - (t_u1 - ai0_2h)
            t_p2 = ai0_2h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+2)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+2))
            t_r2 = ur_yh(i_1+2) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_2h*ur_yl(i_1+2)
     +            + ai0_2l*ur_yh(i_1+2))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_2 * ur_y(i_1+2)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_3 * ui_y(i_1+3)
            tmp1h = ar0_3h * ui_yh(i_1+3)
            t_u1 = 134217729.0 * ar0_3h
            t_p1 = t_u1
     +               - (t_u1 - ar0_3h)
            t_p2 = ar0_3h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+3)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+3))
            t_r2 = ui_yh(i_1+3) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_3h*ui_yl(i_1+3)
     +            + ar0_3l*ui_yh(i_1+3))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_3 * ui_y(i_1+3)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_3 * ur_y(i_1+3)
            tmp1h = ai0_3h * ur_yh(i_1+3)
            t_u1 = 134217729.0 * ai0_3h
            t_p1 = t_u1
     +               - (t_u1 - ai0_3h)
            t_p2 = ai0_3h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+3)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+3))
            t_r2 = ur_yh(i_1+3) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_3h*ur_yl(i_1+3)
     +            + ai0_3l*ur_yh(i_1+3))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_3 * ur_y(i_1+3)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!            ar0_4 = ar(j_1+0,i_1+4)
!            ai0_4 = ai(j_1+0,i_1+4)
!            ar0_5 = ar(j_1+0,i_1+5)
!            ai0_5 = ai(j_1+0,i_1+5)
!            ar0_6 = ar(j_1+0,i_1+6)
!            ai0_6 = ai(j_1+0,i_1+6)
!            ar0_7 = ar(j_1+0,i_1+7)
!            ai0_7 = ai(j_1+0,i_1+7)
            ar0_4h = arh(j_1+0,i_1+4)
            ar0_4l = arl(j_1+0,i_1+4)
            ai0_4h = aih(j_1+0,i_1+4)
            ai0_4l = ail(j_1+0,i_1+4)
            ar0_5h = arh(j_1+0,i_1+5)
            ar0_5l = arl(j_1+0,i_1+5)
            ai0_5h = aih(j_1+0,i_1+5)
            ai0_5l = ail(j_1+0,i_1+5)
            ar0_6h = arh(j_1+0,i_1+6)
            ar0_6l = arl(j_1+0,i_1+6)
            ai0_6h = aih(j_1+0,i_1+6)
            ai0_6l = ail(j_1+0,i_1+6)
            ar0_7h = arh(j_1+0,i_1+7)
            ar0_7l = arl(j_1+0,i_1+7)
            ai0_7h = aih(j_1+0,i_1+7)
            ai0_7l = ail(j_1+0,i_1+7)
!            vr_t(i_1+4) = vr_t(i_1+4)
!     &                  + (ar0_4*ur0)
!     &                  + (ai0_4*ui0)
!<<<        tmp1 = ar0_4 * ur0
            tmp1h = ar0_4h * ur0h
            t_u1 = 134217729.0 * ar0_4h
            t_p1 = t_u1
     +               - (t_u1 - ar0_4h)
            t_p2 = ar0_4h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_4h*ur0l
     +            + ar0_4l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_4 * ur0
!<<<        vr_t(i_1+4) = vr_t(i_1+4) + tmp1
            t_p1 = vr_th(i_1+4) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+4)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+4) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+4) + tmp1l
            vr_th(i_1+4) = t_q1 + t_q2
            vr_tl(i_1+4) = t_q2 - (vr_th(i_1+4) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+4) = vr_t(i_1+4) + tmp1
!<<<        tmp1 = ai0_4 * ui0
            tmp1h = ai0_4h * ui0h
            t_u1 = 134217729.0 * ai0_4h
            t_p1 = t_u1
     +               - (t_u1 - ai0_4h)
            t_p2 = ai0_4h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_4h*ui0l
     +            + ai0_4l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_4 * ui0
!<<<        vr_t(i_1+4) = vr_t(i_1+4) + tmp1
            t_p1 = vr_th(i_1+4) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+4)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+4) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+4) + tmp1l
            vr_th(i_1+4) = t_q1 + t_q2
            vr_tl(i_1+4) = t_q2 - (vr_th(i_1+4) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+4) = vr_t(i_1+4) + tmp1

!            vi_t(i_1+4) = vi_t(i_1+4)
!     &                  + (ar0_4*ui0)
!     &                  - (ai0_4*ur0)
!            vr_t(i_1+5) = vr_t(i_1+5)
!     &                  + (ar0_5*ur0)
!     &                  + (ai0_5*ui0)
!<<<        tmp1 = ar0_4 * ui0
            tmp1h = ar0_4h * ui0h
            t_u1 = 134217729.0 * ar0_4h
            t_p1 = t_u1
     +               - (t_u1 - ar0_4h)
            t_p2 = ar0_4h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_4h*ui0l
     +            + ar0_4l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_4 * ui0
!<<<        vi_t(i_1+4) = vi_t(i_1+4) + tmp1
            t_p1 = vi_th(i_1+4) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+4)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+4) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+4) + tmp1l
            vi_th(i_1+4) = t_q1 + t_q2
            vi_tl(i_1+4) = t_q2 - (vi_th(i_1+4) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+4) = vi_t(i_1+4) + tmp1
!<<<        tmp1 = ai0_4 * ur0
            tmp1h = ai0_4h * ur0h
            t_u1 = 134217729.0 * ai0_4h
            t_p1 = t_u1
     +               - (t_u1 - ai0_4h)
            t_p2 = ai0_4h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_4h*ur0l
     +            + ai0_4l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_4 * ur0
!<<<        vi_t(i_1+4) = vi_t(i_1+4) - tmp1
            t_p1 = vi_th(i_1+4) - tmp1h
            t_p2 = t_p1 - vi_th(i_1+4)
            t_ch = t_p1
            t_cl = (vi_th(i_1+4) - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vi_tl(i_1+4) - tmp1l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+4) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+4) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+4) = vi_t(i_1+4) - tmp1
!<<<        tmp1 = ar0_5 * ur0
            tmp1h = ar0_5h * ur0h
            t_u1 = 134217729.0 * ar0_5h
            t_p1 = t_u1
     +               - (t_u1 - ar0_5h)
            t_p2 = ar0_5h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_5h*ur0l
     +            + ar0_5l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_5 * ur0
!<<<        vr_t(i_1+5) = vr_t(i_1+5) + tmp1
            t_p1 = vr_th(i_1+5) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+5)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+5) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+5) + tmp1l
            vr_th(i_1+5) = t_q1 + t_q2
            vr_tl(i_1+5) = t_q2 - (vr_th(i_1+5) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+5) = vr_t(i_1+5) + tmp1
!<<<        tmp1 = ai0_5 * ui0
            tmp1h = ai0_5h * ui0h
            t_u1 = 134217729.0 * ai0_5h
            t_p1 = t_u1
     +               - (t_u1 - ai0_5h)
            t_p2 = ai0_5h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_5h*ui0l
     +            + ai0_5l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_5 * ui0
!<<<        vr_t(i_1+5) = vr_t(i_1+5) + tmp1
            t_p1 = vr_th(i_1+5) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+5)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+5) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+5) + tmp1l
            vr_th(i_1+5) = t_q1 + t_q2
            vr_tl(i_1+5) = t_q2 - (vr_th(i_1+5) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+5) = vr_t(i_1+5) + tmp1

!            vi_t(i_1+5) = vi_t(i_1+5)
!     &                  + (ar0_5*ui0)
!     &                  - (ai0_5*ur0)
!            vr_t(i_1+6) = vr_t(i_1+6)
!     &                  + (ar0_6*ur0)
!     &                  + (ai0_6*ui0)
!<<<        tmp1 = ar0_5 * ui0
            tmp1h = ar0_5h * ui0h
            t_u1 = 134217729.0 * ar0_5h
            t_p1 = t_u1
     +               - (t_u1 - ar0_5h)
            t_p2 = ar0_5h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_5h*ui0l
     +            + ar0_5l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_5 * ui0
!<<<        vi_t(i_1+5) = vi_t(i_1+5) + tmp1
            t_p1 = vi_th(i_1+5) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+5)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+5) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+5) + tmp1l
            vi_th(i_1+5) = t_q1 + t_q2
            vi_tl(i_1+5) = t_q2 - (vi_th(i_1+5) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+5) = vi_t(i_1+5) + tmp1
!<<<        tmp1 = ai0_5 * ur0
            tmp1h = ai0_5h * ur0h
            t_u1 = 134217729.0 * ai0_5h
            t_p1 = t_u1
     +               - (t_u1 - ai0_5h)
            t_p2 = ai0_5h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_5h*ur0l
     +            + ai0_5l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_5 * ur0
!<<<        vi_t(i_1+5) = vi_t(i_1+5) - tmp1
            t_p1 = vi_th(i_1+5) - tmp1h
            t_p2 = t_p1 - vi_th(i_1+5)
            t_ch = t_p1
            t_cl = (vi_th(i_1+5) - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vi_tl(i_1+5) - tmp1l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+5) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+5) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+5) = vi_t(i_1+5) - tmp1
!<<<        tmp1 = ar0_6 * ur0
            tmp1h = ar0_6h * ur0h
            t_u1 = 134217729.0 * ar0_6h
            t_p1 = t_u1
     +               - (t_u1 - ar0_6h)
            t_p2 = ar0_6h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_6h*ur0l
     +            + ar0_6l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_6 * ur0
!<<<        vr_t(i_1+6) = vr_t(i_1+6) + tmp1
            t_p1 = vr_th(i_1+6) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+6)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+6) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+6) + tmp1l
            vr_th(i_1+6) = t_q1 + t_q2
            vr_tl(i_1+6) = t_q2 - (vr_th(i_1+6) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+6) = vr_t(i_1+6) + tmp1
!<<<        tmp1 = ai0_6 * ui0
            tmp1h = ai0_6h * ui0h
            t_u1 = 134217729.0 * ai0_6h
            t_p1 = t_u1
     +               - (t_u1 - ai0_6h)
            t_p2 = ai0_6h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_6h*ui0l
     +            + ai0_6l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_6 * ui0
!<<<        vr_t(i_1+6) = vr_t(i_1+6) + tmp1
            t_p1 = vr_th(i_1+6) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+6)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+6) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+6) + tmp1l
            vr_th(i_1+6) = t_q1 + t_q2
            vr_tl(i_1+6) = t_q2 - (vr_th(i_1+6) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+6) = vr_t(i_1+6) + tmp1

!            vi_t(i_1+6) = vi_t(i_1+6)
!     &                  + (ar0_6*ui0)
!     &                  - (ai0_6*ur0)
!            vr_t(i_1+7) = vr_t(i_1+7)
!     &                  + (ar0_7*ur0)
!     &                  + (ai0_7*ui0)
!<<<        tmp1 = ar0_6 * ui0
            tmp1h = ar0_6h * ui0h
            t_u1 = 134217729.0 * ar0_6h
            t_p1 = t_u1
     +               - (t_u1 - ar0_6h)
            t_p2 = ar0_6h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_6h*ui0l
     +            + ar0_6l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_6 * ui0
!<<<        vi_t(i_1+6) = vi_t(i_1+6) + tmp1
            t_p1 = vi_th(i_1+6) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+6)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+6) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+6) + tmp1l
            vi_th(i_1+6) = t_q1 + t_q2
            vi_tl(i_1+6) = t_q2 - (vi_th(i_1+6) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+6) = vi_t(i_1+6) + tmp1
!<<<        tmp1 = ai0_6 * ur0
            tmp1h = ai0_6h * ur0h
            t_u1 = 134217729.0 * ai0_6h
            t_p1 = t_u1
     +               - (t_u1 - ai0_6h)
            t_p2 = ai0_6h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_6h*ur0l
     +            + ai0_6l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_6 * ur0
!<<<        vi_t(i_1+6) = vi_t(i_1+6) - tmp1
            t_p1 = vi_th(i_1+6) - tmp1h
            t_p2 = t_p1 - vi_th(i_1+6)
            t_ch = t_p1
            t_cl = (vi_th(i_1+6) - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vi_tl(i_1+6) - tmp1l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+6) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+6) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+6) = vi_t(i_1+6) - tmp1
!<<<        tmp1 = ar0_7 * ur0
            tmp1h = ar0_7h * ur0h
            t_u1 = 134217729.0 * ar0_7h
            t_p1 = t_u1
     +               - (t_u1 - ar0_7h)
            t_p2 = ar0_7h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_7h*ur0l
     +            + ar0_7l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_7 * ur0
!<<<        vr_t(i_1+7) = vr_t(i_1+7) + tmp1
            t_p1 = vr_th(i_1+7) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+7)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+7) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+7) + tmp1l
            vr_th(i_1+7) = t_q1 + t_q2
            vr_tl(i_1+7) = t_q2 - (vr_th(i_1+7) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+7) = vr_t(i_1+7) + tmp1
!<<<        tmp1 = ai0_7 * ui0
            tmp1h = ai0_7h * ui0h
            t_u1 = 134217729.0 * ai0_7h
            t_p1 = t_u1
     +               - (t_u1 - ai0_7h)
            t_p2 = ai0_7h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_7h*ui0l
     +            + ai0_7l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_7 * ui0
!<<<        vr_t(i_1+7) = vr_t(i_1+7) + tmp1
            t_p1 = vr_th(i_1+7) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+7)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+7) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+7) + tmp1l
            vr_th(i_1+7) = t_q1 + t_q2
            vr_tl(i_1+7) = t_q2 - (vr_th(i_1+7) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+7) = vr_t(i_1+7) + tmp1

!            vi_t(i_1+7) = vi_t(i_1+7)
!     &                  + (ar0_7*ui0)
!     &                  - (ai0_7*ur0)
!<<<        tmp1 = ar0_7 * ui0
            tmp1h = ar0_7h * ui0h
            t_u1 = 134217729.0 * ar0_7h
            t_p1 = t_u1
     +               - (t_u1 - ar0_7h)
            t_p2 = ar0_7h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_7h*ui0l
     +            + ar0_7l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_7 * ui0
!<<<        vi_t(i_1+7) = vi_t(i_1+7) + tmp1
            t_p1 = vi_th(i_1+7) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+7)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+7) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+7) + tmp1l
            vi_th(i_1+7) = t_q1 + t_q2
            vi_tl(i_1+7) = t_q2 - (vi_th(i_1+7) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+7) = vi_t(i_1+7) + tmp1
!<<<        tmp1 = ai0_7 * ur0
            tmp1h = ai0_7h * ur0h
            t_u1 = 134217729.0 * ai0_7h
            t_p1 = t_u1
     +               - (t_u1 - ai0_7h)
            t_p2 = ai0_7h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_7h*ur0l
     +            + ai0_7l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_7 * ur0
!<<<        vi_t(i_1+7) = vi_t(i_1+7) - tmp1
            t_p1 = vi_th(i_1+7) - tmp1h
            t_p2 = t_p1 - vi_th(i_1+7)
            t_ch = t_p1
            t_cl = (vi_th(i_1+7) - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vi_tl(i_1+7) - tmp1l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+7) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+7) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+7) = vi_t(i_1+7) - tmp1
!            vr0 = vr0
!     &                  + (ar0_4*ur_y(i_1+4))
!     &                  - (ai0_4*ui_y(i_1+4))
!     &                  + (ar0_5*ur_y(i_1+5))
!     &                  - (ai0_5*ui_y(i_1+5))
!     &                  + (ar0_6*ur_y(i_1+6))
!     &                  - (ai0_6*ui_y(i_1+6))
!     &                  + (ar0_7*ur_y(i_1+7))
!     &                  - (ai0_7*ui_y(i_1+7))
!<<<        tmp1 = ar0_4 * ur_y(i_1+4)
            tmp1h = ar0_4h * ur_yh(i_1+4)
            t_u1 = 134217729.0 * ar0_4h
            t_p1 = t_u1
     +               - (t_u1 - ar0_4h)
            t_p2 = ar0_4h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+4)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+4))
            t_r2 = ur_yh(i_1+4) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_4h*ur_yl(i_1+4)
     +            + ar0_4l*ur_yh(i_1+4))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_4 * ur_y(i_1+4)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_4 * ui_y(i_1+4)
            tmp1h = ai0_4h * ui_yh(i_1+4)
            t_u1 = 134217729.0 * ai0_4h
            t_p1 = t_u1
     +               - (t_u1 - ai0_4h)
            t_p2 = ai0_4h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+4)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+4))
            t_r2 = ui_yh(i_1+4) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_4h*ui_yl(i_1+4)
     +            + ai0_4l*ui_yh(i_1+4))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_4 * ui_y(i_1+4)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_5 * ur_y(i_1+5)
            tmp1h = ar0_5h * ur_yh(i_1+5)
            t_u1 = 134217729.0 * ar0_5h
            t_p1 = t_u1
     +               - (t_u1 - ar0_5h)
            t_p2 = ar0_5h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+5)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+5))
            t_r2 = ur_yh(i_1+5) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_5h*ur_yl(i_1+5)
     +            + ar0_5l*ur_yh(i_1+5))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_5 * ur_y(i_1+5)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_5 * ui_y(i_1+5)
            tmp1h = ai0_5h * ui_yh(i_1+5)
            t_u1 = 134217729.0 * ai0_5h
            t_p1 = t_u1
     +               - (t_u1 - ai0_5h)
            t_p2 = ai0_5h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+5)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+5))
            t_r2 = ui_yh(i_1+5) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_5h*ui_yl(i_1+5)
     +            + ai0_5l*ui_yh(i_1+5))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_5 * ui_y(i_1+5)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_6 * ur_y(i_1+6)
            tmp1h = ar0_6h * ur_yh(i_1+6)
            t_u1 = 134217729.0 * ar0_6h
            t_p1 = t_u1
     +               - (t_u1 - ar0_6h)
            t_p2 = ar0_6h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+6)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+6))
            t_r2 = ur_yh(i_1+6) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_6h*ur_yl(i_1+6)
     +            + ar0_6l*ur_yh(i_1+6))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_6 * ur_y(i_1+6)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_6 * ui_y(i_1+6)
            tmp1h = ai0_6h * ui_yh(i_1+6)
            t_u1 = 134217729.0 * ai0_6h
            t_p1 = t_u1
     +               - (t_u1 - ai0_6h)
            t_p2 = ai0_6h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+6)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+6))
            t_r2 = ui_yh(i_1+6) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_6h*ui_yl(i_1+6)
     +            + ai0_6l*ui_yh(i_1+6))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_6 * ui_y(i_1+6)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_7 * ur_y(i_1+7)
            tmp1h = ar0_7h * ur_yh(i_1+7)
            t_u1 = 134217729.0 * ar0_7h
            t_p1 = t_u1
     +               - (t_u1 - ar0_7h)
            t_p2 = ar0_7h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+7)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+7))
            t_r2 = ur_yh(i_1+7) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_7h*ur_yl(i_1+7)
     +            + ar0_7l*ur_yh(i_1+7))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_7 * ur_y(i_1+7)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_7 * ui_y(i_1+7)
            tmp1h = ai0_7h * ui_yh(i_1+7)
            t_u1 = 134217729.0 * ai0_7h
            t_p1 = t_u1
     +               - (t_u1 - ai0_7h)
            t_p2 = ai0_7h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+7)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+7))
            t_r2 = ui_yh(i_1+7) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_7h*ui_yl(i_1+7)
     +            + ai0_7l*ui_yh(i_1+7))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_7 * ui_y(i_1+7)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!            vi0 = vi0
!     &                  + (ar0_4*ui_y(i_1+4))
!     &                  + (ai0_4*ur_y(i_1+4))
!     &                  + (ar0_5*ui_y(i_1+5))
!     &                  + (ai0_5*ur_y(i_1+5))
!     &                  + (ar0_6*ui_y(i_1+6))
!     &                  + (ai0_6*ur_y(i_1+6))
!     &                  + (ar0_7*ui_y(i_1+7))
!     &                  + (ai0_7*ur_y(i_1+7))
!<<<        tmp1 = ar0_4 * ui_y(i_1+4)
            tmp1h = ar0_4h * ui_yh(i_1+4)
            t_u1 = 134217729.0 * ar0_4h
            t_p1 = t_u1
     +               - (t_u1 - ar0_4h)
            t_p2 = ar0_4h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+4)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+4))
            t_r2 = ui_yh(i_1+4) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_4h*ui_yl(i_1+4)
     +            + ar0_4l*ui_yh(i_1+4))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_4 * ui_y(i_1+4)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_4 * ur_y(i_1+4)
            tmp1h = ai0_4h * ur_yh(i_1+4)
            t_u1 = 134217729.0 * ai0_4h
            t_p1 = t_u1
     +               - (t_u1 - ai0_4h)
            t_p2 = ai0_4h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+4)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+4))
            t_r2 = ur_yh(i_1+4) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_4h*ur_yl(i_1+4)
     +            + ai0_4l*ur_yh(i_1+4))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_4 * ur_y(i_1+4)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_5 * ui_y(i_1+5)
            tmp1h = ar0_5h * ui_yh(i_1+5)
            t_u1 = 134217729.0 * ar0_5h
            t_p1 = t_u1
     +               - (t_u1 - ar0_5h)
            t_p2 = ar0_5h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+5)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+5))
            t_r2 = ui_yh(i_1+5) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_5h*ui_yl(i_1+5)
     +            + ar0_5l*ui_yh(i_1+5))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_5 * ui_y(i_1+5)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_5 * ur_y(i_1+5)
            tmp1h = ai0_5h * ur_yh(i_1+5)
            t_u1 = 134217729.0 * ai0_5h
            t_p1 = t_u1
     +               - (t_u1 - ai0_5h)
            t_p2 = ai0_5h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+5)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+5))
            t_r2 = ur_yh(i_1+5) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_5h*ur_yl(i_1+5)
     +            + ai0_5l*ur_yh(i_1+5))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_5 * ur_y(i_1+5)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_6 * ui_y(i_1+6)
            tmp1h = ar0_6h * ui_yh(i_1+6)
            t_u1 = 134217729.0 * ar0_6h
            t_p1 = t_u1
     +               - (t_u1 - ar0_6h)
            t_p2 = ar0_6h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+6)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+6))
            t_r2 = ui_yh(i_1+6) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_6h*ui_yl(i_1+6)
     +            + ar0_6l*ui_yh(i_1+6))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_6 * ui_y(i_1+6)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_6 * ur_y(i_1+6)
            tmp1h = ai0_6h * ur_yh(i_1+6)
            t_u1 = 134217729.0 * ai0_6h
            t_p1 = t_u1
     +               - (t_u1 - ai0_6h)
            t_p2 = ai0_6h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+6)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+6))
            t_r2 = ur_yh(i_1+6) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_6h*ur_yl(i_1+6)
     +            + ai0_6l*ur_yh(i_1+6))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_6 * ur_y(i_1+6)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_7 * ui_y(i_1+7)
            tmp1h = ar0_7h * ui_yh(i_1+7)
            t_u1 = 134217729.0 * ar0_7h
            t_p1 = t_u1
     +               - (t_u1 - ar0_7h)
            t_p2 = ar0_7h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+7)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+7))
            t_r2 = ui_yh(i_1+7) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_7h*ui_yl(i_1+7)
     +            + ar0_7l*ui_yh(i_1+7))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_7 * ui_y(i_1+7)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_7 * ur_y(i_1+7)
            tmp1h = ai0_7h * ur_yh(i_1+7)
            t_u1 = 134217729.0 * ai0_7h
            t_p1 = t_u1
     +               - (t_u1 - ai0_7h)
            t_p2 = ai0_7h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+7)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+7))
            t_r2 = ur_yh(i_1+7) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_7h*ur_yl(i_1+7)
     +            + ai0_7l*ur_yh(i_1+7))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_7 * ur_y(i_1+7)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!            ar0_8 = ar(j_1+0,i_1+8)
!            ai0_8 = ai(j_1+0,i_1+8)
!            ar0_9 = ar(j_1+0,i_1+9)
!            ai0_9 = ai(j_1+0,i_1+9)
            ar0_8h = arh(j_1+0,i_1+8)
            ar0_8l = arl(j_1+0,i_1+8)
            ai0_8h = aih(j_1+0,i_1+8)
            ai0_8l = ail(j_1+0,i_1+8)
            ar0_9h = arh(j_1+0,i_1+9)
            ar0_9l = arl(j_1+0,i_1+9)
            ai0_9h = aih(j_1+0,i_1+9)
            ai0_9l = ail(j_1+0,i_1+9)
!            vr_t(i_1+8) = vr_t(i_1+8)
!     &                  + (ar0_8*ur0)
!     &                  + (ai0_8*ui0)
!<<<        tmp1 = ar0_8 * ur0
            tmp1h = ar0_8h * ur0h
            t_u1 = 134217729.0 * ar0_8h
            t_p1 = t_u1
     +               - (t_u1 - ar0_8h)
            t_p2 = ar0_8h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_8h*ur0l
     +            + ar0_8l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_8 * ur0
!<<<        vr_t(i_1+8) = vr_t(i_1+8) + tmp1
            t_p1 = vr_th(i_1+8) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+8)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+8) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+8) + tmp1l
            vr_th(i_1+8) = t_q1 + t_q2
            vr_tl(i_1+8) = t_q2 - (vr_th(i_1+8) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+8) = vr_t(i_1+8) + tmp1
!<<<        tmp1 = ai0_8 * ui0
            tmp1h = ai0_8h * ui0h
            t_u1 = 134217729.0 * ai0_8h
            t_p1 = t_u1
     +               - (t_u1 - ai0_8h)
            t_p2 = ai0_8h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_8h*ui0l
     +            + ai0_8l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_8 * ui0
!<<<        vr_t(i_1+8) = vr_t(i_1+8) + tmp1
            t_p1 = vr_th(i_1+8) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+8)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+8) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+8) + tmp1l
            vr_th(i_1+8) = t_q1 + t_q2
            vr_tl(i_1+8) = t_q2 - (vr_th(i_1+8) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+8) = vr_t(i_1+8) + tmp1

!            vi_t(i_1+8) = vi_t(i_1+8)
!     &                  + (ar0_8*ui0)
!     &                  - (ai0_8*ur0)
!            vr_t(i_1+9) = vr_t(i_1+9)
!     &                  + (ar0_9*ur0)
!     &                  + (ai0_9*ui0)
!<<<        tmp1 = ar0_8 * ui0
            tmp1h = ar0_8h * ui0h
            t_u1 = 134217729.0 * ar0_8h
            t_p1 = t_u1
     +               - (t_u1 - ar0_8h)
            t_p2 = ar0_8h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_8h*ui0l
     +            + ar0_8l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_8 * ui0
!<<<        vi_t(i_1+8) = vi_t(i_1+8) + tmp1
            t_p1 = vi_th(i_1+8) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+8)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+8) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+8) + tmp1l
            vi_th(i_1+8) = t_q1 + t_q2
            vi_tl(i_1+8) = t_q2 - (vi_th(i_1+8) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+8) = vi_t(i_1+8) + tmp1
!<<<        tmp1 = ai0_8 * ur0
            tmp1h = ai0_8h * ur0h
            t_u1 = 134217729.0 * ai0_8h
            t_p1 = t_u1
     +               - (t_u1 - ai0_8h)
            t_p2 = ai0_8h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_8h*ur0l
     +            + ai0_8l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_8 * ur0
!<<<        vi_t(i_1+8) = vi_t(i_1+8) - tmp1
            t_p1 = vi_th(i_1+8) - tmp1h
            t_p2 = t_p1 - vi_th(i_1+8)
            t_ch = t_p1
            t_cl = (vi_th(i_1+8) - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vi_tl(i_1+8) - tmp1l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+8) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+8) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+8) = vi_t(i_1+8) - tmp1
!<<<        tmp1 = ar0_9 * ur0
            tmp1h = ar0_9h * ur0h
            t_u1 = 134217729.0 * ar0_9h
            t_p1 = t_u1
     +               - (t_u1 - ar0_9h)
            t_p2 = ar0_9h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_9h*ur0l
     +            + ar0_9l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_9 * ur0
!<<<        vr_t(i_1+9) = vr_t(i_1+9) + tmp1
            t_p1 = vr_th(i_1+9) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+9)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+9) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+9) + tmp1l
            vr_th(i_1+9) = t_q1 + t_q2
            vr_tl(i_1+9) = t_q2 - (vr_th(i_1+9) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+9) = vr_t(i_1+9) + tmp1
!<<<        tmp1 = ai0_9 * ui0
            tmp1h = ai0_9h * ui0h
            t_u1 = 134217729.0 * ai0_9h
            t_p1 = t_u1
     +               - (t_u1 - ai0_9h)
            t_p2 = ai0_9h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_9h*ui0l
     +            + ai0_9l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_9 * ui0
!<<<        vr_t(i_1+9) = vr_t(i_1+9) + tmp1
            t_p1 = vr_th(i_1+9) + tmp1h
            t_p2 = t_p1 - vr_th(i_1+9)
            t_q1 = t_p1
            t_q2 = (vr_th(i_1+9) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr_tl(i_1+9) + tmp1l
            vr_th(i_1+9) = t_q1 + t_q2
            vr_tl(i_1+9) = t_q2 - (vr_th(i_1+9) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr_t(i_1+9) = vr_t(i_1+9) + tmp1

!            vi_t(i_1+9) = vi_t(i_1+9)
!     &                  + (ar0_9*ui0)
!     &                  - (ai0_9*ur0)
!<<<        tmp1 = ar0_9 * ui0
            tmp1h = ar0_9h * ui0h
            t_u1 = 134217729.0 * ar0_9h
            t_p1 = t_u1
     +               - (t_u1 - ar0_9h)
            t_p2 = ar0_9h - t_p1
            t_u1 = 134217729.0 * ui0h
            t_r1 = t_u1
     +               - (t_u1 - ui0h)
            t_r2 = ui0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_9h*ui0l
     +            + ar0_9l*ui0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_9 * ui0
!<<<        vi_t(i_1+9) = vi_t(i_1+9) + tmp1
            t_p1 = vi_th(i_1+9) + tmp1h
            t_p2 = t_p1 - vi_th(i_1+9)
            t_q1 = t_p1
            t_q2 = (vi_th(i_1+9) - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi_tl(i_1+9) + tmp1l
            vi_th(i_1+9) = t_q1 + t_q2
            vi_tl(i_1+9) = t_q2 - (vi_th(i_1+9) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi_t(i_1+9) = vi_t(i_1+9) + tmp1
!<<<        tmp1 = ai0_9 * ur0
            tmp1h = ai0_9h * ur0h
            t_u1 = 134217729.0 * ai0_9h
            t_p1 = t_u1
     +               - (t_u1 - ai0_9h)
            t_p2 = ai0_9h - t_p1
            t_u1 = 134217729.0 * ur0h
            t_r1 = t_u1
     +               - (t_u1 - ur0h)
            t_r2 = ur0h - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_9h*ur0l
     +            + ai0_9l*ur0h)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_9 * ur0
!<<<        vi_t(i_1+9) = vi_t(i_1+9) - tmp1
            t_p1 = vi_th(i_1+9) - tmp1h
            t_p2 = t_p1 - vi_th(i_1+9)
            t_ch = t_p1
            t_cl = (vi_th(i_1+9) - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vi_tl(i_1+9) - tmp1l
            t_s1 = t_ch + t_cl
            vi_tl(i_1+9) = t_cl - (t_s1 - t_ch)
            vi_th(i_1+9) = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vi_t(i_1+9) = vi_t(i_1+9) - tmp1
!            vr0 = vr0
!     &                  + (ar0_8*ur_y(i_1+8))
!     &                  - (ai0_8*ui_y(i_1+8))
!     &                  + (ar0_9*ur_y(i_1+9))
!     &                  - (ai0_9*ui_y(i_1+9))
!            vi0 = vi0
!     &                  + (ar0_8*ui_y(i_1+8))
!     &                  + (ai0_8*ur_y(i_1+8))
!     &                  + (ar0_9*ui_y(i_1+9))
!     &                  + (ai0_9*ur_y(i_1+9))
!<<<        tmp1 = ar0_8 * ur_y(i_1+8)
            tmp1h = ar0_8h * ur_yh(i_1+8)
            t_u1 = 134217729.0 * ar0_8h
            t_p1 = t_u1
     +               - (t_u1 - ar0_8h)
            t_p2 = ar0_8h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+8)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+8))
            t_r2 = ur_yh(i_1+8) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_8h*ur_yl(i_1+8)
     +            + ar0_8l*ur_yh(i_1+8))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_8 * ur_y(i_1+8)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_8 * ui_y(i_1+8)
            tmp1h = ai0_8h * ui_yh(i_1+8)
            t_u1 = 134217729.0 * ai0_8h
            t_p1 = t_u1
     +               - (t_u1 - ai0_8h)
            t_p2 = ai0_8h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+8)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+8))
            t_r2 = ui_yh(i_1+8) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_8h*ui_yl(i_1+8)
     +            + ai0_8l*ui_yh(i_1+8))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_8 * ui_y(i_1+8)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_9 * ur_y(i_1+9)
            tmp1h = ar0_9h * ur_yh(i_1+9)
            t_u1 = 134217729.0 * ar0_9h
            t_p1 = t_u1
     +               - (t_u1 - ar0_9h)
            t_p2 = ar0_9h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+9)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+9))
            t_r2 = ur_yh(i_1+9) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_9h*ur_yl(i_1+9)
     +            + ar0_9l*ur_yh(i_1+9))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_9 * ur_y(i_1+9)
!<<<        vr0 = vr0 + tmp1
            t_p1 = vr0h + tmp1h
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vr0l + tmp1l
            vr0h = t_q1 + t_q2
            vr0l = t_q2 - (vr0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vr0 = vr0 + tmp1
!<<<        tmp1 = ai0_9 * ui_y(i_1+9)
            tmp1h = ai0_9h * ui_yh(i_1+9)
            t_u1 = 134217729.0 * ai0_9h
            t_p1 = t_u1
     +               - (t_u1 - ai0_9h)
            t_p2 = ai0_9h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+9)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+9))
            t_r2 = ui_yh(i_1+9) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_9h*ui_yl(i_1+9)
     +            + ai0_9l*ui_yh(i_1+9))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_9 * ui_y(i_1+9)
!<<<        vr0 = vr0 - tmp1
            t_p1 = vr0h - tmp1h
            t_p2 = t_p1 - vr0h
            t_ch = t_p1
            t_cl = (vr0h - (t_p1 - t_p2))
     +               - (tmp1h + t_p2)
            t_cl = t_cl + vr0l - tmp1l
            t_s1 = t_ch + t_cl
            vr0l = t_cl - (t_s1 - t_ch)
            vr0h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>        vr0 = vr0 - tmp1
!<<<        tmp1 = ar0_8 * ui_y(i_1+8)
            tmp1h = ar0_8h * ui_yh(i_1+8)
            t_u1 = 134217729.0 * ar0_8h
            t_p1 = t_u1
     +               - (t_u1 - ar0_8h)
            t_p2 = ar0_8h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+8)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+8))
            t_r2 = ui_yh(i_1+8) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_8h*ui_yl(i_1+8)
     +            + ar0_8l*ui_yh(i_1+8))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_8 * ui_y(i_1+8)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_8 * ur_y(i_1+8)
            tmp1h = ai0_8h * ur_yh(i_1+8)
            t_u1 = 134217729.0 * ai0_8h
            t_p1 = t_u1
     +               - (t_u1 - ai0_8h)
            t_p2 = ai0_8h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+8)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+8))
            t_r2 = ur_yh(i_1+8) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_8h*ur_yl(i_1+8)
     +            + ai0_8l*ur_yh(i_1+8))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_8 * ur_y(i_1+8)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ar0_9 * ui_y(i_1+9)
            tmp1h = ar0_9h * ui_yh(i_1+9)
            t_u1 = 134217729.0 * ar0_9h
            t_p1 = t_u1
     +               - (t_u1 - ar0_9h)
            t_p2 = ar0_9h - t_p1
            t_u1 = 134217729.0 * ui_yh(i_1+9)
            t_r1 = t_u1
     +               - (t_u1 - ui_yh(i_1+9))
            t_r2 = ui_yh(i_1+9) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ar0_9h*ui_yl(i_1+9)
     +            + ar0_9l*ui_yh(i_1+9))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ar0_9 * ui_y(i_1+9)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1
!<<<        tmp1 = ai0_9 * ur_y(i_1+9)
            tmp1h = ai0_9h * ur_yh(i_1+9)
            t_u1 = 134217729.0 * ai0_9h
            t_p1 = t_u1
     +               - (t_u1 - ai0_9h)
            t_p2 = ai0_9h - t_p1
            t_u1 = 134217729.0 * ur_yh(i_1+9)
            t_r1 = t_u1
     +               - (t_u1 - ur_yh(i_1+9))
            t_r2 = ur_yh(i_1+9) - t_r1
            tmp1l = ((t_p1*t_r1
     +              - tmp1h)
     +              + t_p1 * t_r2
     +              + t_p2 * t_r1)
     +              + t_p2 * t_r2
            tmp1l = tmp1l
     +            + (ai0_9h*ur_yl(i_1+9)
     +            + ai0_9l*ur_yh(i_1+9))
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>        tmp1 = ai0_9 * ur_y(i_1+9)
!<<<        vi0 = vi0 + tmp1
            t_p1 = vi0h + tmp1h
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (tmp1h - t_p2)
            t_q2 = t_q2 + vi0l + tmp1l
            vi0h = t_q1 + t_q2
            vi0l = t_q2 - (vi0h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        vi0 = vi0 + tmp1

!            ur_t(j_1+0) = vr0 + ur_t(j_1+0)
!            ui_t(j_1+0) = vi0 + ui_t(j_1+0)
!<<<        ur_t(j_1+0) = vr0 + ur_t(j_1+0)
            t_p1 = vr0h + ur_th(j_1+0)
            t_p2 = t_p1 - vr0h
            t_q1 = t_p1
            t_q2 = (vr0h - (t_p1 - t_p2))
     +               + (ur_th(j_1+0) - t_p2)
            t_q2 = t_q2 + vr0l + ur_tl(j_1+0)
            ur_th(j_1+0) = t_q1 + t_q2
            ur_tl(j_1+0) = t_q2 - (ur_th(j_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        ur_t(j_1+0) = vr0 + ur_t(j_1+0)
!<<<        ui_t(j_1+0) = vi0 + ui_t(j_1+0)
            t_p1 = vi0h + ui_th(j_1+0)
            t_p2 = t_p1 - vi0h
            t_q1 = t_p1
            t_q2 = (vi0h - (t_p1 - t_p2))
     +               + (ui_th(j_1+0) - t_p2)
            t_q2 = t_q2 + vi0l + ui_tl(j_1+0)
            ui_th(j_1+0) = t_q1 + t_q2
            ui_tl(j_1+0) = t_q2 - (ui_th(j_1+0) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>        ui_t(j_1+0) = vi0 + ui_t(j_1+0)

         end do! j_1

      end do! i_1

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_Au_step1:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_Au_step1:ui_x")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_Au_step1:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_Au_step1:ui_y")
      end function
#endif
      end subroutine ! ddeigen_hrd_Au_step1

!      subroutine  eigen_hrd_Au_step2(
!     &            ur_t,ui_t, ur_z,ui_z,
!     &            vr_t,vi_t, vr_z,vi_z, nv, x_pos, y_pos
!     &           ,local_rank, local_size
      subroutine  ddeigen_hrd_Au_step2(
     &            ur_th,ur_tl,ui_th,ui_tl,ur_zh,ur_zl,ui_zh,ui_zl,
     &            vr_th,vr_tl,vi_th,vi_tl,vr_zh,vr_zl,vi_zh,vi_zl, nv,
     &            x_pos, y_pos,
     &            local_rank, local_size
#ifdef MEMORY1
! vr_x > ur_t, vi_x > ui_t
     &      ,nxx_ur_t,nxx_ui_t
     &      ,nxx_vr_t,nxx_vi_t
#endif
     &            )
      implicit none

      integer, intent(in)    :: nv, x_pos, y_pos
!      real(8), intent(out)   :: ur_t(1:nv),   ui_t(1:nv)
!      real(8), intent(out)   :: vr_t(1:nv),   vi_t(1:nv)
!      real(8), intent(in)    :: ur_z(1:nv,*), ui_z(1:nv,*)
!      real(8), intent(in)    :: vr_z(1:nv,*), vi_z(1:nv,*)
      real(8), intent(out)   :: ur_th(1:nv),   ui_th(1:nv)
      real(8), intent(out)   :: vr_th(1:nv),   vi_th(1:nv)
      real(8), intent(in)    :: ur_zh(1:nv,*), ui_zh(1:nv,*)
      real(8), intent(in)    :: vr_zh(1:nv,*), vi_zh(1:nv,*)
      real(8), intent(out)   :: ur_tl(1:nv),   ui_tl(1:nv)
      real(8), intent(out)   :: vr_tl(1:nv),   vi_tl(1:nv)
      real(8), intent(in)    :: ur_zl(1:nv,*), ui_zl(1:nv,*)
      real(8), intent(in)    :: vr_zl(1:nv,*), vi_zl(1:nv,*)

      integer                :: local_rank, local_size
      integer                :: j_1, j_2, j_3, j_4
      integer                :: jj_1, jj_2, jj_3, jj_4
      integer                :: i, j, k
      integer, parameter     :: lx = 1024
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_t
      integer,intent(in) :: nxx_ui_t
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
#endif
#ifdef MEMORY1
      integer :: nxx
#endif
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      jj_1 = x_pos
      jj_2 = (jj_1-1)/local_size+1
      jj_3 =    (jj_2*(local_rank+0)     )+1
      jj_4 = min(jj_2*(local_rank+1),jj_1)

      if ( jj_2 < 1024 ) then
         if(local_rank==0)then
            jj_3=1; jj_4=x_pos
         else
            jj_3=1; jj_4=0
         endif
      endif

      j_3=jj_3; j_4=jj_4
#ifdef MEMORY1
      nxx = xx_ur_t(4260,j_4)
      nxx = xx_ui_t(4270,j_4)
#endif
      if ( mod(local_size,2) == 1 ) then
         do j_1=j_3,j_4
!            ur_t(j_1) = ur_z(j_1,1)
!            ui_t(j_1) = ui_z(j_1,1)
            ur_th(j_1) = ur_zh(j_1,1)
            ur_tl(j_1) = ur_zl(j_1,1)
            ui_th(j_1) = ui_zh(j_1,1)
            ui_tl(j_1) = ui_zl(j_1,1)
         end do
      else
         do j_1=j_3,j_4
!            ur_t(j_1) = ur_z(j_1,1)+ur_z(j_1,2)
!            ui_t(j_1) = ui_z(j_1,1)+ui_z(j_1,2)
!<<<        ur_t(j_1) = ur_z(j_1,1) + ur_z(j_1,2)
            t_p1 = ur_zh(j_1,1) + ur_zh(j_1,2)
            t_p2 = t_p1 - ur_zh(j_1,1)
            ur_th(j_1) = t_p1
            ur_tl(j_1) = (ur_zh(j_1,1) - (t_p1 - t_p2))
     +            + (ur_zh(j_1,2) - t_p2)
            ur_tl(j_1) = ur_tl(j_1) + ur_zl(j_1,1) + ur_zl(j_1,2)
            t_s1 = ur_th(j_1) + ur_tl(j_1)
            ur_tl(j_1) = ur_tl(j_1) - (t_s1 - ur_th(j_1))
            ur_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        ur_t(j_1) = ur_z(j_1,1) + ur_z(j_1,2)
!<<<        ui_t(j_1) = ui_z(j_1,1) + ui_z(j_1,2)
            t_p1 = ui_zh(j_1,1) + ui_zh(j_1,2)
            t_p2 = t_p1 - ui_zh(j_1,1)
            ui_th(j_1) = t_p1
            ui_tl(j_1) = (ui_zh(j_1,1) - (t_p1 - t_p2))
     +            + (ui_zh(j_1,2) - t_p2)
            ui_tl(j_1) = ui_tl(j_1) + ui_zl(j_1,1) + ui_zl(j_1,2)
            t_s1 = ui_th(j_1) + ui_tl(j_1)
            ui_tl(j_1) = ui_tl(j_1) - (t_s1 - ui_th(j_1))
            ui_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        ui_t(j_1) = ui_z(j_1,1) + ui_z(j_1,2)
         end do
      end if
      do j=mod(local_size-1,2)+2,local_size,2
         do j_1=j_3,j_4
!            ur_t(j_1) = ur_t(j_1)+ur_z(j_1,j+0)+ur_z(j_1,j+1)
!            ui_t(j_1) = ui_t(j_1)+ui_z(j_1,j+0)+ui_z(j_1,j+1)
!<<<        tmp1 = ur_t(j_1) + ur_z(j_1,j+0)
            t_p1 = ur_th(j_1) + ur_zh(j_1,j+0)
            t_p2 = t_p1 - ur_th(j_1)
            tmp1h = t_p1
            tmp1l = (ur_th(j_1) - (t_p1 - t_p2))
     +            + (ur_zh(j_1,j+0) - t_p2)
            tmp1l = tmp1l + ur_tl(j_1) + ur_zl(j_1,j+0)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        tmp1 = ur_t(j_1) + ur_z(j_1,j+0)
!<<<        ur_t(j_1) = tmp1 + ur_z(j_1,j+1)
            t_p1 = tmp1h + ur_zh(j_1,j+1)
            t_p2 = t_p1 - tmp1h
            ur_th(j_1) = t_p1
            ur_tl(j_1) = (tmp1h - (t_p1 - t_p2))
     +            + (ur_zh(j_1,j+1) - t_p2)
            ur_tl(j_1) = ur_tl(j_1) + tmp1l + ur_zl(j_1,j+1)
            t_s1 = ur_th(j_1) + ur_tl(j_1)
            ur_tl(j_1) = ur_tl(j_1) - (t_s1 - ur_th(j_1))
            ur_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        ur_t(j_1) = tmp1 + ur_z(j_1,j+1)
!<<<        tmp1 = ui_t(j_1) + ui_z(j_1,j+0)
            t_p1 = ui_th(j_1) + ui_zh(j_1,j+0)
            t_p2 = t_p1 - ui_th(j_1)
            tmp1h = t_p1
            tmp1l = (ui_th(j_1) - (t_p1 - t_p2))
     +            + (ui_zh(j_1,j+0) - t_p2)
            tmp1l = tmp1l + ui_tl(j_1) + ui_zl(j_1,j+0)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        tmp1 = ui_t(j_1) + ui_z(j_1,j+0)
!<<<        ui_t(j_1) = tmp1 + ui_z(j_1,j+1)
            t_p1 = tmp1h + ui_zh(j_1,j+1)
            t_p2 = t_p1 - tmp1h
            ui_th(j_1) = t_p1
            ui_tl(j_1) = (tmp1h - (t_p1 - t_p2))
     +            + (ui_zh(j_1,j+1) - t_p2)
            ui_tl(j_1) = ui_tl(j_1) + tmp1l + ui_zl(j_1,j+1)
            t_s1 = ui_th(j_1) + ui_tl(j_1)
            ui_tl(j_1) = ui_tl(j_1) - (t_s1 - ui_th(j_1))
            ui_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        ui_t(j_1) = tmp1 + ui_z(j_1,j+1)
         end do
      end do

      jj_1 = y_pos
      jj_2 = (jj_1-1)/local_size+1
      jj_3 =    (jj_2*(local_rank+0)     )+1
      jj_4 = min(jj_2*(local_rank+1),jj_1)

      if ( jj_2 < 1024 ) then
         if(local_rank==0)then
            jj_3=1; jj_4=y_pos
         else
            jj_3=1; jj_4=0
         endif
      endif

      j_3=jj_3; j_4=jj_4
#ifdef MEMORY1
      if (j_3 <= j_4) then
      nxx = xx_vr_t(4280,j_4)
      nxx = xx_vi_t(4290,j_4)
      end if
#endif
      if ( mod(local_size,2) == 1 ) then
         do j_1=j_3,j_4
!            vr_t(j_1) = vr_z(j_1,1)
!            vi_t(j_1) = vi_z(j_1,1)
            vr_th(j_1) = vr_zh(j_1,1)
            vr_tl(j_1) = vr_zl(j_1,1)
            vi_th(j_1) = vi_zh(j_1,1)
            vi_tl(j_1) = vi_zl(j_1,1)
         end do
      else
         do j_1=j_3,j_4
!            vr_t(j_1) = vr_z(j_1,1)+vr_z(j_1,2)
!            vi_t(j_1) = vi_z(j_1,1)+vi_z(j_1,2)
!<<<        vr_t(j_1) = vr_z(j_1,1) + vr_z(j_1,2)
            t_p1 = vr_zh(j_1,1) + vr_zh(j_1,2)
            t_p2 = t_p1 - vr_zh(j_1,1)
            vr_th(j_1) = t_p1
            vr_tl(j_1) = (vr_zh(j_1,1) - (t_p1 - t_p2))
     +            + (vr_zh(j_1,2) - t_p2)
            vr_tl(j_1) = vr_tl(j_1) + vr_zl(j_1,1) + vr_zl(j_1,2)
            t_s1 = vr_th(j_1) + vr_tl(j_1)
            vr_tl(j_1) = vr_tl(j_1) - (t_s1 - vr_th(j_1))
            vr_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        vr_t(j_1) = vr_z(j_1,1) + vr_z(j_1,2)
!<<<        vi_t(j_1) = vi_z(j_1,1) + vi_z(j_1,2)
            t_p1 = vi_zh(j_1,1) + vi_zh(j_1,2)
            t_p2 = t_p1 - vi_zh(j_1,1)
            vi_th(j_1) = t_p1
            vi_tl(j_1) = (vi_zh(j_1,1) - (t_p1 - t_p2))
     +            + (vi_zh(j_1,2) - t_p2)
            vi_tl(j_1) = vi_tl(j_1) + vi_zl(j_1,1) + vi_zl(j_1,2)
            t_s1 = vi_th(j_1) + vi_tl(j_1)
            vi_tl(j_1) = vi_tl(j_1) - (t_s1 - vi_th(j_1))
            vi_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        vi_t(j_1) = vi_z(j_1,1) + vi_z(j_1,2)
         end do
      end if
      do j=mod(local_size-1,2)+2,local_size,2
         do j_1=j_3,j_4
!            vr_t(j_1) = vr_t(j_1)+vr_z(j_1,j+0)+vr_z(j_1,j+1)
!            vi_t(j_1) = vi_t(j_1)+vi_z(j_1,j+0)+vi_z(j_1,j+1)
!<<<        tmp1 = vr_t(j_1) + vr_z(j_1,j+0)
            t_p1 = vr_th(j_1) + vr_zh(j_1,j+0)
            t_p2 = t_p1 - vr_th(j_1)
            tmp1h = t_p1
            tmp1l = (vr_th(j_1) - (t_p1 - t_p2))
     +            + (vr_zh(j_1,j+0) - t_p2)
            tmp1l = tmp1l + vr_tl(j_1) + vr_zl(j_1,j+0)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        tmp1 = vr_t(j_1) + vr_z(j_1,j+0)
!<<<        vr_t(j_1) = tmp1 + vr_z(j_1,j+1)
            t_p1 = tmp1h + vr_zh(j_1,j+1)
            t_p2 = t_p1 - tmp1h
            vr_th(j_1) = t_p1
            vr_tl(j_1) = (tmp1h - (t_p1 - t_p2))
     +            + (vr_zh(j_1,j+1) - t_p2)
            vr_tl(j_1) = vr_tl(j_1) + tmp1l + vr_zl(j_1,j+1)
            t_s1 = vr_th(j_1) + vr_tl(j_1)
            vr_tl(j_1) = vr_tl(j_1) - (t_s1 - vr_th(j_1))
            vr_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        vr_t(j_1) = tmp1 + vr_z(j_1,j+1)
!<<<        tmp1 = vi_t(j_1) + vi_z(j_1,j+0)
            t_p1 = vi_th(j_1) + vi_zh(j_1,j+0)
            t_p2 = t_p1 - vi_th(j_1)
            tmp1h = t_p1
            tmp1l = (vi_th(j_1) - (t_p1 - t_p2))
     +            + (vi_zh(j_1,j+0) - t_p2)
            tmp1l = tmp1l + vi_tl(j_1) + vi_zl(j_1,j+0)
            t_s1 = tmp1h + tmp1l
            tmp1l = tmp1l - (t_s1 - tmp1h)
            tmp1h = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        tmp1 = vi_t(j_1) + vi_z(j_1,j+0)
!<<<        vi_t(j_1) = tmp1 + vi_z(j_1,j+1)
            t_p1 = tmp1h + vi_zh(j_1,j+1)
            t_p2 = t_p1 - tmp1h
            vi_th(j_1) = t_p1
            vi_tl(j_1) = (tmp1h - (t_p1 - t_p2))
     +            + (vi_zh(j_1,j+1) - t_p2)
            vi_tl(j_1) = vi_tl(j_1) + tmp1l + vi_zl(j_1,j+1)
            t_s1 = vi_th(j_1) + vi_tl(j_1)
            vi_tl(j_1) = vi_tl(j_1) - (t_s1 - vi_th(j_1))
            vi_th(j_1) = t_s1
#ifdef FPCOUNTER
#include "fadd.h"
#endif
!>>>        vi_t(j_1) = tmp1 + vi_z(j_1,j+1)
         end do
      end do

      return
#ifdef MEMORY1
      contains

      function xx_ur_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_t
      integer :: i0,i1
      xx_ur_t = nxx_ur_t + i1 - 1
      call accessor(i0,xx_ur_t,kxx_ur_t2,"ddeigen_hrd_Au_step2:ur_t2")
      end function

      function xx_ui_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_t
      integer :: i0,i1
      xx_ui_t = nxx_ui_t + i1 - 1
      call accessor(i0,xx_ui_t,kxx_ui_t2,"ddeigen_hrd_Au_step2:ui_t2")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_Au_step2:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_Au_step2:vi_t")
      end function
#endif
      end subroutine ! ddeigen_hrd_Au_step2

!      subroutine  eigen_hrd_Au_step3(
!     &              ur_x,ui_x,ur_y,ui_y,
!     &              vr_x,vi_x,
!     &              ur_t,ui_t,vr_t,vi_t,d_t,
!     &              n1,n2,x_pos,y_pos,nv
      subroutine  ddeigen_hrd_Au_step3(
     &              ur_xh,ur_xl,ui_xh,ui_xl,ur_yh,ur_yl,ui_yh,ui_yl,
     &              vr_xh,vr_xl,vi_xh,vi_xl,
     &              ur_th,ur_tl,ui_th,ui_tl,vr_th,vr_tl,vi_th,vi_tl,
     &              d_th,d_tl,
     &              n1,n2,x_pos,y_pos,nv
#ifdef MEMORY1
     &         ,nxx_ur_x,nxx_ui_x
     &         ,nxx_ur_y,nxx_ui_y
     &         ,nxx_vr_x,nxx_vi_x
     &         ,nxx_ur_t,nxx_ui_t,nxx_vr_t,nxx_vi_t
     &         ,nxx_d_t
#endif
     &            )
!----
!      use communication_h, only : translate_l2g
!     &               , translate_g2l
      use ddcommunication_h, only : translate_l2g
     &                            , translate_g2l
!----
      implicit none

      integer, intent(in)    :: nv, n1, n2
!      real(8), intent(in)    :: ur_x(1:nv),ui_x(1:nv)
!      real(8), intent(in)    :: ur_y(1:nv),ui_y(1:nv)
!      real(8), intent(inout) :: vr_x(1:nv),vi_x(1:nv)
!      real(8), intent(in)    :: ur_t(*),ui_t(*),vr_t(*),vi_t(*)
!      real(8), intent(in)    :: d_t(1:nv)
      real(8), intent(in)    :: ur_xh(1:nv),ui_xh(1:nv)
      real(8), intent(in)    :: ur_yh(1:nv),ui_yh(1:nv)
      real(8), intent(inout) :: vr_xh(1:nv),vi_xh(1:nv)
      real(8), intent(in)    :: ur_xl(1:nv),ui_xl(1:nv)
      real(8), intent(in)    :: ur_yl(1:nv),ui_yl(1:nv)
      real(8), intent(inout) :: vr_xl(1:nv),vi_xl(1:nv)
      real(8), intent(in)    :: ur_th(*),ui_th(*),vr_th(*),vi_th(*)
      real(8), intent(in)    :: ur_tl(*),ui_tl(*),vr_tl(*),vi_tl(*)
      real(8), intent(in)    :: d_th(1:nv),d_tl(1:nv)
      integer                :: x_pos, y_pos

      integer                :: i_2, i_3
      integer                :: i, j, k
      integer                :: nm1, nm2

      include 'mpif.h'
      include 'trd.h'
#ifdef MEMORY1
      integer,intent(in) :: nxx_ur_x
      integer,intent(in) :: nxx_ui_x
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_ur_t
      integer,intent(in) :: nxx_ui_t
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
#endif

      i_2 = n1
      i_3 = n2

      if ( diag_0 > 0 ) then

         j = translate_l2g(diag_0, size_of_row,my_row)
         j = translate_g2l(j, size_of_col,my_col)
         if ( j > nv ) return

         nm1 = size_of_row/n_common
         nm2 = size_of_col/n_common

         if ( nm2 == 1 ) then
            if ( nm1 == 1 ) then
!               call eigen_hrd_Au_step3_sub3(
!     &                vr_x(j), vi_x(j),
!     &                vr_t(diag_0), vi_t(diag_0),
!     &                d_t(diag_0),
!     &                ur_y(diag_0), ui_y(diag_0),
!     &                (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
               call ddeigen_hrd_Au_step3_sub3(
     &                vr_xh(j), vr_xl(j), vi_xh(j), vi_xl(j),
     &                vr_th(diag_0), vr_tl(diag_0),
     &                vi_th(diag_0), vi_tl(diag_0),
     &                d_th(diag_0), d_tl(diag_0),
     &                ur_yh(diag_0), ur_yl(diag_0),
     &                ui_yh(diag_0), ui_yl(diag_0),
     &                (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
#ifdef MEMORY1
     &               ,xx_vr_x(0,j)     , xx_vi_x(0,j)
     &               ,xx_vr_t(0,diag_0), xx_vi_t(0,diag_0)
     &               ,xx_d_t (0,diag_0)
     &               ,xx_ur_y(0,diag_0), xx_ui_y(0,diag_0)
#endif
     &              )
            else
!               call eigen_hrd_Au_step3_sub2(
!     &                vr_x(j), vi_x(j),
!     &                vr_t(diag_0), vi_t(diag_0),
!     &                d_t(diag_0),
!     &                ur_y(diag_0), ui_y(diag_0),
!     &                (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
               call ddeigen_hrd_Au_step3_sub2(
     &                vr_xh(j), vr_xl(j), vi_xh(j), vi_xl(j),
     &                vr_th(diag_0), vr_tl(diag_0),
     &                vi_th(diag_0), vi_tl(diag_0),
     &                d_th(diag_0), d_tl(diag_0),
     &                ur_yh(diag_0), ur_yl(diag_0),
     &                ui_yh(diag_0), ui_yl(diag_0),
     &                (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
#ifdef MEMORY1
     &               ,xx_vr_x(0,j)     , xx_vi_x(0,j)
     &               ,xx_vr_t(0,diag_0), xx_vi_t(0,diag_0)
     &               ,xx_d_t (0,diag_0)
     &               ,xx_ur_y(0,diag_0), xx_ui_y(0,diag_0)
#endif
     &              )
            end if
         else
!            call eigen_hrd_Au_step3_sub1(
!     &             vr_x(j), vi_x(j),
!     &             vr_t(diag_0), vi_t(diag_0),
!     &             d_t(diag_0),
!     &             ur_y(diag_0), ui_y(diag_0),
!     &             (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
            call ddeigen_hrd_Au_step3_sub1(
     &             vr_xh(j), vr_xl(j), vi_xh(j), vi_xl(j),
     &             vr_th(diag_0), vr_tl(diag_0), 
     &             vi_th(diag_0), vi_tl(diag_0),
     &             d_th(diag_0), d_tl(diag_0),
     &             ur_yh(diag_0), ur_yl(diag_0),
     &             ui_yh(diag_0), ui_yl(diag_0),
     &             (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
#ifdef MEMORY1
     &            ,xx_vr_x(0,j)     , xx_vi_x(0,j)
     &            ,xx_vr_t(0,diag_0), xx_vi_t(0,diag_0)
     &            ,xx_d_t (0,diag_0)
     &            ,xx_ur_y(0,diag_0), xx_ui_y(0,diag_0)
#endif
     &           )

         end if

      end if

      return
#ifdef MEMORY1
      contains

      function xx_ur_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_x
      integer :: i0,i1
      xx_ur_x = nxx_ur_x + i1 - 1
      call accessor(i0,xx_ur_x,kxx_ur_x,"ddeigen_hrd_Au_step3:ur_x")
      end function

      function xx_ui_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_x
      integer :: i0,i1
      xx_ui_x = nxx_ui_x + i1 - 1
      call accessor(i0,xx_ui_x,kxx_ui_x,"ddeigen_hrd_Au_step3:ui_x")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_Au_step3:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_Au_step3:ui_y")
      end function

      function xx_vr_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1
      xx_vr_x = nxx_vr_x + i1 - 1
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_Au_step3:vr_x")
      end function

      function xx_vi_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1
      xx_vi_x = nxx_vi_x + i1 - 1
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_Au_step3:vi_x")
      end function

      function xx_ur_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_t
      integer :: i0,i1
      xx_ur_t = nxx_ur_t + i1 - 1
      call accessor(i0,xx_ur_t,kxx_ur_t,"ddeigen_hrd_Au_step3:ur_t")
      end function

      function xx_ui_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_t
      integer :: i0,i1
      xx_ui_t = nxx_ui_t + i1 - 1
      call accessor(i0,xx_ui_t,kxx_ui_t,"ddeigen_hrd_Au_step3:ui_t")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_Au_step3:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_Au_step3:vi_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_Au_step3:d_t")
      end function
#endif
      end subroutine ! ddeigen_hrd_Au_step3

!      subroutine eigen_hrd_Au_step3_sub1(
!     &             vr_x,vi_x,vr_t,vi_t,d_t,ur_y,ui_y,
!     &             n,nm1,nm2
      subroutine ddeigen_hrd_Au_step3_sub1(
     &             vr_xh,vr_xl,vi_xh,vi_xl,vr_th,vr_tl,vi_th,vi_tl,
     &             d_th,d_tl,ur_yh,ur_yl,ui_yh,ui_yl,
     &             n,nm1,nm2
#ifdef MEMORY1
     &               ,nxx_vr_x, nxx_vi_x
     &               ,nxx_vr_t, nxx_vi_t
     &               ,nxx_d_t
     &               ,nxx_ur_y, nxx_ui_y
#endif
     &           )
      implicit none

      integer, intent(in)    :: n, nm1, nm2
!      real(8), intent(inout) :: vr_x(nm1,*), vi_x(nm1,*)
!      real(8), intent(in)    :: vr_t(nm2,*), vi_t(nm2,*)
!      real(8), intent(in)    :: d_t(nm2,*)
!      real(8), intent(in)    :: ur_y(nm2,*), ui_y(nm2,*)
      real(8), intent(inout) :: vr_xh(nm1,*), vi_xh(nm1,*)
      real(8), intent(in)    :: vr_th(nm2,*), vi_th(nm2,*)
      real(8), intent(in)    :: ur_yh(nm2,*), ui_yh(nm2,*)
      real(8), intent(inout) :: vr_xl(nm1,*), vi_xl(nm1,*)
      real(8), intent(in)    :: vr_tl(nm2,*), vi_tl(nm2,*)
      real(8), intent(in)    :: ur_yl(nm2,*), ui_yl(nm2,*)
      real(8), intent(in)    :: d_th(nm2,*), d_tl(nm2,*)
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      integer                :: i
#ifdef MEMORY1
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

#ifdef MEMORY1
      nxx = xx_vr_x(4300,1,n)
      nxx = xx_vr_t(4310,1,n)
      nxx = xx_ur_y(4320,1,n)
      nxx = xx_vi_x(4330,1,n)
      nxx = xx_vi_t(4340,1,n)
      nxx = xx_ui_y(4350,1,n)
      nxx = xx_d_t (4360,1,n)
#endif
      do i=1,n
!         vr_x(1,i) = vr_x(1,i)+vr_t(1,i)+d_t(1,i)*ur_y(1,i)
!         vi_x(1,i) = vi_x(1,i)+vi_t(1,i)+d_t(1,i)*ui_y(1,i)
!<<<     tmp1 = d_t(1,i) * ur_y(1,i)
         tmp1h = d_th(1,i) * ur_yh(1,i)
         t_u1 = 134217729.0 * d_th(1,i)
         t_p1 = t_u1
     +            - (t_u1 - d_th(1,i))
         t_p2 = d_th(1,i) - t_p1
         t_u1 = 134217729.0 * ur_yh(1,i)
         t_r1 = t_u1
     +            - (t_u1 - ur_yh(1,i))
         t_r2 = ur_yh(1,i) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (d_th(1,i)*ur_yl(1,i)
     +         + d_tl(1,i)*ur_yh(1,i))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = d_t(1,i) * ur_y(1,i)
!<<<     vr_x(1,i) = vr_x(1,i) + vr_t(1,i)
         t_p1 = vr_xh(1,i) + vr_th(1,i)
         t_p2 = t_p1 - vr_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vr_xh(1,i) - (t_p1 - t_p2))
     +            + (vr_th(1,i) - t_p2)
         t_q2 = t_q2 + vr_xl(1,i) + vr_tl(1,i)
         vr_xh(1,i) = t_q1 + t_q2
         vr_xl(1,i) = t_q2 - (vr_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vr_x(1,i) = vr_x(1,i) + vr_t(1,i)
!<<<     vr_x(1,i) = vr_x(1,i) + tmp1
         t_p1 = vr_xh(1,i) + tmp1h
         t_p2 = t_p1 - vr_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vr_xh(1,i) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + vr_xl(1,i) + tmp1l
         vr_xh(1,i) = t_q1 + t_q2
         vr_xl(1,i) = t_q2 - (vr_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vr_x(1,i) = vr_x(1,i) + tmp1
!<<<     tmp1 = d_t(1,i) * ui_y(1,i)
         tmp1h = d_th(1,i) * ui_yh(1,i)
         t_u1 = 134217729.0 * d_th(1,i)
         t_p1 = t_u1
     +            - (t_u1 - d_th(1,i))
         t_p2 = d_th(1,i) - t_p1
         t_u1 = 134217729.0 * ui_yh(1,i)
         t_r1 = t_u1
     +            - (t_u1 - ui_yh(1,i))
         t_r2 = ui_yh(1,i) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (d_th(1,i)*ui_yl(1,i)
     +         + d_tl(1,i)*ui_yh(1,i))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = d_t(1,i) * ui_y(1,i)
!<<<     vi_x(1,i) = vi_x(1,i) + vi_t(1,i)
         t_p1 = vi_xh(1,i) + vi_th(1,i)
         t_p2 = t_p1 - vi_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vi_xh(1,i) - (t_p1 - t_p2))
     +            + (vi_th(1,i) - t_p2)
         t_q2 = t_q2 + vi_xl(1,i) + vi_tl(1,i)
         vi_xh(1,i) = t_q1 + t_q2
         vi_xl(1,i) = t_q2 - (vi_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vi_x(1,i) = vi_x(1,i) + vi_t(1,i)
!<<<     vi_x(1,i) = vi_x(1,i) + tmp1
         t_p1 = vi_xh(1,i) + tmp1h
         t_p2 = t_p1 - vi_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vi_xh(1,i) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + vi_xl(1,i) + tmp1l
         vi_xh(1,i) = t_q1 + t_q2
         vi_xl(1,i) = t_q2 - (vi_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vi_x(1,i) = vi_x(1,i) + tmp1
      end do! i

      return
#ifdef MEMORY1
      contains

      function xx_vr_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1,i2
      xx_vr_x = nxx_vr_x + i1 - 1 + (i2 - 1)*nm1
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_Au_step3_sub1:vr_x")
      end function

      function xx_vi_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1,i2
      xx_vi_x = nxx_vi_x + i1 - 1 + (i2 - 1)*nm1
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_Au_step3_sub1:vi_x")
      end function

      function xx_vr_t(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1,i2
      xx_vr_t = nxx_vr_t + i1 - 1 + (i2 - 1)*nm2
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_Au_step3_sub1:vr_t")
      end function

      function xx_vi_t(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1,i2
      xx_vi_t = nxx_vi_t + i1 - 1 + (i2 - 1)*nm2
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_Au_step3_sub1:vi_t")
      end function

      function xx_ur_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1,i2
      xx_ur_y = nxx_ur_y + i1 - 1 + (i2 - 1)*nm2
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_Au_step3_sub1:ur_y")
      end function

      function xx_ui_y(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1,i2
      xx_ui_y = nxx_ui_y + i1 - 1 + (i2 - 1)*nm2
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_Au_step3_sub1:ui_y")
      end function

      function xx_d_t(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1,i2
      xx_d_t = nxx_d_t + i1 - 1 + (i2 - 1)*nm2
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_Au_step3_sub1:d_t")
      end function
#endif
      end subroutine ! eigen_hrd_Au_step3_sub1

!      subroutine eigen_hrd_Au_step3_sub2(
!     &             vr_x,vi_x,vr_t,vi_t,d_t,ur_y,ui_y
!     &            ,n,nm1,nm2
      subroutine ddeigen_hrd_Au_step3_sub2(
     &             vr_xh,vr_xl,vi_xh,vi_xl,vr_th,vr_tl,vi_th,vi_tl,
     &             d_th,d_tl,ur_yh,ur_yl,ui_yh,ui_yl,
     &             n,nm1,nm2
#ifdef MEMORY1
     &               ,nxx_vr_x, nxx_vi_x
     &               ,nxx_vr_t, nxx_vi_t
     &               ,nxx_d_t
     &               ,nxx_ur_y, nxx_ui_y
#endif
     &           )
      implicit none

      integer, intent(in)    :: n, nm1, nm2
!      real(8), intent(inout) :: vr_x(nm1,*), vi_x(nm1,*)
!      real(8), intent(in)    :: vr_t(*), vi_t(*)
!      real(8), intent(in)    :: d_t(*)
!      real(8), intent(in)    :: ur_y(*), ui_y(*)
      real(8), intent(inout) :: vr_xh(nm1,*), vi_xh(nm1,*)
      real(8), intent(inout) :: vr_xl(nm1,*), vi_xl(nm1,*)
      real(8), intent(in)    :: vr_th(*), vi_th(*)
      real(8), intent(in)    :: vr_tl(*), vi_tl(*)
      real(8), intent(in)    :: d_th(*), d_tl(*)
      real(8), intent(in)    :: ur_yh(*), ui_yh(*)
      real(8), intent(in)    :: ur_yl(*), ui_yl(*)
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      integer                :: i
#ifdef MEMORY1
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

#ifdef MEMORY1
      nxx = xx_vr_x(4370,1,n)
      nxx = xx_vr_t(4380,n)
      nxx = xx_ur_y(4390,n)
      nxx = xx_vi_x(4400,1,n)
      nxx = xx_vi_t(4410,n)
      nxx = xx_ui_y(4420,n)
      nxx = xx_d_t(4430,n)
#endif
      do i=1,n
!         vr_x(1,i) = vr_x(1,i)+vr_t(i)+d_t(i)*ur_y(i)
!         vi_x(1,i) = vi_x(1,i)+vi_t(i)+d_t(i)*ui_y(i)
!<<<     tmp1 = d_t(i) * ur_y(i)
         tmp1h = d_th(i) * ur_yh(i)
         t_u1 = 134217729.0 * d_th(i)
         t_p1 = t_u1
     +            - (t_u1 - d_th(i))
         t_p2 = d_th(i) - t_p1
         t_u1 = 134217729.0 * ur_yh(i)
         t_r1 = t_u1
     +            - (t_u1 - ur_yh(i))
         t_r2 = ur_yh(i) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (d_th(i)*ur_yl(i)
     +         + d_tl(i)*ur_yh(i))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = d_t(i) * ur_y(i)
!<<<     vr_x(1,i) = vr_x(1,i) + vr_t(i)
         t_p1 = vr_xh(1,i) + vr_th(i)
         t_p2 = t_p1 - vr_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vr_xh(1,i) - (t_p1 - t_p2))
     +            + (vr_th(i) - t_p2)
         t_q2 = t_q2 + vr_xl(1,i) + vr_tl(i)
         vr_xh(1,i) = t_q1 + t_q2
         vr_xl(1,i) = t_q2 - (vr_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vr_x(1,i) = vr_x(1,i) + vr_t(i)
!<<<     vr_x(1,i) = vr_x(1,i) + tmp1
         t_p1 = vr_xh(1,i) + tmp1h
         t_p2 = t_p1 - vr_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vr_xh(1,i) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + vr_xl(1,i) + tmp1l
         vr_xh(1,i) = t_q1 + t_q2
         vr_xl(1,i) = t_q2 - (vr_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vr_x(1,i) = vr_x(1,i) + tmp1
!<<<     tmp1 = d_t(i) * ui_y(i)
         tmp1h = d_th(i) * ui_yh(i)
         t_u1 = 134217729.0 * d_th(i)
         t_p1 = t_u1
     +            - (t_u1 - d_th(i))
         t_p2 = d_th(i) - t_p1
         t_u1 = 134217729.0 * ui_yh(i)
         t_r1 = t_u1
     +            - (t_u1 - ui_yh(i))
         t_r2 = ui_yh(i) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (d_th(i)*ui_yl(i)
     +         + d_tl(i)*ui_yh(i))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = d_t(i) * ui_y(i)
!<<<     vi_x(1,i) = vi_x(1,i) + vi_t(i)
         t_p1 = vi_xh(1,i) + vi_th(i)
         t_p2 = t_p1 - vi_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vi_xh(1,i) - (t_p1 - t_p2))
     +            + (vi_th(i) - t_p2)
         t_q2 = t_q2 + vi_xl(1,i) + vi_tl(i)
         vi_xh(1,i) = t_q1 + t_q2
         vi_xl(1,i) = t_q2 - (vi_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vi_x(1,i) = vi_x(1,i) + vi_t(i)
!<<<     vi_x(1,i) = vi_x(1,i) + tmp1
         t_p1 = vi_xh(1,i) + tmp1h
         t_p2 = t_p1 - vi_xh(1,i)
         t_q1 = t_p1
         t_q2 = (vi_xh(1,i) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + vi_xl(1,i) + tmp1l
         vi_xh(1,i) = t_q1 + t_q2
         vi_xl(1,i) = t_q2 - (vi_xh(1,i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vi_x(1,i) = vi_x(1,i) + tmp1
      end do! i

      return
#ifdef MEMORY1
      contains

      function xx_vr_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1,i2
      xx_vr_x = nxx_vr_x + i1 - 1 + (i2 - 1)*nm1
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_Au_step3_sub2:vr_x")
      end function

      function xx_vi_x(i0,i1,i2)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1,i2
      xx_vi_x = nxx_vi_x + i1 - 1 + (i2 - 1)*nm1
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_Au_step3_sub2:vi_x")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_Au_step3_sub2:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_Au_step3_sub2:vi_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_Au_step3_sub2:d_t")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_Au_step3_sub2:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_Au_step3_sub2:ui_y")
      end function
#endif
      end subroutine ! eigen_hrd_Au_step3_sub2

!      subroutine eigen_hrd_Au_step3_sub3(
!     &             vr_x,vi_x,vr_t,vi_t,d_t,ur_y,ui_y,
!     &             n,nm1,nm2
      subroutine ddeigen_hrd_Au_step3_sub3(
     &             vr_xh,vr_xl,vi_xh,vi_xl,vr_th,vr_tl,vi_th,vi_tl,
     &             d_th,d_tl,ur_yh,ur_yl,ui_yh,ui_yl,
     &             n,nm1,nm2
#ifdef MEMORY1
     &               ,nxx_vr_x, nxx_vi_x
     &               ,nxx_vr_t, nxx_vi_t
     &               ,nxx_d_t
     &               ,nxx_ur_y, nxx_ui_y
#endif
     &           )
      implicit none

      integer, intent(in)    :: n, nm1, nm2
!      real(8), intent(inout) :: vr_x(1:n), vi_x(1:n)
!      real(8), intent(in)    :: vr_t(1:n), vi_t(1:n)
!      real(8), intent(in)    :: d_t(1:n)
!      real(8), intent(in)    :: ur_y(1:n), ui_y(1:n)
      real(8), intent(inout) :: vr_xh(1:n), vi_xh(1:n)
      real(8), intent(in)    :: vr_th(1:n), vi_th(1:n)
      real(8), intent(in)    :: ur_yh(1:n), ui_yh(1:n)
      real(8), intent(inout) :: vr_xl(1:n), vi_xl(1:n)
      real(8), intent(in)    :: vr_tl(1:n), vi_tl(1:n)
      real(8), intent(in)    :: ur_yl(1:n), ui_yl(1:n)
      real(8), intent(in)    :: d_th(1:n), d_tl(1:n)
      double precision tmp1h, tmp1l
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

      integer                :: i
#ifdef MEMORY1
      integer,intent(in) :: nxx_vr_x
      integer,intent(in) :: nxx_vi_x
      integer,intent(in) :: nxx_vr_t
      integer,intent(in) :: nxx_vi_t
      integer,intent(in) :: nxx_d_t
      integer,intent(in) :: nxx_ur_y
      integer,intent(in) :: nxx_ui_y
#endif
#ifdef MEMORY1
      integer :: nxx
#endif

#ifdef MEMORY1
      nxx = xx_vr_x(4440,n)
      nxx = xx_vr_t(4450,n)
      nxx = xx_ur_y(4460,n)
      nxx = xx_vi_x(4470,n)
      nxx = xx_vi_t(4480,n)
      nxx = xx_ui_y(4490,n)
      nxx = xx_d_t (4500,n)
#endif
      do i=1,n
!         vr_x(i) = vr_x(i)+vr_t(i)+d_t(i)*ur_y(i)
!         vi_x(i) = vi_x(i)+vi_t(i)+d_t(i)*ui_y(i)
!<<<     tmp1 = d_t(i) * ur_y(i)
         tmp1h = d_th(i) * ur_yh(i)
         t_u1 = 134217729.0 * d_th(i)
         t_p1 = t_u1
     +            - (t_u1 - d_th(i))
         t_p2 = d_th(i) - t_p1
         t_u1 = 134217729.0 * ur_yh(i)
         t_r1 = t_u1
     +            - (t_u1 - ur_yh(i))
         t_r2 = ur_yh(i) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (d_th(i)*ur_yl(i)
     +         + d_tl(i)*ur_yh(i))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = d_t(i) * ur_y(i)
!<<<     vr_x(i) = vr_x(i) + vr_t(i)
         t_p1 = vr_xh(i) + vr_th(i)
         t_p2 = t_p1 - vr_xh(i)
         t_q1 = t_p1
         t_q2 = (vr_xh(i) - (t_p1 - t_p2))
     +            + (vr_th(i) - t_p2)
         t_q2 = t_q2 + vr_xl(i) + vr_tl(i)
         vr_xh(i) = t_q1 + t_q2
         vr_xl(i) = t_q2 - (vr_xh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vr_x(i) = vr_x(i) + vr_t(i)
!<<<     vr_x(i) = vr_x(i) + tmp1
         t_p1 = vr_xh(i) + tmp1h
         t_p2 = t_p1 - vr_xh(i)
         t_q1 = t_p1
         t_q2 = (vr_xh(i) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + vr_xl(i) + tmp1l
         vr_xh(i) = t_q1 + t_q2
         vr_xl(i) = t_q2 - (vr_xh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vr_x(i) = vr_x(i) + tmp1
!<<<     tmp1 = d_t(i) * ui_y(i)
         tmp1h = d_th(i) * ui_yh(i)
         t_u1 = 134217729.0 * d_th(i)
         t_p1 = t_u1
     +            - (t_u1 - d_th(i))
         t_p2 = d_th(i) - t_p1
         t_u1 = 134217729.0 * ui_yh(i)
         t_r1 = t_u1
     +            - (t_u1 - ui_yh(i))
         t_r2 = ui_yh(i) - t_r1
         tmp1l = ((t_p1*t_r1
     +           - tmp1h)
     +           + t_p1 * t_r2
     +           + t_p2 * t_r1)
     +           + t_p2 * t_r2
         tmp1l = tmp1l
     +         + (d_th(i)*ui_yl(i)
     +         + d_tl(i)*ui_yh(i))
         t_s1 = tmp1h + tmp1l
         tmp1l = tmp1l - (t_s1 - tmp1h)
         tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>     tmp1 = d_t(i) * ui_y(i)
!<<<     vi_x(i) = vi_x(i) + vi_t(i)
         t_p1 = vi_xh(i) + vi_th(i)
         t_p2 = t_p1 - vi_xh(i)
         t_q1 = t_p1
         t_q2 = (vi_xh(i) - (t_p1 - t_p2))
     +            + (vi_th(i) - t_p2)
         t_q2 = t_q2 + vi_xl(i) + vi_tl(i)
         vi_xh(i) = t_q1 + t_q2
         vi_xl(i) = t_q2 - (vi_xh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vi_x(i) = vi_x(i) + vi_t(i)
!<<<     vi_x(i) = vi_x(i) + tmp1
         t_p1 = vi_xh(i) + tmp1h
         t_p2 = t_p1 - vi_xh(i)
         t_q1 = t_p1
         t_q2 = (vi_xh(i) - (t_p1 - t_p2))
     +            + (tmp1h - t_p2)
         t_q2 = t_q2 + vi_xl(i) + tmp1l
         vi_xh(i) = t_q1 + t_q2
         vi_xl(i) = t_q2 - (vi_xh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>     vi_x(i) = vi_x(i) + tmp1
      end do! i

      return
#ifdef MEMORY1
      contains

      function xx_vr_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_x
      integer :: i0,i1
      xx_vr_x = nxx_vr_x + i1 - 1
      call accessor(i0,xx_vr_x,kxx_vr_x,"ddeigen_hrd_Au_step3_sub3:vr_x")
      end function

      function xx_vi_x(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_x
      integer :: i0,i1
      xx_vi_x = nxx_vi_x + i1 - 1
      call accessor(i0,xx_vi_x,kxx_vi_x,"ddeigen_hrd_Au_step3_sub3:vi_x")
      end function

      function xx_vr_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vr_t
      integer :: i0,i1
      xx_vr_t = nxx_vr_t + i1 - 1
      call accessor(i0,xx_vr_t,kxx_vr_t,"ddeigen_hrd_Au_step3_sub3:vr_t")
      end function

      function xx_vi_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_vi_t
      integer :: i0,i1
      xx_vi_t = nxx_vi_t + i1 - 1
      call accessor(i0,xx_vi_t,kxx_vi_t,"ddeigen_hrd_Au_step3_sub3:vi_t")
      end function

      function xx_d_t(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_d_t
      integer :: i0,i1
      xx_d_t = nxx_d_t + i1 - 1
      call accessor(i0,xx_d_t,kxx_d_t,"ddeigen_hrd_Au_step3_sub3:d_t")
      end function

      function xx_ur_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ur_y
      integer :: i0,i1
      xx_ur_y = nxx_ur_y + i1 - 1
      call accessor(i0,xx_ur_y,kxx_ur_y,"ddeigen_hrd_Au_step3_sub3:ur_y")
      end function

      function xx_ui_y(i0,i1)
      use xx_hrd_info
      implicit none
      integer :: xx_ui_y
      integer :: i0,i1
      xx_ui_y = nxx_ui_y + i1 - 1
      call accessor(i0,xx_ui_y,kxx_ui_y,"ddeigen_hrd_Au_step3_sub3:ui_y")
      end function
#endif
      end subroutine ! ddeigen_hrd_Au_step3_sub3
